/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2015 by GJ Business Division
 *                   RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2018 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _SIFIVE_FE310_H_
#define _SIFIVE_FE310_H_

#define TMAX_INTNO          52
#define TMAX_PRIORITY       256

#define NUM_GPIO            32

/*
 *  MCAUSE REGISTER
 */
#define MCAUSE_INT          0x80000000
#define MCAUSE_CAUSE        0x7FFFFFFF

/*
 *  MACHINE EXCEPTION NUMBER
 */
#define EXC_INSTRUCTION_ADDRESS_MISALIGNED  0
#define EXC_INSTRUCTION_ADDRESS_FAULT       1
#define EXC_ILLEGAL_INSTRUCTION             2
#define EXC_BREAKPOINT                      3
#define EXC_LOAD_ADDRESS_MISALIGNED         4
#define EXC_LOAD_ADDRESS_FAULT              5
#define EXC_STORE_AMO_ADDRESS_MISALIGNED    6
#define EXC_STORE_AMO_ACCESS_FAUT           7
#define EXC_ENVIRONMENT_CALL_FROM_MMODE     11

/*
 *  MACHINE INTERRUPT NUMBER
 */
#define IRQ_MACHINE_SOFTWARE                3
#define IRQ_MACHIE_TIMER                    7
#define IRQ_MACHINE_EXTERNAL                11

/*
 *  GLOBAL INTERRUPT NUMBER
 */
#define IRQ_VECTOR_RESERVED                 0
#define IRQ_VECTOR_WDOGCMP                  1
#define IRQ_VECTOR_RTCCMP                   2
#define IRQ_VECTOR_UART0                    3
#define IRQ_VECTOR_UART1                    4
#define IRQ_VECTOR_SPI0                     5
#define IRQ_VECTOR_SPI1                     6
#define IRQ_VECTOR_SPI2                     7
#define IRQ_VECTOR_GPIO                     8
#define IRQ_VECTOR_PWM0                     40
#define IRQ_VECTOR_PWM1                     44
#define IRQ_VECTOR_PWM2                     48


/*
 *  SIFIVE FE310 G0000 MEMORY MAP
 */
#define MASKROM_MEM_ADDR        0x00001000
#define TRAPVEC_TABLE_CTRL_ADDR 0x00001010
#define OTP_MEM_ADDR            0x00020000
#define CLINT_CTRL_ADDR         0x02000000
#define PLIC_CTRL_ADDR          0x0C000000
#define AON_CTRL_ADDR           0x10000000
#define PRCI_CTRL_ADDR          0x10008000
#define OTP_CTRL_ADDR           0x10010000
#define GPIO_CTRL_ADDR          0x10012000
#define UART0_CTRL_ADDR         0x10013000
#define SPI0_CTRL_ADDR          0x10014000
#define PWM0_CTRL_ADDR          0x10015000
#define UART1_CTRL_ADDR         0x10023000
#define SPI1_CTRL_ADDR          0x10024000
#define PWM1_CTRL_ADDR          0x10025000
#define SPI2_CTRL_ADDR          0x10034000
#define PWM2_CTRL_ADDR          0x10035000
#define SPI0_MEM_ADDR           0x20000000
#define MEM_CTRL_ADDR           0x80000000

/*
 *  AON-WATCH DOG
 */
#define TADR_AON_BASE       (AON_CTRL_ADDR)
#define TOFF_AON_WDOGCFG    0x0000
  #define AON_WDOGCFG_SCALE       0x0000000F
  #define AON_WDOGCFG_RSTEN       0x00000100
  #define AON_WDOGCFG_ZEROCMP     0x00000200
  #define AON_WDOGCFG_ENALWAYS    0x00001000
  #define AON_WDOGCFG_ENCOREAWAKE 0x00002000
  #define AON_WDOGCFG_CMPIP       0x10000000
#define TOFF_AON_WDOGCOUNT  0x0008
#define TOFF_AON_WDOGS      0x0010
#define TOFF_AON_WDOGFEED   0x0018
  #define AON_WDOGFEED_VALUE      0x0D09F00D
#define TOFF_AON_WDOGKEY    0x001C
  #define AON_WDOGKEY_VALUE       0x0051F15E
#define TOFF_AON_WDOGCMP    0x0020

/*
 *  AON-RTC
 */
#define TOFF_AON_RTCCFG     0x0040
  #define AON_RTCCFG_SCALE        0x0000000F
  #define AON_RTCCFG_ENALWAYS     0x00001000
  #define AON_RTCCFG_CMPIP        0x10000000
#define TOFF_AON_RTCLO      0x0048
#define TOFF_AON_RTCHI      0x004C
#define TOFF_AON_RTCS       0x0050
#define TOFF_AON_RTCCMP     0x0060

/*
 *  AON-CLOCK
 */
#define TOFF_AON_LFROSC     0x0070
  #define LFROSC_OSC_EN           0x40000000
  #define LFROSC_OSC_RDY          0x80000000

/*
 *  AON-BACKUP
 */
#define TOFF_AON_BACKUP0    0x0080
#define TOFF_AON_BACKUP1    0x0084
#define TOFF_AON_BACKUP2    0x0088
#define TOFF_AON_BACKUP3    0x008C
#define TOFF_AON_BACKUP4    0x0090
#define TOFF_AON_BACKUP5    0x0094
#define TOFF_AON_BACKUP6    0x0098
#define TOFF_AON_BACKUP7    0x009C
#define TOFF_AON_BACKUP8    0x00A0
#define TOFF_AON_BACKUP9    0x00A4
#define TOFF_AON_BACKUP10   0x00A8
#define TOFF_AON_BACKUP11   0x00AC
#define TOFF_AON_BACKUP12   0x00B0
#define TOFF_AON_BACKUP13   0x00B4
#define TOFF_AON_BACKUP14   0x00B8
#define TOFF_AON_BACKUP15   0x00BC

/*
 *  AON-PMU
 */
#define TOFF_AON_PMUWAKEUPI0 0x0100
#define TOFF_AON_PMUWAKEUPI1 0x0104
#define TOFF_AON_PMUWAKEUPI2 0x0108
#define TOFF_AON_PMUWAKEUPI3 0x010C
#define TOFF_AON_PMUWAKEUPI4 0x0110
#define TOFF_AON_PMUWAKEUPI5 0x0114
#define TOFF_AON_PMUWAKEUPI6 0x0118
#define TOFF_AON_PMUWAKEUPI7 0x011C
#define TOFF_AON_PMUSLEEPI0 0x0120
#define TOFF_AON_PMUSLEEPI1 0x0124
#define TOFF_AON_PMUSLEEPI2 0x0128
#define TOFF_AON_PMUSLEEPI3 0x012C
#define TOFF_AON_PMUSLEEPI4 0x0130
#define TOFF_AON_PMUSLEEPI5 0x0134
#define TOFF_AON_PMUSLEEPI6 0x0138
#define TOFF_AON_PMUSLEEPI7 0x013C
#define TOFF_AON_PMUIE      0x0140
#define TOFF_AON_PMUCAUSE   0x0144
  #define AON_PMUCAUSE_WAKEUPCAUSE 0x00000003
  #define AON_WAKEUPCAUSE_RESET   0x00000000
  #define AON_WAKEUPCAUSE_RTC     0x00000001
  #define AON_WAKEUPCAUSE_DWAKEUP 0x00000002
  #define AON_WAKEUPCAUSE_AWAKEUP 0x00000003
  #define AON_PMUCAUSE_RESETCAUSE 0x00000300
  #define AON_RESETCAUSE_POWERON  0x00000000
  #define AON_RESETCAUSE_EXTERNAL 0x00000100
  #define AON_RESETCAUSE_WATCHDOG 0x00000200
#define TOFF_AON_PMUSLEEP   0x0148
#define TOFF_AON_PMUKEY     0x014C

#define RTC_FREQ            32768
#define TIMER_FREQ          (RTC_FREQ)

/*
 *  CLINT
 */
#define TADR_CLIC_BASE      (CLINT_CTRL_ADDR)
#define TOFF_CLINT_MSIP     0x0000
#define CLINT_MSIP_size     0x4
#define TOFF_CLINT_MTIMECMP 0x4000
#define CLINT_MTIMECMP_size 0x8
#define TOFF_CLINT_MTIME    0xBFF8
#define CLINT_MTIME_size    0x8


/*
 *  PLIC
 */
#define TADR_PLIC_BASE      (PLIC_CTRL_ADDR)
#define TOFF_PLIC_PRIORITY  0x00000000
#define TOFF_PLIC_PENDING   0x00001000
#define TOFF_PLIC_ENABLE    0x00002000
#define NUM_PLIC_ENABLE     128
#define TOFF_PLIC_THRESHOLD 0x00200000
#define NUM_PLIC_THRESHOLD  4096
#define TOFF_PLIC_CLAIM     0x00200004


/*
 *  GPIO
 */
#define TADR_GPIO_BASE      (GPIO_CTRL_ADDR)
#define TOFF_GPIO_INPUT_VAL   0x0000
#define TOFF_GPIO_INPUT_EN    0x0004
#define TOFF_GPIO_OUTPUT_EN   0x0008
#define TOFF_GPIO_OUTPUT_VAL  0x000C
#define TOFF_GPIO_PULLUP_EN   0x0010
#define TOFF_GPIO_DRIVE       0x0014
#define TOFF_GPIO_RISE_IE     0x0018
#define TOFF_GPIO_RISE_IP     0x001C
#define TOFF_GPIO_FALL_IE     0x0020
#define TOFF_GPIO_FALL_IP     0x0024
#define TOFF_GPIO_HIGH_IE     0x0028
#define TOFF_GPIO_HIGH_IP     0x002C
#define TOFF_GPIO_LOW_IE      0x0030
#define TOFF_GPIO_LOW_IP      0x0034
#define TOFF_GPIO_IOF_EN      0x0038
  #define IOF_SPI1_SS0        0x00000004
  #define IOF_SPI1_MOSI       0x00000008
  #define IOF_SPI1_MISO       0x00000010
  #define IOF_SPI1_SCK        0x00000020
  #define IOF_SPI1_DQ2        0x00000040
  #define IOF_SPI1_DQ3        0x00000080
  #define IOF_SPI1_SS1        0x00000100
  #define IOF_SPI1_SS2        0x00000200
  #define IOF_SPI1_SS3        0x00000400
  #define IOF_SPI1_DQ0        0x00000008
  #define IOF_SPI1_DQ1        0x00000010
  #define IOF0_SPI1_MASK      (IOF_SPI1_SS0 | IOF_SPI1_MOSI | IOF_SPI1_MISO | IOF_SPI1_SCK | \
                               IOF_SPI1_DQ2 | IOF_SPI1_DQ3  | IOF_SPI1_SS1  | IOF_SPI1_SS2 | IOF_SPI1_SS3)

  #define IOF_UART0_RX        0x00010000
  #define IOF_UART0_TX        0x00020000
  #define IOF0_UART0_MASK     (IOF_UART0_RX | IOF_UART0_TX)
  #define IOF_UART1_RX        0x01000000
  #define IOF_UART1_TX        0x02000000
  #define IOF0_UART1_MASK     (IOF_UART1_RX | IOF_UART1_TX)
  #define IOF_SPI2_SS0        0x04000000
  #define IOF_SPI2_MOSI       0x08000000
  #define IOF_SPI2_MISO       0x10000000
  #define IOF_SPI2_SCK        0x20000000
  #define IOF_SPI2_DQ0        0x08000000
  #define IOF_SPI2_DQ1        0x10000000
  #define IOF_SPI2_DQ2        0x40000000
  #define IOF_SPI2_DQ3        0x80000000
  #define IOF0_SPI2_MASK      (IOF_SPI2_SS0 | IOF_SPI2_MOSI | IOF_SPI2_MISO | IOF_SPI2_SCK | IOF_SPI2_DQ2 | IOF_SPI2_DQ3)
#define TOFF_GPIO_IOF_SEL     0x003C
#define TOFF_GPIO_OUTPUT_XOR  0x0040

/*
 *  IOF1 masks
 */
#define IOF1_PWM0_MASK        0x0000000F
#define IOF1_PWM1_MASK        0x00780000
#define IOF1_PWM2_MASK        0x00003C00


/*
 *  OPT
 */
#define TADR_OTP_BASE       (OTP_CTRL_ADDR)
#define TOFF_OTP_LOCK       0x0000
#define TOFF_OTP_CK         0x0004
#define TOFF_OTP_OE         0x0008
#define TOFF_OTP_SEL        0x000C
#define TOFF_OTP_WE         0x0010
#define TOFF_OTP_MR         0x0014
#define TOFF_OTP_MRR        0x0018
#define TOFF_OTP_MPP        0x001C
#define TOFF_OTP_VRREN      0x0020
#define TOFF_OTP_VPPEN      0x0024
#define TOFF_OTP_A          0x0028
#define TOFF_OTP_D          0x002C
#define TOFF_OTP_Q          0x0030
#define TOFF_OTP_READ_TIMINGS 0x0034

/*
 *  PRCI
 */
#define TADR_PRCI_BASE      (PRCI_CTRL_ADDR)
#define PRCI_HFROSCCFG      (0x0000)
  #define HFROSCCFG_OSC_DIV   0x0000002F
  #define HFROSCCFG_OSC_TRIM  0x001F0000
  #define HFROSCCFG_OSC_EN    0x40000000
  #define HFROSCCFG_OSC_RDY   0x80000000

#define PRCI_HFXOSCCFG      (0x0004)
#define PRCI_PLLCFG         (0x0008)
  #define PLLCFG_R            0x00000007
  #define PLLCFG_F            0x000003F0
  #define PLLCFG_Q            0x00000C00
  #define PLLCFG_PLL_SEL      0x00010000
  #define PLLCFG_SEL_HFROSC   0x00000000
  #define PLLCFG_SEL_PLL      (PLLCFG_PLL_SEL)
  #define PLLCFG_PLL_REFSEL   0x00020000
  #define PLLCFG_REFSEL_HFROSC  0x00000000
  #define PLLCFG_REFSEL_HFXOSC  (PLLCFG_PLL_REFSEL)
  #define PLLCFG_PLL_BYPASS   0x00040000
  #define PLLCFG_PLL_LOCK     0x80000000
#define PRCI_PLLDIV         (0x000C)
  #define PLL_FINAL_DIV(x)      (((x) & 0x3F) << 0)
  #define PLL_FINAL_DIV_BY_1(x) (((x) & 0x1 ) << 8)
#define PRCI_PROCMONCFG     (0x00F0)
  #define PROCMON_DIV(x)   (((x) & 0x1F) << 0)
  #define PROCMON_TRIM(x)  (((x) & 0x1F) << 8)
  #define PROCMONCFG_EN     0x00010000
  #define PROCMON_SEL(x)   (((x) & 0x3)  << 24)
  #define PROCMONCFG_SEL_HFCLK     (0 << 24)
  #define PROCMONCFG_SEL_HFXOSCIN  (1 << 24)
  #define PROCMONCFG_SEL_PLLOUTDIV (2 << 24)
  #define PROCMONCFG_SEL_PROCMON   (3 << 24)
  #define PROCMONCFG_NT_EN  0x10000000


/*
 *  UART
 */
#define TADR_UART0_BASE     (UART0_CTRL_ADDR)
#define TADR_UART1_BASE     (UART1_CTRL_ADDR)
#define TOFF_UART_TXFIFO    0x0000
#define TOFF_UART_RXFIFO    0x0004
#define TOFF_UART_TXCTRL    0x0008
  #define UART_TXEN         0x00000001
  #define UART_TXCNT        0x00070000
#define TOFF_UART_RXCTRL    0x000C
  #define UART_RXEN         0x00000001
  #define UART_RXCT         0x00070000
#define TOFF_UART_IE        0x0010
#define TOFF_UART_IP        0x0014
  #define UART_IP_TXWM      0x00000001
  #define UART_IP_RXWM      0x00000002
#define TOFF_UART_DIV       0x0018


/*
 *  PWM
 */
#define TADR_PWM0_BASE      (PWM0_CTRL_ADDR)
#define TADR_PWM1_BASE      (PWM1_CTRL_ADDR)
#define TADR_PWM2_BASE      (PWM2_CTRL_ADDR)
#define TOFF_PWM_CFG        0x0000
  #define PWM_CFG_SCALE       0x0000000F
  #define PWM_CFG_STICKY      0x00000100
  #define PWM_CFG_ZEROCMP     0x00000200
  #define PWM_CFG_DEGLITCH    0x00000400
  #define PWM_CFG_ENALWAYS    0x00001000
  #define PWM_CFG_ONESHOT     0x00002000
  #define PWM_CFG_CMP0CENTER  0x00010000
  #define PWM_CFG_CMP1CENTER  0x00020000
  #define PWM_CFG_CMP2CENTER  0x00040000
  #define PWM_CFG_CMP3CENTER  0x00080000
  #define PWM_CFG_CMP0GANG    0x01000000
  #define PWM_CFG_CMP1GANG    0x02000000
  #define PWM_CFG_CMP2GANG    0x04000000
  #define PWM_CFG_CMP3GANG    0x08000000
  #define PWM_CFG_CMP0IP      0x10000000
  #define PWM_CFG_CMP1IP      0x20000000
  #define PWM_CFG_CMP2IP      0x40000000
  #define PWM_CFG_CMP3IP      0x80000000
#define TOFF_PWM_COUNT      0x0008
#define TOFF_PWM_S          0x0010
#define TOFF_PWM_CMP0       0x0020
#define TOFF_PWM_CMP1       0x0024
#define TOFF_PWM_CMP2       0x0028
#define TOFF_PWM_CMP3       0x002C


/*
 *  SPI
 */
#define TADR_SPI0_BASE      (SPI0_CTRL_ADDR)
#define TADR_SPI1_BASE      (SPI1_CTRL_ADDR)
#define TADR_SPI2_BASE      (SPI2_CTRL_ADDR)
#define TOFF_SPI_SCKDIV     0x0000
#define TOFF_SPI_SCKMODE    0x0004
  #define SPI_SCK_PHA         0x00000001
  #define SPI_SCK_POL         0x00000002
#define TOFF_SPI_CSID       0x0010
#define TOFF_SPI_CSDEF      0x0014
#define TOFF_SPI_CSMODE     0x0018
  #define SPI_CSMODE_AUTO     0
  #define SPI_CSMODE_HOLD     2
  #define SPI_CSMODE_OFF      3
#define TOFF_SPI_DCSSCK     0x0028
#define TOFF_SPI_DSCKCS     0x002A
#define TOFF_SPI_DINTERCS   0x002C
#define TOFF_SPI_DINTERXFR  0x002E

#define TOFF_SPI_FMT        0x0040
  #define SPI_PROTO_S         0
  #define SPI_PROTO_D         1
  #define SPI_PROTO_Q         2
  #define SPI_FMT_PROTO       0x00000003
  #define SPI_FMT_ENDIAN_MSB  0x00000000
  #define SPI_FMT_ENDIAN_LSB  0x00000004
  #define SPI_FMT_DIR_RX      0x00000000
  #define SPI_FMT_DIR_TX      0x00000008
  #define SPI_FMT_LEN         0x000F0000
#define TOFF_SPI_TXFIFO     0x0048
  #define SPI_TXFIFO_FULL     0x80000000
#define TOFF_SPI_RXFIFO     0x004C
  #define SPI_RXFIFO_EMPTY    0x80000000
#define TOFF_SPI_TXCTRL     0x0050
  #define SPI_TXWM(x)         ((x) & 0xffff)
#define TOFF_SPI_RXCTRL     0x0054
  #define SPI_RXWM(x)         ((x) & 0xffff)

#define TOFF_SPI_FCTRL      0x0060
  #define SPI_FCTRL_EN        0x0000001

#define TOFF_SPI_FFMT       0x0064
  #define SPI_INSN_CMD_EN     0x00000001
  #define SPI_INSN_ADDR_LEN(x)    (((x) & 0x7) << 1)
  #define SPI_INSN_PAD_CNT(x)     (((x) & 0xf) << 4)
  #define SPI_INSN_CMD_PROTO(x)   (((x) & 0x3) << 8)
  #define SPI_INSN_ADDR_PROTO(x)  (((x) & 0x3) << 10)
  #define SPI_INSN_DATA_PROTO(x)  (((x) & 0x3) << 12)
  #define SPI_INSN_CMD_CODE(x)    (((x) & 0xff) << 16)
  #define SPI_INSN_PAD_CODE(x)    (((x) & 0xff) << 24)

#define TOFF_SPI_IE         0x0070
#define TOFF_SPI_IP         0x0074
  #define SPI_IP_TXWM         0x00000001
  #define SPI_IP_RXWM         0x00000002

#define SPI1_NUM_SS       (4)
#define SPI2_NUM_SS       (1)

#endif /* _SIFIVE_FE310_H_ */
