
#ifndef _SYS_DEFS_H_
#define _SYS_DEFS_H_

/*	Values	*/

#if BOARDNO == 0
#ifdef DEFAULT_CLOCK
#define TARGET_CPU_STR		"HiFIVE1(H)"
#else
#define TARGET_CPU_STR		"HiFIVE1(L)"
#endif
#else
#ifdef DEFAULT_CLOCK
#define TARGET_CPU_STR		"HiFIVE1-B(H)"
#else
#define TARGET_CPU_STR		"HiFIVE1-B(L)"
#endif
#endif

/* endian */
#define SIL_ENDIAN      0		/* LITTLE ENDIAN */

/*	Address		*/
#define RAM_BASE        0x80000000
#define RAM_SIZE        (16*1024)
#define VECTOR_SIZE		(4*8)
#if BOARDNO == 0
#define CLOAD_ADDRESS   0x20400000
#else
#define CLOAD_ADDRESS   0x20010000
#endif

/*
 *  ԤΤ
 *  ϥåȿ˰¸롣
 */
#define    SIL_DLY_TIM1     1
#ifdef DEFAULT_CLOCK
#define    SIL_DLY_TIM2     7
#else
#define    SIL_DLY_TIM2     110
#endif

/*	Default Values	*/

#define MAX_INT_NUM     32
#define DEF_DUMP_LENGTH	256
#define MonitorVector   &trap_entry
#define UserVector      RAM_BASE
#define NOT_INITDECT
#define NOT_DEFVECTORTYPE
//#ifdef DEFAULT_CLOCK
//#define NOINT_UARTTX
//#endif

#ifndef _MACRO_ONLY
/*
 *  ѥ¸Υǡ
 */
#define	_int8_		char		/* 8ӥåȤ	*/
#define	_int16_		short		/* 16ӥåȤ	*/
#define	_int32_		int			/* 32ӥåȤ	*/
#define	_int64_		long long	/* 64ӥåȤ	*/

/*
 *  ѥγĥǽΤΥޥ
 */
#define	Inline          static inline

typedef	int                 ID;			/* ֥ȤIDֹ */
typedef	int                 ER;			/* 顼 */
typedef int                 bool_t;		/*  */

#ifndef NULL
#define NULL                0			/* ̵ݥ */
#endif /* NULL */

#ifndef true
#define true                1			/*  */
#endif /* true */

#ifndef false
#define false               0			/*  */
#endif /* false */

/*
 *  SDMMCĥ顼
 */
#define E_OK                0			/* ｪλ */
#define E_SYS               (-5)		/* ƥ२顼 */
#define E_PAR               (-17)		/* ѥ᡼顼 */
#define E_OBJ               (-41)		/* ֥Ⱦ֥顼 */
#define E_TMOUT             (-50)		/* ݡ󥰼Ԥޤϥॢ */
#define E_SDCOM             (-80)		/* ޥɥ顼 */

typedef void (*function_ptr_t) (void);

#define plic_set_vector(n, f)   (plic_interrupt_handlers[(n)] = f)

extern void SetVector(void *addr);
extern int sys_printf(const char * format, ...);
extern void sys_putc(char c);
extern void trap_entry(void);
extern unsigned long long get_timer_value(void);
extern void start_m_time(void);

extern void plic_init (void);
extern void plic_set_threshold (unsigned long threshold);
extern void plic_enable_interrupt(unsigned int source);
extern void plic_disable_interrupt (unsigned int source);
extern void plic_set_priority (unsigned int source, unsigned int priority);

extern unsigned int   cpu_frequency;
extern function_ptr_t plic_interrupt_handlers[];

#endif	/* _MACRO_ONLY */

#include "sifive-fe310.h"
#include "encoding.h"

/*	Serial Channels		*/

#define MAX_SERIAL		1
#define DEF_MON_SERIAL	0


/* serial definitions */

#define DEFAULT_SPEED		115200

#endif	/* SYS_DEFS_H_ */

