/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2015 by GJ Business Division
 *                   RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2020 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _GD32VF103_H_
#define _GD32VF103_H_

#define TMAX_INTNO          87
#define TMAX_PRIORITY       16

#define NUM_GPIO            32

/*
 *  MCAUSE REGISTER
 */
#define MCAUSE_INT          0x80000000
#define MCAUSE_CAUSE        0x7FFFFFFF

/*
 *  MACHINE EXCEPTION NUMBER
 */
#define EXC_INSTRUCTION_ADDRESS_MISALIGNED  0
#define EXC_INSTRUCTION_ADDRESS_FAULT       1
#define EXC_ILLEGAL_INSTRUCTION             2
#define EXC_BREAKPOINT                      3
#define EXC_LOAD_ADDRESS_MISALIGNED         4
#define EXC_LOAD_ADDRESS_FAULT              5
#define EXC_STORE_AMO_ADDRESS_MISALIGNED    6
#define EXC_STORE_AMO_ACCESS_FAUT           7
#define EXC_ENVIRONMENT_CALL_FROM_MMODE     11

/*
 *  MACHINE INTERRUPT NUMBER
 */
#define IRQ_MACHINE_SOFTWARE                3
#define IRQ_MACHIE_TIMER                    7
#define IRQ_MACHINE_EXTERNAL                11

/*
 *  GLOBAL INTERRUPT NUMBER
 */
#define IRQ_VECTOR_RESERVED                 0	/* RISC-V reserved */
#define IRQ_VECTOR_CLIC_INT_SFT             3	/* Software interrupt */
#define IRQ_VECTOR_CLIC_INT_TMR             7	/* CPU Timer interrupt */
#define IRQ_VECTOR_CLIC_INT_BWEI            17	/* Bus Error interrupt */
#define IRQ_VECTOR_CLIC_INT_PMOVI           18	/* Performance Monitor */
#define IRQ_VECTOR_WWDGT                    19	/* window watchDog timer interrupt */
#define IRQ_VECTOR_LVD                      20	/* LVD through EXTI line detect interrupt */
#define IRQ_VECTOR_TAMPER                   21	/* tamper through EXTI line detect */
#define IRQ_VECTOR_RTC                      22	/* RTC alarm interrupt */
#define IRQ_VECTOR_FMC                      23	/* FMC interrupt */
#define IRQ_VECTOR_RCU_CTC                  24	/* RCU and CTC interrupt */
#define IRQ_VECTOR_EXTI0                    25	/* EXTI line 0 interrupts */
#define IRQ_VECTOR_EXTI1                    26	/* EXTI line 1 interrupts */
#define IRQ_VECTOR_EXTI2                    27	/* EXTI line 2 interrupts */
#define IRQ_VECTOR_EXTI3                    28	/* EXTI line 3 interrupts */
#define IRQ_VECTOR_EXTI4                    29	/* EXTI line 4 interrupts */
#define IRQ_VECTOR_DMA0_Channel0            30	/* DMA0 channel0 interrupt */
#define IRQ_VECTOR_DMA0_Channel1            31	/* DMA0 channel1 interrupt */
#define IRQ_VECTOR_DMA0_Channel2            32	/* DMA0 channel2 interrupt */
#define IRQ_VECTOR_DMA0_Channel3            33	/* DMA0 channel3 interrupt */
#define IRQ_VECTOR_DMA0_Channel4            34	/* DMA0 channel4 interrupt */
#define IRQ_VECTOR_DMA0_Channel5            35	/* DMA0 channel5 interrupt */
#define IRQ_VECTOR_DMA0_Channel6            36	/* DMA0 channel6 interrupt */
#define IRQ_VECTOR_ADC0_1                   37	/* ADC0 and ADC1 interrupt */
#define IRQ_VECTOR_CAN0_TX                  38	/* CAN0 TX interrupts */
#define IRQ_VECTOR_CAN0_RX0                 39	/* CAN0 RX0 interrupts */
#define IRQ_VECTOR_CAN0_RX1                 40	/* CAN0 RX1 interrupts */
#define IRQ_VECTOR_CAN0_EWMC                41	/* CAN0 EWMC interrupts */
#define IRQ_VECTOR_EXTI5_9                  42	/* EXTI[9:5] interrupts */
#define IRQ_VECTOR_TIMER0_BRK               43	/* TIMER0 break interrupts */
#define IRQ_VECTOR_TIMER0_UP                44	/* TIMER0 update interrupts */
#define IRQ_VECTOR_TIMER0_TRG_CMT           45	/* TIMER0 trigger and commutation interrupts */
#define IRQ_VECTOR_TIMER0_Channel           46	/* TIMER0 channel capture compare interrupts */
#define IRQ_VECTOR_TIMER1                   47	/* TIMER1 interrupt */
#define IRQ_VECTOR_TIMER2                   48	/* TIMER2 interrupt */
#define IRQ_VECTOR_TIMER3                   49	/* TIMER3 interrupt */
#define IRQ_VECTOR_I2C0_EV                  50	/* I2C0 event interrupt */
#define IRQ_VECTOR_I2C0_ER                  51	/* I2C0 error interrupt */
#define IRQ_VECTOR_I2C1_EV                  52	/* I2C1 event interrupt */
#define IRQ_VECTOR_I2C1_ER                  53	/* I2C1 error interrupt */
#define IRQ_VECTOR_SPI0                     54	/* SPI0 interrupt */
#define IRQ_VECTOR_SPI1                     55	/* SPI1 interrupt */
#define IRQ_VECTOR_USART0                   56	/* USART0 interrupt */
#define IRQ_VECTOR_USART1                   57	/* USART1 interrupt */
#define IRQ_VECTOR_USART2                   58	/* USART2 interrupt */
#define IRQ_VECTOR_EXTI10_15                59	/* EXTI[15:10] interrupts */
#define IRQ_VECTOR_RTC_ALARM                60	/* RTC alarm interrupt EXTI */
#define IRQ_VECTOR_USBFS_WKUP               61	/* USBFS wakeup interrupt */
#define IRQ_VECTOR_EXMC                     67	/* EXMC global interrupt*/
#define IRQ_VECTOR_TIMER4                   69	/* TIMER4 global interrupt */
#define IRQ_VECTOR_SPI2                     70	/* SPI2 global interrupt */
#define IRQ_VECTOR_UART3                    71	/* UART3 global interrupt */
#define IRQ_VECTOR_UART4                    72	/* UART4 global interrupt */
#define IRQ_VECTOR_TIMER5                   73	/* TIMER5 global interrupt */
#define IRQ_VECTOR_TIMER6                   74	/* TIMER6 global interrupt */
#define IRQ_VECTOR_DMA1_Channel0            75	/* DMA1 channel0 global interrupt */
#define IRQ_VECTOR_DMA1_Channel1            76	/* DMA1 channel1 global interrupt */
#define IRQ_VECTOR_DMA1_Channel2            77	/* DMA1 channel2 global interrupt */
#define IRQ_VECTOR_DMA1_Channel3            78	/* DMA1 channel3 global interrupt */
#define IRQ_VECTOR_DMA1_Channel4            79	/* DMA1 channel3 global interrupt */
#define IRQ_VECTOR_CAN1_TX                  82	 /* CAN1 TX interrupt */
#define IRQ_VECTOR_CAN1_RX0                 83	 /* CAN1 RX0 interrupt */
#define IRQ_VECTOR_CAN1_RX1                 84	 /* CAN1 RX1 interrupt */
#define IRQ_VECTOR_CAN1_EWMC                85	 /* CAN1 EWMC interrupt */
#define IRQ_VECTOR_USBFS                    86	 /* USBFS global interrupt */

/*
 *  GD32VF103 MEMORY MAP
 */
#define FLASH_BASE              0x08000000U		/* main FLASH base address */
#define SRAM_BASE               0x20000000U		/* SRAM0 base address */
#define OB_BASE                 0x1FFFF800U		/* OB base address */
#define EXMC_BASE               0xA0000000U		/* EXMC register base address */
#define DBG_BASE                0xE0042000U		/* DBG base address */

/*
 *  GD32VF103 BUS MAP
 */
#define APB1_BUS_BASE           0x40000000U		/* apb1 base address */
#define APB2_BUS_BASE           0x40010000U		/* apb2 base address */
#define AHB1_BUS_BASE           0x40018000U		/* ahb1 base address */
#define AHB3_BUS_BASE           0x60000000U		/* ahb3 base address */

#define CLINT_CTRL_ADDR         0xD1000000U
#define ECLIC_ADDR_BASE         0xD2000000U

/*
 *  GD32VF103 PERiPHERAL MEMORY MAP
 */
#define TIMER_BASE              (APB1_BUS_BASE+0x00000000U)	/* TIMER base address */
#define RTC_BASE                (APB1_BUS_BASE+0x00002800U)	/* RTC base address */
#define WWDGT_BASE              (APB1_BUS_BASE+0x00002C00U)	/* WWDGT base address */
#define FWDGT_BASE              (APB1_BUS_BASE+0x00003000U)	/* FWDGT base address */
#define SPI_BASE                (APB1_BUS_BASE+0x00003800U)	/* SPI base address */
#define USART_BASE              (APB1_BUS_BASE+0x00004400U)	/* USART base address */
#define I2C_BASE                (APB1_BUS_BASE+0x00005400U)	/* I2C base address */
#define CAN_BASE                (APB1_BUS_BASE+0x00006400U)	/* CAN base address */
#define BKP_BASE                (APB1_BUS_BASE+0x00006C00U)	/* BKP base address */
#define PMU_BASE                (APB1_BUS_BASE+0x00007000U)	/* PMU base address */
#define DAC_BASE                (APB1_BUS_BASE+0x00007400U)	/* DAC base address */

#define AFIO_BASE               (APB2_BUS_BASE+0x00000000U)	/* AFIO base address */
#define EXTI_BASE               (APB2_BUS_BASE+0x00000400U)	/* EXTI base address */
#define GPIO_BASE               (APB2_BUS_BASE+0x00000800U)	/* GPIO base address */
#define ADC_BASE                (APB2_BUS_BASE+0x00002400U)	/* ADC base address */

#define DMA_BASE                (AHB1_BUS_BASE+0x00008000U)	/* DMA base address */
#define RCU_BASE                (AHB1_BUS_BASE+0x00009000U)	/* RCU base address */
#define FMC_BASE                (AHB1_BUS_BASE+0x0000A000U)	/* FMC base address */
#define CRC_BASE                (AHB1_BUS_BASE+0x0000B000U)	/* CRC base address */
#define USBFS_BASE              (AHB1_BUS_BASE+0x0FFE8000U)	/* USBFS base address */


/*
 *  CLINT
 */
#define TADR_CLIC_BASE      (CLINT_CTRL_ADDR)
#define TOFF_CLINT_MSIP     0x0FFC
#define CLINT_MSIP_size     0x4
#define TOFF_CLINT_MTIMECMP 0x0008
#define CLINT_MTIMECMP_size 0x8
#define TOFF_CLINT_MTIME    0x0000
#define CLINT_MTIME_size    0x8


/*
 *  ECLIC
 */
#define TADR_ECLIC_BASE     (ECLIC_ADDR_BASE)
#define TOFF_ECLIC_CFG      0x0000			/* (RW8) ecliccfg */
#define TOFF_ECLIC_INFO     0x0004			/* (R)   eclicinfo */
#define TOFF_ECLIC_MTH      0x000B			/* (RW8) mintthresh */
#define TOFF_ECLIC_INT_IP   0x1000			/* (RW8) eclicintip */
#define TOFF_ECLIC_INT_IE   0x1001			/* (RW8) eclicintie */
#define TOFF_ECLIC_INT_ATTR 0x1002			/* (RW8) eclicintattr */
  #define ECLIC_INT_ATTR_SHV        0x01
  #define ECLIC_INT_ATTR_TRIG_LEVEL 0x00
  #define ECLIC_INT_ATTR_TRIG_EDGE  0x02
  #define ECLIC_INT_ATTR_TRIG_POS   0x00
  #define ECLIC_INT_ATTR_TRIG_NEG   0x04
#define TOFF_ECLIC_INT_CTRL 0x1003			/* (RW8) eclicintctrl */


/*
 *  EXMC
 */
#define TADR_EXMC_BASE      EXMC_BASE
#define TOFF_EXMC_SNCTL0    0x0000		/* (RW) EXMC SRAM/NOR flash control register 0 */
  #define EXMC_SNCTL_NRBKEN     0x00000001	/* NOR bank enable */
  #define EXMC_SNCTL_NRMUX      0x00000002	/* NOR bank memory address/data multiplexing */
  #define EXMC_SNCTL_NRTP       0x0000000C	/* NOR bank memory type */
  #define EXMC_SNCTL_NRW        0x00000030	/* NOR bank memory data bus width */
  #define EXMC_SNCTL_NREN       0x00000040	/* NOR flash access enable */
  #define EXMC_SNCTL_NRWTPOL    0x00000200	/* NWAIT signal polarity */
  #define EXMC_SNCTL_WREN       0x00001000	/* write enable */
  #define EXMC_SNCTL_NRWTEN     0x00002000	/* NWAIT signal enable */
  #define EXMC_SNCTL_ASYNCWAIT  0x00008000	/* asynchronous wait */
#define TOFF_EXMC_SNTCFG0   0x0004		/* (RW) EXMC SRAM/NOR flash timing configuration register 0 */
  #define EXMC_SNTCFG_ASET      0x0000000F	/* address setup time */
  #define EXMC_SNTCFG_AHLD      0x000000F0	/* address hold time */
  #define EXMC_SNTCFG_DSET      0x0000FF00	/* data setup time */
  #define EXMC_SNTCFG_BUSLAT    0x000F0000	/* bus latency */
#define TOFF_EXMC_SNWTCFG0  0x0104		/* (RW) EXMC SRAM/NOR flash write timing configuration register 0 */

/*
 *  DBG
 */
#define TADR_DBG_BASE       DBG_BASE
#define TOFF_DBG_ID         0x0000		/* (RW) DBG_ID code register */
#define TOFF_DBG_CTL        0x0004		/* (RW) DBG control register */
  #define DBG_CTL_SLP_HOLD      0x00000001		/* keep debugger connection during sleep mode */
  #define DBG_CTL_DSLP_HOLD     0x00000002		/* keep debugger connection during deepsleep mode */
  #define DBG_CTL_STB_HOLD      0x00000004		/* keep debugger connection during standby mode */
  #define DBG_CTL_FWDGT_HOLD    0x00000100		/* debug FWDGT kept when core is halted */
  #define DBG_CTL_WWDGT_HOLD    0x00000200		/* debug WWDGT kept when core is halted */
  #define DBG_CTL_TIMER0_HOLD   0x00000400		/* hold TIMER0 counter when core is halted */
  #define DBG_CTL_TIMER1_HOLD   0x00000800		/* hold TIMER1 counter when core is halted */
  #define DBG_CTL_TIMER2_HOLD   0x00001000		/* hold TIMER2 counter when core is halted */
  #define DBG_CTL_TIMER3_HOLD   0x00002000		/* hold TIMER3 counter when core is halted */
  #define DBG_CTL_CAN0_HOLD     0x00004000		/* debug CAN0 kept when core is halted */
  #define DBG_CTL_I2C0_HOLD     0x00008000		/* hold I2C0 smbus when core is halted */
  #define DBG_CTL_I2C1_HOLD     0x00010000		/* hold I2C1 smbus when core is halted */
  #define DBG_CTL_TIMER4_HOLD   0x00040000		/* hold TIMER4 counter when core is halted */
  #define DBG_CTL_TIMER5_HOLD   0x00080000		/* hold TIMER5 counter when core is halted */
  #define DBG_CTL_TIMER6_HOLD   0x00100000		/* hold TIMER6 counter when core is halted */
  #define DBG_CTL_CAN1_HOLD     0x00200000		/* debug CAN1 kept when core is halted */


/*
 *  TIMER
 */
#define TADR_TIMER0_BASE    (TIMER_BASE + 0x00012C00U)
#define TADR_TIMER1_BASE    (TIMER_BASE + 0x00000000U)
#define TADR_TIMER2_BASE    (TIMER_BASE + 0x00000400U)
#define TADR_TIMER3_BASE    (TIMER_BASE + 0x00000800U)
#define TADR_TIMER4_BASE    (TIMER_BASE + 0x00000C00U)
#define TADR_TIMER5_BASE    (TIMER_BASE + 0x00001000U)
#define TADR_TIMER6_BASE    (TIMER_BASE + 0x00001400U)
#define TOFF_TIMER_CTL0     0x0000		/* (RW) TIMER control register 0 */
  #define TIMER_CTL0_CEN          0x00000001	/* TIMER counter enable */
  #define TIMER_CTL0_UPDIS        0x00000002	/* update disable */
  #define TIMER_CTL0_UPS          0x00000004	/* update source */
  #define TIMER_CTL0_SPM          0x00000008	/* single pulse mode */
  #define TIMER_CTL0_DIR          0x00000010	/* timer counter direction */
  #define TIMER_CTL0_CAM          0x00000060	/* center-aligned mode selection */
  #define TIMER_CTL0_ARSE         0x00000080	/*  auto-reload shadow enable */
  #define TIMER_CTL0_CKDIV        0x00000300	/*  clock division */
#define TOFF_TIMER_CTL1     0x0004		/* (RW) TIMER control register 1 */
  #define TIMER_CTL1_CCSE         0x00000001	/* commutation control shadow enable */
  #define TIMER_CTL1_CCUC         0x00000004	/* commutation control shadow register update control */
  #define TIMER_CTL1_DMAS         0x00000008	/* DMA request source selection */
  #define TIMER_CTL1_MMC          0x00000070	/* master mode control */
  #define TIMER_CTL1_TI0S         0x00000080	/* channel 0 trigger input selection(hall mode selection) */
  #define TIMER_CTL1_ISO0         0x00000100	/* idle state of channel 0 output */
  #define TIMER_CTL1_ISO0N        0x00000200	/* idle state of channel 0 complementary output */
  #define TIMER_CTL1_ISO1         0x00000400	/* idle state of channel 1 output */
  #define TIMER_CTL1_ISO1N        0x00000800	/* idle state of channel 1 complementary output */
  #define TIMER_CTL1_ISO2         0x00001000	/* idle state of channel 2 output */
  #define TIMER_CTL1_ISO2N        0x00002000	/* idle state of channel 2 complementary output */
  #define TIMER_CTL1_ISO3         0x00004000	/* idle state of channel 3 output */
#define TOFF_TIMER_SMCFG    0x0008		/* (RW) TIMER slave mode configuration register */
  #define TIMER_SMCFG_SMC         0x00000007	/* slave mode control */
  #define TIMER_SMCFG_TRGS        0x00000070	/* trigger selection */
  #define TIMER_SMCFG_MSM         0x00000080	/* master-slave mode */
  #define TIMER_SMCFG_ETFC        0x00000F00	/* external trigger filter control */
  #define TIMER_SMCFG_ETPSC       0x00003000	/* external trigger prescaler */
  #define TIMER_SMCFG_SMC1        0x00004000	/* part of SMC for enable external clock mode 1 */
  #define TIMER_SMCFG_ETP         0x00008000	/* external trigger polarity */
#define TOFF_TIMER_DMAINTEN 0x000C		/* (RW) TIMER DMA and interrupt enable register */
  #define TIMER_DMAINTEN_UPIE     0x00000001	/* update interrupt enable */
  #define TIMER_DMAINTEN_CH0IE    0x00000002	/* channel 0 capture/compare interrupt enable */
  #define TIMER_DMAINTEN_CH1IE    0x00000004	/* channel 1 capture/compare interrupt enable */
  #define TIMER_DMAINTEN_CH2IE    0x00000008	/* channel 2 capture/compare interrupt enable */
  #define TIMER_DMAINTEN_CH3IE    0x00000010	/* channel 3 capture/compare interrupt enable */
  #define TIMER_DMAINTEN_CMTIE    0x00000020	/* commutation interrupt request enable */
  #define TIMER_DMAINTEN_TRGIE    0x00000040	/* trigger interrupt enable */
  #define TIMER_DMAINTEN_BRKIE    0x00000080	/* break interrupt enable */
  #define TIMER_DMAINTEN_UPDEN    0x00000100	/* update DMA request enable */
  #define TIMER_DMAINTEN_CH0DEN   0x00000200	/* channel 0 capture/compare DMA request enable */
  #define TIMER_DMAINTEN_CH1DEN   0x00000400	/* channel 1 capture/compare DMA request enable */
  #define TIMER_DMAINTEN_CH2DEN   0x00000800	/* channel 2 capture/compare DMA request enable */
  #define TIMER_DMAINTEN_CH3DEN   0x00001000	/* channel 3 capture/compare DMA request enable */
  #define TIMER_DMAINTEN_CMTDEN   0x00002000	/* commutation DMA request enable */
  #define TIMER_DMAINTEN_TRGDEN   0x00004000	/* trigger DMA request enable */
#define TOFF_TIMER_INTF     0x0010		/* (RW) TIMER interrupt flag register */
  #define TIMER_INTF_UPIF         0x00000001	/* update interrupt flag */
  #define TIMER_INTF_CH0IF        0x00000002	/* channel 0 capture/compare interrupt flag */
  #define TIMER_INTF_CH1IF        0x00000004	/* channel 1 capture/compare interrupt flag */
  #define TIMER_INTF_CH2IF        0x00000008	/* channel 2 capture/compare interrupt flag */
  #define TIMER_INTF_CH3IF        0x00000010	/* channel 3 capture/compare interrupt flag */
  #define TIMER_INTF_CMTIF        0x00000020	/* channel commutation interrupt flag */
  #define TIMER_INTF_TRGIF        0x00000040	/* trigger interrupt flag */
  #define TIMER_INTF_BRKIF        0x00000080	/* break interrupt flag */
  #define TIMER_INTF_CH0OF        0x00000200	/* channel 0 over capture flag */
  #define TIMER_INTF_CH1OF        0x00000400	/* channel 1 over capture flag */
  #define TIMER_INTF_CH2OF        0x00000800	/* channel 2 over capture flag */
  #define TIMER_INTF_CH3OF        0x00001000	/* channel 3 over capture flag */
#define TOFF_TIMER_SWEVG    0x0014		/* (RW) TIMER software event generation register */
  #define TIMER_SWEVG_UPG         0x00000001	/* update event generate */
  #define TIMER_SWEVG_CH0G        0x00000002	/* channel 0 capture or compare event generation */
  #define TIMER_SWEVG_CH1G        0x00000004	/* channel 1 capture or compare event generation */
  #define TIMER_SWEVG_CH2G        0x00000008	/* channel 2 capture or compare event generation */
  #define TIMER_SWEVG_CH3G        0x00000010	/* channel 3 capture or compare event generation */
  #define TIMER_SWEVG_CMTG        0x00000020	/* channel commutation event generation */
  #define TIMER_SWEVG_TRGG        0x00000040	/* trigger event generation */
  #define TIMER_SWEVG_BRKG        0x00000080	/* break event generation */
#define TOFF_TIMER_CHCTL0   0x0018		/* (RW) TIMER channel control register 0 */
  /* output compare mode */
  #define TIMER_CHCTL0_CH0MS      0x00000003	/* channel 0 mode selection */
  #define TIMER_CHCTL0_CH0COMFEN  0x00000004	/* channel 0 output compare fast enable */
  #define TIMER_CHCTL0_CH0COMSEN  0x00000008	/* channel 0 output compare shadow enable */
  #define TIMER_CHCTL0_CH0COMCTL  0x00000070	/* channel 0 output compare control  */
  #define TIMER_CHCTL0_CH0COMCEN  0x00000080	/* channel 0 output compare clear enable */
  #define TIMER_CHCTL0_CH1MS      0x00000300	/* channel 1 mode selection */
  #define TIMER_CHCTL0_CH1COMFEN  0x00000400	/* channel 1 output compare fast enable */
  #define TIMER_CHCTL0_CH1COMSEN  0x00000800	/* channel 1 output compare shadow enable */
  #define TIMER_CHCTL0_CH1COMCTL  0x00007000	/* channel 1 output compare control  */
  #define TIMER_CHCTL0_CH1COMCEN  0x00008000	/* channel 1 output compare clear enable */
  /* input capture mode */
  #define TIMER_CHCTL0_CH0CAPPSC  0x0000000E	/* channel 0 input capture prescaler */
  #define TIMER_CHCTL0_CH0CAPFLT  0x000000F0	/* channel 0 input capture filter control */
  #define TIMER_CHCTL0_CH1CAPPSC  0x00000C00	/* channel 1 input capture prescaler */
  #define TIMER_CHCTL0_CH1CAPFLT  0x0000F000	/* channel 1 input capture filter control */
#define TOFF_TIMER_CHCTL1   0x001C		/* (RW) TIMER channel control register 1 */
  /* output compare mode */
  #define TIMER_CHCTL1_CH2MS      0x00000003	/* channel 2 mode selection */
  #define TIMER_CHCTL1_CH2COMFEN  0x00000004	/* channel 2 output compare fast enable */
  #define TIMER_CHCTL1_CH2COMSEN  0x00000008	/* channel 2 output compare shadow enable */
  #define TIMER_CHCTL1_CH2COMCTL  0x00000070	/* channel 2 output compare control */
  #define TIMER_CHCTL1_CH2COMCEN  0x00000080	/* channel 2 output compare clear enable */
  #define TIMER_CHCTL1_CH3MS      0x00000300	/* channel 3 mode selection */
  #define TIMER_CHCTL1_CH3COMFEN  0x00000400	/* channel 3 output compare fast enable */
  #define TIMER_CHCTL1_CH3COMSEN  0x00000800	/* channel 3 output compare shadow enable */
  #define TIMER_CHCTL1_CH3COMCTL  0x00007000	/* channel 3 output compare control */
  #define TIMER_CHCTL1_CH3COMCEN  0x00008000	/* channel 3 output compare clear enable */
  /* input capture mode */
  #define TIMER_CHCTL1_CH2CAPPSC  0x0000000C	/* channel 2 input capture prescaler */
  #define TIMER_CHCTL1_CH2CAPFLT  0x000000F0	/* channel 2 input capture filter control */
  #define TIMER_CHCTL1_CH3CAPPSC  0x00000C00	/* channel 3 input capture prescaler */
  #define TIMER_CHCTL1_CH3CAPFLT  0x0000F000	/* channel 3 input capture filter control */
#define TOFF_TIMER_CHCTL2   0x0020		/* (RW) TIMER channel control register 2 */
  #define TIMER_CHCTL2_CH0EN      0x00000001	/* channel 0 capture/compare function enable */
  #define TIMER_CHCTL2_CH0P       0x00000002	/* channel 0 capture/compare function polarity */
  #define TIMER_CHCTL2_CH0NEN     0x00000004	/* channel 0 complementary output enable */
  #define TIMER_CHCTL2_CH0NP      0x00000008	/* channel 0 complementary output polarity */
  #define TIMER_CHCTL2_CH1EN      0x00000010	/* channel 1 capture/compare function enable  */
  #define TIMER_CHCTL2_CH1P       0x00000020	/* channel 1 capture/compare function polarity */
  #define TIMER_CHCTL2_CH1NEN     0x00000040	/* channel 1 complementary output enable */
  #define TIMER_CHCTL2_CH1NP      0x00000080	/* channel 1 complementary output polarity */
  #define TIMER_CHCTL2_CH2EN      0x00000100	/* channel 2 capture/compare function enable  */
  #define TIMER_CHCTL2_CH2P       0x00000200	/* channel 2 capture/compare function polarity */
  #define TIMER_CHCTL2_CH2NEN     0x00000400	/* channel 2 complementary output enable */
  #define TIMER_CHCTL2_CH2NP      0x00000800	/* channel 2 complementary output polarity */
  #define TIMER_CHCTL2_CH3EN      0x00001000	/* channel 3 capture/compare function enable  */
  #define TIMER_CHCTL2_CH3P       0x00002000	/* channel 3 capture/compare function polarity */
#define TOFF_TIMER_CNT      0x0024		/* (RW) TIMER counter register */
#define TOFF_TIMER_PSC      0x0028		/* (RW) TIMER prescaler register */
#define TOFF_TIMER_CAR      0x002C		/* (RW) TIMER counter auto reload register */
#define TOFF_TIMER_CREP     0x0030		/* (RW) TIMER counter repetition register */
#define TOFF_TIMER_CH0CV    0x0034		/* (RW) TIMER channel 0 capture/compare value register */
#define TOFF_TIMER_CH1CV    0x0038		/* (RW) TIMER channel 1 capture/compare value register */
#define TOFF_TIMER_CH2CV    0x003C		/* (RW) TIMER channel 2 capture/compare value register */
#define TOFF_TIMER_CH3CV    0x0040		/* (RW) TIMER channel 3 capture/compare value register */
#define TOFF_TIMER_CCHP     0x0044		/* (RW) TIMER channel complementary protection register */
  #define TIMER_CCHP_DTCFG        0x000000FF	/* dead time configure */
  #define TIMER_CCHP_PROT         0x00000300	/* complementary register protect control */
  #define TIMER_CCHP_IOS          0x00000400	/* idle mode off-state configure */
  #define TIMER_CCHP_ROS          0x00000800	/* run mode off-state configure */
  #define TIMER_CCHP_BRKEN        0x00001000	/* break enable */
  #define TIMER_CCHP_BRKP         0x00002000	/* break polarity */
  #define TIMER_CCHP_OAEN         0x00004000	/* output automatic enable */
  #define TIMER_CCHP_POEN         0x00008000	/* primary output enable */
#define TOFF_TIMER_DMACFG   0x0048		/* (RW) TIMER DMA configuration register */
  #define TIMER_DMACFG_DMATA      0x0000001F	/* DMA transfer access start address */
  #define TIMER_DMACFG_DMATC      0x00001F00	/* DMA transfer count */
#define TOFF_TIMER_DMATB    0x004C		/* (RW) TIMER DMA transfer buffer register */


/*
 *  RTC
 */
#define TADR_RTC_BASE       RTC_BASE
#define TOFF_RTC_INTEN      0x0000		/* (RW) interrupt enable register */
  #define RTC_INTEN_SCIE        0x00000001	/* second interrupt enable */
  #define RTC_INTEN_ALRMIE      0x00000002	/* alarm interrupt enable */
  #define RTC_INTEN_OVIE        0x00000004	/* overflow interrupt enable */
#define TOFF_RTC_CTL        0x0004		/* (RW) control register */
  #define RTC_CTL_SCIF          0x00000001	/* second interrupt flag */
  #define RTC_CTL_ALRMIF        0x00000002	/* alarm interrupt flag */
  #define RTC_CTL_OVIF          0x00000004	/* overflow interrupt flag */
  #define RTC_CTL_RSYNF         0x00000008	/* registers synchronized flag */
  #define RTC_CTL_CMF           0x00000010	/* configuration mode flag */
  #define RTC_CTL_LWOFF         0x00000020	/* last write operation finished flag */
#define TOFF_RTC_PSCH       0x0008		/* (RW) prescaler high register */
  #define RTC_PSCH_PSC          0x0000000F	/* prescaler high value */
#define TOFF_RTC_PSCL       0x000C		/* (RW) prescaler low register */
  #define RTC_PSCL_PSC          0x0000FFFF	/* prescaler low value */
#define TOFF_RTC_DIVH       0x0010		/* (RW) divider high register */
  #define RTC_DIVH_DIV          0x0000000F	/* divider high value */
#define TOFF_RTC_DIVL       0x0014		/* (RW) divider low register */
  #define RTC_DIVL_DIV          0x0000FFFF	/* divider low value */
#define TOFF_RTC_CNTH       0x0018		/* (RW) counter high register */
  #define RTC_CNTH_CNT          0x0000FFFF	/* counter high value */
#define TOFF_RTC_CNTL       0x001C		/* (RW) counter low register */
  #define RTC_CNTL_CNT          0x0000FFFF	/* counter low value */
#define TOFF_RTC_ALRMH      0x0020		/* (RW) alarm high register */
  #define RTC_ALRMH_ALRM        0x0000FFFF	/* alarm high value */
#define TOFF_RTC_ALRML      0x0024		/* (RW) alarm low register */
  #define RTC_ALRML_ALRM        0x0000FFFF	/* alarm low value */


/*
 *  WWDGT
 */
#define TADR_WWDGT_BASE     WWDGT_BASE
#define TOFF_WWDGT_CTL      0x0000		/* (RW) WWDGT control register */
  #define WWDGT_CTL_CNT         0x0000007F	/* WWDGT counter value */
  #define WWDGT_CTL_WDGTEN      0x00000080	/* WWDGT counter enable */
#define TOFF_WWDGT_CFG      0x0004		/* (RW) WWDGT configuration register */
  #define WWDGT_CFG_WIN         0x0000007F	/* WWDGT counter window value */
  #define WWDGT_CFG_PSC         0x00000180	/* WWDGT prescaler divider value */
  #define WWDGT_CFG_EWIE        0x00000200	/* early wakeup interrupt enable */
#define TOFF_WWDGT_STAT     0x0008		/* (RW) WWDGT status register */
  #define WWDGT_STAT_EWIF       0x00000001	/* early wakeup interrupt flag */


/*
 *  FWDGT
 */
#define TADR_FWDGT_BASE     FWDGT_BASE
#define TOFF_FWDGT_CTL      0x0000		/* (RW) FWDGT control register */
  #define FWDGT_CTL_CMD         0x0000FFFF	/* FWDGT command value */
#define TOFF_FWDGT_PSC      0x0004		/* (RW) FWDGT prescaler register */
  #define FWDGT_PSC_PSC         0x00000007	/* FWDGT prescaler divider value */
#define TOFF_FWDGT_RLD      0x0008		/* (RW) FWDGT reload register */
  #define FWDGT_RLD_RLD         0x00000FFF	/* FWDGT counter reload value */
#define TOFF_FWDGT_STAT     0x000C		/* (RW) FWDGT status register */
  #define FWDGT_STAT_PUD        0x00000001	/* FWDGT prescaler divider value update */
  #define FWDGT_STAT_RUD        0x00000002	/* FWDGT counter reload value update */


/*
 *  SPI
 */
#define TADR_SPI0_BASE      (SPI_BASE + 0x0000F800U)
#define TADR_SPI1_BASE      SPI_BASE
#define TADR_SPI2_BASE      (SPI_BASE + 0x00000400U)
#define TOFF_SPI_CTL0       0x0000		/* (RW) SPI control register 0 */
  #define SPI_CTL0_CKPH         0x00000001	/* clock phase selection*/
  #define SPI_CTL0_CKPL         0x00000002	/* clock polarity selection */
  #define SPI_CTL0_MSTMOD       0x00000004	/* master mode enable */
  #define SPI_CTL0_PSC          0x00000038	/* master clock prescaler selection */
  #define SPI_CTL0_SPIEN        0x00000040	/* SPI enable*/
  #define SPI_CTL0_LF           0x00000080	/* LSB first mode */
  #define SPI_CTL0_SWNSS        0x00000100	/* NSS pin selection in NSS software mode */
  #define SPI_CTL0_SWNSSEN      0x00000200	/* NSS software mode selection */
  #define SPI_CTL0_RO           0x00000400	/* receive only */
  #define SPI_CTL0_FF16         0x00000800	/* data frame size */
  #define SPI_CTL0_CRCNT        0x00001000	/* CRC next transfer */
  #define SPI_CTL0_CRCEN        0x00002000	/* CRC calculation enable */
  #define SPI_CTL0_BDOEN        0x00004000	/* bidirectional transmit output enable*/
  #define SPI_CTL0_BDEN         0x00008000	/* bidirectional enable */
#define TOFF_SPI_CTL1       0x0004		/* (RW) SPI control register 1*/
  #define SPI_CTL1_DMAREN       0x00000001	/* receive buffer dma enable */
  #define SPI_CTL1_DMATEN       0x00000002	/* transmit buffer dma enable */
  #define SPI_CTL1_NSSDRV       0x00000004	/* drive NSS output */
  #define SPI_CTL1_NSSP         0x00000008	/* SPI NSS pulse mode enable */
  #define SPI_CTL1_TMOD         0x00000010	/* SPI TI mode enable */
  #define SPI_CTL1_ERRIE        0x00000020	/* errors interrupt enable */
  #define SPI_CTL1_RBNEIE       0x00000040	/* receive buffer not empty interrupt enable */
  #define SPI_CTL1_TBEIE        0x00000080	/* transmit buffer empty interrupt enable */
#define TOFF_SPI_STAT       0x0008		/* (RW) SPI status register */
  #define SPI_STAT_RBNE         0x00000001	/* receive buffer not empty */
  #define SPI_STAT_TBE          0x00000002	/* transmit buffer empty */
  #define SPI_STAT_I2SCH        0x00000004	/* I2S channel side */
  #define SPI_STAT_TXURERR      0x00000008	/* I2S transmission underrun error bit */
  #define SPI_STAT_CRCERR       0x00000010	/* SPI CRC error bit */
  #define SPI_STAT_CONFERR      0x00000020	/* SPI configuration error bit */
  #define SPI_STAT_RXORERR      0x00000040	/* SPI reception overrun error bit */
  #define SPI_STAT_TRANS        0x00000080	/* transmitting on-going bit */
  #define SPI_STAT_FERR         0x00000100	/* format error bit */
#define TOFF_SPI_DATA       0x000C		/* (RW) SPI data register */
  #define SPI_DATA_DATA         0x0000FFFF	/* data transfer register */
#define TOFF_SPI_CRCPOLY    0x0010		/* (RW) SPI CRC polynomial register */
  #define SPI_CRCPOLY_CRCPOLY   0x0000FFFF	/* CRC polynomial value */
#define TOFF_SPI_RCRC       0x0014		/* (RW) SPI receive CRC register */
  #define SPI_RCRC_RCRC         0x0000FFFF	/* RX CRC value */
#define TOFF_SPI_TCRC       0x0018		/* (RW) SPI transmit CRC register */
  #define SPI_TCRC_TCRC         0x0000FFFF	/* TX CRC value */
#define TOFF_SPI_I2SCTL     0x001C		/* (RW) SPI I2S control register */
  #define SPI_I2SCTL_CHLEN      0x00000001	/* channel length */
  #define SPI_I2SCTL_DTLEN      0x00000006	/* data length */
  #define SPI_I2SCTL_CKPL       0x00000008	/* idle state clock polarity */
  #define SPI_I2SCTL_I2SSTD     0x00000030	/* I2S standard selection */
  #define SPI_I2SCTL_PCMSMOD    0x00000080	/* PCM frame synchronization mode */
  #define SPI_I2SCTL_I2SOPMOD   0x00000300	/* I2S operation mode */
  #define SPI_I2SCTL_I2SEN      0x00000400	/* I2S enable */
  #define SPI_I2SCTL_I2SSEL     0x00000800	/* I2S mode selection */
#define TOFF_SPI_I2SPSC     0x0020		/* (RW) SPI I2S clock prescaler register */
  #define SPI_I2SPSC_DIV        0x000000FF	/* dividing factor for the prescaler */
  #define SPI_I2SPSC_OF         0x00000100	/* odd factor for the prescaler */
  #define SPI_I2SPSC_MCKOEN     0x00000200	/* I2S MCK output enable */


/*
 *  UART
 */
#define TADR_USART0_BASE    (USART_BASE+0xF400U)
#define TADR_USART1_BASE    USART_BASE
#define TADR_USART2_BASE    (USART_BASE+0x0400U)
#define TADR_UART3_BASE     (USART_BASE+0x0800U)
#define TADR_UART4_BASE     (USART_BASE+0x0C00U)
#define TOFF_USART_STAT     0x0000		/* (RW) USART status register */
  #define USART_STAT_PERR       0x00000001	/* parity error flag */
  #define USART_STAT_FERR       0x00000002	/* frame error flag */
  #define USART_STAT_NERR       0x00000004	/* noise error flag */
  #define USART_STAT_ORERR      0x00000008	/* overrun error */
  #define USART_STAT_IDLEF      0x00000010	/* IDLE frame detected flag */
  #define USART_STAT_RBNE       0x00000020	/* read data buffer not empty */
  #define USART_STAT_TC         0x00000040	/* transmission complete */
  #define USART_STAT_TBE        0x00000080	/* transmit data buffer empty */
  #define USART_STAT_LBDF       0x00000100	/* LIN break detected flag */
  #define USART_STAT_CTSF       0x00000200	/* CTS change flag */
#define TOFF_USART_DATA     0x0004		/* (RW) USART data register */
#define TOFF_USART_BAUD     0x0008		/* (RW) USART baud rate register */
  #define USART_BAUD_FRADIV     0x0000000F	/* fraction part of baud-rate divider */
  #define USART_BAUD_INTDIV     0x0000FFF0	/* integer part of baud-rate divider */
#define TOFF_USART_CTL0     0x000C		/* (RW) USART control register 0 */
  #define USART_CTL0_SBKCMD     0x00000001	/* send break command */
  #define USART_CTL0_RWU        0x00000002	/* receiver wakeup from mute mode */
  #define USART_CTL0_REN        0x00000004	/* receiver enable */
  #define USART_CTL0_TEN        0x00000008	/* transmitter enable */
  #define USART_CTL0_IDLEIE     0x00000010	/* idle line detected interrupt enable */
  #define USART_CTL0_RBNEIE     0x00000020	/* read data buffer not empty interrupt and overrun error interrupt enable */
  #define USART_CTL0_TCIE       0x00000040	/* transmission complete interrupt enable */
  #define USART_CTL0_TBEIE      0x00000080	/* transmitter buffer empty interrupt enable */
  #define USART_CTL0_PERRIE     0x00000100	/* parity error interrupt enable */
  #define USART_CTL0_PM         0x00000200	/* parity mode */
  #define USART_CTL0_PCEN       0x00000400	/* parity check function enable */
  #define USART_CTL0_WM         0x00000800	/* wakeup method in mute mode */
  #define USART_CTL0_WL         0x00001000	/* word length */
  #define USART_CTL0_UEN        0x00002000	/* USART enable */
#define TOFF_USART_CTL1     0x0010		/* (RW) USART control register 1 */
  #define USART_CTL1_ADDR       0x0000000F	/* address of USART */
  #define USART_CTL1_LBLEN      0x00000020	/* LIN break frame length */
  #define USART_CTL1_LBDIE      0x00000040	/* LIN break detected interrupt eanble */
  #define USART_CTL1_CLEN       0x00000100	/* CK length */
  #define USART_CTL1_CPH        0x00000200	/* CK phase */
  #define USART_CTL1_CPL        0x00000400	/* CK polarity */
  #define USART_CTL1_CKEN       0x00000800	/* CK pin enable */
  #define USART_CTL1_STB        0x00003000	/* STOP bits length */
  #define USART_CTL1_STB_0      0x00001000
  #define USART_CTL1_STB_1      0x00002000
  #define USART_CTL1_LMEN       0x00004000	/* LIN mode enable */
#define TOFF_USART_CTL2     0x0014		/* (RW) USART control register 2 */
  #define USART_CTL2_ERRIE      0x00000001	/* error interrupt enable */
  #define USART_CTL2_IREN       0x00000002	/* IrDA mode enable */
  #define USART_CTL2_IRLP       0x00000004	/* IrDA low-power */
  #define USART_CTL2_HDEN       0x00000008	/* half-duplex enable */
  #define USART_CTL2_NKEN       0x00000010	/* NACK enable in smartcard mode */
  #define USART_CTL2_SCEN       0x00000020	/* smartcard mode enable */
  #define USART_CTL2_DENR       0x00000040	/* DMA request enable for reception */
  #define USART_CTL2_DENT       0x00000080	/* DMA request enable for transmission */
  #define USART_CTL2_RTSEN      0x00000100	/* RTS enable */
  #define USART_CTL2_CTSEN      0x00000200	/* CTS enable */
  #define USART_CTL2_CTSIE      0x00000400	/* CTS interrupt enable */
#define TOFF_USART_GP       0x0018		/* (RW) USART guard time and prescaler register */
  #define USART_GP_PSC          0x000000FF	/* prescaler value for dividing the system clock */
  #define USART_GP_GUAT         0x0000FF00	/* guard time value in smartcard mode */


/*
 *  I2C
 */
#define TADR_I2C0_BASE      I2C_BASE
#define TADR_I2C1_BASE      (I2C_BASE + 0x00000400U)
#define TOFF_I2C_CTL0       0x0000		/* (RW) I2C control register 0 */
  #define I2C_CTL0_I2CEN        0x00000001	/* peripheral enable */
  #define I2C_CTL0_SMBEN        0x00000002	/* SMBus mode */
  #define I2C_CTL0_SMBSEL       0x00000008	/* SMBus type */
  #define I2C_CTL0_ARPEN        0x00000010	/* ARP enable */
  #define I2C_CTL0_PECEN        0x00000020	/* PEC enable */
  #define I2C_CTL0_GCEN         0x00000040	/* general call enable */
  #define I2C_CTL0_SS           0x00000080	/* clock stretching disable (slave mode) */
  #define I2C_CTL0_START        0x00000100	/* start generation */
  #define I2C_CTL0_STOP         0x00000200	/* stop generation */
  #define I2C_CTL0_ACKEN        0x00000400	/* acknowledge enable */
  #define I2C_CTL0_POAP         0x00000800	/* acknowledge/PEC position (for data reception) */
  #define I2C_CTL0_PECTRANS     0x00001000	/* packet error checking */
  #define I2C_CTL0_SALT         0x00002000	/* SMBus alert */
  #define I2C_CTL0_SRESET       0x00008000	/* software reset */
#define TOFF_I2C_CTL1       0x0004		/* (RW) I2C control register 1 */
  #define I2C_CTL1_I2CCLK       0x0000003F	/* I2CCLK[5:0] bits (peripheral clock frequency) */
  #define I2C_CTL1_ERRIE        0x00000100	/* error interrupt enable */
  #define I2C_CTL1_EVIE         0x00000200	/* event interrupt enable */
  #define I2C_CTL1_BUFIE        0x00000400	/* buffer interrupt enable */
  #define I2C_CTL1_DMAON        0x00000800	/* DMA requests enable */
  #define I2C_CTL1_DMALST       0x00001000	/* DMA last transfer */
#define TOFF_I2C_SADDR0     0x0008		/* (RW) I2C slave address register 0 */
  #define I2C_SADDR0_ADDRESS0   0x00000001	/* bit 0 of a 10-bit address */
  #define I2C_SADDR0_ADDRESS    0x000000FE	/* 7-bit address or bits 7:1 of a 10-bit address */
  #define I2C_SADDR0_ADDRESS_H  0x00000300	/* highest two bits of a 10-bit address */
  #define I2C_SADDR0_ADDFORMAT  0x00008000	/* address mode for the I2C slave */
#define TOFF_I2C_SADDR1     0x000C		/* (RW) I2C slave address register */
  #define I2C_SADDR1_DUADEN     0x00000001	/* aual-address mode switch */
  #define I2C_SADDR1_ADDRESS2   0x000000FE	/* second I2C address for the slave in dual-address mode */
#define TOFF_I2C_DATA       0x0010		/* (RW) I2C transfer buffer register */
  #define I2C_DATA_TRB          0x000000FF	/* 8-bit data register */
#define TOFF_I2C_STAT0      0x0014		/* (RW) I2C transfer status register 0 */
  #define I2C_STAT0_SBSEND      0x00000001	/* start bit (master mode) */
  #define I2C_STAT0_ADDSEND     0x00000002	/* address sent (master mode)/matched (slave mode) */
  #define I2C_STAT0_BTC         0x00000004	/* byte transfer finished */
  #define I2C_STAT0_ADD10SEND   0x00000008	/* 10-bit header sent (master mode) */
  #define I2C_STAT0_STPDET      0x00000010	/* stop detection (slave mode) */
  #define I2C_STAT0_RBNE        0x00000040	/* data register not empty (receivers) */
  #define I2C_STAT0_TBE         0x00000080	/* data register empty (transmitters) */
  #define I2C_STAT0_BERR        0x00000100	/* bus error */
  #define I2C_STAT0_LOSTARB     0x00000200	/* arbitration lost (master mode) */
  #define I2C_STAT0_AERR        0x00000400	/* acknowledge failure */
  #define I2C_STAT0_OUERR       0x00000800	/* overrun/underrun */
  #define I2C_STAT0_PECERR      0x00001000	/* PEC error in reception */
  #define I2C_STAT0_SMBTO       0x00004000	/* timeout signal in SMBus mode */
  #define I2C_STAT0_SMBALT      0x00008000	/* SMBus alert status */
#define TOFF_I2C_STAT1      0x0018		/* (RW) I2C transfer status register */
  #define I2C_STAT1_MASTER      0x00000001	/* master/slave */
  #define I2C_STAT1_I2CBSY      0x00000002	/* bus busy */
  #define I2C_STAT1_TR          0x00000004	/* transmitter/receiver */
  #define I2C_STAT1_RXGC        0x00000010	/* general call address (slave mode) */
  #define I2C_STAT1_DEFSMB      0x00000020	/* SMBus device default address (slave mode) */
  #define I2C_STAT1_HSTSMB      0x00000040	/* SMBus host header (slave mode) */
  #define I2C_STAT1_DUMODF      0x00000080	/* dual flag (slave mode) */
  #define I2C_STAT1_PECV        0x0000FF00	/* packet error checking value */
#define TOFF_I2C_CKCFG      0x001C		/* (RW) I2C clock configure register */
  #define I2C_CKCFG_CLKC        0x00000FFF	/* clock control register in fast/standard mode (master mode) */
  #define I2C_CKCFG_DTCY        0x00004000	/* fast mode duty cycle */
  #define I2C_CKCFG_FAST        0x00008000	/* I2C speed selection in master mode */
#define TOFF_I2C_RT         0x0020		/* (RW) I2C rise time register */
  #define I2C_RT_RISETIME       0x0000003F	/* maximum rise time in fast/standard mode (Master mode) */


/*
 *  CAN
 */
#define TADR_CAN0_BASE      CAN_BASE
#define TADR_CAN1_BASE      (CAN_BASE + 0x00000400U)
#define TOFF_CAN_CTL        0x0000		/* (RW) CAN control register */
  #define CAN_CTL_IWMOD         0x00000001	/* initial working mode */
  #define CAN_CTL_SLPWMOD       0x00000002	/* sleep working mode */
  #define CAN_CTL_TFO           0x00000004	/* transmit FIFO order */
  #define CAN_CTL_RFOD          0x00000008	/* receive FIFO overwrite disable */
  #define CAN_CTL_ARD           0x00000010	/* automatic retransmission disable */
  #define CAN_CTL_AWU           0x00000020	/* automatic wakeup */
  #define CAN_CTL_ABOR          0x00000040	/* automatic bus-off recovery */
  #define CAN_CTL_TTC           0x00000080	/* time triggered communication */
  #define CAN_CTL_SWRST         0x00008000	/* CAN software reset */
  #define CAN_CTL_DFZ           0x00010000	/* CAN debug freeze */
#define TOFF_CAN_STAT       0x0004		/* (RW) CAN status register */
  #define CAN_STAT_IWS          0x00000001	/* initial working state */
  #define CAN_STAT_SLPWS        0x00000002	/* sleep working state */
  #define CAN_STAT_ERRIF        0x00000004	/* error interrupt flag*/
  #define CAN_STAT_WUIF         0x00000008	/* status change interrupt flag of wakeup from sleep working mode */
  #define CAN_STAT_SLPIF        0x00000010	/* status change interrupt flag of sleep working mode entering */
  #define CAN_STAT_TS           0x00000100	/* transmitting state */
  #define CAN_STAT_RS           0x00000200	/* receiving state */
  #define CAN_STAT_LASTRX       0x00000400	/* last sample value of rx pin */
  #define CAN_STAT_RXL          0x00000800	/* CAN rx signal */
#define TOFF_CAN_TSTAT      0x0008		/* (RW) CAN transmit status register*/
  #define CAN_TSTAT_MTF0        0x00000001	/* mailbox0 transmit finished */
  #define CAN_TSTAT_MTFNERR0    0x00000002	/* mailbox0 transmit finished and no error */
  #define CAN_TSTAT_MAL0        0x00000004	/* mailbox0 arbitration lost */
  #define CAN_TSTAT_MTE0        0x00000008	/* mailbox0 transmit error */
  #define CAN_TSTAT_MST0        0x00000080	/* mailbox0 stop transmitting */
  #define CAN_TSTAT_MTF1        0x00000100	/* mailbox1 transmit finished */
  #define CAN_TSTAT_MTFNERR1    0x00000200	/* mailbox1 transmit finished and no error */
  #define CAN_TSTAT_MAL1        0x00000400	/* mailbox1 arbitration lost */
  #define CAN_TSTAT_MTE1        0x00000800	/* mailbox1 transmit error */
  #define CAN_TSTAT_MST1        0x00008000	/* mailbox1 stop transmitting */
  #define CAN_TSTAT_MTF2        0x00010000	/* mailbox2 transmit finished */
  #define CAN_TSTAT_MTFNERR2    0x00020000	/* mailbox2 transmit finished and no error */
  #define CAN_TSTAT_MAL2        0x00040000	/* mailbox2 arbitration lost */
  #define CAN_TSTAT_MTE2        0x00080000	/* mailbox2 transmit error */
  #define CAN_TSTAT_MST2        0x00800000	/* mailbox2 stop transmitting */
  #define CAN_TSTAT_NUM         0x03000000	/* mailbox number */
  #define CAN_TSTAT_TME0        0x04000000	/* transmit mailbox0 empty */
  #define CAN_TSTAT_TME1        0x08000000	/* transmit mailbox1 empty */
  #define CAN_TSTAT_TME2        0x10000000	/* transmit mailbox2 empty */
  #define CAN_TSTAT_TMLS0       0x20000000	/* last sending priority flag for mailbox0 */
  #define CAN_TSTAT_TMLS1       0x40000000	/* last sending priority flag for mailbox1 */
  #define CAN_TSTAT_TMLS2       0x80000000	/* last sending priority flag for mailbox2 */
#define TOFF_CAN_RFIFO0     0x000C		/* (RW) CAN receive FIFO0 register */
  #define CAN_RFIFO0_RFL0       0x00000003	/* receive FIFO0 length */
  #define CAN_RFIFO0_RFF0       0x00000008	/* receive FIFO0 full */
  #define CAN_RFIFO0_RFO0       0x00000010	/* receive FIFO0 overfull */
  #define CAN_RFIFO0_RFD0       0x00000020	/* receive FIFO0 dequeue */
#define TOFF_CAN_RFIFO1     0x0010		/* (RW) CAN receive FIFO1 register */
  #define CAN_RFIFO1_RFL1       0x00000003	/* receive FIFO1 length */
  #define CAN_RFIFO1_RFF1       0x00000008	/* receive FIFO1 full */
  #define CAN_RFIFO1_RFO1       0x00000010	/* receive FIFO1 overfull */
  #define CAN_RFIFO1_RFD1       0x00000020	/* receive FIFO1 dequeue */
#define TOFF_CAN_INTEN      0x0014		/* (RW) CAN interrupt enable register */
  #define CAN_INTEN_TMEIE       0x00000001	/* transmit mailbox empty interrupt enable */
  #define CAN_INTEN_RFNEIE0     0x00000002	/* receive FIFO0 not empty interrupt enable */
  #define CAN_INTEN_RFFIE0      0x00000004	/* receive FIFO0 full interrupt enable */
  #define CAN_INTEN_RFOIE0      0x00000008	/* receive FIFO0 overfull interrupt enable */
  #define CAN_INTEN_RFNEIE1     0x00000010	/* receive FIFO1 not empty interrupt enable */
  #define CAN_INTEN_RFFIE1      0x00000020	/* receive FIFO1 full interrupt enable */
  #define CAN_INTEN_RFOIE1      0x00000040	/* receive FIFO1 overfull interrupt enable */
  #define CAN_INTEN_WERRIE      0x00000100	/* warning error interrupt enable */
  #define CAN_INTEN_PERRIE      0x00000200	/* passive error interrupt enable */
  #define CAN_INTEN_BOIE        0x00000400	/* bus-off interrupt enable */
  #define CAN_INTEN_ERRNIE      0x00000800	/* error number interrupt enable */
  #define CAN_INTEN_ERRIE       0x00008000	/* error interrupt enable */
  #define CAN_INTEN_WIE         0x00010000	/* wakeup interrupt enable */
  #define CAN_INTEN_SLPWIE      0x00020000	/* sleep working interrupt enable */
#define TOFF_CAN_ERR        0x0018		/* (RW) CAN error register */
  #define CAN_ERR_WERR          0x00000001	/* warning error */
  #define CAN_ERR_PERR          0x00000002	/* passive error */
  #define CAN_ERR_BOERR         0x00000004	/* bus-off error */
  #define CAN_ERR_ERRN          0x00000070	/* error number */
  #define CAN_ERR_TECNT         0x00FF0000	/* transmit error count */
  #define CAN_ERR_RECNT         0xFF000000	/* receive error count */
#define TOFF_CAN_BT         0x001C		/* (RW) CAN bit timing register */
  #define CAN_BT_BAUDPSC        0x000001FF	/* baudrate prescaler */
  #define CAN_BT_BS1            0x000F0000	/* bit segment 1 */
  #define CAN_BT_BS2            0x00700000	/* bit segment 2 */
  #define CAN_BT_SJW            0x03000000	/* resynchronization jump width */
  #define CAN_BT_LCMOD          0x40000000	/* loopback communication mode */
  #define CAN_BT_SCMOD          0x80000000	/* silent communication mode */
#define TOFF_CAN_TMI0       0x0180		/* (RW) CAN transmit mailbox0 identifier register */
  #define CAN_TMI_TEN           0x00000001	/* transmit enable */
  #define CAN_TMI_FT            0x00000002	/* frame type */
  #define CAN_TMI_FF            0x00000004	/* frame format */
  #define CAN_TMI_EFID          0x001FFFC   /* the frame identifier */
  #define CAN_TMI_SFID          0xFFE0000	/* the frame identifier */
#define TOFF_CAN_TMP0       0x0184		/* (RW) CAN transmit mailbox0 property register */
  #define CAN_TMP_DLENC         0x0000000F	/* data length code */
  #define CAN_TMP_TSEN          0x00000100	/* time stamp enable */
  #define CAN_TMP_TS            0xFFFF0000	/* time stamp */
#define TOFF_CAN_TMDATA00   0x0188		/* (RW) CAN transmit mailbox0 data0 register */
  #define CAN_TMDATA0_DB0       0x000000FF	/* transmit data byte 0 */
  #define CAN_TMDATA0_DB1       0x0000FF00	/* transmit data byte 1 */
  #define CAN_TMDATA0_DB2       0x00FF0000	/* transmit data byte 2 */
  #define CAN_TMDATA0_DB3       0xFF000000	/* transmit data byte 3 */
#define TOFF_CAN_TMDATA10   0x018C		/* (RW) CAN transmit mailbox0 data1 register */
  #define CAN_TMDATA1_DB4       0x000000FF	/* transmit data byte 4 */
  #define CAN_TMDATA1_DB5       0x0000FF00	/* transmit data byte 5 */
  #define CAN_TMDATA1_DB6       0x00FF0000	/* transmit data byte 6 */
  #define CAN_TMDATA1_DB7       0xFF000000	/* transmit data byte 7 */
#define TOFF_CAN_TMI1       0x0190		/* (RW) CAN transmit mailbox1 identifier register */
#define TOFF_CAN_TMP1       0x0194		/* (RW) CAN transmit mailbox1 property register */
#define TOFF_CAN_TMDATA01   0x0198		/* (RW) CAN transmit mailbox1 data0 register */
#define TOFF_CAN_TMDATA11   0x019C		/* (RW) CAN transmit mailbox1 data1 register */
#define TOFF_CAN_TMI2       0x01A0		/* (RW) CAN transmit mailbox2 identifier register */
#define TOFF_CAN_TMP2       0x01A4		/* (RW) CAN transmit mailbox2 property register */
#define TOFF_CAN_TMDATA02   0x01A8		/* (RW) CAN transmit mailbox2 data0 register */
#define TOFF_CAN_TMDATA12   0x01AC		/* (RW) CAN transmit mailbox2 data1 register */
#define TOFF_CAN_RFIFOMI0   0x01B0		/* (RW) CAN receive FIFO0 mailbox identifier register */
  #define CAN_RFIFOMI_FT        0x00000002	/* frame type */
  #define CAN_RFIFOMI_FF        0x00000004	/* frame format */
  #define CAN_RFIFOMI_EFID      0x001FFFF8	/* the frame identifier */
  #define CAN_RFIFOMI_SFID      0xFFE00000	/* the frame identifier */
#define TOFF_CAN_RFIFOMP0   0x01B4		/* (RW) CAN receive FIFO0 mailbox property register */
  #define CAN_RFIFOMP_DLENC     0x0000000F	/* receive data length code */
  #define CAN_RFIFOMP_FI        0x0000FF00	/* filter index */
  #define CAN_RFIFOMP_TS        0xFFFF0000	/* time stamp */
#define TOFF_CAN_RFIFOMDATA00 0x01B8	/* (RW) CAN receive FIFO0 mailbox data0 register */
  #define CAN_RFIFOMDATA0_DB0   0x000000FF	/* receive data byte 0 */
  #define CAN_RFIFOMDATA0_DB1   0x0000FF00	/* receive data byte 1 */
  #define CAN_RFIFOMDATA0_DB2   0x00FF0000	/* receive data byte 2 */
  #define CAN_RFIFOMDATA0_DB3   0xFF000000	/* receive data byte 3 */
#define TOFF_CAN_RFIFOMDATA10 0x01BC	/* (RW) CAN receive FIFO0 mailbox data1 register */
  #define CAN_RFIFOMDATA1_DB4   0x000000FF	/* receive data byte 4 */
  #define CAN_RFIFOMDATA1_DB5   0x0000FF00	/* receive data byte 5 */
  #define CAN_RFIFOMDATA1_DB6   0x00FF0000	/* receive data byte 6 */
  #define CAN_RFIFOMDATA1_DB7   0xFF000000	/* receive data byte 7 */
#define TOFF_CAN_RFIFOMI1   0x01C0		/* (RW) CAN receive FIFO1 mailbox identifier register */
#define TOFF_CAN_RFIFOMP1   0x01C4		/* (RW) CAN receive FIFO1 mailbox property register */
#define TOFF_CAN_RFIFOMDATA01 0x01C8	/* (RW) CAN receive FIFO1 mailbox data0 register */
#define TOFF_CAN_RFIFOMDATA11 0x01CC	/* (RW) CAN receive FIFO1 mailbox data1 register */
#define TOFF_CAN_FCTL       0x0200		/* (RW) CAN filter control register */
  #define CAN_FCTL_FLD          0x00000001	/* filter lock disable */
  #define CAN_FCTL_HBC1F        0x00003F00	/* header bank of CAN1 filter */
#define TOFF_CAN_FMCFG      0x0204		/* (RW) CAN filter mode register */
#define TOFF_CAN_FSCFG      0x020C		/* (RW) CAN filter scale register */
#define TOFF_CAN_FAFIFO     0x0214		/* (RW) CAN filter associated FIFO register */
#define TOFF_CAN_FW         0x021C		/* (RW) CAN filter working register */
#define TOFF_CAN_F0DATA0    0x0240		/* (RW) CAN filter 0 data 0 register */
#define TOFF_CAN_F1DATA0    0x0248		/* (RW) CAN filter 1 data 0 register */
#define TOFF_CAN_F2DATA0    0x0250		/* (RW) CAN filter 2 data 0 register */
#define TOFF_CAN_F3DATA0    0x0258		/* (RW) CAN filter 3 data 0 register */
#define TOFF_CAN_F4DATA0    0x0260		/* (RW) CAN filter 4 data 0 register */
#define TOFF_CAN_F5DATA0    0x0268		/* (RW) CAN filter 5 data 0 register */
#define TOFF_CAN_F6DATA0    0x0270		/* (RW) CAN filter 6 data 0 register */
#define TOFF_CAN_F7DATA0    0x0278		/* (RW) CAN filter 7 data 0 register */
#define TOFF_CAN_F8DATA0    0x0280		/* (RW) CAN filter 8 data 0 register */
#define TOFF_CAN_F9DATA0    0x0288		/* (RW) CAN filter 9 data 0 register */
#define TOFF_CAN_F10DATA0   0x0290		/* (RW) CAN filter 10 data 0 register */
#define TOFF_CAN_F11DATA0   0x0298		/* (RW) CAN filter 11 data 0 register */
#define TOFF_CAN_F12DATA0   0x02A0		/* (RW) CAN filter 12 data 0 register */
#define TOFF_CAN_F13DATA0   0x02A8		/* (RW) CAN filter 13 data 0 register */
#define TOFF_CAN_F14DATA0   0x02B0		/* (RW) CAN filter 14 data 0 register */
#define TOFF_CAN_F15DATA0   0x02B8		/* (RW) CAN filter 15 data 0 register */
#define TOFF_CAN_F16DATA0   0x02C0		/* (RW) CAN filter 16 data 0 register */
#define TOFF_CAN_F17DATA0   0x02C8		/* (RW) CAN filter 17 data 0 register */
#define TOFF_CAN_F18DATA0   0x02D0		/* (RW) CAN filter 18 data 0 register */
#define TOFF_CAN_F19DATA0   0x02D8		/* (RW) CAN filter 19 data 0 register */
#define TOFF_CAN_F20DATA0   0x02E0		/* (RW) CAN filter 20 data 0 register */
#define TOFF_CAN_F21DATA0   0x02E8		/* (RW) CAN filter 21 data 0 register */
#define TOFF_CAN_F22DATA0   0x02F0		/* (RW) CAN filter 22 data 0 register */
#define TOFF_CAN_F23DATA0   0x03F8		/* (RW) CAN filter 23 data 0 register */
#define TOFF_CAN_F24DATA0   0x0300		/* (RW) CAN filter 24 data 0 register */
#define TOFF_CAN_F25DATA0   0x0308		/* (RW) CAN filter 25 data 0 register */
#define TOFF_CAN_F26DATA0   0x0310		/* (RW) CAN filter 26 data 0 register */
#define TOFF_CAN_F27DATA0   0x0318		/* (RW) CAN filter 27 data 0 register */
#define TOFF_CAN_F0DATA1    0x0244		/* (RW) CAN filter 0 data 1 register */
#define TOFF_CAN_F1DATA1    0x024C		/* (RW) CAN filter 1 data 1 register */
#define TOFF_CAN_F2DATA1    0x0254		/* (RW) CAN filter 2 data 1 register */
#define TOFF_CAN_F3DATA1    0x025C		/* (RW) CAN filter 3 data 1 register */
#define TOFF_CAN_F4DATA1    0x0264		/* (RW) CAN filter 4 data 1 register */
#define TOFF_CAN_F5DATA1    0x026C		/* (RW) CAN filter 5 data 1 register */
#define TOFF_CAN_F6DATA1    0x0274		/* (RW) CAN filter 6 data 1 register */
#define TOFF_CAN_F7DATA1    0x027C		/* (RW) CAN filter 7 data 1 register */
#define TOFF_CAN_F8DATA1    0x0284		/* (RW) CAN filter 8 data 1 register */
#define TOFF_CAN_F9DATA1    0x028C		/* (RW) CAN filter 9 data 1 register */
#define TOFF_CAN_F10DATA1   0x0294		/* (RW) CAN filter 10 data 1 register */
#define TOFF_CAN_F11DATA1   0x029C		/* (RW) CAN filter 11 data 1 register */
#define TOFF_CAN_F12DATA1   0x02A4		/* (RW) CAN filter 12 data 1 register */
#define TOFF_CAN_F13DATA1   0x02AC		/* (RW) CAN filter 13 data 1 register */
#define TOFF_CAN_F14DATA1   0x02B4		/* (RW) CAN filter 14 data 1 register */
#define TOFF_CAN_F15DATA1   0x02BC		/* (RW) CAN filter 15 data 1 register */
#define TOFF_CAN_F16DATA1   0x02C4		/* (RW) CAN filter 16 data 1 register */
#define TOFF_CAN_F17DATA1   0x024C		/* (RW) CAN filter 17 data 1 register */
#define TOFF_CAN_F18DATA1   0x02D4		/* (RW) CAN filter 18 data 1 register */
#define TOFF_CAN_F19DATA1   0x02DC		/* (RW) CAN filter 19 data 1 register */
#define TOFF_CAN_F20DATA1   0x02E4		/* (RW) CAN filter 20 data 1 register */
#define TOFF_CAN_F21DATA1   0x02EC		/* (RW) CAN filter 21 data 1 register */
#define TOFF_CAN_F22DATA1   0x02F4		/* (RW) CAN filter 22 data 1 register */
#define TOFF_CAN_F23DATA1   0x02FC		/* (RW) CAN filter 23 data 1 register */
#define TOFF_CAN_F24DATA1   0x0304		/* (RW) CAN filter 24 data 1 register */
#define TOFF_CAN_F25DATA1   0x030C		/* (RW) CAN filter 25 data 1 register */
#define TOFF_CAN_F26DATA1   0x0314		/* (RW) CAN filter 26 data 1 register */
#define TOFF_CAN_F27DATA1   0x031C		/* (RW) CAN filter 27 data 1 register */


/*
 *  BKP
 */
#define TADR_BKP_BASE       BKP_BASE
#define TOFF_BKP_DATA0      0x0004		/* (RW) BKP data register 0 */
  #define BKP_DATA              0x0000FFFF	/* backup data */
#define TOFF_BKP_DATA1      0x0008		/* (RW) BKP data register 1 */
#define TOFF_BKP_DATA2      0x000C		/* (RW) BKP data register 2 */
#define TOFF_BKP_DATA3      0x0010		/* (RW) BKP data register 3 */
#define TOFF_BKP_DATA4      0x0014		/* (RW) BKP data register 4 */
#define TOFF_BKP_DATA5      0x0018		/* (RW) BKP data register 5 */
#define TOFF_BKP_DATA6      0x001C		/* (RW) BKP data register 6 */
#define TOFF_BKP_DATA7      0x0020		/* (RW) BKP data register 7 */
#define TOFF_BKP_DATA8      0x0024		/* (RW) BKP data register 8 */
#define TOFF_BKP_DATA9      0x0028		/* (RW) BKP data register 9 */
#define TOFF_BKP_DATA10     0x0040		/* (RW) BKP data register 10 */
#define TOFF_BKP_DATA11     0x0044		/* (RW) BKP data register 11 */
#define TOFF_BKP_DATA12     0x0048		/* (RW) BKP data register 12 */
#define TOFF_BKP_DATA13     0x004C		/* (RW) BKP data register 13 */
#define TOFF_BKP_DATA14     0x0050		/* (RW) BKP data register 14 */
#define TOFF_BKP_DATA15     0x0054		/* (RW) BKP data register 15 */
#define TOFF_BKP_DATA16     0x0058		/* (RW) BKP data register 16 */
#define TOFF_BKP_DATA17     0x005C		/* (RW) BKP data register 17 */
#define TOFF_BKP_DATA18     0x0060		/* (RW) BKP data register 18 */
#define TOFF_BKP_DATA19     0x0064		/* (RW) BKP data register 19 */
#define TOFF_BKP_DATA20     0x0068		/* (RW) BKP data register 20 */
#define TOFF_BKP_DATA21     0x006C		/* (RW) BKP data register 21 */
#define TOFF_BKP_DATA22     0x0070		/* (RW) BKP data register 22 */
#define TOFF_BKP_DATA23     0x0074		/* (RW) BKP data register 23 */
#define TOFF_BKP_DATA24     0x0078		/* (RW) BKP data register 24 */
#define TOFF_BKP_DATA25     0x007C		/* (RW) BKP data register 25 */
#define TOFF_BKP_DATA26     0x0080		/* (RW) BKP data register 26 */
#define TOFF_BKP_DATA27     0x0084		/* (RW) BKP data register 27 */
#define TOFF_BKP_DATA28     0x0088		/* (RW) BKP data register 28 */
#define TOFF_BKP_DATA29     0x008C		/* (RW) BKP data register 29 */
#define TOFF_BKP_DATA30     0x0090		/* (RW) BKP data register 30 */
#define TOFF_BKP_DATA31     0x0094		/* (RW) BKP data register 31 */
#define TOFF_BKP_DATA32     0x0098		/* (RW) BKP data register 32 */
#define TOFF_BKP_DATA33     0x009C		/* (RW) BKP data register 33 */
#define TOFF_BKP_DATA34     0x00A0		/* (RW) BKP data register 34 */
#define TOFF_BKP_DATA35     0x00A4		/* (RW) BKP data register 35 */
#define TOFF_BKP_DATA36     0x00A8		/* (RW) BKP data register 36 */
#define TOFF_BKP_DATA37     0x00AC		/* (RW) BKP data register 37 */
#define TOFF_BKP_DATA38     0x00B0		/* (RW) BKP data register 38 */
#define TOFF_BKP_DATA39     0x00B4		/* (RW) BKP data register 39 */
#define TOFF_BKP_DATA40     0x00B8		/* (RW) BKP data register 40 */
#define TOFF_BKP_DATA41     0x00BC		/* (RW) BKP data register 41 */
#define TOFF_BKP_OCTL       0x002C		/* (RW) RTC signal output control register */
  #define BKP_OCTL_RCCV         0x0000007F	/* RTC clock calibration value */
  #define BKP_OCTL_COEN         0x00000080	/* RTC clock calibration output enable */
  #define BKP_OCTL_ASOEN        0x00000100	/* RTC alarm or second signal output enable */
  #define BKP_OCTL_ROSEL        0x00000200	/* RTC output selection */
#define TOFF_BKP_TPCTL      0x0030		/* (RW) tamper pin control register */
  #define BKP_TPCTL_TPEN        0x00000001	/* tamper detection enable */
  #define BKP_TPCTL_TPAL        0x00000002	/* tamper pin active level */
#define TOFF_BKP_TPCS       0x0034		/* (RW) tamper control and status register */
  #define BKP_TPCS_TER          0x00000001	/* tamper event reset */
  #define BKP_TPCS_TIR          0x00000002	/* tamper interrupt reset */
  #define BKP_TPCS_TPIE         0x00000004	/* tamper interrupt enable */
  #define BKP_TPCS_TEF          0x00000100	/* tamper event flag */
  #define BKP_TPCS_TIF          0x00000200	/* tamper interrupt flag */


/*
 *  PMU
 */
#define TADR_PMU_BASE       PMU_BASE
#define TOFF_PMU_CTL        0x0000		/* (RW) PMU control register */
  #define PMU_CTL_LDOLP         0x00000001	/* LDO low power mode */
  #define PMU_CTL_STBMOD        0x00000002	/* standby mode */
  #define PMU_CTL_WURST         0x00000004	/* wakeup flag reset */
  #define PMU_CTL_STBRST        0x00000008	/* standby flag reset */
  #define PMU_CTL_LVDEN         0x00000010	/* low voltage detector enable */
  #define PMU_CTL_LVDT          0x000000E0	/* low voltage detector threshold */
  #define PMU_CTL_BKPWEN        0x00000100	/* backup domain write enable */
#define TOFF_PMU_CS         0x0004		/* (RW) PMU control and status register */
  #define PMU_CS_WUF            0x00000001	/* wakeup flag */
  #define PMU_CS_STBF           0x00000002	/* standby flag */
  #define PMU_CS_LVDF           0x00000004	/* low voltage detector status flag */
  #define PMU_CS_WUPEN          0x00000100	/* wakeup pin enable */


/*
 *  DAC
 */
#define TADR_DAC_BASE       DAC_BASE
#define TOFF_DAC_CTL        0x0000		/* (RW) DAC control register */
  #define DAC_CTL_DEN0          0x00000001	/* DAC0 enable/disable bit */
  #define DAC_CTL_DBOFF0        0x00000002	/* DAC0 output buffer turn on/turn off bit */
  #define DAC_CTL_DTEN0         0x00000004	/* DAC0 trigger enable/disable bit */
  #define DAC_CTL_DTSEL0        0x00000038	/* DAC0 trigger source selection enable/disable bits */
  #define DAC_CTL_DWM0          0x000000C0	/* DAC0 noise wave mode */
  #define DAC_CTL_DWBW0         0x00000F00	/* DAC0 noise wave bit width */
  #define DAC_CTL_DDMAEN0       0x00001000	/* DAC0 DMA enable/disable bit */
  #define DAC_CTL_DEN1          0x00010000	/* DAC1 enable/disable bit */ 
  #define DAC_CTL_DBOFF1        0x00020000	/* DAC1 output buffer turn on/turn off bit */
  #define DAC_CTL_DTEN1         0x00040000	/* DAC1 trigger enable/disable bit */
  #define DAC_CTL_DTSEL1        0x00380000	/* DAC1 trigger source selection enable/disable bits */
  #define DAC_CTL_DWM1          0x00C00000	/* DAC1 noise wave mode */
  #define DAC_CTL_DWBW1         0x0F000000	/* DAC1 noise wave bit width */
  #define DAC_CTL_DDMAEN1       0x10000000	/* DAC1 DMA enable/disable bit */
#define TOFF_DAC_SWT        0x0004		/* (RW) DAC software trigger register */
  #define DAC_SWT_SWTR0         0x00000001	/* DAC0 software trigger bit, cleared by hardware */
  #define DAC_SWT_SWTR1         0x00000002	/* DAC1 software trigger bit, cleared by hardware */
#define TOFF_DAC0_R12DH     0x0008		/* (RW) DAC0 12-bit right-aligned data holding register */
  #define DAC0_R12DH_DAC0_DH    0x00000FFF	/* DAC0 12-bit right-aligned data bits */
#define TOFF_DAC0_L12DH     0x000C		/* (RW) DAC0 12-bit left-aligned data holding register */
  #define DAC0_L12DH_DAC0_DH    0x0000FFF0	/* DAC0 12-bit left-aligned data bits */
#define TOFF_DAC0_R8DH      0x0010		/* (RW) DAC0 8-bit right-aligned data holding register */
  #define DAC0_R8DH_DAC0_DH     0x000000FF	/* DAC0 8-bit right-aligned data bits */
#define TOFF_DAC1_R12DH     0x0014		/* (RW) DAC1 12-bit right-aligned data holding register */
  #define DAC1_R12DH_DAC1_DH    0x00000FFF	/* DAC1 12-bit right-aligned data bits */
#define TOFF_DAC1_L12DH     0x0018		/* (RW) DAC1 12-bit left-aligned data holding register */
  #define DAC1_L12DH_DAC1_DH    0x0000FFF0	/* DAC1 12-bit left-aligned data bits */
#define TOFF_DAC1_R8DH      0x001C		/* (RW) DAC1 8-bit right-aligned data holding register */
  #define DAC1_R8DH_DAC1_DH     0x000000FF	/* DAC1 8-bit right-aligned data bits */
#define TOFF_DACC_R12DH     0x0020		/* (RW) DAC concurrent mode 12-bit right-aligned data holding register */
  #define DACC_R12DH_DAC0_DH    0x00000FFF	/* DAC concurrent mode DAC0 12-bit right-aligned data bits */
  #define DACC_R12DH_DAC1_DH    0x0FFF0000	/* DAC concurrent mode DAC1 12-bit right-aligned data bits */
#define TOFF_DACC_L12DH     0x0024		/* (RW) DAC concurrent mode 12-bit left-aligned data holding register */
  #define DACC_L12DH_DAC0_DH    0x0000FFF0	/* DAC concurrent mode DAC0 12-bit left-aligned data bits */
  #define DACC_L12DH_DAC1_DH    0xFFF00000	/* DAC concurrent mode DAC1 12-bit left-aligned data bits */
#define TOFF_DACC_R8DH      0x0028		/* (RW) DAC concurrent mode 8-bit right-aligned data holding register */
  #define DACC_R8DH_DAC0_DH     0x000000FF	/* DAC concurrent mode DAC0 8-bit right-aligned data bits */
  #define DACC_R8DH_DAC1_DH     0x0000FF00	/* DAC concurrent mode DAC1 8-bit right-aligned data bits */
#define TOFF_DAC0_DO        0x002C		/* (RW) DAC0 data output register */
  #define DAC0_DO_DAC0_DO       0x00000FFF	/* DAC0 12-bit output data bits */
#define TOFF_DAC1_DO        0x0030		/* (RW) DAC1 data output register */
  #define DAC1_DO_DAC1_DO       0x00000FFF	/* DAC1 12-bit output data bits */


/*
 *  AFIO
 */
#define TADR_AFIO_BASE      (AFIO_BASE)
#define TOFF_AFIO_EC        0x0000		/* (RW) AFIO event control register */
  #define AFIO_EC_PIN                 0x0000000F	/* event output pin selection */
  #define AFIO_EC_PORT                0x00000070	/* event output port selection */
  #define AFIO_EC_EOE                 0x00000080	/* event output enable */
#define TOFF_AFIO_PCF0      0x0004		/* (RW) AFIO port configuration register 0 */
  #define AFIO_PCF0_SPI0_REMAP        0x00000001	/* SPI0 remapping */
  #define AFIO_PCF0_I2C0_REMAP        0x00000002	/* I2C0 remapping */
  #define AFIO_PCF0_USART0_REMAP      0x00000004	/* USART0 remapping */
  #define AFIO_PCF0_USART1_REMAP      0x00000008	/* USART1 remapping */
  #define AFIO_PCF0_USART2_REMAP      0x00000030	/* USART2 remapping */
  #define AFIO_PCF0_TIMER0_REMAP      0x000000C0	/* TIMER0 remapping */
  #define AFIO_PCF0_TIMER1_REMAP      0x00000300	/* TIMER1 remapping */
  #define AFIO_PCF0_TIMER2_REMAP      0x00000C00	/* TIMER2 remapping */
  #define AFIO_PCF0_TIMER3_REMAP      0x00001000	/* TIMER3 remapping */
  #define AFIO_PCF0_CAN_REMAP         0x00006000	/* CAN remapping */
  #define AFIO_PCF0_PD01_REMAP        0x00008000	/* port D0/port D1 mapping on OSC_IN/OSC_OUT */
  #define AFIO_PCF0_TIMER4CH3_IREMAP  0x00010000	/* TIMER3 channel3 internal remapping */
  #define AFIO_PCF0_SWJ_CFG           0x07000000	/* serial wire JTAG configuration */
  #define AFIO_PCF0_SPI2_REMAP        0x10000000	/* SPI2/I2S2 remapping */
  #define AFIO_PCF0_TIMER1_ITI1_REMAP 0x20000000	/* TIMER1 internal trigger 1 remapping */
#define TOFF_AFIO_EXTISS0   0x0008		/* (RW) AFIO port EXTI sources selection register 0 */
  #define AFIO_EXTI0_SS               0x0000000F	/* EXTI 0 sources selection */
  #define AFIO_EXTI1_SS               0x000000F0	/* EXTI 1 sources selection */
  #define AFIO_EXTI2_SS               0x00000F00	/* EXTI 2 sources selection */
  #define AFIO_EXTI3_SS               0x0000F000	/* EXTI 3 sources selection */
#define TOFF_AFIO_EXTISS1   0x000C		/* (RW) AFIO port EXTI sources selection register 1 */
  #define AFIO_EXTI4_SS               0x0000000F	/* EXTI 4 sources selection */
  #define AFIO_EXTI5_SS               0x000000F0	/* EXTI 5 sources selection */
  #define AFIO_EXTI6_SS               0x00000F00	/* EXTI 6 sources selection */
  #define AFIO_EXTI7_SS               0x0000F000	/* EXTI 7 sources selection */
#define TOFF_AFIO_EXTISS2   0x0010		/* (RW) AFIO port EXTI sources selection register 2 */
  #define AFIO_EXTI8_SS               0x0000000F	/* EXTI 8 sources selection */
  #define AFIO_EXTI9_SS               0x000000F0	/* EXTI 9 sources selection */
  #define AFIO_EXTI10_SS              0x00000F00	/* EXTI 10 sources selection */
  #define AFIO_EXTI11_SS              0x0000F000	/* EXTI 11 sources selection */
#define TOFF_AFIO_EXTISS3   0x0014		/* (RW) AFIO port EXTI sources selection register 3 */
  #define AFIO_EXTI12_SS              0x0000000F	/* EXTI 12 sources selection */
  #define AFIO_EXTI13_SS              0x000000F0	/* EXTI 13 sources selection */
  #define AFIO_EXTI14_SS              0x00000F00	/* EXTI 14 sources selection */
  #define AFIO_EXTI15_SS              0x0000F000	/* EXTI 15 sources selection */
#define TOFF_AFIO_PCF1      0x001C		/* (RW) AFIO port configuration register 1 */
  #define AFIO_PCF1_EXMC_NADV         0x00000200	/* EXMC_NADV connect/disconnect */

/*
 *  EXTI
 */
#define TADR_EXTI_BASE      EXTI_BASE
#define TOFF_EXTI_INTEN     0x0000		/* (RW) interrupt enable register */
  #define EXTI_INTEN_INTEN0     0x00000001	/* interrupt from line 0 */
  #define EXTI_INTEN_INTEN1     0x00000002	/* interrupt from line 1 */
  #define EXTI_INTEN_INTEN2     0x00000004	/* interrupt from line 2 */
  #define EXTI_INTEN_INTEN3     0x00000008	/* interrupt from line 3 */
  #define EXTI_INTEN_INTEN4     0x00000010	/* interrupt from line 4 */
  #define EXTI_INTEN_INTEN5     0x00000020	/* interrupt from line 5 */
  #define EXTI_INTEN_INTEN6     0x00000040	/* interrupt from line 6 */
  #define EXTI_INTEN_INTEN7     0x00000080	/* interrupt from line 7 */
  #define EXTI_INTEN_INTEN8     0x00000100	/* interrupt from line 8 */
  #define EXTI_INTEN_INTEN9     0x00000200	/* interrupt from line 9 */
  #define EXTI_INTEN_INTEN10    0x00000400	/* interrupt from line 10 */
  #define EXTI_INTEN_INTEN11    0x00000800	/* interrupt from line 11 */
  #define EXTI_INTEN_INTEN12    0x00001000	/* interrupt from line 12 */
  #define EXTI_INTEN_INTEN13    0x00002000	/* interrupt from line 13 */
  #define EXTI_INTEN_INTEN14    0x00004000	/* interrupt from line 14 */
  #define EXTI_INTEN_INTEN15    0x00008000	/* interrupt from line 15 */
  #define EXTI_INTEN_INTEN16    0x00010000	/* interrupt from line 16 */
  #define EXTI_INTEN_INTEN17    0x00020000	/* interrupt from line 17 */
  #define EXTI_INTEN_INTEN18    0x00040000	/* interrupt from line 18 */
#define TOFF_EXTI_EVEN      0x0004		/* (RW) event enable register */
  #define EXTI_EVEN_EVEN0       0x00000001	/* event from line 0 */
  #define EXTI_EVEN_EVEN1       0x00000002	/* event from line 1 */
  #define EXTI_EVEN_EVEN2       0x00000004	/* event from line 2 */
  #define EXTI_EVEN_EVEN3       0x00000008	/* event from line 3 */
  #define EXTI_EVEN_EVEN4       0x00000010	/* event from line 4 */
  #define EXTI_EVEN_EVEN5       0x00000020	/* event from line 5 */
  #define EXTI_EVEN_EVEN6       0x00000040	/* event from line 6 */
  #define EXTI_EVEN_EVEN7       0x00000080	/* event from line 7 */
  #define EXTI_EVEN_EVEN8       0x00000100	/* event from line 8 */
  #define EXTI_EVEN_EVEN9       0x00000200	/* event from line 9 */
  #define EXTI_EVEN_EVEN10      0x00000400	/* event from line 10 */
  #define EXTI_EVEN_EVEN11      0x00000800	/* event from line 11 */
  #define EXTI_EVEN_EVEN12      0x00001000	/* event from line 12 */
  #define EXTI_EVEN_EVEN13      0x00002000	/* event from line 13 */
  #define EXTI_EVEN_EVEN14      0x00004000	/* event from line 14 */
  #define EXTI_EVEN_EVEN15      0x00008000	/* event from line 15 */
  #define EXTI_EVEN_EVEN16      0x00010000	/* event from line 16 */
  #define EXTI_EVEN_EVEN17      0x00020000	/* event from line 17 */
  #define EXTI_EVEN_EVEN18      0x00040000	/* event from line 18 */
#define TOFF_EXTI_RTEN      0x0008		/* (RW) rising edge trigger enable register */
  #define EXTI_RTEN_RTEN0       0x00000001	/* rising edge from line 0 */
  #define EXTI_RTEN_RTEN1       0x00000002	/* rising edge from line 1 */
  #define EXTI_RTEN_RTEN2       0x00000004	/* rising edge from line 2 */
  #define EXTI_RTEN_RTEN3       0x00000008	/* rising edge from line 3 */
  #define EXTI_RTEN_RTEN4       0x00000010	/* rising edge from line 4 */
  #define EXTI_RTEN_RTEN5       0x00000020	/* rising edge from line 5 */
  #define EXTI_RTEN_RTEN6       0x00000040	/* rising edge from line 6 */
  #define EXTI_RTEN_RTEN7       0x00000080	/* rising edge from line 7 */
  #define EXTI_RTEN_RTEN8       0x00000100	/* rising edge from line 8 */
  #define EXTI_RTEN_RTEN9       0x00000200	/* rising edge from line 9 */
  #define EXTI_RTEN_RTEN10      0x00000400	/* rising edge from line 10 */
  #define EXTI_RTEN_RTEN11      0x00000800	/* rising edge from line 11 */
  #define EXTI_RTEN_RTEN12      0x00001000	/* rising edge from line 12 */
  #define EXTI_RTEN_RTEN13      0x00002000	/* rising edge from line 13 */
  #define EXTI_RTEN_RTEN14      0x00004000	/* rising edge from line 14 */
  #define EXTI_RTEN_RTEN15      0x00008000	/* rising edge from line 15 */
  #define EXTI_RTEN_RTEN16      0x00010000	/* rising edge from line 16 */
  #define EXTI_RTEN_RTEN17      0x00020000	/* rising edge from line 17 */
  #define EXTI_RTEN_RTEN18      0x00040000	/* rising edge from line 18 */
#define TOFF_EXTI_FTEN      0x000C		/* (RW) falling trigger enable register */
  #define EXTI_FTEN_FTEN0       0x00000001	/* falling edge from line 0 */
  #define EXTI_FTEN_FTEN1       0x00000002	/* falling edge from line 1 */
  #define EXTI_FTEN_FTEN2       0x00000004	/* falling edge from line 2 */
  #define EXTI_FTEN_FTEN3       0x00000008	/* falling edge from line 3 */
  #define EXTI_FTEN_FTEN4       0x00000010	/* falling edge from line 4 */
  #define EXTI_FTEN_FTEN5       0x00000020	/* falling edge from line 5 */
  #define EXTI_FTEN_FTEN6       0x00000040	/* falling edge from line 6 */
  #define EXTI_FTEN_FTEN7       0x00000080	/* falling edge from line 7 */
  #define EXTI_FTEN_FTEN8       0x00000100	/* falling edge from line 8 */
  #define EXTI_FTEN_FTEN9       0x00000200	/* falling edge from line 9 */
  #define EXTI_FTEN_FTEN10      0x00000400	/* falling edge from line 10 */
  #define EXTI_FTEN_FTEN11      0x00000800	/* falling edge from line 11 */
  #define EXTI_FTEN_FTEN12      0x00001000	/* falling edge from line 12 */
  #define EXTI_FTEN_FTEN13      0x00002000	/* falling edge from line 13 */
  #define EXTI_FTEN_FTEN14      0x00004000	/* falling edge from line 14 */
  #define EXTI_FTEN_FTEN15      0x00008000	/* falling edge from line 15 */
  #define EXTI_FTEN_FTEN16      0x00010000	/* falling edge from line 16 */
  #define EXTI_FTEN_FTEN17      0x00020000	/* falling edge from line 17 */
  #define EXTI_FTEN_FTEN18      0x00040000	/* falling edge from line 18 */
#define TOFF_EXTI_SWIEV     0x0010		/* (RW) software interrupt event register */
  #define EXTI_SWIEV_SWIEV0     0x00000001	/* software interrupt/event request from line 0 */
  #define EXTI_SWIEV_SWIEV1     0x00000002	/* software interrupt/event request from line 1 */
  #define EXTI_SWIEV_SWIEV2     0x00000004	/* software interrupt/event request from line 2 */
  #define EXTI_SWIEV_SWIEV3     0x00000008	/* software interrupt/event request from line 3 */
  #define EXTI_SWIEV_SWIEV4     0x00000010	/* software interrupt/event request from line 4 */
  #define EXTI_SWIEV_SWIEV5     0x00000020	/* software interrupt/event request from line 5 */
  #define EXTI_SWIEV_SWIEV6     0x00000040	/* software interrupt/event request from line 6 */
  #define EXTI_SWIEV_SWIEV7     0x00000080	/* software interrupt/event request from line 7 */
  #define EXTI_SWIEV_SWIEV8     0x00000100	/* software interrupt/event request from line 8 */
  #define EXTI_SWIEV_SWIEV9     0x00000200	/* software interrupt/event request from line 9 */
  #define EXTI_SWIEV_SWIEV10    0x00000400	/* software interrupt/event request from line 10 */
  #define EXTI_SWIEV_SWIEV11    0x00000800	/* software interrupt/event request from line 11 */
  #define EXTI_SWIEV_SWIEV12    0x00001000	/* software interrupt/event request from line 12 */
  #define EXTI_SWIEV_SWIEV13    0x00002000	/* software interrupt/event request from line 13 */
  #define EXTI_SWIEV_SWIEV14    0x00004000	/* software interrupt/event request from line 14 */
  #define EXTI_SWIEV_SWIEV15    0x00008000	/* software interrupt/event request from line 15 */
  #define EXTI_SWIEV_SWIEV16    0x00010000	/* software interrupt/event request from line 16 */
  #define EXTI_SWIEV_SWIEV17    0x00020000	/* software interrupt/event request from line 17 */
  #define EXTI_SWIEV_SWIEV18    0x00040000	/* software interrupt/event request from line 18 */
#define TOFF_EXTI_PD        0x0014		/* (RW) pending register */
  #define EXTI_PD_PD0           0x00000001	/* interrupt/event pending status from line 0 */
  #define EXTI_PD_PD1           0x00000002	/* interrupt/event pending status from line 1 */
  #define EXTI_PD_PD2           0x00000004	/* interrupt/event pending status from line 2 */
  #define EXTI_PD_PD3           0x00000008	/* interrupt/event pending status from line 3 */
  #define EXTI_PD_PD4           0x00000010	/* interrupt/event pending status from line 4 */
  #define EXTI_PD_PD5           0x00000020	/* interrupt/event pending status from line 5 */
  #define EXTI_PD_PD6           0x00000040	/* interrupt/event pending status from line 6 */
  #define EXTI_PD_PD7           0x00000080	/* interrupt/event pending status from line 7 */
  #define EXTI_PD_PD8           0x00000100	/* interrupt/event pending status from line 8 */
  #define EXTI_PD_PD9           0x00000200	/* interrupt/event pending status from line 9 */
  #define EXTI_PD_PD10          0x00000400	/* interrupt/event pending status from line 10 */
  #define EXTI_PD_PD11          0x00000800	/* interrupt/event pending status from line 11 */
  #define EXTI_PD_PD12          0x00001000	/* interrupt/event pending status from line 12 */
  #define EXTI_PD_PD13          0x00002000	/* interrupt/event pending status from line 13 */
  #define EXTI_PD_PD14          0x00004000	/* interrupt/event pending status from line 14 */
  #define EXTI_PD_PD15          0x00008000	/* interrupt/event pending status from line 15 */
  #define EXTI_PD_PD16          0x00010000	/* interrupt/event pending status from line 16 */
  #define EXTI_PD_PD17          0x00020000	/* interrupt/event pending status from line 17 */
  #define EXTI_PD_PD18          0x00040000	/* interrupt/event pending status from line 18 */


/*
 *  GPIO
 */
#define TADR_GPIOA_BASE     (GPIO_BASE + 0x0000U)
#define TADR_GPIOB_BASE     (GPIO_BASE + 0x0400U)
#define TADR_GPIOC_BASE     (GPIO_BASE + 0x0800U)
#define TADR_GPIOD_BASE     (GPIO_BASE + 0x0C00U)
#define TADR_GPIOE_BASE     (GPIO_BASE + 0x1000U)
#define TOFF_GPIO_CTL0      0x0000		/* (RW) GPIO port control register 0 */
  #define GPIO_CTL0_MD0         0x00000003	/* port 0 mode bits */
  #define GPIO_CTL0_CTL0        0x0000000C	/* pin 0 configuration bits */
  #define GPIO_CTL0_MD1         0x00000030	/* port 1 mode bits */
  #define GPIO_CTL0_CTL1        0x000000C0	/* pin 1 configuration bits */
  #define GPIO_CTL0_MD2         0x00000300	/* port 2 mode bits */
  #define GPIO_CTL0_CTL2        0x00000C00	/* pin 2 configuration bits */
  #define GPIO_CTL0_MD3         0x00003000	/* port 3 mode bits */
  #define GPIO_CTL0_CTL3        0x0000C000	/* pin 3 configuration bits */
  #define GPIO_CTL0_MD4         0x00030000	/* port 4 mode bits */
  #define GPIO_CTL0_CTL4        0x000C0000	/* pin 4 configuration bits */
  #define GPIO_CTL0_MD5         0x00300000	/* port 5 mode bits */
  #define GPIO_CTL0_CTL5        0x00C00000	/* pin 5 configuration bits */
  #define GPIO_CTL0_MD6         0x03000000	/* port 6 mode bits */
  #define GPIO_CTL0_CTL6        0x0C000000	/* pin 6 configuration bits */
  #define GPIO_CTL0_MD7         0x30000000	/* port 7 mode bits */
  #define GPIO_CTL0_CTL7        0xC0000000	/* pin 7 configuration bits */
#define TOFF_GPIO_CTL1      0x0004		/* (RW) GPIO port control register 1 */
  #define GPIO_CTL1_MD8         0x00000003	/* port 8 mode bits */
  #define GPIO_CTL1_CTL8        0x0000000C	/* pin 8 configuration bits */
  #define GPIO_CTL1_MD9         0x00000030	/* port 9 mode bits */
  #define GPIO_CTL1_CTL9        0x000000C0	/* pin 9 configuration bits */
  #define GPIO_CTL1_MD10        0x00000300	/* port 10 mode bits */
  #define GPIO_CTL1_CTL10       0x00000C00	/* pin 10 configuration bits */
  #define GPIO_CTL1_MD11        0x00003000	/* port 11 mode bits */
  #define GPIO_CTL1_CTL11       0x0000C000	/* pin 11 configuration bits */
  #define GPIO_CTL1_MD12        0x00030000	/* port 12 mode bits */
  #define GPIO_CTL1_CTL12       0x000C0000	/* pin 12 configuration bits */
  #define GPIO_CTL1_MD13        0x00300000	/* port 13 mode bits */
  #define GPIO_CTL1_CTL13       0x00C00000	/* pin 13 configuration bits */
  #define GPIO_CTL1_MD14        0x03000000	/* port 14 mode bits */
  #define GPIO_CTL1_CTL14       0x0C000000	/* pin 14 configuration bits */
  #define GPIO_CTL1_MD15        0x30000000	/* port 15 mode bits */
  #define GPIO_CTL1_CTL15       0xC0000000	/* pin 15 configuration bits */
#define TOFF_GPIO_ISTAT     0x0008		/* (RW) GPIO port input status register */
  #define GPIO_ISTAT_ISTAT0     0x00000001	/* pin 0 input status */
  #define GPIO_ISTAT_ISTAT1     0x00000002	/* pin 1 input status */
  #define GPIO_ISTAT_ISTAT2     0x00000004	/* pin 2 input status */
  #define GPIO_ISTAT_ISTAT3     0x00000008	/* pin 3 input status */
  #define GPIO_ISTAT_ISTAT4     0x00000010	/* pin 4 input status */
  #define GPIO_ISTAT_ISTAT5     0x00000020	/* pin 5 input status */
  #define GPIO_ISTAT_ISTAT6     0x00000040	/* pin 6 input status */
  #define GPIO_ISTAT_ISTAT7     0x00000080	/* pin 7 input status */
  #define GPIO_ISTAT_ISTAT8     0x00000100	/* pin 8 input status */
  #define GPIO_ISTAT_ISTAT9     0x00000200	/* pin 9 input status */
  #define GPIO_ISTAT_ISTAT10    0x00000400	/* pin 10 input status */
  #define GPIO_ISTAT_ISTAT11    0x00000800	/* pin 11 input status */
  #define GPIO_ISTAT_ISTAT12    0x00001000	/* pin 12 input status */
  #define GPIO_ISTAT_ISTAT13    0x00002000	/* pin 13 input status */
  #define GPIO_ISTAT_ISTAT14    0x00004000	/* pin 14 input status */
  #define GPIO_ISTAT_ISTAT15    0x00008000	/* pin 15 input status */
#define TOFF_GPIO_OCTL      0x000C		/* (RW) GPIO port output control register */
  #define GPIO_OCTL_OCTL0       0x00000001	/* pin 0 output bit */
  #define GPIO_OCTL_OCTL1       0x00000002	/* pin 1 output bit */
  #define GPIO_OCTL_OCTL2       0x00000004	/* pin 2 output bit */
  #define GPIO_OCTL_OCTL3       0x00000008	/* pin 3 output bit */
  #define GPIO_OCTL_OCTL4       0x00000010	/* pin 4 output bit */
  #define GPIO_OCTL_OCTL5       0x00000020	/* pin 5 output bit */
  #define GPIO_OCTL_OCTL6       0x00000040	/* pin 6 output bit */
  #define GPIO_OCTL_OCTL7       0x00000080	/* pin 7 output bit */
  #define GPIO_OCTL_OCTL8       0x00000100	/* pin 8 output bit */
  #define GPIO_OCTL_OCTL9       0x00000200	/* pin 9 output bit */
  #define GPIO_OCTL_OCTL10      0x00000400	/* pin 10 output bit */
  #define GPIO_OCTL_OCTL11      0x00000800	/* pin 11 output bit */
  #define GPIO_OCTL_OCTL12      0x00001000	/* pin 12 output bit */
  #define GPIO_OCTL_OCTL13      0x00002000	/* pin 13 output bit */
  #define GPIO_OCTL_OCTL14      0x00004000	/* pin 14 output bit */
  #define GPIO_OCTL_OCTL15      0x00008000	/* pin 15 output bit */
#define TOFF_GPIO_BOP       0x0010		/* (RW) GPIO port bit operation register */
  #define GPIO_BOP_BOP0         0x00000001	/* pin 0 set bit */
  #define GPIO_BOP_BOP1         0x00000002	/* pin 1 set bit */
  #define GPIO_BOP_BOP2         0x00000004	/* pin 2 set bit */
  #define GPIO_BOP_BOP3         0x00000008	/* pin 3 set bit */
  #define GPIO_BOP_BOP4         0x00000010	/* pin 4 set bit */
  #define GPIO_BOP_BOP5         0x00000020	/* pin 5 set bit */
  #define GPIO_BOP_BOP6         0x00000040	/* pin 6 set bit */
  #define GPIO_BOP_BOP7         0x00000080	/* pin 7 set bit */
  #define GPIO_BOP_BOP8         0x00000100	/* pin 8 set bit */
  #define GPIO_BOP_BOP9         0x00000200	/* pin 9 set bit */
  #define GPIO_BOP_BOP10        0x00000400	/* pin 10 set bit */
  #define GPIO_BOP_BOP11        0x00000800	/* pin 11 set bit */
  #define GPIO_BOP_BOP12        0x00001000	/* pin 12 set bit */
  #define GPIO_BOP_BOP13        0x00002000	/* pin 13 set bit */
  #define GPIO_BOP_BOP14        0x00004000	/* pin 14 set bit */
  #define GPIO_BOP_BOP15        0x00008000	/* pin 15 set bit */
  #define GPIO_BOP_CR0          0x00010000	/* pin 0 clear bit */
  #define GPIO_BOP_CR1          0x00020000	/* pin 1 clear bit */
  #define GPIO_BOP_CR2          0x00040000	/* pin 2 clear bit */
  #define GPIO_BOP_CR3          0x00080000	/* pin 3 clear bit */
  #define GPIO_BOP_CR4          0x00100000	/* pin 4 clear bit */
  #define GPIO_BOP_CR5          0x00200000	/* pin 5 clear bit */
  #define GPIO_BOP_CR6          0x00400000	/* pin 6 clear bit */
  #define GPIO_BOP_CR7          0x00800000	/* pin 7 clear bit */
  #define GPIO_BOP_CR8          0x01000000	/* pin 8 clear bit */
  #define GPIO_BOP_CR9          0x02000000	/* pin 9 clear bit */
  #define GPIO_BOP_CR10         0x04000000	/* pin 10 clear bit */
  #define GPIO_BOP_CR11         0x08000000	/* pin 11 clear bit */
  #define GPIO_BOP_CR12         0x10000000	/* pin 12 clear bit */
  #define GPIO_BOP_CR13         0x20000000	/* pin 13 clear bit */
  #define GPIO_BOP_CR14         0x40000000	/* pin 14 clear bit */
  #define GPIO_BOP_CR15         0x80000000	/* pin 15 clear bit */
#define TOFF_GPIO_BC        0x0014		/* (RW) GPIO bit clear register */
  #define GPIO_BC_CR0           0x00000001	/* pin 0 clear bit */
  #define GPIO_BC_CR1           0x00000002	/* pin 1 clear bit */
  #define GPIO_BC_CR2           0x00000004	/* pin 2 clear bit */
  #define GPIO_BC_CR3           0x00000008	/* pin 3 clear bit */
  #define GPIO_BC_CR4           0x00000010	/* pin 4 clear bit */
  #define GPIO_BC_CR5           0x00000020	/* pin 5 clear bit */
  #define GPIO_BC_CR6           0x00000040	/* pin 6 clear bit */
  #define GPIO_BC_CR7           0x00000080	/* pin 7 clear bit */
  #define GPIO_BC_CR8           0x00000100	/* pin 8 clear bit */
  #define GPIO_BC_CR9           0x00000200	/* pin 9 clear bit */
  #define GPIO_BC_CR10          0x00000400	/* pin 10 clear bit */
  #define GPIO_BC_CR11          0x00000800	/* pin 11 clear bit */
  #define GPIO_BC_CR12          0x00001000	/* pin 12 clear bit */
  #define GPIO_BC_CR13          0x00002000	/* pin 13 clear bit */
  #define GPIO_BC_CR14          0x00004000	/* pin 14 clear bit */
  #define GPIO_BC_CR15          0x00008000	/* pin 15 clear bit */
#define TPFF_GPIO_LOCK      0x0018		/* (RW) GPIO port configuration lock register */
  #define GPIO_LOCK_LK0         0x00000001	/* pin 0 lock bit */
  #define GPIO_LOCK_LK1         0x00000002	/* pin 1 lock bit */
  #define GPIO_LOCK_LK2         0x00000004	/* pin 2 lock bit */
  #define GPIO_LOCK_LK3         0x00000008	/* pin 3 lock bit */
  #define GPIO_LOCK_LK4         0x00000010	/* pin 4 lock bit */
  #define GPIO_LOCK_LK5         0x00000020	/* pin 5 lock bit */
  #define GPIO_LOCK_LK6         0x00000040	/* pin 6 lock bit */
  #define GPIO_LOCK_LK7         0x00000080	/* pin 7 lock bit */
  #define GPIO_LOCK_LK8         0x00000100	/* pin 8 lock bit */
  #define GPIO_LOCK_LK9         0x00000200	/* pin 9 lock bit */
  #define GPIO_LOCK_LK10        0x00000400	/* pin 10 lock bit */
  #define GPIO_LOCK_LK11        0x00000800	/* pin 11 lock bit */
  #define GPIO_LOCK_LK12        0x00001000	/* pin 12 lock bit */
  #define GPIO_LOCK_LK13        0x00002000	/* pin 13 lock bit */
  #define GPIO_LOCK_LK14        0x00004000	/* pin 14 lock bit */
  #define GPIO_LOCK_LK15        0x00008000	/* pin 15 lock bit */
  #define GPIO_LOCK_LKK         0x00010000	/* pin sequence lock key */


/*
 *  ADC
 */
#define TADR_ADC0_BASE      ADC_BASE
#define TADR_ADC1_BASE      (ADC_BASE + 0x00000400U)
#define TOFF_ADC_STAT       0x0000		/* (RW) ADC status register */
  #define ADC_STAT_WDE          0x00000001	/* analog watchdog event flag */
  #define ADC_STAT_EOC          0x00000002	/* end of conversion */
  #define ADC_STAT_EOIC         0x00000004	/* inserted channel end of conversion */
  #define ADC_STAT_STIC         0x00000008	/* inserted channel start flag */
  #define ADC_STAT_STRC         0x00000010	/* regular channel start flag */
#define TOFF_ADC_CTL0       0x0004		/* (RW) ADC control register 0 */
  #define ADC_CTL0_WDCHSEL      0x0000001F	/* analog watchdog channel select bits */
  #define ADC_CTL0_EOCIE        0x00000020	/* interrupt enable for EOC */
  #define ADC_CTL0_WDEIE        0x00000040	/* analog watchdog interrupt enable */
  #define ADC_CTL0_EOICIE       0x00000080	/* interrupt enable for inserted channels */
  #define ADC_CTL0_SM           0x00000100	/* scan mode */
  #define ADC_CTL0_WDSC         0x00000200	/* when in scan mode, analog watchdog is effective on a single channel */
  #define ADC_CTL0_ICA          0x00000400	/* automatic inserted group conversion */
  #define ADC_CTL0_DISRC        0x00000800	/* discontinuous mode on regular channels */
  #define ADC_CTL0_DISIC        0x00001000	/* discontinuous mode on inserted channels */
  #define ADC_CTL0_DISNUM       0x0000E000	/* discontinuous mode channel count */
  #define ADC_CTL0_SYNCM        0x000F0000	/* sync mode selection */
  #define ADC_CTL0_IWDEN        0x00400000	/* analog watchdog enable on inserted channels */
  #define ADC_CTL0_RWDEN        0x00800000	/* analog watchdog enable on regular channels */
#define TOFF_ADC_CTL1       0x0008		/* (RW) ADC control register 1 */
  #define ADC_CTL1_ADCON        0x00000001	/* ADC converter on */
  #define ADC_CTL1_CTN          0x00000002	/* continuous conversion */
  #define ADC_CTL1_CLB          0x00000004	/* ADC calibration */
  #define ADC_CTL1_RSTCLB       0x00000008	/* reset calibration */
  #define ADC_CTL1_DMA          0x00000100	/* direct memory access mode */
  #define ADC_CTL1_DAL          0x00000800	/* data alignment */
  #define ADC_CTL1_ETSIC        0x00007000	/* external trigger select for inserted channel */
  #define ADC_CTL1_ETEIC        0x00008000	/* external trigger enable for inserted channel */
  #define ADC_CTL1_ETSRC        0x000E0000	/* external trigger select for regular channel */
  #define ADC_CTL1_ETERC        0x00100000  /* external trigger conversion mode for inserted channels */
  #define ADC_CTL1_SWICST       0x00200000	/* start on inserted channel */
  #define ADC_CTL1_SWRCST       0x00400000	/* start on regular channel */
  #define ADC_CTL1_TSVREN       0x00800000	/* channel 16 and 17 enable of ADC0 */
#define TOFF_ADC_SAMPT0     0x000C		/* (RW) ADC sampling time register 0 */
  #define ADC_SAMPTX_SPTN       0x00000007	/* channel n sample time selection */
#define TOFF_ADC_SAMPT1     0x0010		/* (RW) ADC sampling time register 1 */
#define TOFF_ADC_IOFF0      0x0014		/* (RW) ADC inserted channel data offset register 0 */
  #define ADC_IOFFX_IOFF        0x00000FFF	/* data offset for inserted channel x */
#define TOFF_ADC_IOFF1      0x0018		/* (RW) ADC inserted channel data offset register 1 */
#define TOFF_ADC_IOFF2      0x001C		/* (RW) ADC inserted channel data offset register 2 */
#define TOFF_ADC_IOFF3      0x0020		/* (RW) ADC inserted channel data offset register 3 */
#define TOFF_ADC_WDHT       0x0024		/* (RW) ADC watchdog high threshold register */
  #define ADC_WDHT_WDHT         0x00000FFF	/* analog watchdog high threshold */
#define TOFF_ADC_WDLT       0x0028		/* (RW) ADC watchdog low threshold register */
  #define ADC_WDLT_WDLT         0x00000FFF	/* analog watchdog low threshold */
#define TOFF_ADC_RSQ0       0x002C		/* (RW) ADC regular sequence register 0 */
  #define ADC_RSQX_RSQN         0x0000001F	/* nth conversion in regular sequence */
  #define ADC_RSQ0_RL           0x00F00000	/* regular channel sequence length */
#define TOFF_ADC_RSQ1       0x0030		/* (RW) ADC regular sequence register 1 */
#define TOFF_ADC_RSQ2       0x0034		/* (RW) ADC regular sequence register 2 */
#define TOFF_ADC_ISQ        0x0038		/* (RW) ADC inserted sequence register */
  #define ADC_ISQ_ISQN          0x0000001F	/* nth conversion in inserted sequence */
  #define ADC_ISQ_IL            0x00300000	/* inserted sequence length */
#define TOFF_ADC_IDATA0     0x003C		/* (RW) ADC inserted data register 0 */
  #define ADC_IDATAX_IDATAN     0x0000FFFF	/* inserted data n */
#define TOFF_ADC_IDATA1     0x0040		/* (RW) ADC inserted data register 1 */
#define TOFF_ADC_IDATA2     0x0044		/* (RW) ADC inserted data register 2 */
#define TOFF_ADC_IDATA3     0x0048		/* (RW) ADC inserted data register 3 */
#define TOFF_ADC_RDATA      0x004C		/* (RW) ADC regular data register */
  #define ADC_RDATA_RDATA       0x0000FFFF	/* regular data */
  #define ADC_RDATA_ADC1RDTR    0xFFFF0000	/* ADC1 regular channel data */
#define TOFF_ADC_OVSCR      0x0080		/* (RW) ADC oversample control register */
  #define ADC_OVSCR_OVSEN       0x00000001	/* oversampling enable */
  #define ADC_OVSCR_OVSR        0x0000001C	/* oversampling ratio */
  #define ADC_OVSCR_OVSS        0x000001E0	/* oversampling shift */
  #define ADC_OVSCR_TOVS        0x00000200	/* triggered oversampling */
  #define ADC_OVSCR_DRES        0x00003000	/* ADC data resolution */


/*
 *  DMA
 */
#define TADR_DMA0_BASE      DMA_BASE
#define TADR_DMA1_BASE      (DMA_BASE + 0x00000400U)
#define TOFF_DMA_INTF       0x0000		/* (RW) DMA interrupt flag register */
  #define DMA_INTF_GIF          0x00000001	/* global interrupt flag of channel */
  #define DMA_INTF_FTFIF        0x00000002	/* full transfer finish flag of channel */
  #define DMA_INTF_HTFIF        0x00000004	/* half transfer finish flag of channel */
  #define DMA_INTF_ERRIF        0x00000008	/* error flag of channel */
#define TOFF_DMA_INTC       0x0004		/* (RW) DMA interrupt flag clear register */
  #define DMA_INTC_GIFC         0x00000001	/* clear global interrupt flag of channel */
  #define DMA_INTC_FTFIFC       0x00000002	/* clear transfer finish flag of channel */
  #define DMA_INTC_HTFIFC       0x00000004	/* clear half transfer finish flag of channel */
  #define DMA_INTC_ERRIFC       0x00000008	/* clear error flag of channel */

#define TADR_DMA0_CH0_BASE  (TADR_DMA0_BASE + 0x0008)
#define TADR_DMA0_CH1_BASE  (TADR_DMA0_BASE + 0x001C)
#define TADR_DMA0_CH2_BASE  (TADR_DMA0_BASE + 0x0030)
#define TADR_DMA0_CH3_BASE  (TADR_DMA0_BASE + 0x0044)
#define TADR_DMA0_CH4_BASE  (TADR_DMA0_BASE + 0x0058)
#define TADR_DMA0_CH5_BASE  (TADR_DMA0_BASE + 0x006C)
#define TADR_DMA0_CH6_BASE  (TADR_DMA0_BASE + 0x0080)
#define TADR_DMA1_CH0_BASE  (TADR_DMA1_BASE + 0x0008)
#define TADR_DMA1_CH1_BASE  (TADR_DMA1_BASE + 0x001C)
#define TADR_DMA1_CH2_BASE  (TADR_DMA1_BASE + 0x0030)
#define TADR_DMA1_CH3_BASE  (TADR_DMA1_BASE + 0x0044)
#define TADR_DMA1_CH4_BASE  (TADR_DMA1_BASE + 0x0058)
#define TOFF_DMA_CHXCTL     0x0000		/* (RW) DMA channel X control register */
  #define DMA_CHXCTL_CHEN       0x00000001	/* channel enable */
  #define DMA_CHXCTL_FTFIE      0x00000002	/* enable bit for channel full transfer finish interrupt */
  #define DMA_CHXCTL_HTFIE      0x00000004	/* enable bit for channel half transfer finish interrupt */
  #define DMA_CHXCTL_ERRIE      0x00000008	/* enable bit for channel error interrupt */
  #define DMA_CHXCTL_DIR        0x00000010	/* transfer direction */
  #define DMA_CHXCTL_CMEN       0x00000020	/* circular mode enable */
  #define DMA_CHXCTL_PNAGA      0x00000040	/* next address generation algorithm of peripheral */
  #define DMA_CHXCTL_MNAGA      0x00000080	/* next address generation algorithm of memory */
  #define DMA_CHXCTL_PWIDTH     0x00000300	/* transfer data width of peripheral */
  #define DMA_CHXCTL_PWIDTH_0   0x00000100
  #define DMA_CHXCTL_PWIDTH_1   0x00000200
  #define DMA_CHXCTL_MWIDTH     0x00000C00	/* transfer data width of memory */
  #define DMA_CHXCTL_MWIDTH_0   0x00000400
  #define DMA_CHXCTL_MWIDTH_1   0x00000800
  #define DMA_CHXCTL_PRIO       0x00003000	/* priority level */
  #define DMA_CHXCTL_PRIO_0     0x00001000
  #define DMA_CHXCTL_PRIO_1     0x00002000
  #define DMA_CHXCTL_M2M        0x00004000	/* memory to memory mode */
#define TOFF_DMA_CHXCNT     0x0004		/* (RW) DMA channel 0 counter register */
  #define DMA_CHXCNT_CNT        0x0000FFFF	/* transfer counter */
#define TOFF_DMA_CHXPADDR   0x0008		/* (RW) DMA channel 0 peripheral base address register */
#define TOFF_DMA_CHXMADDR   0x000C		/* (RW) DMA channel 0 memory base address register */


/*
 *  RCU
 */
#define TADR_RCU_BASE       (RCU_BASE)
#define TOFF_RCU_CTL        0x0000		/* (RW) control register */
  #define RCU_CTL_IRC8MEN       0x00000001	/* internal high speed oscillator enable */
  #define RCU_CTL_IRC8MSTB      0x00000002	/* IRC8M high speed internal oscillator stabilization flag */
  #define RCU_CTL_IRC8MADJ      0x000000F8	/* high speed internal oscillator clock trim adjust value */
  #define RCU_CTL_IRC8MCALIB    0x0000FF00	/* high speed internal oscillator calibration value register */
  #define RCU_CTL_HXTALEN       0x00010000	/* external high speed oscillator enable */
  #define RCU_CTL_HXTALSTB      0x00020000	/* external crystal oscillator clock stabilization flag */
  #define RCU_CTL_HXTALBPS      0x00040000	/* external crystal oscillator clock bypass mode enable */
  #define RCU_CTL_CKMEN         0x00080000	/* HXTAL clock monitor enable */
  #define RCU_CTL_PLLEN         0x01000000	/* PLL enable */
  #define RCU_CTL_PLLSTB        0x02000000	/* PLL clock stabilization flag */
  #define RCU_CTL_PLL1EN        0x04000000	/* PLL1 enable */
  #define RCU_CTL_PLL1STB       0x08000000	/* PLL1 clock stabilization flag */
  #define RCU_CTL_PLL2EN        0x10000000	/* PLL2 enable */
  #define RCU_CTL_PLL2STB       0x20000000	/* PLL2 clock stabilization flag */
#define TOFF_RCU_CFG0       0x0004		/* (RW) clock configuration register 0 */
  #define RCU_CFG0_SCS          0x00000003	/* system clock switch */
  #define RCU_CFG0_SCS_0        0x00000001
  #define RCU_CFG0_SCS_1        0x00000002
  #define RCU_CFG0_SCSS         0x0000000C	/* system clock switch status */
  #define RCU_CFG0_SCSS_0       0x00000004
  #define RCU_CFG0_SCSS_1       0x00000008
  #define RCU_CFG0_AHBPSC       0x000000F0	/* AHB prescaler selection */
  #define RCU_CFG0_AHBPSC_0     0x00000010
  #define RCU_CFG0_AHBPSC_1     0x00000020
  #define RCU_CFG0_AHBPSC_2     0x00000040
  #define RCU_CFG0_AHBPSC_3     0x00000080
  #define RCU_CFG0_APB1PSC      0x00000700	/* APB1 prescaler selection */
  #define RCU_CFG0_APB1PSC_0    0x00000100
  #define RCU_CFG0_APB1PSC_1    0x00000200
  #define RCU_CFG0_APB1PSC_2    0x00000400
  #define RCU_CFG0_APB2PSC      0x00003800	/* APB2 prescaler selection */
  #define RCU_CFG0_APB2PSC_0    0x00000800
  #define RCU_CFG0_APB2PSC_1    0x00001000
  #define RCU_CFG0_APB2PSC_2    0x00002000
  #define RCU_CFG0_ADCPSC       0x0000C000	/* ADC prescaler selection */
  #define RCU_CFG0_PLLSEL       0x00010000	/* PLL clock source selection */
  #define RCU_CFG0_PREDV0_LSB   0x00020000	/* the LSB of PREDV0 division factor */
  #define RCU_CFG0_PLLMF        0x003C0000	/* PLL clock multiplication factor */
  #define RCU_CFG0_USBFSPSC     0x00C00000	/* USBFS clock prescaler selection */
  #define RCU_CFG0_CKOUT0SEL    0x0F000000	/* CKOUT0 clock source selection */
  #define RCU_CFG0_ADCPSC_2     0x10000000	/* bit 2 of ADCPSC */
  #define RCU_CFG0_PLLMF_4      0x20000000	/* bit 4 of PLLMF */
#define TOFF_RCU_INT        0x0008		/* (RW) clock interrupt register */
  #define RCU_INT_IRC40KSTBIF   0x00000001	/* IRC40K stabilization interrupt flag */
  #define RCU_INT_LXTALSTBIF    0x00000002	/* LXTAL stabilization interrupt flag */
  #define RCU_INT_IRC8MSTBIF    0x00000004	/* IRC8M stabilization interrupt flag */
  #define RCU_INT_HXTALSTBIF    0x00000008	/* HXTAL stabilization interrupt flag */
  #define RCU_INT_PLLSTBIF      0x00000010	/* PLL stabilization interrupt flag */
  #define RCU_INT_PLL1STBIF     0x00000020	/* PLL1 stabilization interrupt flag */
  #define RCU_INT_PLL2STBIF     0x00000040	/* PLL2 stabilization interrupt flag */
  #define RCU_INT_CKMIF         0x00000080	/* HXTAL clock stuck interrupt flag */
  #define RCU_INT_IRC40KSTBIE   0x00000100	/* IRC40K stabilization interrupt enable */
  #define RCU_INT_LXTALSTBIE    0x00000200	/* LXTAL stabilization interrupt enable */
  #define RCU_INT_IRC8MSTBIE    0x00000400	/* IRC8M stabilization interrupt enable */
  #define RCU_INT_HXTALSTBIE    0x00000800	/* HXTAL stabilization interrupt enable */
  #define RCU_INT_PLLSTBIE      0x00001000	/* PLL stabilization interrupt enable */
  #define RCU_INT_PLL1STBIE     0x00002000	/* PLL1 stabilization interrupt enable */
  #define RCU_INT_PLL2STBIE     0x00004000	/* PLL2 stabilization interrupt enable */
  #define RCU_INT_IRC40KSTBIC   0x00010000	/* IRC40K stabilization interrupt clear */
  #define RCU_INT_LXTALSTBIC    0x00020000	/* LXTAL stabilization interrupt clear */
  #define RCU_INT_IRC8MSTBIC    0x00040000	/* IRC8M stabilization interrupt clear */
  #define RCU_INT_HXTALSTBIC    0x00080000	/* HXTAL stabilization interrupt clear */
  #define RCU_INT_PLLSTBIC      0x00100000	/* PLL stabilization interrupt clear */
  #define RCU_INT_PLL1STBIC     0x00200000	/* PLL1 stabilization interrupt clear */
  #define RCU_INT_PLL2STBIC     0x00400000	/* PLL2 stabilization interrupt clear */
  #define RCU_INT_CKMIC         0x00800000	/* HXTAL clock stuck interrupt clear */
#define TOFF_RCU_APB2RST    0x000C		/* (RW) APB2 reset register */
  #define RCU_APB2RST_AFRST     0x00000001	/* alternate function I/O reset */
  #define RCU_APB2RST_PARST     0x00000004	/* GPIO port A reset */
  #define RCU_APB2RST_PBRST     0x00000008	/* GPIO port B reset */
  #define RCU_APB2RST_PCRST     0x00000010	/* GPIO port C reset */
  #define RCU_APB2RST_PDRST     0x00000020	/* GPIO port D reset */
  #define RCU_APB2RST_PERST     0x00000040	/* GPIO port E reset */
  #define RCU_APB2RST_ADC0RST   0x00000200	/* ADC0 reset */
  #define RCU_APB2RST_ADC1RST   0x00000400	/* ADC1 reset */
  #define RCU_APB2RST_TIMER0RST 0x00000800	/* TIMER0 reset */
  #define RCU_APB2RST_SPI0RST   0x00001000	/* SPI0 reset */
  #define RCU_APB2RST_USART0RST 0x00004000	/* USART0 reset */
#define TOFF_RCU_APB1RST    0x0010		/* (RW) APB1 reset register */
  #define RCU_APB1RST_TIMER1RST 0x00000001	/* TIMER1 reset */
  #define RCU_APB1RST_TIMER2RST 0x00000002	/* TIMER2 reset */
  #define RCU_APB1RST_TIMER3RST 0x00000004	/* TIMER3 reset */
  #define RCU_APB1RST_TIMER4RST 0x00000008	/* TIMER4 reset */
  #define RCU_APB1RST_TIMER5RST 0x00000010	/* TIMER5 reset */
  #define RCU_APB1RST_TIMER6RST 0x00000020	/* TIMER6 reset */
  #define RCU_APB1RST_WWDGTRST  0x00000800	/* WWDGT reset */
  #define RCU_APB1RST_SPI1RST   0x00004000	/* SPI1 reset */
  #define RCU_APB1RST_SPI2RST   0x00008000	/* SPI2 reset */
  #define RCU_APB1RST_USART1RST 0x00020000	/* USART1 reset */
  #define RCU_APB1RST_USART2RST 0x00040000	/* USART2 reset */
  #define RCU_APB1RST_UART3RST  0x00080000	/* UART3 reset */
  #define RCU_APB1RST_UART4RST  0x00100000	/* UART4 reset */
  #define RCU_APB1RST_I2C0RST   0x00200000	/* I2C0 reset */
  #define RCU_APB1RST_I2C1RST   0x00400000	/* I2C1 reset */
  #define RCU_APB1RST_CAN0RST   0x02000000	/* CAN0 reset */
  #define RCU_APB1RST_CAN1RST   0x04000000	/* CAN1 reset */
  #define RCU_APB1RST_BKPIRST   0x08000000	/* backup interface reset */
  #define RCU_APB1RST_PMURST    0x10000000	/* PMU reset */
  #define RCU_APB1RST_DACRST    0x20000000	/* DAC reset */
#define TOFF_RCU_AHBEN      0x0014		/* (RW) AHB1 enable register */
  #define RCU_AHBEN_DMA0EN      0x00000001	/* DMA0 clock enable */
  #define RCU_AHBEN_DMA1EN      0x00000002	/* DMA1 clock enable */
  #define RCU_AHBEN_SRAMSPEN    0x00000004	/* SRAM clock enable when sleep mode */
  #define RCU_AHBEN_FMCSPEN     0x00000010	/* FMC clock enable when sleep mode */
  #define RCU_AHBEN_CRCEN       0x00000040	/* CRC clock enable */
  #define RCU_AHBEN_EXMCEN      0x00000100	/* EXMC clock enable */
  #define RCU_AHBEN_USBFSEN     0x00001000	/* USBFS clock enable */
#define TOFF_RCU_APB2EN     0x0018		/* (RW) APB2 enable register */
  #define RCU_APB2EN_AFEN       0x00000001	/* alternate function IO clock enable */
  #define RCU_APB2EN_PAEN       0x00000004	/* GPIO port A clock enable */
  #define RCU_APB2EN_PBEN       0x00000008	/* GPIO port B clock enable */
  #define RCU_APB2EN_PCEN       0x00000010	/* GPIO port C clock enable */
  #define RCU_APB2EN_PDEN       0x00000020	/* GPIO port D clock enable */
  #define RCU_APB2EN_PEEN       0x00000040	/* GPIO port E clock enable */
  #define RCU_APB2EN_ADC0EN     0x00000200	/* ADC0 clock enable */
  #define RCU_APB2EN_ADC1EN     0x00000400	/* ADC1 clock enable */
  #define RCU_APB2EN_TIMER0EN   0x00000800	/* TIMER0 clock enable */
  #define RCU_APB2EN_SPI0EN     0x00001000	/* SPI0 clock enable */
  #define RCU_APB2EN_USART0EN   0x00004000	/* USART0 clock enable */
#define TOFF_RCU_APB1EN     0x001C		/* (RW) APB1 enable register */
  #define RCU_APB1EN_TIMER1EN   0x00000001	/* TIMER1 clock enable */
  #define RCU_APB1EN_TIMER2EN   0x00000002	/* TIMER2 clock enable */
  #define RCU_APB1EN_TIMER3EN   0x00000004	/* TIMER3 clock enable */
  #define RCU_APB1EN_TIMER4EN   0x00000008	/* TIMER4 clock enable */
  #define RCU_APB1EN_TIMER5EN   0x00000010	/* TIMER5 clock enable */
  #define RCU_APB1EN_TIMER6EN   0x00000020	/* TIMER6 clock enable */
  #define RCU_APB1EN_WWDGTEN    0x00000800	/* WWDGT clock enable */
  #define RCU_APB1EN_SPI1EN     0x00004000	/* SPI1 clock enable */
  #define RCU_APB1EN_SPI2EN     0x00008000	/* SPI2 clock enable */
  #define RCU_APB1EN_USART1EN   0x00020000	/* USART1 clock enable */
  #define RCU_APB1EN_USART2EN   0x00040000	/* USART2 clock enable */
  #define RCU_APB1EN_UART3EN    0x00080000	/* UART3 clock enable */
  #define RCU_APB1EN_UART4EN    0x00100000	/* UART4 clock enable */
  #define RCU_APB1EN_I2C0EN     0x00200000	/* I2C0 clock enable */
  #define RCU_APB1EN_I2C1EN     0x00400000	/* I2C1 clock enable */
  #define RCU_APB1EN_CAN0EN     0x02000000	/* CAN0 clock enable */
  #define RCU_APB1EN_CAN1EN     0x04000000	/* CAN1 clock enable */
  #define RCU_APB1EN_BKPIEN     0x08000000	/* backup interface clock enable */
  #define RCU_APB1EN_PMUEN      0x10000000	/* PMU clock enable */
  #define RCU_APB1EN_DACEN      0x20000000	/* DAC clock enable */
#define TOFF_RCU_BDCTL      0x0020		/* (RW) backup domain control register */
  #define RCU_BDCTL_LXTALEN     0x00000001	/* LXTAL enable */
  #define RCU_BDCTL_LXTALSTB    0x00000002	/* low speed crystal oscillator stabilization flag */
  #define RCU_BDCTL_LXTALBPS    0x00000004	/* LXTAL bypass mode enable */
  #define RCU_BDCTL_RTCSRC      0x00000300	/* RTC clock entry selection */
  #define RCU_BDCTL_RTCEN       0x00008000	/* RTC clock enable */
  #define RCU_BDCTL_BKPRST      0x00010000	/* backup domain reset */
#define TOFF_RCU_RSTSCK     0x0024		/* (RW) reset source / clock register */
  #define RCU_RSTSCK_IRC40KEN   0x00000001	/* IRC40K enable */
  #define RCU_RSTSCK_IRC40KSTB  0x00000002	/* IRC40K stabilization flag */
  #define RCU_RSTSCK_RSTFC      0x01000000	/* reset flag clear */
  #define RCU_RSTSCK_EPRSTF     0x04000000	/* external pin reset flag */
  #define RCU_RSTSCK_PORRSTF    0x08000000	/* power reset flag */
  #define RCU_RSTSCK_SWRSTF     0x10000000	/* software reset flag */
  #define RCU_RSTSCK_FWDGTRSTF  0x20000000	/* free watchdog timer reset flag */
  #define RCU_RSTSCK_WWDGTRSTF  0x40000000	/* window watchdog timer reset flag */
  #define RCU_RSTSCK_LPRSTF     0x80000000	/* low-power reset flag */
#define TOFF_RCU_AHBRST     0x0028		/* (RW) AHB reset register */
  #define RCU_AHBRST_USBFSRST   0x00001000	/* USBFS reset */
#define TOFF_RCU_CFG1       0x002C		/* (RW) clock configuration register 1 */
  #define RCU_CFG1_PREDV0       0x0000000F	/* PREDV0 division factor */
  #define RCU_CFG1_PREDV0_0     0x00000001
  #define RCU_CFG1_PREDV0_1     0x00000002
  #define RCU_CFG1_PREDV0_2     0x00000004
  #define RCU_CFG1_PREDV0_3     0x00000008
  #define RCU_CFG1_PREDV1       0x000000F0	/* PREDV1 division factor */
  #define RCU_CFG1_PREDV1_0     0x00000010
  #define RCU_CFG1_PREDV1_1     0x00000020
  #define RCU_CFG1_PREDV1_2     0x00000040
  #define RCU_CFG1_PREDV1_3     0x00000080
  #define RCU_CFG1_PLL1MF       0x00000F00	/* PLL1 clock multiplication factor */
  #define RCU_CFG1_PLL2MF       0x0000F000	/* PLL2 clock multiplication factor */
  #define RCU_CFG1_PREDV0SEL    0x00010000	/* PREDV0 input clock source selection */
  #define RCU_CFG1_I2S1SEL      0x00020000	/* I2S1 clock source selection */
  #define RCU_CFG1_I2S2SEL      0x00040000	/* I2S2 clock source selection  */
#define TOFF_RCU_DSV        0x0034		/* (RW) deep-sleep mode voltage register */
  #define RCU_DSV_DSLPVS        0x00000003	/* deep-sleep mode voltage select */


/*
 *  FMC
 */
#define TADR_FMC_BASE       (FMC_BASE)
#define TOFF_FMC_WS         0x0000		/* (RW) FMC wait state register */
  #define TOFF_FMC_WS_WSCNT     0x00000007	/* wait state counter */
#define TOFF_FMC_KEY0       0x0004		/* (RW) FMC unlock key register 0 */
#define TOFF_FMC_OBKEY      0x0008		/* (RW) FMC option bytes unlock key register */
#define TOFF_FMC_STAT0      0x000C		/* (RW) FMC status register 0 */
  #define TOFF_FMC_STAT0_BUSY   0x00000001	/* flash busy flag bit */
  #define TOFF_FMC_STAT0_PGERR  0x00000004	/* flash program error flag bit */
  #define TOFF_FMC_STAT0_WPERR  0x00000010	/* erase/program protection error flag bit */
  #define TOFF_FMC_STAT0_ENDF   0x00000020	/* end of operation flag bit */
#define TOFF_FMC_CTL0       0x0010		/* (RW) FMC control register 0 */
  #define TOFF_FMC_CTL0_PG      0x00000001	/* main flash program for bank0 command bit */
  #define TOFF_FMC_CTL0_PER     0x00000002	/* main flash page erase for bank0 command bit */
  #define TOFF_FMC_CTL0_MER     0x00000004	/* main flash mass erase for bank0 command bit */
  #define TOFF_FMC_CTL0_OBPG    0x00000010	/* option bytes program command bit */
  #define TOFF_FMC_CTL0_OBER    0x00000020	/* option bytes erase command bit */
  #define TOFF_FMC_CTL0_START   0x00000040	/* send erase command to FMC bit */
  #define TOFF_FMC_CTL0_LK      0x00000080	/* FMC_CTL0 lock bit */
  #define TOFF_FMC_CTL0_OBWEN   0x00000200	/* option bytes erase/program enable bit */
  #define TOFF_FMC_CTL0_ERRIE   0x00000400	/* error interrupt enable bit */
  #define TOFF_FMC_CTL0_ENDIE   0x00001000	/* end of operation interrupt enable bit */
#define TOFF_FMC_ADDR0      0x0014		/* (RW) FMC address register 0 */
#define TOFF_FMC_OBSTAT     0x001C		/* (RW) FMC option bytes status register */
  #define TOFF_FMC_OBSTAT_OBERR 0x00000001	/* option bytes read error bit. */
  #define TOFF_FMC_OBSTAT_SPC   0x00000002	/* option bytes security protection code */
  #define TOFF_FMC_OBSTAT_USER  0x000003FC	/* store USER of option bytes block after system reset */
  #define TOFF_FMC_OBSTAT_DATA  0x03FFFC00	/* store DATA of option bytes block after system reset. */
#define TOFF_FMC_WP         0x0020		/* (RW) FMC erase/program protection register */
#define TOFF_FMC_PID        0x0100		/* (RW) FMC product ID register */


/*
 *  OB
 */
#define TADR_OB_BASE        OB_BASE
#define TOFF_OB_SPC         0x0000		/* (RW16) option byte security protection value */
#define TOFF_OB_USER        0x0002		/* (RW16) option byte user value*/
#define TOFF_OB_WP0         0x0008		/* (RW16) option byte write protection 0 */
#define TOFF_OB_WP1         0x000A		/* (RW16) option byte write protection 1 */
#define TOFF_OB_WP2         0x000C		/* (RW16) option byte write protection 2 */
#define TOFF_OB_WP3         0x000E		/* (RW16) option byte write protection 3 */


/*
 *  CRC
 */
#define TADR_CRC_BASE       CRC_BASE
#define TOFF_CRC_DATA       0x0000		/* (RW) CRC data register */
#define TOFF_CRC_FDATA      0x0004		/* (RW) CRC free data register */
  #define CRC_FDATA_FDATA       0x000000FF	/* CRC free data bits */
#define TOFF_CRC_CTL        0x0008		/* (RW) CRC control register */
  #define CRC_CTL_RST           0x00000001	/* CRC reset CRC_DATA register bit */


/*
 *  USBFS
 */
#define USB_OTG_DEVICE_BASE         0x0800
#define USB_OTG_IN_ENDPOINT_BASE    0x0900
#define USB_OTG_OUT_ENDPOINT_BASE   0x0B00
#define USB_OTG_HOST_BASE           0x0400
#define USB_OTG_HOST_PORT_BASE      0x0440
#define USB_OTG_HOST_CHANNEL_BASE   0x0500
#define USB_OTG_PCGCCTL_BASE        0x0E00
#define USB_OTG_FIFO_BASE           0x1000
#define USB_OTG_FIFO_SIZE           0x1000


#define TADR_USB_OTGFS_BASE USBFS_BASE


#define TOFF_USBO_GOTGCS    0x0000		/* (RW) USB global OTG control and status register */
  #define USB_OTG_GOTGCS_SRPS       0x00000001	/* SRP successes */
  #define USB_OTG_GOTGCS_HNPS       0x00000100	/* HNP successes */
  #define USB_OTG_GOTGCS_HNPREQ     0x00000200	/* HNP request */
  #define USB_OTG_GOTGCS_HHNPEN     0x00000400	/* host HNP enable */
  #define USB_OTG_GOTGCS_DHNPEN     0x00000800	/* device HNP enable */
  #define USB_OTG_GOTGCS_CIDPS      0x00010000	/* id pin status */
  #define USB_OTG_GOTGCS_DI         0x00020000	/* debounce interval */
  #define USB_OTG_GOTGCS_ASV        0x00040000	/* A-session valid */
  #define USB_OTG_GOTGCS_BSV        0x00080000	/* B-Session Valid */
#define TOFF_USBO_GOTGINTF  0x0004		/* (RW) USB global OTG interrupt flag register */
  #define USB_OTG_GOTGINTF_SESEND   0x00000004	/* session end */
  #define USB_OTG_GOTGINTF_SRPEND   0x00000100	/* SRP end */
  #define USB_OTG_GOTGINTF_HNPEND   0x00000200	/* HNP end */
  #define USB_OTG_GOTGINTF_HNPDET   0x00020000	/* host negotiation request detected */
  #define USB_OTG_GOTGINTF_ADTO     0x00040000	/* A-device timeout */
  #define USB_OTG_GOTGINTF_DF       0x00080000	/* debounce finish */
#define TOFF_USBO_GAHBCS    0x0008		/* (RW) USB global AHB control and status register */
  #define USB_OTG_GAHBCS_GINTEN     0x00000001	/* global interrupt enable */
  #define USB_OTG_GAHBCS_BURST      0x0000001E	/* the AHB burst type used by DMA */
  #define USB_OTG_GAHBCS_BURST_0    0x00000002	/* Bit 0 */
  #define USB_OTG_GAHBCS_BURST_1    0x00000004	/* Bit 1 */
  #define USB_OTG_GAHBCS_BURST_2    0x00000008	/* Bit 2 */
  #define USB_OTG_GAHBCS_BURST_3    0x00000010	/* Bit 3 */
  #define USB_OTG_GAHBCS_DMAEN      0x00000020	/* DMA function Enable */
  #define USB_OTG_GAHBCS_TXFTH      0x00000080	/* tx FIFO threshold */
  #define USB_OTG_GAHBCS_PTXFTH     0x00000100	/* periodic Tx FIFO threshold */
#define TOFF_USBO_GUSBCS    0x000C		/* (RW) USB global USB control and status register */
  #define USB_OTG_GUSBCS_TOC        0x00000007	/* timeout calibration */
  #define USB_OTG_GUSBCS_TOC_0      0x00000001	/* Bit 0 */
  #define USB_OTG_GUSBCS_TOC_1      0x00000002	/* Bit 1 */
  #define USB_OTG_GUSBCS_TOC_2      0x00000004	/* Bit 2 */
  #define USB_OTG_GUSBCS_EMBPHY     0x00000040	/* embedded PHY selected */
  #define USB_OTG_GUSBCS_SRPCEN     0x00000100	/* SRP capability enable */
  #define USB_OTG_GUSBCS_HNPCEN     0x00000200	/* HNP capability enable */
  #define USB_OTG_GUSBCS_UTT        0x00003C00	/* USB turnaround time */
  #define USB_OTG_GUSBCS_UTT_0      0x00000400	/* Bit 0 */
  #define USB_OTG_GUSBCS_UTT_1      0x00000800	/* Bit 1 */
  #define USB_OTG_GUSBCS_UTT_2      0x00001000	/* Bit 2 */
  #define USB_OTG_GUSBCS_UTT_3      0x00002000	/* Bit 3 */
  #define USB_OTG_GUSBCS_ULPIEVD    0x00100000	/* ULPI external VBUS driver */
  #define USB_OTG_GUSBCS_ULPIEOI    0x00200000	/* ULPI external over-current indicator */
  #define USB_OTG_GUSBCS_FHM        0x20000000	/* force host mode */
  #define USB_OTG_GUSBCS_FDM        0x40000000	/* force device mode */
#define TOFF_USBO_GRSTCTL   0x0010		/* (RW) USB global reset control register */
  #define USB_OTG_GRSTCTL_CSRST     0x00000001	/* core soft reset */
  #define USB_OTG_GRSTCTL_HCSRST    0x00000002	/* HCLK soft reset */
  #define USB_OTG_GRSTCTL_HFCRST    0x00000004	/* host frame counter reset */
  #define USB_OTG_GRSTCTL_RXFF      0x00000010	/* rx FIFO flush */
  #define USB_OTG_GRSTCTL_TXFF      0x00000020	/* tx FIFO flush */
  #define USB_OTG_GRSTCTL_TXFNUM    0x000007C0	/* tx FIFO number */
  #define USB_OTG_GRSTCTL_TXFNUM_0  0x00000040	/* Bit 0 */
  #define USB_OTG_GRSTCTL_TXFNUM_1  0x00000080	/* Bit 1 */
  #define USB_OTG_GRSTCTL_TXFNUM_2  0x00000100	/* Bit 2 */
  #define USB_OTG_GRSTCTL_TXFNUM_3  0x00000200	/* Bit 3 */
  #define USB_OTG_GRSTCTL_TXFNUM_4  0x00000400	/* Bit 4 */
  #define USB_OTG_GRSTCTL_DMABSY    0x40000000	/* DMA busy */
  #define USB_OTG_GRSTCTL_DMAIDL    0x80000000	/* DMA idle state */
#define TOFF_USBO_GINTF     0x0014		/* (RW) USB global interrupt flag register */
  #define USB_OTG_GINTF_COPM        0x00000001	/* current operation mode */
  #define USB_OTG_GINTF_MFIF        0x00000002	/* mode fault interrupt flag */
  #define USB_OTG_GINTF_OTGIF       0x00000004	/* OTG interrupt flag */
  #define USB_OTG_GINTF_SOF         0x00000008	/* start of frame */
  #define USB_OTG_GINTF_RXFNEIF     0x00000010	/* rx FIFO non-empty interrupt flag */
  #define USB_OTG_GINTF_NPTXFEIF    0x00000020	/* non-periodic tx FIFO empty interrupt flag */
  #define USB_OTG_GINTF_GNPINAK     0x00000040	/* global IN non-periodic NAK effective */
  #define USB_OTG_GINTF_GONAK       0x00000080	/* global OUT NAK effective */
  #define USB_OTG_GINTF_ESP         0x00000400	/* early suspend */
  #define USB_OTG_GINTF_SP          0x00000800	/* USB suspend */
  #define USB_OTG_GINTF_RST         0x00001000	/* USB reset */
  #define USB_OTG_GINTF_ENUMFIF     0x00002000	/* enumeration finished */
  #define USB_OTG_GINTF_ISOOPDIF    0x00004000	/* isochronous OUT packet dropped interrupt flag */
  #define USB_OTG_GINTF_EOPFIF      0x00008000	/* end of periodic frame interrupt flag */
  #define USB_OTG_GINTF_IEPIF       0x00040000	/* IN endpoint interrupt flag */
  #define USB_OTG_GINTF_OEPIF       0x00080000	/* OUT endpoint interrupt flag */
  #define USB_OTG_GINTF_ISOINCIF    0x00100000	/* isochronous IN transfer not complete interrupt flag */
  #define USB_OTG_GINTF_ISOONCIF    0x00200000	/* isochronous OUT transfer not complete interrupt flag */
  #define USB_OTG_GINTF_PXNCIF      0x00200000	/* periodic transfer not complete interrupt flag */
  #define USB_OTG_GINTF_HPIF        0x01000000	/* host port interrupt flag */
  #define USB_OTG_GINTF_HCIF        0x02000000	/* host channels interrupt flag */
  #define USB_OTG_GINTF_PTXFEIF     0x04000000	/* periodic tx FIFO empty interrupt flag */
  #define USB_OTG_GINTF_IDPSC       0x10000000	/* id pin status change */
  #define USB_OTG_GINTF_DISCIF      0x20000000	/* disconnect interrupt flag */
  #define USB_OTG_GINTF_SESIF       0x40000000	/* session interrupt flag */
  #define USB_OTG_GINTF_WKUPIF      0x80000000	/* wakeup interrupt flag */
#define TOFF_USBO_GINTEN    0x0018		/* (RW) USB global interrupt enable register */
  #define USB_OTG_GINTEN_MFIE       0x00000002	/* mode fault interrupt enable */
  #define USB_OTG_GINTEN_OTGIE      0x00000004	/* OTG interrupt enable */
  #define USB_OTG_GINTEN_SOFIE      0x00000008	/* start of frame interrupt enable */
  #define USB_OTG_GINTEN_RXFNEIE    0x00000010	/* receive FIFO non-empty interrupt enable */
  #define USB_OTG_GINTEN_NPTXFEIE   0x00000020	/* non-periodic Tx FIFO empty interrupt enable */
  #define USB_OTG_GINTEN_GNPINAKIE  0x00000040	/* global non-periodic IN NAK effective interrupt enable */
  #define USB_OTG_GINTEN_GONAKIE    0x00000080	/* global OUT NAK effective interrupt enable */
  #define USB_OTG_GINTEN_ESPIE      0x00000400	/* early suspend interrupt enable */
  #define USB_OTG_GINTEN_SPIE       0x00000800	/* USB suspend interrupt enable */
  #define USB_OTG_GINTEN_RSTIE      0x00001000	/* USB reset interrupt enable */
  #define USB_OTG_GINTEN_ENUMFIE    0x00002000	/* enumeration finish enable */
  #define USB_OTG_GINTEN_ISOOPDIE   0x00004000	/* isochronous OUT packet dropped interrupt enable */
  #define USB_OTG_GINTEN_EOPFIE     0x00008000	/* end of periodic frame interrupt enable */
  #define USB_OTG_GINTEN_IEPIE      0x00040000	/* IN endpoints interrupt enable */
  #define USB_OTG_GINTEN_OEPIE      0x00080000	/* OUT endpoints interrupt enable */
  #define USB_OTG_GINTEN_ISOINCIE   0x00100000	/* isochronous IN transfer not complete interrupt enable */
  #define USB_OTG_GINTEN_ISOONCIE   0x00200000	/* isochronous OUT transfer not complete interrupt enable */
  #define USB_OTG_GINTEN_IPXIE      0x00400000	/* periodic transfer not complete interrupt enable */
  #define USB_OTG_GINTEN_HPIE       0x01000000	/* host port interrupt enable */
  #define USB_OTG_GINTEN_HCIE       0x02000000	/* host channels interrupt enable */
  #define USB_OTG_GINTEN_PTXFEIE    0x04000000	/* periodic tx FIFO empty interrupt enable */
  #define USB_OTG_GINTEN_IDPSCIE    0x10000000	/* id pin status change interrupt enable */
  #define USB_OTG_GINTEN_DISCIE     0x20000000	/* disconnect interrupt enable */
  #define USB_OTG_GINTEN_SESIE      0x40000000	/* session interrupt enable */
  #define USB_OTG_GINTEN_WKUPIE     0x80000000	/* wakeup interrupt enable */
#define TOFF_USBO_GRSTATR   0x001C		/* (RW) USB receive status debug read register */
#define TOFF_USBO_GRSTATP   0x0020		/* (RW) USB receive status and pop register */
  #define USB_OTG_GRSTATRP_EPNUM    0x0000000F	/* endpoint number */
  #define USB_OTG_GRSTATRP_CNUM     0x0000000F	/* channel number */
  #define USB_OTG_GRSTATRP_BCOUNT   0x00007FF0	/* byte count */
  #define USB_OTG_GRSTATRP_DPID     0x00018000	/* data PID */
  #define USB_OTG_GRSTATRP_RPCKST   0x001E0000	/* received packet status */
#define TOFF_USBO_GRFLEN    0x0024		/* (RW) USB global receive FIFO length register */
  #define USB_OTG_GRFLEN_RXFD       0x0000FFFF	/* rx FIFO depth */
#define TOFF_USBO_DIEP0TFLEN_HNPTFLEN 0x0028              /* (RW) USB device IN endpoint 0/host non-periodic transmit FIFO length register 028h */
  #define USB_OTG_HNPTFLEN_HNPTXRSAR 0x0000FFFF	/* non-periodic Tx RAM start address */
  #define USB_OTG_HNPTFLEN_HNPTXFD   0xFFFF0000	/* non-periodic Tx FIFO depth */
#define TOFF_USBO_HNPTFQSTAT 0x02C		/* (RW) USB host non-periodic FIFO/queue status register 02Ch */
  #define USB_OTG_HNPTFQSTAT_NPTXFS  0x0000FFFF	/* non-periodic Tx FIFO space */
  #define USB_OTG_HNPTFQSTAT_NPTXRQS 0x00FF0000	/* non-periodic Tx request queue space */
  #define USB_OTG_HNPTFQSTAT_NPTXRQTOP 0x7F000000	/* top entry of the non-periodic Tx request queue */
  #define USB_OTG_HNPTFQSTAT_TMF     0x01000000	/* terminate flag */
  #define USB_OTG_HNPTFQSTAT_TYPE    0x06000000	/* token type */
  #define USB_OTG_HNPTFQSTAT_EPNUM   0x78000000	/* endpoint number */
  #define USB_OTG_HNPTFQSTAT_CNUM    0x78000000	/* channel number*/
#define TOFF_USBO_GCCFG     0x0038		/* (RW) USB global core configuration register */
  #define USB_OTG_GCCFG_PWRON       0x00010000	/* power on */
  #define USB_OTG_GCCFG_VBUSACEN    0x00040000	/* the VBUS A-device comparer enable */
  #define USB_OTG_GCCFG_VBUSBCEN    0x00080000	/* the VBUS B-device comparer enable */
  #define USB_OTG_GCCFG_SOFOEN      0x00100000	/* SOF output enable */
  #define USB_OTG_GCCFG_VBUSIG      0x00200000	/* vbus ignored */
#define TOFF_USBO_CID       0x0040		/* (RW) USB core ID register */
#define TOFF_USBO_HPTFLEN   0x0100		/* (RW) USB host periodic transmit FIFO length register */
  #define USB_OTG_HPTFLEN_HPTXFSAR  0x0000FFFF	/* host periodic Tx RAM start address */
  #define USB_OTG_HPTFLEN_HPTXFD    0xFFFF0000	/* host periodic Tx FIFO depth */
#define TOFF_USBO_DIEPTFLEN 0x0104		/* (RW) USB device IN endpoint transmit FIFO length register 104h */
  #define USB_OTG_DIEPTFLEN_IEPTXRSAR 0x0000FFFF	/* IN endpoint FIFOx Tx x RAM start address */
  #define USB_OTG_DIEPTFLEN_IEPTXFD   0xFFFF0000	/* IN endpoint Tx FIFO x depth */

/*
 *  USB DEVICE(OTG)
 */
#define TADR_USB_DEVICE_BASE (USBFS_BASE+USB_OTG_DEVICE_BASE)
#define TOFF_USBD_DCFG      0x0000		/* (RW) USB device configuration register */
  #define USB_OTG_DCFG_DS           0x00000003	/* device speed */
  #define USB_OTG_DCFG_DS_0         0x00000001	/* Bit 0 */
  #define USB_OTG_DCFG_DS_1         0x00000002	/* Bit 1 */
  #define USB_OTG_DCFG_NZLSOH       0x00000004	/* non-zero-length status OUT handshake */
  #define USB_OTG_DCFG_DCFG_DAR     0x000007F0	/* device address */
  #define USB_OTG_DCFG_DAR_0        0x00000010	/* Bit 0 */
  #define USB_OTG_DCFG_DAR_1        0x00000020	/* Bit 1 */
  #define USB_OTG_DCFG_DAR_2        0x00000040	/* Bit 2 */
  #define USB_OTG_DCFG_DAR_3        0x00000080	/* Bit 3 */
  #define USB_OTG_DCFG_DAR_4        0x00000100	/* Bit 4 */
  #define USB_OTG_DCFG_DAR_5        0x00000200	/* Bit 5 */
  #define USB_OTG_DCFG_DAR_6        0x00000400	/* Bit 6 */
  #define USB_OTG_DCFG_EOPFT        0x00001800	/* end of periodic frame time */
  #define USB_OTG_DCFG_EOPFT_0      0x00000800	/* Bit 0 */
  #define USB_OTG_DCFG_EOPFT_1      0x00001000	/* Bit 1 */
#define TOFF_USBD_DCTL      0x0004		/* (RW) USB device control register */
  #define USB_OTG_DCTL_RWKUP        0x00000001	/* remote wakeup */
  #define USB_OTG_DCTL_SD           0x00000002	/* soft disconnect */
  #define USB_OTG_DCTL_GINS         0x00000004	/* global IN NAK status */
  #define USB_OTG_DCTL_GONS         0x00000008	/* global OUT NAK status */
  #define USB_OTG_DCTL_SGINAK       0x00000080	/* set global IN NAK */
  #define USB_OTG_DCTL_CGINAK       0x00000100	/* clear global IN NAK */
  #define USB_OTG_DCTL_SGONAK       0x00000200	/* set global OUT NAK */
  #define USB_OTG_DCTL_CGONAK       0x00000400	/* clear global OUT NAK */
  #define USB_OTG_DCTL_POIF         0x00000800	/* power-on initialization finished */
#define TOFF_USBD_DSTAT     0x0008		/* (RW) USB device status register */
  #define USB_OTG_DSTAT_SPST        0x00000001	/* suspend status */
  #define USB_OTG_DSTAT_ES                  BITS(1, 2)          /* enumerated speed */
  #define USB_OTG_DSTAT_ES_0        0x00000002	/* Bit 0 */
  #define USB_OTG_DSTAT_ES_1        0x00000004	/* Bit 1 */
  #define USB_OTG_DSTAT_FNRSOF      0x003FFF00	/* the frame number of the received SOF. */
#define TOFF_USBD_DIEPINTEN 0x0010		/* (RW) USB device IN endpoint common interrupt enable register */
  #define USB_OTG_DIEPINTEN_TFEN       0x00000001	/* transfer finished interrupt enable bit */ 
  #define USB_OTG_DIEPINTEN_EPDISEN    0x00000002	/* endpoint disabled interrupt enable bit */
  #define USB_OTG_DIEPINTEN_CITOEN     0x00000008	/* control In Timeout interrupt enable bit */
  #define USB_OTG_DIEPINTEN_EPTXFUDEN  0x00000010	/* endpoint Tx FIFO underrun interrupt enable bit */
  #define USB_OTG_DIEPINTEN_IEPNEEN    0x00000020	/* IN endpoint NAK effective interrupt enable bit */
  #define USB_OTG_DIEPINTEN_TXFEEN     0x00000080	/* transmit FIFO empty interrupt enable bit */
  #define USB_OTG_DIEPINTEN_NAKEN      0x00002000	/* NAK handshake sent by USBHS interrupt enable bit */
#define TOFF_USBD_DOEPINTEN 0x0014		/* (RW) USB device OUT endpoint common interrupt enable register */
  #define USB_OTG_DOEPINTEN_TFEN       0x00000001	/* transfer finished interrupt enable bit */
  #define USB_OTG_DOEPINTEN_EPDISEN    0x00000002	/* endpoint disabled interrupt enable bit */
  #define USB_OTG_DOEPINTEN_STPFEN     0x00000008	/* SETUP phase finished interrupt enable bit */
  #define USB_OTG_DOEPINTEN_EPRXFOVREN 0x00000010	/* endpoint Rx FIFO overrun interrupt enable bit */
  #define USB_OTG_DOEPINTEN_BTBSTPEN   0x00000020	/* back-to-back SETUP packets interrupt enable bit */
  #define USB_OTG_DOEPINTEN_NYETEN     0x00004000	/* NYET handshake is sent interrupt enable bit */
#define TOFF_USBD_DAEPINT   0x0018		/* (RW) USB device all endpoints interrupt register */
  #define USB_OTG_DAEPINT_IEPITB    0x0000003F	/* device all IN endpoint interrupt bits */
  #define USB_OTG_DAEPINT_OEPITB    0x003F0000	/* device all OUT endpoint interrupt bits */
#define TOFF_USBD_DAEPINTEN 0x001C		/* (RW) USB device all endpoints interrupt enable register */
  #define USB_OTG_DAEPINTEN_IEPIE   0x0000000F	/* IN endpoint interrupt enable */
  #define USB_OTG_DAEPINTEN_OEPIE   0x003F0000	/* OUT endpoint interrupt enable */
#define TOFF_USBD_DVBUSDT   0x0028		/* (RW) USB device VBUS discharge time register */
  #define USB_OTG_DVBUSDT_DVBUSDT   0x0000FFFF	/* device VBUS discharge time */
#define TOFF_USBD_DVBUSPT   0x002C		/* (RW) USB device VBUS pulsing time register */
  #define USB_OTG_DVBUSPT_DVBUSPT   0x00000FFF	/* device VBUS pulsing time */
#define TOFF_USBD_DTHRCTL   0x0030		/* (RW) USB device dev thr  */
#define TOFF_USBD_DIEPFEINTEN 0x0034	/* (RW) USB Device IN endpoint FIFO empty interrupt enable register */
  #define USB_OTG_DIEPFEINTEN_IEPTXFEIE 0x0000003F	/* IN endpoint Tx FIFO empty interrupt enable bits */
#define TOFF_USBD_DEP1INT   0x0038		/* (RW) USB device endpoint 1 interrupt register */
#define TOFF_USBD_DEP1INTEN 0x0040		/* (RW) USB device endpoint 1 interrupt enable register */
#define TOFF_USBD_DIEP1INTEN 0x0044		/* (RW) USB device IN endpoint-1 interrupt enable register */
#define TOFF_USBD_DOEP1INTEN 0x0084		/* (RW) USB device OUT endpoint-1 interrupt enable register */

/*
 *  USB OTG IN ENDPOINT
 */
#define TADR_USBO_INEP_BASE (USBFS_BASE+USB_OTG_IN_ENDPOINT_BASE)
#define USBO_EP_REG_SIZE    0x20
#define TOFF_USBEI_DIEPCTL  0x0000		/* (RW) USB device IN endpoint control register */
  #define USB_OTG_DIEPCTL_MPL       0x000007FF	/* maximum packet length */
  #define USB_OTG_DIEPCTL_EPACT     0x00000800	/* endpoint active */
  #define USB_OTG_DIEPCTL_DPID      0x00010000	/* endpoint data PID */
  #define USB_OTG_DIEPCTL_EOFRM     0x00010000	/* even/odd frame */
  #define USB_OTG_DIEPCTL_NAKS      0x00020000	/* NAK status */
  #define USB_OTG_DIEPCTL_EPTYPE    0x000C0000	/* endpoint type */
  #define USB_OTG_DIEPCTL_EPTYPE_0  0x00040000	/* Bit 0 */
  #define USB_OTG_DIEPCTL_EPTYPE_1  0x00080000	/* Bit 1 */
  #define USB_OTG_DIEPCTL_STALL     0x00200000	/* STALL handshake */
  #define USB_OTG_DIEPCTL_TXFNUM    0x03C00000	/* tx FIFO number */
  #define USB_OTG_DIEPCTL_TXFNUM_0  0x00400000	/* Bit 0 */
  #define USB_OTG_DIEPCTL_TXFNUM_1  0x00800000	/* Bit 1 */
  #define USB_OTG_DIEPCTL_TXFNUM_2  0x01000000	/* Bit 2 */
  #define USB_OTG_DIEPCTL_TXFNUM_3  0x02000000	/* Bit 3 */
  #define USB_OTG_DIEPCTL_CNAK      0x04000000	/* clear NAK */
  #define USB_OTG_DIEPCTL_SNAK      0x08000000	/* set NAK */
  #define USB_OTG_DIEPCTL_SD0PID    0x10000000	/* set DATA0 PID */
  #define USB_OTG_DIEPCTL_SEVNFRM   0x10000000	/* set even frame */
  #define USB_OTG_DIEPCTL_SD1PID    0x20000000	/* set DATA1 PID */
  #define USB_OTG_DIEPCTL_SODDFRM   0x20000000	/* set odd frame */
  #define USB_OTG_DIEPCTL_EPD       0x40000000	/* endpoint disable */
  #define USB_OTG_DIEPCTL_EPEN      0x80000000	/* endpoint enable */
#define TOFF_USBEI_DIEPINTF 0x0008		/* (RW) USB device IN endpoint interrupt flag register */
  #define USB_OTG_DIEPINTF_TF       0x00000001	/* transfer finished */
  #define USB_OTG_DIEPINTF_EPDIS    0x00000002	/* endpoint disabled */
  #define USB_OTG_DIEPINTF_CITO     0x00000008	/* control In Timeout interrupt */
  #define USB_OTG_DIEPINTF_EPTXFUD  0x00000010	/* endpoint Tx FIFO underrun */
  #define USB_OTG_DIEPINTF_IEPNE    0x00000040	/* IN endpoint NAK effective */
  #define USB_OTG_DIEPINTF_TXFE     0x00000080	/* transmit FIFO empty */
  #define USB_OTG_DIEPINTF_NAK      0x00002000	/* NAK handshake sent by USBHS */
#define TOFF_USBEI_DIEPLEN  0x0010		/* (RW) USB device IN endpoint transfer length register */
  #define USB_OTG_DIEPLEN_TLEN      0x0007FFFF	/* transfer length */
  #define USB_OTG_DIEPLEN_PCNT      0x1FF80000	/* packet count */
  #define USB_OTG_DIEPLEN_MCNT      0x60000000	/* multi count */
#define TOFF_USBEI_DIEPDMAADDR  0x0014	/* (RW) Device IN endpoint-x DMA address register */
  #define USB_OTG_DIEPDMAADDR_DMAADDR 0xFFFFFFFF	/* DMA address */
#define TOFF_USBEI_DIEPTFSTAT   0x0018	/* (RW) USB device IN endpoint transmit FIFO status register */
  #define USB_OTG_DIEPTFSTAT_IEPTFS   0x0000FFFF	/* IN endpoint Tx FIFO space remaining */

/*
 *  USB OTG OUTPUT ENDPOINT
 */
#define TADR_USBO_OUTEP_BASE    (USBFS_BASE+USB_OTG_OUT_ENDPOINT_BASE)
#define TOFF_USBO_DOEPCTL       0x0000		/* (RW) USB device IN endpoint control register */
  #define USB_OTG_DOEPCTL_MPL       0x000007FF	/* maximum packet length */
  #define USB_OTG_DOEPCTL_EPACT     0x00000800	/* endpoint active */
  #define USB_OTG_DOEPCTL_DPID      0x00010000	/* endpoint data PID */
  #define USB_OTG_DOEPCTL_EOFRM     0x00010000	/* even/odd frame */
  #define USB_OTG_DOEPCTL_NAKS      0x00020000	/* NAK status */
  #define USB_OTG_DOEPCTL_EPTYPE    0x000C0000	/* endpoint type */
  #define USB_OTG_DOEPCTL_EPTYPE_0  0x00040000	/* Bit 0 */
  #define USB_OTG_DOEPCTL_EPTYPE_1  0x00080000	/* Bit 1 */
  #define USB_OTG_DOEPCTL_SNOOP     0x00100000	/* snoop mode */
  #define USB_OTG_DOEPCTL_STALL     0x00200000	/* STALL handshake */
  #define USB_OTG_DOEPCTL_CNAK      0x04000000	/* clear NAK */
  #define USB_OTG_DOEPCTL_SNAK      0x08000000	/* set NAK */
  #define USB_OTG_DOEPCTL_EPD       0x40000000	/* endpoint disable */
  #define USB_OTG_DOEPCTL_EPEN      0x80000000	/* endpoint enable */
#define TOFF_USBO_DOEPINTF      0x0008		/* (RW) USB device IN endpoint interrupt flag register */
  #define USB_OTG_DOEPINTF_TF       0x00000001	/* transfer finished */
  #define USB_OTG_DOEPINTF_EPDIS    0x00000002	/* endpoint disabled */
  #define USB_OTG_DOEPINTF_STPF     0x00000008	/* SETUP phase finished */
  #define USB_OTG_DOEPINTF_EPRXFOVR 0x00000010	/* endpoint Rx FIFO overrun */
  #define USB_OTG_DOEPINTF_BTBSTP   0x00000040	/* back-to-back SETUP packets */
  #define USB_OTG_DOEPINTF_NYET     0x00004000	/* NYET handshake is sent */
#define TOFF_USBO_DOEPLEN       0x0010		/* (RW) USB device IN endpoint transfer length register */
  #define USB_OTG_DOEPLEN_TLEN      0x0007FFFF	/* transfer length */
  #define USB_OTG_DOEPLEN_PCNT      0x1FF80000	/* packet count */
  #define USB_OTG_DOEPLEN_STPCNT    0x60000000	/* SETUP packet count */
  #define USB_OTG_DOEPLEN_STPCNT_0  0x20000000	/* Bit 0 */
  #define USB_OTG_DOEPLEN_STPCNT_1  0x40000000	/* Bit 1 */
#define TOFF_USBO_DOEPDMAADDR   0x0014		/* (RW) Device OUT endpoint-x DMA address register */
  #define USB_OTG_DOEPDMAADDR_DMAADDR 0xFFFFFFFF	/* DMA address */

/*
 *  USB OTG HOST
 */
#define TADR_USBO_HOST_BASE     (USBFS_BASE+USB_OTG_HOST_BASE)

#define TOFF_USBH_HCTL          0x0000		/* (RW) USB host control register */
  #define USB_OTG_HCTL_CLKSEL       0x00000003	/* clock select for USB clock */
  #define USB_OTG_HCTL_CLKSEL_0     0x00000001	/* Bit 0 */
  #define USB_OTG_HCTL_CLKSEL_1     0x00000002	/* Bit 1 */
  #define USB_OTG_HCTL_SPDFSLS      0x00000004	/* speed limited to FS and LS */
#define TOFF_USBH_HFT           0x0004		/* (RW) USB host frame interval register */
  #define USB_OTG_HFT_FRI           0x0000FFFF	/* frame interval */
#define TOFF_USBH_HFINFR        0x0008		/* (RW) USB host frame information remaining register */
  #define USB_OTG_HFINFR_FRNUM      0x0000FFFF	/* frame number */
  #define USB_OTG_HFINFR_FRT        0xFFFF0000	/* frame remaining time */
#define TOFF_USBH_HPTFQSTAT     0x0010		/* (RW) USB host periodic transmit FIFO/queue status register */
  #define USB_OTG_HPTFQSTAT_PTXFS   0x0000FFFF	/* periodic Tx FIFO space */
  #define USB_OTG_HPTFQSTAT_PTXREQS 0x00FF0000	/* periodic Tx request queue space */
  #define USB_OTG_HPTFQSTAT_PTXREQS_0 0x00010000	/* Bit 0 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_1 0x00020000	/* Bit 1 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_2 0x00040000	/* Bit 2 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_3 0x00080000	/* Bit 3 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_4 0x00100000	/* Bit 4 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_5 0x00200000	/* Bit 5 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_6 0x00400000	/* Bit 6 */
  #define USB_OTG_HPTFQSTAT_PTXREQS_7 0x00800000	/* Bit 7 */
  #define USB_OTG_HPTFQSTAT_PTXREQT 0xFF000000	/* top entry of the periodic Tx request queue */
  #define USB_OTG_HPTFQSTAT_PTXREQT_0 0x01000000	/* Bit 0 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_1 0x02000000	/* Bit 1 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_2 0x04000000	/* Bit 2 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_3 0x08000000	/* Bit 3 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_4 0x10000000	/* Bit 4 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_5 0x20000000	/* Bit 5 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_6 0x40000000	/* Bit 6 */
  #define USB_OTG_HPTFQSTAT_PTXREQT_7 0x80000000	/* Bit 7 */
  #define USB_OTG_HPTFQSTAT_TMF     0x01000000	/* terminate flag */
  #define USB_OTG_HPTFQSTAT_TYPE    0x06000000	/* token type */
  #define USB_OTG_HPTFQSTAT_EPNUM   0x78000000	/* endpoint number */
  #define USB_OTG_HPTFQSTAT_CNUM    0x78000000	/* channel number */
  #define USB_OTG_HPTFQSTAT_OEFRM   0x80000000	/* odd/eveb frame */
#define TOFF_USBH_HACHINT       0x0014		/* (RW) USB host all channels interrupt register */
  #define USB_OTG_HACHINT_HACHINT   0x00000FFF	/* host all channel interrupts */
#define TOFF_USBH_HACHINTEN     0x0018		/* (RW) USB host all channels interrupt enable register */
  #define USB_OTG_HACHINTEN_CINTEN  0x00000FFF	/* channel interrupt enable */

/*
 *  USB HOST CHANNEL SPECIFIC
 */
#define TADR_USBH_HC_BASE        (USBFS_BASE+USB_OTG_HOST_CHANNEL_BASE)
#define USBO_HOST_CHANNEL_REG_SIZE    0x20
#define TOFF_USBHC_HCHCTL       0x0000		/* (RW) USB host channel control register */
  #define USB_OTG_HCHCTL_MPL        0x000007FF	/* maximum packet length */
  #define USB_OTG_HCHCTL_EPNUM      0x00007800	/* endpoint number */
  #define USB_OTG_HCHCTL_EPNUM_0    0x00000800	/* Bit 0 */
  #define USB_OTG_HCHCTL_EPNUM_1    0x00001000	/* Bit 1 */
  #define USB_OTG_HCHCTL_EPNUM_2    0x00002000	/* Bit 2 */
  #define USB_OTG_HCHCTL_EPNUM_3    0x00004000	/* Bit 3 */
  #define USB_OTG_HCHCTL_EPDIR      0x00008000	/* endpoint direction */
  #define USB_OTG_HCHCTL_LSD        0x00020000	/* low-speed device */
  #define USB_OTG_HCHCTL_EPTYPE     0x000C0000	/* endpoint type */
  #define USB_OTG_HCCHAR_EPTYPE_0   0x00040000	/* Bit 0 */
  #define USB_OTG_HCCHAR_EPTYPE_1   0x00080000	/* Bit 1 */
  #define USB_OTG_HCHCTL_MPC        0x00300000	/* multiple packet count */
  #define USB_OTG_HCCHAR_MPC_0      0x00100000	/* Bit 0 */
  #define USB_OTG_HCCHAR_MPC_1      0x00200000	/* Bit 1 */
  #define USB_OTG_HCHCTL_DAR        0x1FC00000	/* device address */
  #define USB_OTG_HCCHAR_DAR_0      0x00400000	/* Bit 0 */
  #define USB_OTG_HCCHAR_DAR_1      0x00800000	/* Bit 1 */
  #define USB_OTG_HCCHAR_DAR_2      0x01000000	/* Bit 2 */
  #define USB_OTG_HCCHAR_DAR_3      0x02000000	/* Bit 3 */
  #define USB_OTG_HCCHAR_DAR_4      0x04000000	/* Bit 4 */
  #define USB_OTG_HCCHAR_DAR_5      0x08000000	/* Bit 5 */
  #define USB_OTG_HCCHAR_DAR_6      0x10000000	/* Bit 6 */
  #define USB_OTG_HCHCTL_ODDFRM     0x20000000	/* odd frame */
  #define USB_OTG_HCHCTL_CDIS       0x40000000	/* channel disable */
  #define USB_OTG_HCHCTL_CEN        0x80000000	/* channel enable */
#define TOFF_USBHC_HCHSTCTL     0x0004		/* (RW) Reserved  */
  #define USB_OTG_HCHSTCTL_PADDR    0x0000007F	/* port address */
  #define USB_OTG_HCHSTCTL_PADDR_0  0x00000001	/* Bit 0 */
  #define USB_OTG_HCHSTCTL_PADDR_1  0x00000002	/* Bit 1 */
  #define USB_OTG_HCHSTCTL_PADDR_2  0x00000004	/* Bit 2 */
  #define USB_OTG_HCHSTCTL_PADDR_3  0x00000008	/* Bit 3 */
  #define USB_OTG_HCHSTCTL_PADDR_4  0x00000010	/* Bit 4 */
  #define USB_OTG_HCHSTCTL_PADDR_5  0x00000020	/* Bit 5 */
  #define USB_OTG_HCHSTCTL_PADDR_6  0x00000040	/* Bit 6 */
  #define USB_OTG_HCHSTCTL_HADDR    0x00003F80	/* HUB address */
  #define USB_OTG_HCHSTCTL_HADDR_0  0x00000080	/* Bit 0 */
  #define USB_OTG_HCHSTCTL_HADDR_1  0x00000100	/* Bit 1 */
  #define USB_OTG_HCHSTCTL_HADDR_2  0x00000200	/* Bit 2 */
  #define USB_OTG_HCHSTCTL_HADDR_3  0x00000400	/* Bit 3 */
  #define USB_OTG_HCHSTCTL_HADDR_4  0x00000800	/* Bit 4 */
  #define USB_OTG_HCHSTCTL_HADDR_5  0x00001000	/* Bit 5 */
  #define USB_OTG_HCHSTCTL_HADDR_6  0x00002000	/* Bit 6 */
  #define USB_OTG_HCHSTCTL_ISOPCE   0x0000C000	/* isochronous OUT payload continuation encoding */
  #define USB_OTG_HCHSTCTL_ISOPCE_0 0x00004000	/* Bit 0 */
  #define USB_OTG_HCHSTCTL_ISOPCE_1 0x00008000	/* Bit 1 */
  #define USB_OTG_HCHSTCTL_CSPLT    0x00010000	/* complete-split enable */
  #define USB_OTG_HCHSTCTL_SPLEN    0x80000000	/* enable high-speed split transaction */
#define TOFF_USBHC_HCHINTF      0x0008		/* (RW) USB host channel interrupt flag register */
  #define USB_OTG_HCHINTF_TF        0x00000001	/* transfer finished */
  #define USB_OTG_HCHINTF_CH        0x00000002	/* channel halted */
  #define USB_OTG_HCHINTF_DMAER     0x00000004	/* DMA error */
  #define USB_OTG_HCHINTF_STALL     0x00000008	/* STALL */
  #define USB_OTG_HCHINTF_NAK       0x00000010	/* NAK */
  #define USB_OTG_HCHINTF_ACK       0x00000020	/* ACK */
  #define USB_OTG_HCHINTF_NYET      0x00000040	/* NYET */
  #define USB_OTG_HCHINTF_USBER     0x00000080	/* USB bus Error */
  #define USB_OTG_HCHINTF_BBER      0x00000100	/* babble error */
  #define USB_OTG_HCHINTF_REQOVR    0x00000200	/* request queue overrun */
  #define USB_OTG_HCHINTF_DTER      0x00000400	/* data toggle error */
#define TOFF_USBHC_HCHINTEN     0x000C		/* (RW) USB host channel interrupt enable register  */
  #define USB_OTG_HCHINTEN_TFIE     0x00000001	/* transfer finished interrupt enable */
  #define USB_OTG_HCHINTEN_CHIE     0x00000002	/* channel halted interrupt enable */
  #define USB_OTG_HCHINTEN_DMAERIE  0x00000004	/* DMA error interrupt enable */
  #define USB_OTG_HCHINTEN_STALLIE  0x00000008	/* STALL interrupt enable */
  #define USB_OTG_HCHINTEN_NAKIE    0x00000010	/* NAK interrupt enable */
  #define USB_OTG_HCHINTEN_ACKIE    0x00000020	/* ACK interrupt enable */
  #define USB_OTG_HCHINTEN_NYETIE   0x00000040	/* NYET interrupt enable */
  #define USB_OTG_HCHINTEN_USBERIE  0x00000080	/* USB bus error interrupt enable */
  #define USB_OTG_HCHINTEN_BBERIE   0x00000100	/* babble error interrupt enable */
  #define USB_OTG_HCHINTEN_REQOVRIE 0x00000200	/* request queue overrun interrupt enable */
  #define USB_OTG_HCHINTEN_DTERIE   0x00000400	/* data toggle error interrupt enable */
#define TOFF_USBHC_HCHLEN       0x0010		/* (RW) USB host channel transfer length register */
  #define USB_OTG_HCHLEN_TLEN       0x0007FFFF	/* transfer length */
  #define USB_OTG_HCHLEN_PCNT       0x1FF80000	/* packet count */
  #define USB_OTG_HCHLEN_DPID       0x60000000	/* data PID */
  #define USB_OTG_HCTSIZ_DPID_0     0x20000000	/* Bit 0 */
  #define USB_OTG_HCTSIZ_DPID_1     0x40000000	/* Bit 1 */
  #define USB_OTG_HCHLEN_PING       0x80000000	/* PING token request */
#define TOFF_USBHC_HCHDMAADDR   0x0014		/* (RW) USB host channel-x DMA address register */

  #define USB_OTG_HCHDMAADDR_DMAADDR 0xFFFFFFFF	/* DMA address */

/*
 *  USB OTG HPCS
 */
#define TADR_USBO_HPCS_BASE     (USBFS_BASE+USB_OTG_HOST_PORT_BASE)
  #define USB_OTG_HPCS_PCST         0x00000001	/* port connect status */
  #define USB_OTG_HPCS_PCD          0x00000002	/* port connect detected */
  #define USB_OTG_HPCS_PE           0x00000004	/* port enable */
  #define USB_OTG_HPCS_PEDC         0x00000008	/* port enable/disable change */
  #define USB_OTG_HPCS_PREM         0x00000040	/* port resume */
  #define USB_OTG_HPCS_PSP          0x00000080	/* port suspend */
  #define USB_OTG_HPCS_PRST         0x00000100	/* port reset */
  #define USB_OTG_HPCS_PLST         0x00000C00	/* port line status */
  #define USB_OTG_HPCS_PLST_0       0x00000400	/* Bit 0 */
  #define USB_OTG_HPCS_PLST_1       0x00000800	/* Bit 1 */
  #define USB_OTG_HPCS_PP           0x00001000	/* port power */
  #define USB_OTG_HPCS_PS           0x00060000	/* port speed */
  #define USB_OTG_HPCS_PS_0         0x00020000	/* Bit 0 */
  #define USB_OTG_HPCS_PS_1         0x00040000	/* Bit 1 */


#endif /* _GD32VF103_H_ */
