/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006-2015 by GJ Business Division
 *                   RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2016-2019 by TOPPERS PROJECT Educational Working Group.
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: $
 */

#include "sys_defs.h"
#include <sil.h>
#include "comdefs.h"
#include "serial.h"

/*
 *  SIL֐̃}N`
 */
#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define mtime_low_value()       sil_rew_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIME))
#define mtime_high_value()      sil_rew_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIME+4))

#define NUM_USART               3

/*
 *  GPIO[h`
 */
#define GPIO_MODE_MASK          0x0FU
#define GPIO_MODE_OUTPUT_DEF    0x10U
#define GPIO_MODE_AIN           0x00U	/* analog input mode */
#define GPIO_MODE_IN_FLOATING   0x04U	/* floating input mode */
#define GPIO_MODE_IPD           0x28U	/* pull-down input mode */
#define GPIO_MODE_IPU           0x48U	/* pull-up input mode */
#define GPIO_MODE_OUT_OD        (GPIO_MODE_OUTPUT_DEF | 0x04U)	/* GPIO output with open-drain */
#define GPIO_MODE_OUT_PP        (GPIO_MODE_OUTPUT_DEF | 0x00U)	/* GPIO output with push-pull */
#define GPIO_MODE_AF_OD         (GPIO_MODE_OUTPUT_DEF | 0x0CU)	/* AFIO output with open-drain */
#define GPIO_MODE_AF_PP         (GPIO_MODE_OUTPUT_DEF | 0x08U)	/* AFIO output with push-pull */

/*
 *  GPIOo̓Xs[h`
 */
#define GPIO_OSPEED_10MHZ       0x01U	/* output max speed 10MHz */
#define GPIO_OSPEED_2MHZ        0x02U	/* output max speed 2MHz */
#define GPIO_OSPEED_50MHZ       0x03U	/* output max speed 50MHz */

/*
 *  USART Word Length
 */
#define USART_WordLength_8b     0x00000000
#define USART_WordLength_9b     USART_CTL0_WL

/*
 *  USART Stop Bits
 */ 
#define USART_StopBits_1        0x00000000
#define USART_StopBits_0_5      USART_CTL1_STB_0
#define USART_StopBits_2        USART_CTL1_STB_1
#define USART_StopBits_1_5      USART_CTL1_STB

/*
 *  USART Parity
 */
#define USART_Parity_No         0x00000000
#define USART_Parity_Even       USART_CTL0_PCEN
#define USART_Parity_Odd        (USART_CTL0_PCEN | USART_CTL0_PM) 

/*
 *  USART Hardware Flow Control
 */ 
#define USART_HardFlowCtl_None  0x00000000
#define USART_HardFlowCtl_RTS   USART_CTL2_RTSEN
#define USART_HardFlowCtl_CTS   USART_CTL2_CTSEN
#define USART_HardFlowCtl_RTS_CTS (USART_CTL2_RTSEN | USART_CTL2_CTSEN)

typedef struct usart_struct {
	unsigned int    taddr;
	unsigned int	no;
} usart_struct_t;

typedef struct usart_gpio {
	unsigned int    tx_gaddr;
	unsigned int    rx_gaddr;
	unsigned int	tx_af;
	unsigned int	rx_af;
	unsigned int	tx_pin;
	unsigned int	rx_pin;
	unsigned int	tx_gpio_clock;
	unsigned int	rx_gpio_clock;
	unsigned int    usart_caddr;
	unsigned int	usart_clock;
	unsigned int    usart_raddr;
	unsigned int	usart_rbit;
} usart_control_t;

static const usart_struct_t usart_table[NUM_USART] = {
	{ TADR_USART0_BASE, IRQ_VECTOR_USART0 },
	{ TADR_USART1_BASE, IRQ_VECTOR_USART1 },
	{ TADR_USART2_BASE, IRQ_VECTOR_USART2 }
};

static const usart_control_t usart_control[NUM_USART] = {
	{ TADR_GPIOA_BASE, TADR_GPIOA_BASE, GPIO_MODE_AF_PP, GPIO_MODE_IN_FLOATING, 9, 10,
	  RCU_APB2EN_PAEN, RCU_APB2EN_PAEN,
	 (TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_USART0EN,
	 (TADR_RCU_BASE+TOFF_RCU_APB2RST), RCU_APB2RST_USART0RST },
	{ TADR_GPIOA_BASE, TADR_GPIOA_BASE, GPIO_MODE_AF_PP, GPIO_MODE_IN_FLOATING, 2, 3,
	  RCU_APB2EN_PAEN, RCU_APB2EN_PAEN,
	 (TADR_RCU_BASE+TOFF_RCU_APB1EN), RCU_APB1EN_USART1EN,
	 (TADR_RCU_BASE+TOFF_RCU_APB1RST), RCU_APB1RST_USART1RST },
	{ TADR_GPIOB_BASE, TADR_GPIOB_BASE, GPIO_MODE_AF_PP, GPIO_MODE_IN_FLOATING, 10, 11,
	  RCU_APB2EN_PBEN, RCU_APB2EN_PBEN,
	 (TADR_RCU_BASE+TOFF_RCU_APB1EN), RCU_APB1EN_USART2EN,
	 (TADR_RCU_BASE+TOFF_RCU_APB1RST), RCU_APB1RST_USART2RST }
};

/*
 *  GPIO-PINݒ
 *  parameter1: GPIOx[XAhX
 *  parameter2: ݒ胂[h
 *  parameter3: sԍ
 */
void gpio_pin_init(uint32_t base, uint32_t mode, uint8_t pinno)
{
	uint32_t cbase = 0U;
    uint32_t tmode = 0U, reg = 0U;

	if(pinno < 8)
		cbase = base+TOFF_GPIO_CTL0;
	else
		cbase = base+TOFF_GPIO_CTL1;

    /*
	 *  GPIO[hERtBM[Vl쐬
	 */
    tmode = (uint32_t)(mode & GPIO_MODE_MASK);

    /*
	 *  GPIOAEgvbgXs[hǉ
	 */
    if(((uint32_t)mode & GPIO_MODE_OUTPUT_DEF) != 0) {
        /* output mode max speed:10MHz,2MHz,50MHz */
        tmode |= (uint32_t) GPIO_OSPEED_50MHZ;
    }

    /*
	 *  GPIORtBM[VEWX^o
	 */
	reg = sil_rew_mem((uint32_t *)(cbase));

	/*
	 *  [hǉ
	 */
	reg &= ~(0xFU << (4U * (pinno & 7)));
	reg |= tmode << (4U * (pinno & 7));

	/* set IPD or IPU */
	if (GPIO_MODE_IPD == mode) {
		/* reset the corresponding OCTL bit */
		sil_wrw_mem((uint32_t *)(base+TOFF_GPIO_BC), (1U << pinno));
	}
	else{
		/* set the corresponding OCTL bit */
		if (GPIO_MODE_IPU == mode) {
			sil_wrw_mem((uint32_t *)(base+TOFF_GPIO_BOP), (1U << pinno));
		}
	}

    /*
	 *  GPIORtBM[VEWX^ݒ
	 */
	sil_wrw_mem((uint32_t *)(cbase), reg);
}


/*
 *  none-interrupt UART functions.
 */
void sys_putc(char c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
}

/*
 *  UART0 Interrupt Handler
 */
void USART0_IRQHandler(void)
{
	const usart_struct_t  *pusart = &usart_table[0];
	uint32_t base = pusart->taddr;
	uint32_t stat;
	stat = sil_rew_mem((uint32_t *)(base+TOFF_USART_STAT));

	if((stat & USART_STAT_RBNE) != 0){
		ComInterRX(0);
    }
#ifndef NOINT_UARTTX
	if((stat & USART_STAT_TBE) != 0){
		ComInterTX(0);
	}
#endif
}

#ifdef CLIC_TEST
/*
 *  CLIC݃eXg
 */
#define CLIC_COUNT 100000000

uint64_t get_timer_valuex()
{
  while (1) {
    uint32_t hi = mtime_high_value();
    uint32_t lo = mtime_low_value();
    if (hi == mtime_high_value())
      return ((uint64_t)hi << 32) | lo;
  }
}

void eclic_mtip_handler(void)
{
	uint64_t tim = get_timer_valuex() + CLIC_COUNT;
	sil_wrw_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIMECMP), (uint32_t)tim);
	sil_wrw_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIMECMP +4), (uint32_t)(tim >> 32));
	put_hex('C',  mtime_low_value());
}
#endif

void execDisable(void)
{
	eclic_irq_disable(usart_table[DEF_MON_SERIAL].no);
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	const usart_struct_t  *pusart = &usart_table[id];

	return sil_rew_mem((uint32_t *)(pusart->taddr+TOFF_USART_DATA)) | CHKRXDATA;

}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
#ifndef NOINT_UARTTX
	const usart_struct_t *pusart = &usart_table[id];
	sil_orw_mem((uint32_t *)(pusart->taddr+TOFF_USART_CTL0), USART_CTL0_TBEIE);
#endif
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	const usart_struct_t *pusart = &usart_table[id];
	sil_andw_mem((uint32_t *)(pusart->taddr+TOFF_USART_CTL0), USART_CTL0_TBEIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	const usart_struct_t *pusart = &usart_table[id];
	sil_wrw_mem((uint32_t *)(pusart->taddr+TOFF_USART_DATA), c);
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	const usart_struct_t *pusart = &usart_table[id];
    while((sil_rew_mem((uint32_t *)(pusart->taddr+TOFF_USART_STAT)) & USART_STAT_TBE) == 0);
}


void InitSIO(int id)
{
	RCU_ClocksTypeDef RCU_Clocks;
	const usart_struct_t  *pusart    = &usart_table[id];
	const usart_control_t *p_control = &usart_control[id];
	uint32_t base;
    uint32_t uclk = 0U, udiv = 0U;

    /*
	 *  GPIONbNL
	 */
	sil_orw_mem((uint32_t *)(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_PAEN);

    /*
	 *  USARTNbNL
	 */
	sil_orw_mem((uint32_t *)(TADR_RCU_BASE+TOFF_RCU_APB2EN), RCU_APB2EN_USART0EN);

    /*
	 *  USART TX|[gݒ
	 */
    gpio_pin_init(p_control->tx_gaddr, p_control->tx_af, p_control->tx_pin);

    /*
	 *  USART RX|[gݒ
	 */
    gpio_pin_init(p_control->rx_gaddr, p_control->rx_af, p_control->rx_pin);

	/*
	 *  W[Zbg
	 */
	sil_orw_mem((uint32_t *)(p_control->usart_raddr), p_control->usart_rbit);
	sil_andw_mem((uint32_t *)(p_control->usart_raddr), p_control->usart_rbit);

	/*
	 *  ʐMݒ
	 */
	RCC_GetClocksFreq( &RCU_Clocks);
	base = pusart->taddr;
	switch(base){	/* get clock frequency */
	case TADR_USART0_BASE:
		uclk = RCU_Clocks.APB2_Frequency;
		break;
	case TADR_USART1_BASE:
	case TADR_USART2_BASE:
	case TADR_UART3_BASE:
	case TADR_UART4_BASE:
		uclk = RCU_Clocks.APB1_Frequency;
		break;
	default:
		break;
	}
	udiv   = (uclk + DEFAULT_SPEED/2U) / DEFAULT_SPEED;
	sil_wrw_mem((uint32_t *)(base+TOFF_USART_BAUD), (udiv & 0xffff));

	sil_modw_mem((uint32_t *)(base+TOFF_USART_CTL0), USART_CTL0_WL, USART_WordLength_8b);
	sil_modw_mem((uint32_t *)(base+TOFF_USART_CTL1), USART_CTL1_STB, USART_StopBits_1);
	sil_modw_mem((uint32_t *)(base+TOFF_USART_CTL0), (USART_CTL0_PCEN | USART_CTL0_PM), USART_Parity_No);
	sil_modw_mem((uint32_t *)(base+TOFF_USART_CTL2), (USART_CTL2_RTSEN | USART_CTL2_CTSEN), USART_HardFlowCtl_None);
	sil_orw_mem((uint32_t *)(base+TOFF_USART_CTL0), (USART_CTL0_TEN | USART_CTL0_REN));
	sil_orw_mem((uint32_t *)(base+TOFF_USART_CTL0), USART_CTL0_UEN);

	eclic_irq_enable(pusart->no, 0, 5);
	sil_orw_mem((uint32_t *)(base+TOFF_USART_CTL0), USART_CTL0_RBNEIE);

#ifdef CLIC_TEST
	{
		uint64_t tim = get_timer_valuex() + CLIC_COUNT;
		sil_wrw_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIMECMP), (uint32_t)tim);
		sil_wrw_mem((uint32_t *)(TADR_CLIC_BASE+TOFF_CLINT_MTIMECMP +4), (uint32_t)(tim >> 32));
		eclic_irq_enable(IRQ_VECTOR_CLIC_INT_TMR, 0, 7);
		put_hex('T', eclic_get_irq_priority(IRQ_VECTOR_CLIC_INT_TMR));
	}
#endif
#ifdef CLOCK_TEST
	put_hex('X', RCU_Clocks.SYSCLK_Frequency);
	put_hex('0', RCU_Clocks.AHB_Frequency);
	put_hex('1', RCU_Clocks.APB1_Frequency);
	put_hex('2', RCU_Clocks.APB2_Frequency);
#endif
}

