/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _3069_H_
#define _3069_H_

/*
 *	3069.h -- definitions for H8/3069F 
 */

/*	Values	*/

#define CLOCK_RATE		20000000

/*	Address		*/

#if 0
#define ROM_BASE		0x000000
#define ROM_SIZE		0x080000
#endif
/*#define RAM_BASE		0xffbf20*/
#if 0
#define VECTOR_BASE		ROM_BASE
#endif
/*#define VECTOR_SIZE		0x100*/

/*	Vector Address	*/

#define VEC_RESET		0x000000
#define VEC_SCI0		0x0000d0		/* SCI #0 */
#define VEC_SCI1		0x0000e0		/* SCI #1 */
#define VEC_SCI2		0x0000f0		/* SCI #2 */

/*	 Condition Code Register */

#define CCR_INTERRUPT		0x80
#define CCR_USER_INTER		0x40
#define CCR_HALF_CARRY		0x20
#define CCR_USER		0x10
#define CCR_NEGATIVE		0x08
#define CCR_ZERO		0x04
#define CCR_OVERFLOW		0x02
#define CCR_CARRY		0x01

/*	Serial Channels		*/

#define IOREG_SCI_BASE		0xffffb0
#define IOREG_SMR_OFFSET	0x0
#define IOREG_BRR_OFFSET	0x1
#define IOREG_SCR_OFFSET	0x2
#define IOREG_TDR_OFFSET	0x3
#define IOREG_SSR_OFFSET	0x4
#define IOREG_RDR_OFFSET	0x5

/*	Status bits in SSR	*/

#define SSR_TDRE		0x80
#define SSR_RDRF		0x40
#define SSR_OPER		0x20
#define SSR_FER			0x10
#define SSR_PER			0x08

/*	Status bits in SCR	*/

#define SCR_TIE			0x80
#define SCR_RIE			0x40
#define SCR_TE			0x20
#define SCR_RE			0x10

/*	Palarel Ports		*/

#define IOREG_PPBASE		0xffff00

#define IOREG_P1DDR		0xfee000
#define IOREG_P2DDR		0xfee001
#define IOREG_P3DDR		0xfee002
#define IOREG_P4DDR		0xfee003
#define IOREG_P5DDR		0xfee004
#define IOREG_P6DDR		0xfee005
#define IOREG_P8DDR		0xfee007
#define IOREG_P9DDR		0xfee008
#define IOREG_PADDR		0xfee009
#define IOREG_PBDDR		0xfee00a

#define IOREG_P1DR		0xffffd0
#define IOREG_P2DR		0xffffd1
#define IOREG_P3DR		0xffffd2
#define IOREG_P4DR		0xffffd3
#define IOREG_P5DR		0xffffd4
#define IOREG_P6DR		0xffffd5
#define IOREG_P7DR		0xffffd6
#define IOREG_P8DR		0xffffd7
#define IOREG_P9DR		0xffffd8
#define IOREG_PADR		0xffffd9
#define IOREG_PBDR		0xffffda

#define IOREG_P2PCR		0xfee03c
#define IOREG_P4PCR		0xfee03e
#define IOREG_P5PCR		0xfee03f

/*	Memory Address		*/

#define P5DDR_A19		0x08
#define P5DDR_A18		0x04
#define P5DDR_A17		0x02
#define P5DDR_A16		0x01

/*	Control bit in Memory Chip Select	*/

#define P8DDR_CS0		0x10
#define P8DDR_CS1		0x08
#define P8DDR_CS2		0x04
#define P8DDR_CS3		0x02
#define PBDDR_CS4		0x08
#define PBDDR_CS5		0x04
#define PBDDR_CS6		0x02
#define PBDDR_CS7		0x01

/*	Control bit in Column Address Strobe	*/

#define PBDDR_LCAS		0x20
#define PBDDR_UCAS		0x10

/*	Mode Control Regisger		*/

#define IOREG_MDCR		0xfee011

/*	Control bit in MDCR		*/

#define MDCR_MDS0		0x01
#define MDCR_MDS1		0x02
#define MDCR_MDS2		0x04
#define MDCR_MDS_MASK		0x07

/*	DRAM Control Registers		*/

#define IOREG_DRCRA		0xfee026	/* DRAM Control Register A		*/
#define IOREG_DRCRB		0xfee027	/* DRAM Control Register B		*/
#define IOREG_RTMCSR		0xfee028	/* DRAM Timer Control / Status Register	*/
#define IOREG_RTCNT		0xfee029	/* DRAM Reflesh Timer Counter		*/
#define IOREG_RTCOR		0xfee02a	/* DRAM Reflesh Time Constant Register	*/

/*	DRAM Control Register A		*/

#define DRCRA_DRAS2		0x80
#define DRCRA_DRAS1		0x40
#define DRCRA_DRAS0		0x20
#define DRCRA_BE		0x08
#define DRCRA_RDM		0x04
#define DRCRA_SRFMD		0x02
#define DRCRA_RFSHE		0x01

/*	DRAM Control Register B		*/

#define DRCRB_MXC1		0x80
#define DRCRB_MXC0		0x40
#define DRCRB_CSEL		0x20
#define DRCRB_RCYCE		0x10
#define DRCRB_TPC		0x04
#define DRCRB_RCW		0x02
#define DRCRB_RLW		0x01

/*	DRAM Timer Control / Status Register	*/

#define RTMCSR_CMF		0x80
#define RTMCSR_CMIE		0x40
#define RTMCSR_CKS2		0x20
#define RTMCSR_CKS1		0x10
#define RTMCSR_CKS0		0x08

#endif	/* of #ifndef _3069_H_ */
