/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	monitor.c -- rom Monitor Core
 */

#include <stdio.h>
#include "comdefs.h"
#include "mondefs.h"
#include "serial.h"

extern const void (*CommandVector[])(int id, char **s);

char *AddressPointer[MAX_SERIAL];
char *DumpPointer[MAX_SERIAL];
unsigned char CommandMode[MAX_SERIAL];
unsigned char Status[MAX_SERIAL];
const long BeforeInitEntry = (long)BeforeInit;
const long AfterInitEntry  = (long)AfterInit;

static unsigned char DataSize[MAX_SERIAL];

/*
 *	Put Error Status
 *  Input:  arg1: Serial Channel #
 *          arg2: Error Status
 */

static void PutErrorStatus(int id, char status)
{
	putchar(ERROR_PROMPT);
	printf("%02x\n", status);
}

/*
 *	Enter Data
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
static void EnterData(int id, char *s)
{
	if(DataSize[id] == DATA_SIZE_BYTE){
		*((unsigned char *)AddressPointer[id]) = (unsigned char)HexASCII2Long(&s, 128);
		AddressPointer[id] += 1;
	}
	else if(DataSize[id] == DATA_SIZE_LONG){
		*((unsigned long *)AddressPointer[id]) = (unsigned long)HexASCII2Long(&s, 128);
		AddressPointer[id] += 4;
	}
	else{
		*((unsigned short *)AddressPointer[id]) = (unsigned short)HexASCII2Long(&s, 128);
		AddressPointer[id] += 2;
	}
}

/*
 *	Parse Command (Core)
 *  Input:  arg1: Serial Channel #
 */
void ParseCmdCore(int id)
{
	char *s;
	char c;
	unsigned short cmd;
	int  i;

	if((s = ReciveLine(id, id)) != 0){
		if(*s == 0){			/* just return key */
			switch(CommandMode[id]){
			case CMDMODE_ENTER:	/* increment address pointer */
				AddressPointer[id] += DataSize[id];
				break;
			case CMDMODE_DUMP:
				if(DataSize[id] == DATA_SIZE_BYTE)
					DumpByteCmd(id, &s);
				else if(DataSize[id] == DATA_SIZE_WORD)
					DumpWordCmd(id, &s);
				else if(DataSize[id] == DATA_SIZE_LONG)
					DumpLongCmd(id, &s);
				break;
			default:
				break;
			}
		}
		else if(CommandMode[id] == CMDMODE_ENTER){
			if(*s != COMMAND_END)
				EnterData(id, s);
			else
				CommandMode[id] = CMDMODE_ADDR;
		}
		else{
			c = *s++;
			cmd = (c << 8) | (unsigned char)*s;
			if(*s != 0)
				s++;
			for(i = 0 ; CommandString[i] ; i++){
				if(CommandString[i] == cmd){
					SkipBlanks(&s);
					CommandVector[i](id, &s);
					if(Status[id] != 0)
						PutErrorStatus(id, Status[id]);
					SendPrompt(id);
					return;
				}
			}
			PutErrorStatus(id, ERR_NO_COMMAND);
		}
		SendPrompt(id);
	}
}

/*
 *	Send Monitor Prompt
 *  Input:  arg1: Serial Channel #
 */
void MonSendPrompt(int id)
{
	if(CommandMode[id] != CMDMODE_ENTER){
		printf("%x", id);
		putchar(MONITOR_PROMPT);
	}
	else{
		if(DataSize[id] == DATA_SIZE_BYTE)
			printf("%08lx:%02x:", (unsigned long)AddressPointer[id], *((unsigned char *)AddressPointer[id]));
		else if(DataSize[id] == DATA_SIZE_LONG)
			printf("%08lx:%08lx:", (unsigned long)AddressPointer[id], *((unsigned long *)AddressPointer[id]));
		else
			printf("%08lx:%04x:", (unsigned long)AddressPointer[id], *((unsigned short *)AddressPointer[id]));
	}
}

/*
 *	Enter Data (Word) Command
 *		Format: ew [<addr>]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void EnterByteCmd(int id, char **ps)
{
	char *s;
	unsigned long *a;

	s = *ps;
	a = (unsigned long *)HexASCII2Long(ps, 128);
	if(s == *ps)
		a = (unsigned long *)AddressPointer[id];
	AddressPointer[id] = (char *)a;
	CommandMode[id] = CMDMODE_ENTER;
	DataSize[id] = DATA_SIZE_BYTE;
}

/*
 *	Enter Data (Word) Command
 *		Format: ew [<addr>]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void EnterWordCmd(int id, char **ps)
{
	char *s;
	unsigned long *a;

	s = *ps;
	a = (unsigned long *)HexASCII2Long(ps, 128);
	if(s == *ps)
		a = (unsigned long *)AddressPointer[id];
	AddressPointer[id] = (char *)a;
	CommandMode[id] = CMDMODE_ENTER;
	DataSize[id] = DATA_SIZE_WORD;
}

/*
 *	Enter Data (Long Word) Command
 *		Format: el [<addr>]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void EnterLongCmd(int id, char **ps)
{
	char *s;
	unsigned long *a;

	s = *ps;
	a = (unsigned long *)HexASCII2Long(ps, 128);
	if(s == *ps)
		a = (unsigned long *)AddressPointer[id];
	AddressPointer[id] = (char *)a;
	CommandMode[id] = CMDMODE_ENTER;
	DataSize[id] = DATA_SIZE_LONG;
}

/*
 *	Get Address and Length
 *
 *		Input:	er3: input line
 *			er4: Serial Channel #
 *		Output: er0: Length
 *			er1: Address
 *			er3: input line
 */

static int GetAddrLen(int id, char **ps, void **a)
{
	char *s;
	int  len;

	SkipBlanks(ps);
	s = *ps;
	*a = (void *)HexASCII2Long(ps, 128);
	if(s == *ps){			/* no address specified, default length */
		*a = (void *)DumpPointer[id];
		return DEF_DUMP_LENGTH;
	}
	else{
		SkipBlanks(ps);
		s = *ps;
		len = HexASCII2Long(ps, 128);
		if(s == *ps)		/* no length specified, default length */
			len = DEF_DUMP_LENGTH;
		return len;
	}
}

/*
 *	Dump byte Command
 *      Format: db [<addr> [<len>]]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void DumpByteCmd(int id, char **ps)
{
	unsigned char *a, *a2;
	int           len, len2, blank, iblank;
	char          c;

	len = GetAddrLen(id, ps, (void **)&a);
	if(len > 0){
		DumpPointer[id] = (char *)a;
		iblank = (unsigned long)a & 15;
		do{
			printf("%08lx", (unsigned long)a & ~15);
			SendCharCount(' ', iblank*3+1);
			blank = 16 - iblank;
			len2 = len;
			a2   = a;
			while(blank > 0 && len2 > 0){
				if(blank == 8 && len2 != len)
					SendChar(id, '-');
				else
					SendChar(id, ' ');
				printf("%02x", *a2);
				a2++;
				blank--;
				len2--;
			}
			SendCharCount(' ', iblank+2);
			blank = 16 - iblank;
			while(blank > 0 && len > 0){
				c = *a++;
				if(c < ' ' ||  c > 0x7e)
					c = '.';
				SendChar(id, c);
				blank--;
				len--;
			}
			iblank = blank;
			printf("\n");
		}while(len > 0);
	}
	CommandMode[id] = CMDMODE_DUMP;
	DataSize[id]    = DATA_SIZE_BYTE;
}

/*
 *	Dump Word Command
 *		Format: dw [<addr> [<len>]]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void DumpWordCmd(int id, char **ps)
{
	unsigned short *a;
	int            len, len2, blank;

	len = GetAddrLen(id, ps, (void **)&a);
	if(len > 0){
		a = (unsigned short *)((unsigned long)a & ~1);
		DumpPointer[id] = (char *)a;
		len  = (len + 1) & ~1;
		len2 = len;
		blank = (unsigned long)a & 15;
		do{
			printf("%08lx", (unsigned long)a & ~15);
			SendCharCount(' ', (blank/2)*5+1);
			blank = 16 - blank;
			while(blank > 0 && len > 0){
				if(blank == 8 && len != len2)
					putchar('-');
				else
					putchar(' ');
				printf("%04x", *a);
				a++;
				blank -= 2;
				len   -= 2;
			}
			printf("\n");
		}while(len > 0);
	}
	CommandMode[id] = CMDMODE_DUMP;
	DataSize[id]    = DATA_SIZE_WORD;
}

/*
 *	Dump Long Command
 *		Format: dl [<addr> [<len>]]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void DumpLongCmd(int id, char **ps)
{
	unsigned long *a;
	int           len, len2, blank;

	len = GetAddrLen(id, ps, (void **)&a);
	if(len > 0){
		a = (unsigned long *)((unsigned long)a & ~3);
		DumpPointer[id] = (char *)a;
		len  = (len + 3) & ~3;
		len2 = len;
		blank = (unsigned long)a & 15;
		do{
			printf("%08lx", (unsigned long)a & ~15);
			SendCharCount(' ', (blank/4)*9+1);
			blank = 16 - blank;
			while(blank > 0 && len > 0){
				if(blank == 8 && len != len2)
					SendChar(id, '-');
				else
					SendChar(id, ' ');
				printf("%08lx", *a);
				a++;
				blank -= 4;
				len   -= 4;
			}
			printf("\n");
		}while(len > 0);
	}
	CommandMode[id] = CMDMODE_DUMP;
	DataSize[id]    = DATA_SIZE_LONG;
}

/*
 *	Fill byte Command
 *      Format: fb [<addr> [<len> [<init> [<inc> [<repeat>]]]]]
 *  Input:  arg1: Serial Channel #
 *          arg2: input line
 */
void FillByteCmd(int id, char **ps)
{
	unsigned char *a;
    char          *s;
	int           i, len, init;
	int           inc, repeat;

	len = GetAddrLen(id, ps, (void **)&a);
	SkipBlanks(ps);
	s = *ps;
	init = HexASCII2Long(ps, 128);
	if(s == *ps)
		init = 0;
	SkipBlanks(ps);
	s = *ps;
	inc =  HexASCII2Long(ps, 128);
	if(s == *ps)
		inc = 0;
	SkipBlanks(ps);
	s = *ps;
	repeat =  HexASCII2Long(ps, 128);
	if(s == *ps)
		repeat = 1;
	while(repeat > 0){
		for(i = 0 ; i < len ; i++){
			*a++  = init;
			init += inc;
		}
		repeat--;
	}
}

