/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015      by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */
/**
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT 2015 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "serial.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

/* TIMEOUT ------------------------------------------------------------------*/

#define UART_TIMEOUT_VALUE              0x1FFFFFF

#define VECT_TAB_OFFSET  0x0 /* Vector Table base offset field. 
                                   This value must be a multiple of 0x200. */

/*
 *  USART Priority
 */
#define MAIN_PRIORITY      0
#define SUB_PRIORITY       1

/*
 *  USART_Hardware_Flow_Control UART Hardware Flow Control
 */
#define UART_HWCONTROL_NONE                  ((uint32_t)0x00000000)

/*
 *  UARTEx_Word_Length UARTEx Word Length
 */
#define UART_WORDLENGTH_7B                  ((uint32_t)USART_CR1_M_1)
#define UART_WORDLENGTH_8B                  ((uint32_t)0x0000)
#define UART_WORDLENGTH_9B                  ((uint32_t)USART_CR1_M_0)

/*
 *  UART_Stop_Bits   UART Number of Stop Bits
 */
#define UART_STOPBITS_1                     ((uint32_t)0x0000)
#define UART_STOPBITS_2                     ((uint32_t)USART_CR2_STOP_1)

/*
 *  UART_Parity  UART Parity
 */
#define UART_PARITY_NONE                    ((uint32_t)0x00000000)
#define UART_PARITY_EVEN                    ((uint32_t)USART_CR1_PCE)
#define UART_PARITY_ODD                     ((uint32_t)(USART_CR1_PCE | USART_CR1_PS))

/*
 *  UART_Mode UART Transfer Mode
 */
#define UART_MODE_RX                        ((uint32_t)USART_CR1_RE)
#define UART_MODE_TX                        ((uint32_t)USART_CR1_TE)
#define UART_MODE_TX_RX                     ((uint32_t)(USART_CR1_TE |USART_CR1_RE))

/*
 *  UART ISR ACK Flag
 */
#define ISR_ACK                             (USART_ISR_TEACK | USART_ISR_REACK)

/*
 *  RCCEx_USART1_Clock_Source RCCEx USART1 Clock Source
 */
#define RCC_USART1CLKSOURCE_PCLK2      ((uint32_t)0x00000000)
#define RCC_USART1CLKSOURCE_SYSCLK     RCC_DCKCFGR2_USART1SEL_0
#define RCC_USART1CLKSOURCE_HSI        RCC_DCKCFGR2_USART1SEL_1
#define RCC_USART1CLKSOURCE_LSE        RCC_DCKCFGR2_USART1SEL

/*
 *  RCCEx_USART3_Clock_Source RCCEx USART3 Clock Source
 */
#define RCC_USART3CLKSOURCE_PCLK1      ((uint32_t)0x00000000)
#define RCC_USART3CLKSOURCE_SYSCLK     RCC_DCKCFGR2_USART3SEL_0
#define RCC_USART3CLKSOURCE_HSI        RCC_DCKCFGR2_USART3SEL_1
#define RCC_USART3CLKSOURCE_LSE        RCC_DCKCFGR2_USART3SEL

/*
 *  RCCEx_USART6_Clock_Source RCCEx USART6 Clock Source
 */
#define RCC_USART6CLKSOURCE_PCLK2       ((uint32_t)0x00000000)
#define RCC_USART6CLKSOURCE_SYSCLK      RCC_DCKCFGR2_USART6SEL_0
#define RCC_USART6CLKSOURCE_HSI         RCC_DCKCFGR2_USART6SEL_1
#define RCC_USART6CLKSOURCE_LSE         RCC_DCKCFGR2_USART6SEL


typedef struct usart_struct {
	unsigned int    taddr;
	unsigned int	no;
} usart_struct_t;

typedef struct usart_gpio {
	unsigned int    tx_gaddr;
	unsigned int    rx_gaddr;
	unsigned int	tx_af;
	unsigned int	rx_af;
	unsigned int	tx_pin;
	unsigned int	rx_pin;
	unsigned int	tx_gpio_clock;
	unsigned int	rx_gpio_clock;
	unsigned int    usart_caddr;
	unsigned int	usart_clock;
} usart_gpio_t;

static const usart_struct_t usart_table[MAX_SERIAL] = {
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
	{ TADR_USART3_BASE, USART3_IRQn }
#elif BOARDNO == 4
	{ TADR_USART6_BASE, USART6_IRQn }
#else
	{ TADR_USART1_BASE, USART1_IRQn }
#endif
};

static const usart_gpio_t usart_gpio[MAX_SERIAL] = {
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
	{ TADR_GPIOD_BASE, TADR_GPIOD_BASE, 0x07, 0x07, 8, 9, RCC_AHB1ENR_GPIODEN, RCC_AHB1ENR_GPIODEN,
	 (TADR_RCC_BASE+TOFF_RCC_APB1ENR), RCC_APB1ENR_USART3EN }
#elif BOARDNO == 4
	{ TADR_GPIOC_BASE, TADR_GPIOC_BASE, 0x08, 0x08, 6, 7, RCC_AHB1ENR_GPIOCEN, RCC_AHB1ENR_GPIOCEN,
	 (TADR_RCC_BASE+TOFF_RCC_APB2ENR), RCC_APB2ENR_USART6EN }
#elif BOARDNO == 1
	{ TADR_GPIOA_BASE, TADR_GPIOA_BASE, 0x07, 0x07, 9,10, RCC_AHB1ENR_GPIOAEN, RCC_AHB1ENR_GPIOAEN,
	 (TADR_RCC_BASE+TOFF_RCC_APB2ENR), RCC_APB2ENR_USART1EN }
#else
	{ TADR_GPIOA_BASE, TADR_GPIOB_BASE, 0x07, 0x07, 9, 7, RCC_AHB1ENR_GPIOAEN, RCC_AHB1ENR_GPIOBEN,
	 (TADR_RCC_BASE+TOFF_RCC_APB2ENR), RCC_APB2ENR_USART1EN }
#endif
};


void SendTXWait(int id);
extern int MonVector[];

extern uint32_t RCC_GetSysClockFreq(void);
extern uint32_t RCC_GetPCLK1Freq(void);
extern uint32_t RCC_GetPCLK2Freq(void);

void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

#if 0	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
	sys_putc('\r');
}


#endif	/* ROI DEBUG */
void Disable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

void Enable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

/*
 *  ̤㳰äν
 */
void NMI_Handler(void)
{
    sys_printf("NMI Exception occurs. !\n");
    while(1);
}

void HardFault_Handler(void)
{
    sys_printf("Hard Fault Exception occurs. !\n");
    while(1);
}

void MemManage_Handler(void)
{
    sys_printf("Memory Manager Exception occurs. !\n");
    while(1);
}

void BusFault_Handler(void)
{
    sys_printf("Bus Fault Exception occurs. !\n");
    while(1);
}


void UsageFault_Handler(void)
{
    sys_printf("Usage Fault Exception occurs. !\n");
    while(1);
}

void DebugMon_Handler(void)
{
    sys_printf("Debug Monitor Exception occurs. !\n");
    while(1);
}

/*
 * GPIO Configuration Mode 
 * Elements values convention: 0xX0yz00YZ
 *           - X  : GPIO mode or EXTI Mode
 *           - y  : External IT or Event trigger detection 
 *           - z  : IO configuration on External IT or Event
 *           - Y  : Output type (Push Pull or Open Drain)
 *           - Z  : IO Direction mode (Input, Output, Alternate or Analog)
 */ 
#define GPIO_MODE_INPUT       0x00000000	/* Input Floating Mode                   */
#define GPIO_MODE_OUTPUT_PP   0x00000001	/* Output Push Pull Mode                 */
#define GPIO_MODE_AF_PP       0x00000002	/* Alternate Function Push Pull Mode     */
#define GPIO_MODE_ANALOG      0x00000003	/* Analog Mode  */

/*
 *  GPIO Output type enumeration
 */
#define GPIO_OTYPE_PP         0x0
#define GPIO_OTYPE_OD         0x1

/*
 * brief GPIO Output Maximum frequency
 */
#define GPIO_SPEED_LOW        0x00000000	/* Low speed     */
#define GPIO_SPEED_MEDIUM     0x00000001	/* Medium speed  */
#define GPIO_SPEED_FAST       0x00000002	/* Fast speed    */
#define GPIO_SPEED_HIGH       0x00000003	/* High speed    */

 /*
  * GPIO Pull-Up or Pull-Down Activation
  */ 
#define GPIO_NOPULL           0x00000000	/* No Pull-up or Pull-down activation  */
#define GPIO_PULLUP           0x00000001	/* Pull-up activation                  */
#define GPIO_PULLDOWN         0x00000002	/* Pull-down activation                */

#define UART_CR1_FIELDS       ((uint32_t)(USART_CR1_M | USART_CR1_PCE | USART_CR1_PS | \
                                     USART_CR1_TE | USART_CR1_RE | USART_CR1_OVER8))

/*
 * Encode Priority
 *  The function encodes the priority for an interrupt with the given priority group,
 *  preemptive priority value, and subpriority value.
 *  In case of a conflict between priority grouping and available
 *  priority bits (__NVIC_PRIO_BITS), the smallest possible priority group is set.
 *  param [in]     PriorityGroup  Used priority group.
 *  param [in]   PreemptPriority  Preemptive priority value (starting from 0).
 *  param [in]       SubPriority  Subpriority value (starting from 0).
 *  return                        Encoded priority. Value can be used in the function \ref NVIC_SetPriority().
 */
static uint32_t EncodePriority (uint32_t PriorityGroup, uint32_t PreemptPriority, uint32_t SubPriority)
{
	uint32_t PreemptPriorityBits;
	uint32_t SubPriorityBits;

	PriorityGroup &= 0x07;
	PreemptPriorityBits = ((7 - PriorityGroup) > __NVIC_PRIO_BITS) ? __NVIC_PRIO_BITS : (7 - PriorityGroup);
	SubPriorityBits     = ((PriorityGroup + __NVIC_PRIO_BITS) < 7) ? 0 : ((PriorityGroup - 7) + __NVIC_PRIO_BITS);

	return (
           ((PreemptPriority & ((1 << PreemptPriorityBits) - 1)) << SubPriorityBits) |
           ((SubPriority     & ((1 << SubPriorityBits    ) - 1)))
	       );
}

/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	const usart_gpio_t *pgpio;
	uint32_t uaddr, gaddr, n, ino, priority, prioritygrp, tickstart;
	volatile uint32_t tmpreg;

	if(id != 0)
		return;

	pgpio = &usart_gpio[id];
	uaddr = usart_table[id].taddr;
	ino   = usart_table[id].no;
	gaddr = usart_gpio[id].tx_gaddr;

  /* Put the USART peripheral in the Asynchronous mode (UART Mode) */
  /* UART configured as follows:
      - Word Length = 8 Bits
      - Stop Bit = One Stop bit
      - Parity = None
      - BaudRate = DEFAULT_SPEED baud
      - Hardware flow control disabled (RTS and CTS signals) */

    /* Init the low level hardware : GPIO, CLOCK */
	/* Enable GPIO TX clock */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), pgpio->tx_gpio_clock);
	/* Delay after an RCC peripheral clock enabling */
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR));

	/* Enable GPIO RX clock */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR), pgpio->rx_gpio_clock);
	/* Delay after an RCC peripheral clock enabling */
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AHB1ENR));

#if BOARDNO <= 1
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2), RCC_DCKCFGR2_USART1SEL, RCC_USART1CLKSOURCE_SYSCLK);
#elif BOARDNO == 4
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2), RCC_DCKCFGR2_USART6SEL, RCC_USART6CLKSOURCE_SYSCLK);
#endif
	/* Enable USARTx clock */
	sil_orw_mem((uint32_t *)pgpio->usart_caddr, pgpio->usart_clock);
	/* Delay after an RCC peripheral clock enabling */
	tmpreg = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2ENR));
	(void)(tmpreg);

	/* UART TX GPIO pin configuration  */
	n = pgpio->tx_pin;
	/*--------------------- GPIO Mode Configuration ------------------------*/
	/* In case of Alternate function mode selection */
	/* Configure Alternate function mapped with the current IO */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_AFR0+(n >> 3)*4), (0xF << ((n & 0x07)*4)), (pgpio->tx_af << ((n & 0x07)*4)));

	/* Configure IO Direction mode (Input, Output, Alternate or Analog) */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_MODER), (GPIO_MODER_MODER0 << (n * 2)), (GPIO_MODE_AF_PP << (n * 2)));

	/* In case of Output or Alternate function mode selection */
	/* Configure the IO Speed */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR0 << (n * 2)), (GPIO_SPEED_HIGH << (n * 2)));

	/* Configure the IO Output Type */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OTYPER), (1 << n), (GPIO_OTYPE_PP << n));

	/* Activate the Pull-up or Pull down resistor for the current IO */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR0 << (n * 2)), ((GPIO_PULLUP) << (n * 2)));

	/* UART RX GPIO pin configuration  */
	n = pgpio->rx_pin;
	gaddr = usart_gpio[id].rx_gaddr;
	/*--------------------- GPIO Mode Configuration ------------------------*/
	/* In case of Alternate function mode selection */
	/* Configure Alternate function mapped with the current IO */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_AFR0+(n >> 3)*4), (0xF << ((n & 0x07)*4)), (pgpio->rx_af << ((n & 0x07)*4)));

	/* Configure IO Direction mode (Input, Output, Alternate or Analog) */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_MODER), (GPIO_MODER_MODER0 << (n * 2)), (GPIO_MODE_AF_PP << (n * 2)));

	/* In case of Output or Alternate function mode selection */
	/* Configure the IO Speed */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR0 << (n * 2)), (GPIO_SPEED_HIGH << (n * 2)));

	/* Configure the IO Output Type */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_OTYPER), (1 << n), (GPIO_OTYPE_PP << n));

	/* Activate the Pull-up or Pull down resistor for the current IO */
	sil_modw_mem((uint32_t *)(gaddr+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR0 << (n * 2)), ((GPIO_PULLUP) << (n * 2)));

	/* NVIC for USART */
	prioritygrp = (sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR)) & SCB_AIRCR_PRIGROUP_Msk) >> SCB_AIRCR_PRIGROUP_Pos;
	priority = EncodePriority(prioritygrp, MAIN_PRIORITY, SUB_PRIORITY);
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_IP+(ino*4)), ((priority << (8 - __NVIC_PRIO_BITS)) & 0xFF));
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+(ino >> 5) * 4), (1<<(ino & 0x1F)));

	/* Disable the Peripheral */
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_UE);

	/* Set the UART Communication parameters */
	/*-------------------------- USART CR1 Configuration -----------------------*/
	/* Clear M, PCE, PS, TE, RE and OVER8 bits and configure */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), UART_CR1_FIELDS, (UART_WORDLENGTH_8B | UART_PARITY_NONE | UART_MODE_TX_RX));

	/*-------------------------- USART CR2 Configuration -----------------------*/
	/* Configure the UART Stop Bits: Set STOP[13:12] bits according */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR2), USART_CR2_STOP, UART_STOPBITS_1);

	/*-------------------------- USART CR3 Configuration -----------------------*/
	/* Configure 
	 * - UART HardWare Flow Control: set CTSE and RTSE bits according */
	sil_modw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), (USART_CR3_RTSE | USART_CR3_CTSE | USART_CR3_ONEBIT), UART_HWCONTROL_NONE);

	/*-------------------------- USART BRR Configuration -----------------------*/
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
	switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2)) & RCC_DCKCFGR2_USART3SEL){
	case RCC_USART3CLKSOURCE_PCLK1:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetPCLK1Freq() / DEFAULT_SPEED));
		break;
	case RCC_USART3CLKSOURCE_HSI:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(HSI_VALUE / DEFAULT_SPEED));
		break;
	case RCC_USART3CLKSOURCE_SYSCLK:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetSysClockFreq() / DEFAULT_SPEED));
		break;
	case RCC_USART3CLKSOURCE_LSE:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(LSE_VALUE / DEFAULT_SPEED));
		break;
	default:
		return;
	}
#elif BOARDNO == 4
	switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2)) & RCC_DCKCFGR2_USART6SEL){
	case RCC_USART6CLKSOURCE_PCLK2:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetPCLK2Freq() / DEFAULT_SPEED));
		break;
	case RCC_USART6CLKSOURCE_HSI:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(HSI_VALUE / DEFAULT_SPEED));
		break;
	case RCC_USART6CLKSOURCE_SYSCLK:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetSysClockFreq() / DEFAULT_SPEED));
		break;
	case RCC_USART6CLKSOURCE_LSE:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(LSE_VALUE / DEFAULT_SPEED));
		break;
	default:
		return;
	}
#else
	switch(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_DCKCFGR2)) & RCC_DCKCFGR2_USART1SEL){
	case RCC_USART1CLKSOURCE_PCLK2:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetPCLK2Freq() / DEFAULT_SPEED));
		break;
	case RCC_USART1CLKSOURCE_HSI:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(HSI_VALUE / DEFAULT_SPEED));
		break;
	case RCC_USART1CLKSOURCE_SYSCLK:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(RCC_GetSysClockFreq() / DEFAULT_SPEED));
		break;
	case RCC_USART1CLKSOURCE_LSE:
		sil_wrw_mem((uint32_t *)(uaddr+TOFF_USART_BRR), (uint32_t)(LSE_VALUE / DEFAULT_SPEED));
		break;
	default:
		return;
	}
#endif

	/* In asynchronous mode, the following bits must be kept cleared:
	- LINEN and CLKEN bits in the USART_CR2 register,
	- SCEN, HDSEL and IREN  bits in the USART_CR3 register.*/
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR2), (USART_CR2_LINEN | USART_CR2_CLKEN));
	sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), (USART_CR3_SCEN | USART_CR3_HDSEL | USART_CR3_IREN));

	/* Enable the Peripheral */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_UE);

	/* TEACK and/or REACK to check before moving huart->State to Ready */
	tickstart = 0;
    while((sil_rew_mem((uint32_t *)(uaddr+TOFF_USART_ISR)) & ISR_ACK) != ISR_ACK){
		/* Check for the Timeout */
		if(tickstart >=  UART_TIMEOUT_VALUE){
			/* Disable TXE, RXNE, PE and ERR (Frame error, noise error, overrun error) interrupts for the interrupt process */
			sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), (USART_CR1_TXEIE | USART_CR1_RXNEIE | USART_CR1_PEIE));
			sil_andw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), USART_CR3_EIE);
			return;
		}
		sil_dly_nse(1000);
		tickstart++;
	}

    /* Enable the UART Parity Error Interrupt */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_PEIE);

    /* Enable the UART Error Interrupt: (Frame error, noise error, overrun error) */
	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR3), USART_CR3_EIE);

	sil_orw_mem((uint32_t *)(uaddr+TOFF_USART_CR1), USART_CR1_RXNEIE);
}

/*
 *  this is the interrupt request handler (IRQ) for ALL USART2 interrupts
 */
#if BOARDNO == 2 || BOARDNO == 3	/* nucleo */
void USART3_IRQHandler(void)
#elif BOARDNO == 4
void USART6_IRQHandler(void)
#else
void USART1_IRQHandler(void)
#endif
{
	uint32_t regcr1 = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_CR1));
	uint32_t regcr3 = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_CR3));
	uint32_t regisr = sil_rew_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ISR));

	/* UART parity error interrupt occurred */
	if((regisr & USART_ISR_PE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_PECF);
	}

	/* UART frame error interrupt occurred */
	if((regisr & USART_ISR_FE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_FECF);
	}

	/* UART noise error interrupt occurred */
	if((regisr & USART_ISR_NE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_NCF);
	}

	/* UART Over-Run interrupt occurred */
	if((regisr & USART_ISR_ORE) != 0 && (regcr3 & USART_CR3_EIE) != 0){
		sil_wrw_mem((uint32_t *)(usart_table[0].taddr+TOFF_USART_ICR), USART_ICR_ORECF);
	}

	if((regisr & USART_ISR_RXNE) != 0 && (regcr1 & USART_CR1_RXNEIE) != 0){
		ComInterRX(0);
	}
	if((regisr & USART_ISR_TXE) != 0 && (regcr1 & USART_CR1_TXEIE) != 0){
		ComInterTX(0);
	}
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	return sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_RDR)) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	sil_orw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	sil_andw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_CR1), USART_CR1_TXEIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_TDR), (c & 0xFF));
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_ISR)) & USART_ISR_TC) == 0);
}

void SetVector(void *addr)
{
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_VTOR), (unsigned int)addr | VECT_TAB_OFFSET);	/* Vector Table Relocation */
}

