/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2015-2016 by 3rd Designing Center
 *              Imageing System Development Division RICOH COMPANY, LTD.
 *  Copyright (C) 2017-2017 by TOPPERS PROJECT Educational Working Group.
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: stm32l0xx.h,v 1.3 2021/10/17 10:38:17 roi Exp $
 */

#ifndef _STM32L0XX_H_
#define _STM32L0XX_H_

#include <sil.h>
#include "cmsis_m0.h"

/*
 *  ֹκ
 */
#define TMAX_INTNO          (16 + 31)

/*
 *  ͥ٤Υӥå
 */
#define TBITW_IPRI          2

/*
 *  INTERRUPT NUMBER
 */
#define IRQ_VECTOR_WWDG             (16 + 0)	/* Window WatchDog Interrupt */
#define IRQ_VECTOR_PVD              (16 + 1)	/* PVD through EXTI Line detection Interrupt */
#define IRQ_VECTOR_RTC_WKUP         (16 + 2)	/* RTC Wakeup interrupt through the EXTI line */
#define IRQ_VECTOR_FLASH            (16 + 3)	/* FLASH global Interrupt */
#define IRQ_VECTOR_RCC              (16 + 4)	/* RCC global Interrupt */
#define IRQ_VECTOR_EXTI0_1          (16 + 5)	/* EXTI Line0 and 1 Interrupt */
#define IRQ_VECTOR_EXTI2_3          (16 + 6)	/* EXTI Line2 and 3 Interrupt */
#define IRQ_VECTOR_EXTI4_15         (16 + 7)	/* EXTI Line4 to 15 Interrupt */
#define IRQ_VECTOR_TSC              (16 + 8)	/* Touch Sensing Controller Interrupts */
#define IRQ_VECTOR_DMA1_CH1         (16 + 9)	/* DMA1 Channel 1 global Interrupt */
#define IRQ_VECTOR_DMA1_CH_LOW      (16 + 10)	/* DMA1 Channel 2 and 3 global Interrupt */
#define IRQ_VECTOR_DMA1_CH_HIGH     (16 + 11)	/* DMA1 Channel 4 to 7 global Interrupt */
#define IRQ_VECTOR_ADC1_COMP        (16 + 12)	/* ADC1, COMP1 and COMP2 Interrupts */
#define IRQ_VECTOR_LPTIM1           (16 + 13)	/* LPTIM1 Interrupt */
#define IRQ_VECTOR_USART4_5         (16 + 14)	/* USART4 and USART5 Interrupt */
#define IRQ_VECTOR_TIM2             (16 + 15)	/* TIM2 global Interrupt */
#define IRQ_VECTOR_TIM3             (16 + 16)	/* TIM3 global Interrupt */
#define IRQ_VECTOR_TIM6_DAC         (16 + 17)	/* TIM6 global and DAC channel underrun error Interrupt */
#define IRQ_VECTOR_TIM7             (16 + 18)	/* TIM7 global Interrupt */
#define IRQ_VECTOR_TIM21            (16 + 20)	/* TIM21 global Interrupt */
#define IRQ_VECTOR_I2C3             (16 + 21)	/* I2C3 global Interrupt */
#define IRQ_VECTOR_TIM22            (16 + 22)	/* TIM22 global Interrupt */
#define IRQ_VECTOR_I2C1             (16 + 23)	/* I2C1 global Interrupt  */
#define IRQ_VECTOR_I2C2             (16 + 24)	/* I2C2 global Interrupt */
#define IRQ_VECTOR_SPI1             (16 + 25)	/* SPI1 global Interrupt */
#define IRQ_VECTOR_SPI2             (16 + 26)	/* SPI2 global Interrupt */
#define IRQ_VECTOR_USART1           (16 + 27)	/* USART1 global Interrupt */
#define IRQ_VECTOR_USART2           (16 + 28)	/* USART2 global Interrupt */
#define IRQ_VECTOR_RNG_LPUART1      (16 + 29)	/* RNG ang LPUART1 global Interrupt */
#define IRQ_VECTOR_LCD              (16 + 30)	/* LCD global Interrupt */
#define IRQ_VECTOR_USB              (16 + 31)	/* USB global Interrupt */

/*
 *  PERIPHERAL MEMORY MAP
 */
#define FLASH_BASE          0x08000000	/* FLASH base address in the alias region */
#define SRAM_BASE           0x20000000	/* SRAM base address in the alias region */
#define PERIPH_BASE         0x40000000	/* Peripheral base address in the alias region                                */

/* Peripheral memory map */
#define APBPERIPH_BASE      PERIPH_BASE
#define AHBPERIPH_BASE      (PERIPH_BASE + 0x00020000)
#define IOPPERIPH_BASE      (PERIPH_BASE + 0x10000000)

/*
 *  TIMER (F/L)
 */
#define TADR_TIM2_BASE      (APBPERIPH_BASE + 0x0000)
#define TADR_TIM3_BASE      (APBPERIPH_BASE + 0x0400)
#define TADR_TIM6_BASE      (APBPERIPH_BASE + 0x1000)
#define TADR_TIM7_BASE      (APBPERIPH_BASE + 0x1400)
#define TADR_TIM21_BASE     (APBPERIPH_BASE + 0x00010800U)
#define TADR_TIM22_BASE     (APBPERIPH_BASE + 0x00011400U)
#define TOFF_TIM_CR1        0x0000		/* (RW) TIM control register 1 */
  #define TIM_CR1_CEN        0x00000001	/* Counter enable */
  #define TIM_CR1_UDIS       0x00000002	/* Update disable */
  #define TIM_CR1_URS        0x00000004	/* Update request source */
  #define TIM_CR1_OPM        0x00000008	/* One pulse mode */
  #define TIM_CR1_DIR        0x00000010	/* Direction */
  #define TIM_CR1_CMS_0      0x00000020	/* CMS[1:0] bit 0 */
  #define TIM_CR1_CMS_1      0x00000040	/* CMS[1:0] bit 1 */
  #define TIM_CR1_ARPE       0x00000080	/* Auto-reload preload enable */
  #define TIM_CR1_CKD_0      0x00000100	/* CKD[1:0] bit 0 */
  #define TIM_CR1_CKD_1      0x00000200	/* CKD[1:0] bit 1 */
#define TOFF_TIM_CR2        0x0004		/* (RW) TIM control register 2 */
#define TOFF_TIM_SMCR       0x0008		/* (RW) TIM slave mode control register */
#define TOFF_TIM_DIER       0x000C		/* (RW) TIM DMA/interrupt enable register */
  #define TIM_DIER_UIE       0x00000001	/* Update interrupt enable */
  #define TIM_DIER_CC1IE     0x00000002	/* Capture/Compare 1 interrupt enable */
  #define TIM_DIER_CC2IE     0x00000004	/* Capture/Compare 2 interrupt enable */
  #define TIM_DIER_CC3IE     0x00000008	/* Capture/Compare 3 interrupt enable */
  #define TIM_DIER_CC4IE     0x00000010	/* Capture/Compare 4 interrupt enable */
  #define TIM_DIER_COMIE     0x00000020	/* COM interrupt enable */
  #define TIM_DIER_TIE       0x00000040	/* Trigger interrupt enable */
  #define TIM_DIER_BIE       0x00000080	/* Break interrupt enable */
  #define TIM_DIER_UDE       0x00000100	/* Update DMA request enable */
  #define TIM_DIER_CC1DE     0x00000200	/* Capture/Compare 1 DMA request enable */
  #define TIM_DIER_CC2DE     0x00000400	/* Capture/Compare 2 DMA request enable */
  #define TIM_DIER_CC3DE     0x00000800	/* Capture/Compare 3 DMA request enable */
  #define TIM_DIER_CC4DE     0x00001000	/* Capture/Compare 4 DMA request enable */
  #define TIM_DIER_COMDE     0x00002000	/* COM DMA request enable */
  #define TIM_DIER_TDE       0x00004000	/* Trigger DMA request enable */
#define TOFF_TIM_SR         0x0010		/* (RW) TIM status register */
  #define TIM_SR_UIF         0x00000001	/* Update interrupt Flag */
  #define TIM_SR_CC1IF       0x00000002	/* Capture/Compare 1 interrupt Flag */
  #define TIM_SR_CC2IF       0x00000004	/* Capture/Compare 2 interrupt Flag */
  #define TIM_SR_CC3IF       0x00000008	/* Capture/Compare 3 interrupt Flag */
  #define TIM_SR_CC4IF       0x00000010	/* Capture/Compare 4 interrupt Flag */
  #define TIM_SR_COMIF       0x00000020	/* COM interrupt Flag */
  #define TIM_SR_TIF         0x00000040	/* Trigger interrupt Flag */
  #define TIM_SR_BIF         0x00000080	/* Break interrupt Flag */
  #define TIM_SR_CC1OF       0x00000200	/* Capture/Compare 1 Overcapture Flag */
  #define TIM_SR_CC2OF       0x00000400	/* Capture/Compare 2 Overcapture Flag */
  #define TIM_SR_CC3OF       0x00000800	/* Capture/Compare 3 Overcapture Flag */
  #define TIM_SR_CC4OF       0x00001000	/* Capture/Compare 4 Overcapture Flag */
#define TOFF_TIM_EGR        0x0014		/* (RW) TIM event generation register */
#define TOFF_TIM_CCMR1      0x0018		/* (RW) TIM capture/compare mode register 1 */
#define TOFF_TIM_CCMR2      0x001C		/* (RW) TIM capture/compare mode register 2 */
#define TOFF_TIM_CCER       0x0020		/* (RW) TIM capture/compare enable register */
#define TOFF_TIM_CNT        0x0024		/* (RW) TIM counter register */
#define TOFF_TIM_PSC        0x0028		/* (RW) TIM prescaler */
#define TOFF_TIM_ARR        0x002C		/* (RW) TIM auto-reload register */
#define TOFF_TIM_RCR        0x0030		/* (RW) TIM repetition counter register */
#define TOFF_TIM_CCR1       0x0034		/* (RW) TIM capture/compare register 1 */
#define TOFF_TIM_CCR2       0x0038		/* (RW) TIM capture/compare register 2 */
#define TOFF_TIM_CCR3       0x003C		/* (RW) TIM capture/compare register 3 */
#define TOFF_TIM_CCR4       0x0040		/* (RW) TIM capture/compare register 4 */
#define TOFF_TIM_BDTR       0x0044		/* (RW) TIM break and dead-time register */
#define TOFF_TIM_DCR        0x0048		/* (RW) TIM DMA control register */
#define TOFF_TIM_DMAR       0x004C		/* (RW) TIM DMA address for full transfer */
#define TOFF_TIM_OR         0x0050		/* (RW) TIM option register */

#if !defined(TOPPERS_STM32LORA_DISCOVERY)
/*
 *  LCD
 */
#define TADR_LCD_BASE       (APBPERIPH_BASE + 0x2400)
#define TOFF_LCD_CR         0x0000		/* (RW) LCD control register */
  #define LCD_CR_LCDEN       0x00000001	/* LCD Enable Bit */
  #define LCD_CR_VSEL        0x00000002	/* Voltage source selector Bit */
  #define LCD_CR_DUTY        0x0000001C	/* DUTY[2:0] bits (Duty selector) */
  #define LCD_CR_DUTY_0      0x00000004
  #define LCD_CR_DUTY_1      0x00000008
  #define LCD_CR_DUTY_2      0x00000010
  #define LCD_CR_BIAS        0x00000060	/* BIAS[1:0] bits (Bias selector) */
  #define LCD_CR_BIAS_0      0x00000020
  #define LCD_CR_BIAS_1      0x00000040
  #define LCD_CR_MUX_SEG     0x00000080	/* Mux Segment Enable Bit */
  #define LCD_CR_BUFEN       0x00000100	/* Voltage output buffer enable Bit */
#define TOFF_LCD_FCR        0x0004		/* (RW) LCD frame control register */
  #define LCD_FCR_HD         0x00000001	/* High Drive Enable Bit */
  #define LCD_FCR_SOFIE      0x00000002	/* Start of Frame Interrupt Enable Bit */
  #define LCD_FCR_UDDIE      0x00000008	/* Update Display Done Interrupt Enable Bit */
  #define LCD_FCR_PON        0x00000070	/* PON[2:0] bits (Puls ON Duration) */
  #define LCD_FCR_PON_0      0x00000010
  #define LCD_FCR_PON_1      0x00000020
  #define LCD_FCR_PON_2      0x00000040
  #define LCD_FCR_DEAD       0x00000380	/* DEAD[2:0] bits (DEAD Time) */
  #define LCD_FCR_DEAD_0     0x00000080
  #define LCD_FCR_DEAD_1     0x00000100
  #define LCD_FCR_DEAD_2     0x00000200
  #define LCD_FCR_CC         0x00001C00	/* CC[2:0] bits (Contrast Control) */
  #define LCD_FCR_CC_0       0x00000400
  #define LCD_FCR_CC_1       0x00000800
  #define LCD_FCR_CC_2       0x00001000
  #define LCD_FCR_BLINKF     0x0000E000	/* BLINKF[2:0] bits (Blink Frequency) */
  #define LCD_FCR_BLINKF_0   0x00002000
  #define LCD_FCR_BLINKF_1   0x00004000
  #define LCD_FCR_BLINKF_2   0x00008000
  #define LCD_FCR_BLINK      0x00030000	/* BLINK[1:0] bits (Blink Enable) */
  #define LCD_FCR_BLINK_0    0x00010000
  #define LCD_FCR_BLINK_1    0x00020000
  #define LCD_FCR_DIV        0x003C0000	/* DIV[3:0] bits (Divider) */
  #define LCD_FCR_PS         0x03C00000	/* PS[3:0] bits (Prescaler) */
#define TOFF_LCD_SR         0x0008		/* (RW) LCD status register */
  #define LCD_SR_ENS         0x00000001	/* LCD Enabled Bit */
  #define LCD_SR_SOF         0x00000002	/* Start Of Frame Flag Bit */
  #define LCD_SR_UDR         0x00000004	/* Update Display Request Bit */
  #define LCD_SR_UDD         0x00000008	/* Update Display Done Flag Bit */
  #define LCD_SR_RDY         0x00000010	/* Ready Flag Bit */
  #define LCD_SR_FCRSR       0x00000020	/* LCD FCR Register Synchronization Flag Bit */
#define TOFF_LCD_CLR        0x000C		/* (RW) LCD clear register */
  #define LCD_CLR_SOFC       0x00000002	/* Start Of Frame Flag Clear Bit */
  #define LCD_CLR_UDDC       0x00000008	/* Update Display Done Flag Clear Bit */
#define TOFF_LCD_RAM        0x0014		/* (RW) LCD display memory  0x14-0x50 */
#endif

/*
 *  REAL-TIME CLOCK
 */
#define TADR_RTC_BASE       (APBPERIPH_BASE + 0x2800)
#define TOFF_RTC_TR         0x0000		/* (RW) RTC time register */
  #define RTC_TR_PM                0x00400000
  #define RTC_TR_HT                0x00300000
  #define RTC_TR_HT_0              0x00100000
  #define RTC_TR_HT_1              0x00200000
  #define RTC_TR_HU                0x000F0000
  #define RTC_TR_HU_0              0x00010000
  #define RTC_TR_HU_1              0x00020000
  #define RTC_TR_HU_2              0x00040000
  #define RTC_TR_HU_3              0x00080000
  #define RTC_TR_MNT               0x00007000
  #define RTC_TR_MNT_0             0x00001000
  #define RTC_TR_MNT_1             0x00002000
  #define RTC_TR_MNT_2             0x00004000
  #define RTC_TR_MNU               0x00000F00
  #define RTC_TR_MNU_0             0x00000100
  #define RTC_TR_MNU_1             0x00000200
  #define RTC_TR_MNU_2             0x00000400
  #define RTC_TR_MNU_3             0x00000800
  #define RTC_TR_ST                0x00000070
  #define RTC_TR_ST_0              0x00000010
  #define RTC_TR_ST_1              0x00000020
  #define RTC_TR_ST_2              0x00000040
  #define RTC_TR_SU                0x0000000F
  #define RTC_TR_SU_0              0x00000001
  #define RTC_TR_SU_1              0x00000002
  #define RTC_TR_SU_2              0x00000004
  #define RTC_TR_SU_3              0x00000008
#define TOFF_RTC_DR         0x0004		/* (RW) RTC date register */
  #define RTC_DR_YT                0x00F00000
  #define RTC_DR_YT_0              0x00100000
  #define RTC_DR_YT_1              0x00200000
  #define RTC_DR_YT_2              0x00400000
  #define RTC_DR_YT_3              0x00800000
  #define RTC_DR_YU                0x000F0000
  #define RTC_DR_YU_0              0x00010000
  #define RTC_DR_YU_1              0x00020000
  #define RTC_DR_YU_2              0x00040000
  #define RTC_DR_YU_3              0x00080000
  #define RTC_DR_WDU               0x0000E000
  #define RTC_DR_WDU_0             0x00002000
  #define RTC_DR_WDU_1             0x00004000
  #define RTC_DR_WDU_2             0x00008000
  #define RTC_DR_MT                0x00001000
  #define RTC_DR_MU                0x00000F00
  #define RTC_DR_MU_0              0x00000100
  #define RTC_DR_MU_1              0x00000200
  #define RTC_DR_MU_2              0x00000400
  #define RTC_DR_MU_3              0x00000800
  #define RTC_DR_DT                0x00000030
  #define RTC_DR_DT_0              0x00000010
  #define RTC_DR_DT_1              0x00000020
  #define RTC_DR_DU                0x0000000F
  #define RTC_DR_DU_0              0x00000001
  #define RTC_DR_DU_1              0x00000002
  #define RTC_DR_DU_2              0x00000004
  #define RTC_DR_DU_3              0x00000008
#define TOFF_RTC_CR         0x0008		/* (RW) RTC control register */
  #define RTC_CR_COE               0x00800000
  #define RTC_CR_OSEL              0x00600000
  #define RTC_CR_OSEL_0            0x00200000
  #define RTC_CR_OSEL_1            0x00400000
  #define RTC_CR_POL               0x00100000
  #define RTC_CR_COSEL             0x00080000
  #define RTC_CR_BCK               0x00040000
  #define RTC_CR_SUB1H             0x00020000
  #define RTC_CR_ADD1H             0x00010000
  #define RTC_CR_TSIE              0x00008000
  #define RTC_CR_WUTIE             0x00004000
  #define RTC_CR_ALRBIE            0x00002000
  #define RTC_CR_ALRAIE            0x00001000
  #define RTC_CR_TSE               0x00000800
  #define RTC_CR_WUTE              0x00000400
  #define RTC_CR_ALRBE             0x00000200
  #define RTC_CR_ALRAE             0x00000100
  #define RTC_CR_DCE               0x00000080
  #define RTC_CR_FMT               0x00000040
  #define RTC_CR_BYPSHAD           0x00000020
  #define RTC_CR_REFCKON           0x00000010
  #define RTC_CR_TSEDGE            0x00000008
  #define RTC_CR_WUCKSEL           0x00000007
  #define RTC_CR_WUCKSEL_0         0x00000001
  #define RTC_CR_WUCKSEL_1         0x00000002
  #define RTC_CR_WUCKSEL_2         0x00000004
#define TOFF_RTC_ISR        0x000C		/* (RW) RTC initialization and status register */
  #define RTC_ISR_RECALPF          0x00010000
  #define RTC_ISR_TAMP1F           0x00002000
  #define RTC_ISR_TAMP2F           0x00004000
  #define RTC_ISR_TSOVF            0x00001000
  #define RTC_ISR_TSF              0x00000800
  #define RTC_ISR_WUTF             0x00000400
  #define RTC_ISR_ALRBF            0x00000200
  #define RTC_ISR_ALRAF            0x00000100
  #define RTC_ISR_INIT             0x00000080
  #define RTC_ISR_INITF            0x00000040
  #define RTC_ISR_RSF              0x00000020
  #define RTC_ISR_INITS            0x00000010
  #define RTC_ISR_SHPF             0x00000008
  #define RTC_ISR_WUTWF            0x00000004
  #define RTC_ISR_ALRBWF           0x00000002
  #define RTC_ISR_ALRAWF           0x00000001
#define TOFF_RTC_PRER       0x0010		/* (RW) RTC prescaler register */
#define TOFF_RTC_WUTR       0x0014		/* (RW) RTC wakeup timer register */
#define TOFF_RTC_CALIBR     0x0018		/* (RW) RTC calibration register */
#define TOFF_RTC_ALRMAR     0x001C		/* (RW) RTC alarm A register */
  #define RTC_ALRMAR_MSK4          0x80000000
  #define RTC_ALRMAR_WDSEL         0x40000000
  #define RTC_ALRMAR_DT            0x30000000
  #define RTC_ALRMAR_DT_0          0x10000000
  #define RTC_ALRMAR_DT_1          0x20000000
  #define RTC_ALRMAR_DU            0x0F000000
  #define RTC_ALRMAR_DU_0          0x01000000
  #define RTC_ALRMAR_DU_1          0x02000000
  #define RTC_ALRMAR_DU_2          0x04000000
  #define RTC_ALRMAR_DU_3          0x08000000
  #define RTC_ALRMAR_MSK3          0x00800000
  #define RTC_ALRMAR_PM            0x00400000
  #define RTC_ALRMAR_HT            0x00300000
  #define RTC_ALRMAR_HT_0          0x00100000
  #define RTC_ALRMAR_HT_1          0x00200000
  #define RTC_ALRMAR_HU            0x000F0000
  #define RTC_ALRMAR_HU_0          0x00010000
  #define RTC_ALRMAR_HU_1          0x00020000
  #define RTC_ALRMAR_HU_2          0x00040000
  #define RTC_ALRMAR_HU_3          0x00080000
  #define RTC_ALRMAR_MSK2          0x00008000
  #define RTC_ALRMAR_MNT           0x00007000
  #define RTC_ALRMAR_MNT_0         0x00001000
  #define RTC_ALRMAR_MNT_1         0x00002000
  #define RTC_ALRMAR_MNT_2         0x00004000
  #define RTC_ALRMAR_MNU           0x00000F00
  #define RTC_ALRMAR_MNU_0         0x00000100
  #define RTC_ALRMAR_MNU_1         0x00000200
  #define RTC_ALRMAR_MNU_2         0x00000400
  #define RTC_ALRMAR_MNU_3         0x00000800
  #define RTC_ALRMAR_MSK1          0x00000080
  #define RTC_ALRMAR_ST            0x00000070
  #define RTC_ALRMAR_ST_0          0x00000010
  #define RTC_ALRMAR_ST_1          0x00000020
  #define RTC_ALRMAR_ST_2          0x00000040
  #define RTC_ALRMAR_SU            0x0000000F
  #define RTC_ALRMAR_SU_0          0x00000001
  #define RTC_ALRMAR_SU_1          0x00000002
  #define RTC_ALRMAR_SU_2          0x00000004
  #define RTC_ALRMAR_SU_3          0x00000008
#define TOFF_RTC_ALRMBR     0x0020		/* (RW) RTC alarm B register */
  #define RTC_ALRMBR_MSK4          0x80000000
  #define RTC_ALRMBR_WDSEL         0x40000000
  #define RTC_ALRMBR_DT            0x30000000
  #define RTC_ALRMBR_DT_0          0x10000000
  #define RTC_ALRMBR_DT_1          0x20000000
  #define RTC_ALRMBR_DU            0x0F000000
  #define RTC_ALRMBR_DU_0          0x01000000
  #define RTC_ALRMBR_DU_1          0x02000000
  #define RTC_ALRMBR_DU_2          0x04000000
  #define RTC_ALRMBR_DU_3          0x08000000
  #define RTC_ALRMBR_MSK3          0x00800000
  #define RTC_ALRMBR_PM            0x00400000
  #define RTC_ALRMBR_HT            0x00300000
  #define RTC_ALRMBR_HT_0          0x00100000
  #define RTC_ALRMBR_HT_1          0x00200000
  #define RTC_ALRMBR_HU            0x000F0000
  #define RTC_ALRMBR_HU_0          0x00010000
  #define RTC_ALRMBR_HU_1          0x00020000
  #define RTC_ALRMBR_HU_2          0x00040000
  #define RTC_ALRMBR_HU_3          0x00080000
  #define RTC_ALRMBR_MSK2          0x00008000
  #define RTC_ALRMBR_MNT           0x00007000
  #define RTC_ALRMBR_MNT_0         0x00001000
  #define RTC_ALRMBR_MNT_1         0x00002000
  #define RTC_ALRMBR_MNT_2         0x00004000
  #define RTC_ALRMBR_MNU           0x00000F00
  #define RTC_ALRMBR_MNU_0         0x00000100
  #define RTC_ALRMBR_MNU_1         0x00000200
  #define RTC_ALRMBR_MNU_2         0x00000400
  #define RTC_ALRMBR_MNU_3         0x00000800
  #define RTC_ALRMBR_MSK1          0x00000080
  #define RTC_ALRMBR_ST            0x00000070
  #define RTC_ALRMBR_ST_0          0x00000010
  #define RTC_ALRMBR_ST_1          0x00000020
  #define RTC_ALRMBR_ST_2          0x00000040
  #define RTC_ALRMBR_SU            0x0000000F
  #define RTC_ALRMBR_SU_0          0x00000001
  #define RTC_ALRMBR_SU_1          0x00000002
  #define RTC_ALRMBR_SU_2          0x00000004
  #define RTC_ALRMBR_SU_3          0x00000008
#define TOFF_RTC_WPR        0x0024		/* (RW) RTC write protection register */
#define TOFF_RTC_SSR        0x0028		/* (RW) RTC sub second register */
#define TOFF_RTC_SHIFTR     0x002C		/* (RW) RTC shift control register */
#define TOFF_RTC_TSTR       0x0030		/* (RW) RTC time stamp time register */
#define TOFF_RTC_TSDR       0x0034		/* (RW) RTC time stamp date register */
#define TOFF_RTC_TSSSR      0x0038		/* (RW) RTC time-stamp sub second register */
#define TOFF_RTC_CALR       0x003C		/* (RW) RTC calibration register */
#define TOFF_RTC_TAMPCR     0x0040		/* (RW) RTC tamper configuration register */
#define TOFF_RTC_ALRMASSR   0x0044		/* (RW) RTC alarm A sub second register */
  #define RTC_ALRMASSR_MASKSS      0x0F000000
  #define RTC_ALRMASSR_MASKSS_0    0x01000000
  #define RTC_ALRMASSR_MASKSS_1    0x02000000
  #define RTC_ALRMASSR_MASKSS_2    0x04000000
  #define RTC_ALRMASSR_MASKSS_3    0x08000000
  #define RTC_ALRMASSR_SS          0x00007FFF
#define TOFF_RTC_ALRMBSSR   0x0048		/* (RW) RTC alarm B sub second register */
  #define RTC_ALRMBSSR_MASKSS      0x0F000000
  #define RTC_ALRMBSSR_MASKSS_0    0x01000000
  #define RTC_ALRMBSSR_MASKSS_1    0x02000000
  #define RTC_ALRMBSSR_MASKSS_2    0x04000000
  #define RTC_ALRMBSSR_MASKSS_3    0x08000000
  #define RTC_ALRMBSSR_SS          0x00007FFF
#define TOFF_RTC_OR         0x004C		/* (RW) RTC option register */
#define TOFF_RTC_BKP0R      0x0050		/* (RW) RTC backup register 0 */
#define TOFF_RTC_BKP1R      0x0054		/* (RW) RTC backup register 1 */
#define TOFF_RTC_BKP2R      0x0058		/* (RW) RTC backup register 2 */
#define TOFF_RTC_BKP3R      0x005C		/* (RW) RTC backup register 3 */
#define TOFF_RTC_BKP4R      0x0060		/* (RW) RTC backup register 4 */

/*
 *  WINDOW WATCHDOG (F/L)
 */
#define TADR_WWDG_BASE      (APBPERIPH_BASE + 0x2C00)
#define TOFF_WWDG_CR        0x0000		/* (RW) WWDG Control register */
#define TOFF_WWDG_CFR       0x0004		/* (RW) WWDG Configuration register */
#define TOFF_WWDG_SR        0x0008		/* (R)  WWDG Status register */

/*
 *  INDEPENDENT WATCHDOG (F/L)
 */
#define TADR_IWDG_BASE      (APBPERIPH_BASE + 0x3000)
#define TOFF_IWDG_KR        0x0000		/* (RW) IWDG Key register */
#define TOFF_IWDG_PR        0x0004		/* (RW) IWDG Prescaler register */
#define TOFF_IWDG_RLR       0x0008		/* (RW) IWDG Reload register */
#define TOFF_IWDG_SR        0x000C		/* (RW) IWDG Status register */
#define TOFF_IWDG_WINR      0x0010		/* (RW) IWDG Window register */

/*
 *  SERIAL PERIPHERAL IINTERFACE
 */
#define TADR_SPI2_BASE      (APBPERIPH_BASE + 0x3800)
#define TADR_SPI1_BASE      (APBPERIPH_BASE + 0x00013000)
#define TOFF_SPI_CR1        0x0000		/* (RW) SPI control register 1 (not used in I2S mode) */
  #define SPI_CR1_CPHA             0x00000001	/* Clock Phase */
  #define SPI_CR1_CPOL             0x00000002	/* Clock Polarity */
  #define SPI_CR1_MSTR             0x00000004	/* Master Selection */
  #define SPI_CR1_BR               0x00000038	/* Baud Rate Control */
  #define SPI_CR1_BR_0             0x00000008	/* Bit 0 */
  #define SPI_CR1_BR_1             0x00000010	/* Bit 1 */
  #define SPI_CR1_BR_2             0x00000020	/* Bit 2 */
  #define SPI_CR1_SPE              0x00000040	/* SPI Enable */
  #define SPI_CR1_LSBFIRST         0x00000080	/* Frame Format */
  #define SPI_CR1_SSI              0x00000100	/* Internal slave select */
  #define SPI_CR1_SSM              0x00000200	/* Software slave management */
  #define SPI_CR1_RXONLY           0x00000400	/* Receive only */
  #define SPI_CR1_DFF              0x00000800	/*  Data Frame Format */
  #define SPI_CR1_CRCNEXT          0x00001000	/* Transmit CRC next */
  #define SPI_CR1_CRCEN            0x00002000	/* Hardware CRC calculation enable */
  #define SPI_CR1_BIDIOE           0x00004000	/* Output enable in bidirectional mode */
  #define SPI_CR1_BIDIMODE         0x00008000	/* Bidirectional data mode enable */
#define TOFF_SPI_CR2        0x0004		/* (RW) SPI control register 2 */
  #define SPI_CR2_RXDMAEN          0x00000001	/* Rx Buffer DMA Enable */
  #define SPI_CR2_TXDMAEN          0x00000002	/* Tx Buffer DMA Enable */
  #define SPI_CR2_SSOE             0x00000004	/* SS Output Enable */
  #define SPI_CR2_FRF              0x00000010	/* Frame Format */
  #define SPI_CR2_ERRIE            0x00000020	/* Error Interrupt Enable */
  #define SPI_CR2_RXNEIE           0x00000040	/* RX buffer Not Empty Interrupt Enable */
  #define SPI_CR2_TXEIE            0x00000080	/* Tx buffer Empty Interrupt Enable */
#define TOFF_SPI_SR         0x0008		/* (RW) SPI status register */
  #define SPI_SR_RXNE              0x00000001	/* Receive buffer Not Empty */
  #define SPI_SR_TXE               0x00000002	/* Transmit buffer Empty */
  #define SPI_SR_CHSIDE            0x00000004	/* Channel side */
  #define SPI_SR_UDR               0x00000008	/* Underrun flag */
  #define SPI_SR_CRCERR            0x00000010	/* CRC Error flag */
  #define SPI_SR_MODF              0x00000020	/* Mode fault */
  #define SPI_SR_OVR               0x00000040	/* Overrun flag */
  #define SPI_SR_BSY               0x00000080	/* Busy flag */
  #define SPI_SR_FRE               0x00000100	/* Frame format error flag */
#define TOFF_SPI_DR         0x000C		/* (RW) SPI data register */
#define TOFF_SPI_CRCPR      0x0010		/* (RW) SPI CRC polynomial register (not used in I2S mode) */
#define TOFF_SPI_RXCRCR     0x0014		/* (RW) SPI RX CRC register (not used in I2S mode) */
#define TOFF_SPI_TXCRCR     0x0018		/* (RW) SPI TX CRC register (not used in I2S mode) */
#define TOFF_SPI_I2SCFGR    0x001C		/* (RW) SPI_I2S configuration register */
  #define SPI_I2SCFGR_CHLEN        0x00000001	/* Channel length (number of bits per audio channel) */
  #define SPI_I2SCFGR_DATLEN       0x00000006	/* DATLEN[1:0] bits (Data length to be transferred)  */
  #define SPI_I2SCFGR_DATLEN_0     0x00000002	/* Bit 0 */
  #define SPI_I2SCFGR_DATLEN_1     0x00000004	/* Bit 1 */
  #define SPI_I2SCFGR_CKPOL        0x00000008	/* steady state clock polarity */
  #define SPI_I2SCFGR_I2SSTD       0x00000030	/* I2SSTD[1:0] bits (I2S standard selection) */
  #define SPI_I2SCFGR_I2SSTD_0     0x00000010	/* Bit 0 */
  #define SPI_I2SCFGR_I2SSTD_1     0x00000020	/* Bit 1 */
  #define SPI_I2SCFGR_PCMSYNC      0x00000080	/* PCM frame synchronization */
  #define SPI_I2SCFGR_I2SCFG       0x00000300	/* I2SCFG[1:0] bits (I2S configuration mode) */
  #define SPI_I2SCFGR_I2SCFG_0     0x00000100	/* Bit 0 */
  #define SPI_I2SCFGR_I2SCFG_1     0x00000200	/* Bit 1 */
  #define SPI_I2SCFGR_I2SE         0x00000400	/* I2S Enable */
  #define SPI_I2SCFGR_I2SMOD       0x00000800	/* I2S mode selection */
  #define SPI_I2SCFGR_ASTRTEN      0x00001000	/* Asynchronous start enable */
#define TOFF_SPI_I2SPR      0x0020		/* (RW) SPI_I2S prescaler register */

/*
 *  UNIVERSAL SYNCHRONOUS ASYNCHORONOUS RECEIVER TRANSMITTER
 */
#define TADR_USART2_BASE    (APBPERIPH_BASE + 0x4400)
#define TADR_USART4_BASE    (APBPERIPH_BASE + 0x4C00)
#define TADR_USART5_BASE    (APBPERIPH_BASE + 0x5000)
#define TADR_USART6_BASE    (APBPERIPH_BASE + 0x00011400)
#define TADR_USART1_BASE    (APBPERIPH_BASE + 0x00013800)
#define TOFF_USART_CR1      0x0000		/* (RW-32) USART Control register 1 */
  #define USART_CR1_UE       0x00000001	/* USART Enable */
  #define USART_CR1_UESM     0x00000002	/* USART Enable in STOP Mode */
  #define USART_CR1_RE       0x00000004	/* Receiver Enable */
  #define USART_CR1_TE       0x00000008	/* Transmitter Enable */
  #define USART_CR1_IDLEIE   0x00000010	/* IDLE Interrupt Enable */
  #define USART_CR1_RXNEIE   0x00000020	/* RXNE Interrupt Enable */
  #define USART_CR1_TCIE     0x00000040	/* Transmission Complete Interrupt Enable */
  #define USART_CR1_TXEIE    0x00000080	/* PE Interrupt Enable */
  #define USART_CR1_PEIE     0x00000100	/* PE Interrupt Enable */
  #define USART_CR1_PS       0x00000200	/* Parity Selection */
  #define USART_CR1_PCE      0x00000400	/* Parity Control Enable */
  #define USART_CR1_WAKE     0x00000800	/* Wakeup method */
  #define USART_CR1_M0       0x00001000	/* Word length bit 0 */
  #define USART_CR1_MME      0x00002000	/* Mute Mode Enable */
  #define USART_CR1_CMIE     0x00004000	/* Character match interrupt enable */
  #define USART_CR1_OVER8    0x00008000	/* Oversampling by 8-bit or 16-bit mode */
  #define USART_CR1_DEDT     0x001F0000	/* DEDT[4:0] bits (Driver Enable Deassertion Time) */
  #define USART_CR1_DEDT_0   0x00010000
  #define USART_CR1_DEDT_1   0x00020000
  #define USART_CR1_DEDT_2   0x00040000
  #define USART_CR1_DEDT_3   0x00080000
  #define USART_CR1_DEDT_4   0x00100000
  #define USART_CR1_DEAT     0x03E00000	/* DEAT[4:0] bits (Driver Enable Assertion Time) */
  #define USART_CR1_DEAT_0   0x00200000
  #define USART_CR1_DEAT_1   0x00400000
  #define USART_CR1_DEAT_2   0x00800000
  #define USART_CR1_DEAT_3   0x01000000
  #define USART_CR1_DEAT_4   0x02000000
  #define USART_CR1_RTOIE    0x04000000	/* Receive Time Out interrupt enable */
  #define USART_CR1_EOBIE    0x08000000	/* End of Block interrupt enable */
  #define USART_CR1_M1       0x10000000	/* Word length bit 1 */
  #define USART_CR1_M        0x10001000	/* [M1:M0] Word length */
#define TOFF_USART_CR2      0x0004		/* (RW-32) USART Control register 2 */
  #define USART_CR2_ADDM7    0x00000010	/* 7-bit or 4-bit Address Detection */
  #define USART_CR2_LBDL     0x00000020	/* LIN Break Detection Length */
  #define USART_CR2_LBDIE    0x00000040	/* LIN Break Detection Interrupt Enable */
  #define USART_CR2_LBCL     0x00000100	/* Last Bit Clock pulse */
  #define USART_CR2_CPHA     0x00000200	/* Clock Phase */
  #define USART_CR2_CPOL     0x00000400	/* Clock Polarity */
  #define USART_CR2_CLKEN    0x00000800	/* Clock Enable */
  #define USART_CR2_STOP     0x00003000	/* STOP[1:0] bits (STOP bits) */
  #define USART_CR2_STOP_0   0x00001000	/* Bit 0 */
  #define USART_CR2_STOP_1   0x00002000	/* Bit 1 */
  #define USART_CR2_LINEN    0x00004000	/* LIN mode enable */
  #define USART_CR2_SWAP     0x00008000	/* SWAP TX/RX pins */
  #define USART_CR2_RXINV    0x00010000	/* RX pin active level inversion */
  #define USART_CR2_TXINV    0x00020000	/* TX pin active level inversion */
  #define USART_CR2_DATAINV  0x00040000	/* Binary data inversion */
  #define USART_CR2_MSBFIRST 0x00080000	/* Most Significant Bit First */
  #define USART_CR2_ABREN    0x00100000	/* Auto Baud-Rate Enable*/
  #define USART_CR2_ABRMODE  0x00600000	/* ABRMOD[1:0] bits (Auto Baud-Rate Mode) */
  #define USART_CR2_ABRMODE_0 0x00200000
  #define USART_CR2_ABRMODE_1 0x00400000
  #define USART_CR2_RTOEN    0x00800000	/* Receiver Time-Out enable */
  #define USART_CR2_ADD      0xFF000000	/* Address of the USART node */
#define TOFF_USART_CR3      0x0008		/* (RW-32) USART Control register 3 */
  #define USART_CR3_EIE      0x00000001	/* Error Interrupt Enable */
  #define USART_CR3_IREN     0x00000002	/* IrDA mode Enable */
  #define USART_CR3_IRLP     0x00000004	/* IrDA Low-Power */
  #define USART_CR3_HDSEL    0x00000008	/* Half-Duplex Selection */
  #define USART_CR3_NACK     0x00000010	/* Smartcard NACK enable */
  #define USART_CR3_SCEN     0x00000020	/* Smartcard mode enable */
  #define USART_CR3_DMAR     0x00000040	/* DMA Enable Receiver */
  #define USART_CR3_DMAT     0x00000080	/* DMA Enable Transmitter */
  #define USART_CR3_RTSE     0x00000100	/* RTS Enable */
  #define USART_CR3_CTSE     0x00000200	/* CTS Enable */
  #define USART_CR3_CTSIE    0x00000400	/* CTS Interrupt Enable */
  #define USART_CR3_ONEBIT   0x00000800	/* USART One bit method enable */
  #define USART_CR3_OVRDIS   0x00001000	/* Overrun Disable */
  #define USART_CR3_DDRE     0x00002000	/* DMA Disable on Reception Error */
  #define USART_CR3_DEM      0x00004000	/* Driver Enable Mode */
  #define USART_CR3_DEP      0x00008000	/* Driver Enable Polarity Selection */
  #define USART_CR3_SCARCNT  0x000E0000	/* SCARCNT[2:0] bits (SmartCard Auto-Retry Count) */
  #define USART_CR3_SCARCNT_0 0x00020000
  #define USART_CR3_SCARCNT_1 0x00040000
  #define USART_CR3_SCARCNT_2 0x00080000
  #define USART_CR3_WUS      0x00300000	/* WUS[1:0] bits (Wake UP Interrupt Flag Selection) */
  #define USART_CR3_WUS_0    0x00100000
  #define USART_CR3_WUS_1    0x00200000
  #define USART_CR3_WUFIE    0x00400000	/* Wake Up Interrupt Enable */
  #define USART_CR3_UCESM    0x00800000	/* Clock Enable in Stop mode */ 
#define TOFF_USART_BRR      0x000C		/* (RW-32) USART Baud rate register */
#define TOFF_USART_GTPR     0x0010		/* (RW-32) USART Guard time and prescaler register */
  #define USART_GTPR_PSC     0x000000FF	/* PSC[7:0] bits (Prescaler value) */
  #define USART_GTPR_PSC_0   0x00000001	/* Bit 0 */
  #define USART_GTPR_PSC_1   0x00000002	/* Bit 1 */
  #define USART_GTPR_PSC_2   0x00000004	/* Bit 2 */
  #define USART_GTPR_PSC_3   0x00000008	/* Bit 3 */
  #define USART_GTPR_PSC_4   0x00000010	/* Bit 4 */
  #define USART_GTPR_PSC_5   0x00000020	/* Bit 5 */
  #define USART_GTPR_PSC_6   0x00000040	/* Bit 6 */
  #define USART_GTPR_PSC_7   0x00000080	/* Bit 7 */
  #define USART_GTPR_GT      0x0000FF00	/* Guard time value */
#define TOFF_USART_RTOR     0x0014		/* (RW) USART Receiver Time Out register */
  #define USART_RTOR_RTO     0x00FFFFFF	/* Receiver Time Out Value */
  #define USART_RTOR_BLEN    0xFF000000	/* Block Length */
#define TOFF_USART_RQR      0x0018		/* (RW) USART Request register */
  #define USART_RQR_ABRRQ    0x00000001	/* Auto-Baud Rate Request */
  #define USART_RQR_SBKRQ    0x00000002	/* Send Break Request */
  #define USART_RQR_MMRQ     0x00000004	/* Mute Mode Request */
  #define USART_RQR_RXFRQ    0x00000008	/* Receive Data flush Request */
  #define USART_RQR_TXFRQ    0x00000010	/* Transmit data flush Request */
#define TOFF_USART_ISR      0x001C		/* (RW) USART Interrupt and status register */
  #define USART_ISR_PE       0x00000001	/* Parity Error */
  #define USART_ISR_FE       0x00000002	/* Framing Error */
  #define USART_ISR_NE       0x00000004	/* Noise detected Flag */
  #define USART_ISR_ORE      0x00000008	/* OverRun Error */
  #define USART_ISR_IDLE     0x00000010	/* IDLE line detected */
  #define USART_ISR_RXNE     0x00000020	/* Read Data Register Not Empty */
  #define USART_ISR_TC       0x00000040	/* Transmission Complete */
  #define USART_ISR_TXE      0x00000080	/* Transmit Data Register Empty */
  #define USART_ISR_LBDF     0x00000100	/* LIN Break Detection Flag */
  #define USART_ISR_CTSIF    0x00000200	/* CTS interrupt flag */
  #define USART_ISR_CTS      0x00000400	/* CTS flag */
  #define USART_ISR_RTOF     0x00000800	/* Receiver Time Out */
  #define USART_ISR_EOBF     0x00001000	/* End Of Block Flag */
  #define USART_ISR_ABRE     0x00004000	/* Auto-Baud Rate Error */
  #define USART_ISR_ABRF     0x00008000	/* Auto-Baud Rate Flag */
  #define USART_ISR_BUSY     0x00010000	/* Busy Flag */
  #define USART_ISR_CMF      0x00020000	/* Character Match Flag */
  #define USART_ISR_SBKF     0x00040000	/* Send Break Flag */
  #define USART_ISR_RWU      0x00080000	/* Receive Wake Up from mute mode Flag */
  #define USART_ISR_WUF      0x00100000	/* Wake Up from stop mode Flag */
  #define USART_ISR_TEACK    0x00200000	/* Transmit Enable Acknowledge Flag */
  #define USART_ISR_REACK    0x00400000	/* Receive Enable Acknowledge Flag */
#define TOFF_USART_ICR      0x0020		/* (RW) USART Interrupt flag Clear register */
  #define USART_ICR_PECF     0x00000001	/* Parity Error Clear Flag */
  #define USART_ICR_FECF     0x00000002	/* Framing Error Clear Flag */
  #define USART_ICR_NCF      0x00000004	/* Noise detected Clear Flag */
  #define USART_ICR_ORECF    0x00000008	/* OverRun Error Clear Flag */
  #define USART_ICR_IDLECF   0x00000010	/* IDLE line detected Clear Flag */
  #define USART_ICR_TCCF     0x00000040	/* Transmission Complete Clear Flag */
  #define USART_ICR_LBDCF    0x00000100	/* LIN Break Detection Clear Flag */
  #define USART_ICR_CTSCF    0x00000200	/* CTS Interrupt Clear Flag */
  #define USART_ICR_RTOCF    0x00000800	/* Receiver Time Out Clear Flag */
  #define USART_ICR_EOBCF    0x00001000	/* End Of Block Clear Flag */
  #define USART_ICR_CMCF     0x00020000	/* Character Match Clear Flag */
  #define USART_ICR_WUCF     0x00100000	/* Wake Up from stop mode Clear Flag */
#define TOFF_USART_RDR      0x0024		/* (RW-16) USART Receive Data register */
  #define USART_RDR_RDR      0x01FF		/* RDR[8:0] bits (Receive Data value) */
#define TOFF_USART_TDR      0x0028		/* (RW-16) USART Transmit Data register */
  #define USART_TDR_TDR      0x01FF		/* TDR[8:0] bits (Transmit Data value) */


/*
 *  INTER-INTERATED CIRCUIT IINTERFACE
 */
#define TADR_I2C1_BASE      (APBPERIPH_BASE + 0x5400)
#define TADR_I2C2_BASE      (APBPERIPH_BASE + 0x5800)
#define TADR_I2C3_BASE      (APBPERIPH_BASE + 0x7800)
#define TOFF_I2C_CR1        0x0000		/* (RW) I2C Control register 1 */
  #define I2C_CR1_PE         0x00000001	/* Peripheral Enable */
  #define I2C_CR1_TXIE       0x00000002	/* TX interrupt enable */
  #define I2C_CR1_RXIE       0x00000004	/* RX interrupt enable */
  #define I2C_CR1_ADDRIE     0x00000008	/* Address match interrupt enable */
  #define I2C_CR1_NACKIE     0x00000010	/* NACK received interrupt enable */
  #define I2C_CR1_STOPIE     0x00000020	/* STOP detection interrupt enable */
  #define I2C_CR1_TCIE       0x00000040	/* Transfer complete interrupt enable */
  #define I2C_CR1_ERRIE      0x00000080	/* Errors interrupt enable */
  #define I2C_CR1_DNF        0x00000F00	/* Digital noise filter */
  #define I2C_CR1_ANFOFF     0x00001000	/* Analog noise filter OFF */
  #define I2C_CR1_TXDMAEN    0x00004000	/* DMA transmission requests enable */
  #define I2C_CR1_RXDMAEN    0x00008000	/* DMA reception requests enable */
  #define I2C_CR1_SBC        0x00010000	/* Slave byte control */
  #define I2C_CR1_NOSTRETCH  0x00020000	/* Clock stretching disable */
  #define I2C_CR1_WUPEN      0x00040000	/* Wakeup from STOP enable */
  #define I2C_CR1_GCEN       0x00080000	/* General call enable */
  #define I2C_CR1_SMBHEN     0x00100000	/* SMBus host address enable */
  #define I2C_CR1_SMBDEN     0x00200000	/* SMBus device default address enable */
  #define I2C_CR1_ALERTEN    0x00400000	/* SMBus alert enable */
  #define I2C_CR1_PECEN      0x00800000	/* PEC enable */
#define TOFF_I2C_CR2        0x0004		/* (RW) I2C Control register 2 */
  #define I2C_CR2_SADD       0x000003FF	/* Slave address (master mode) */
  #define I2C_CR2_RD_WRN     0x00000400	/* Transfer direction (master mode) */
  #define I2C_CR2_ADD10      0x00000800	/* 10-bit addressing mode (master mode) */
  #define I2C_CR2_HEAD10R    0x00001000	/* 10-bit address header only read direction (master mode) */
  #define I2C_CR2_START      0x00002000	/* START generation */
  #define I2C_CR2_STOP       0x00004000	/* STOP generation (master mode) */
  #define I2C_CR2_NACK       0x00008000	/* NACK generation (slave mode) */
  #define I2C_CR2_NBYTES     0x00FF0000	/* Number of bytes */
  #define I2C_CR2_RELOAD     0x01000000	/* NBYTES reload mode */
  #define I2C_CR2_AUTOEND    0x02000000	/* Automatic end mode (master mode) */
  #define I2C_CR2_PECBYTE    0x04000000	/* Packet error checking byte */
#define TOFF_I2C_OAR1       0x0008		/* (RW) I2C Own address register 1 */
  #define I2C_OAR1_OA1      0x000003FF	/* Interface own address 1 */
  #define I2C_OAR1_OA1MODE  0x00000400	/* Own address 1 10-bit mode */
  #define I2C_OAR1_OA1EN    0x00008000	/* Own address 1 enable */
#define TOFF_I2C_OAR2       0x000C		/* (RW) I2C Own address register 2 */
  #define I2C_OAR2_OA2       0x000000FE	/* Interface own address 2 */
  #define I2C_OAR2_OA2MSK    0x00000700	/* Own address 2 masks */
  #define I2C_OAR2_OA2NOMASK 0x00000000	/* No mask */
  #define I2C_OAR2_OA2MASK01 0x00000100	/* OA2[1] is masked, Only OA2[7:2] are compared */
  #define I2C_OAR2_OA2MASK02 0x00000200	/* OA2[2:1] is masked, Only OA2[7:3] are compared */
  #define I2C_OAR2_OA2MASK03 0x00000300	/* OA2[3:1] is masked, Only OA2[7:4] are compared */
  #define I2C_OAR2_OA2MASK04 0x00000400	/* OA2[4:1] is masked, Only OA2[7:5] are compared */
  #define I2C_OAR2_OA2MASK05 0x00000500	/* OA2[5:1] is masked, Only OA2[7:6] are compared */
  #define I2C_OAR2_OA2MASK06 0x00000600	/* OA2[6:1] is masked, Only OA2[7] are compared */
  #define I2C_OAR2_OA2MASK07 0x00000700	/* OA2[7:1] is masked, No comparison is done */
  #define I2C_OAR2_OA2EN     0x00008000	/* Own address 2 enable */
#define TOFF_I2C_TIMINGR    0x0010		/* (RW) I2C Timing register */
  #define I2C_TIMINGR_SCLL   0x000000FF	/* SCL low period (master mode) */
  #define I2C_TIMINGR_SCLH   0x0000FF00	/* SCL high period (master mode) */
  #define I2C_TIMINGR_SDADEL 0x000F0000	/* Data hold time */
  #define I2C_TIMINGR_SCLDEL 0x00F00000	/* Data setup time */
  #define I2C_TIMINGR_PRESC  0xF0000000	/* Timings prescaler */
#define TOFF_I2C_TIMEOUTR   0x0014		/* (RW) I2C Timeout register */
  #define I2C_TIMEOUTR_TIMEOUTA 0x00000FFF	/* Bus timeout A */
  #define I2C_TIMEOUTR_TIDLE    0x00001000	/* Idle clock timeout detection */
  #define I2C_TIMEOUTR_TIMOUTEN 0x00008000	/* Clock timeout enable */
  #define I2C_TIMEOUTR_TIMEOUTB 0x0FFF0000	/* Bus timeout B*/
  #define I2C_TIMEOUTR_TEXTEN   0x80000000	/* Extended clock timeout enable */
#define TOFF_I2C_ISR        0x0018		/* (RW) I2C Interrupt and status register */
  #define I2C_ISR_TXE        0x00000001	/* Transmit data register empty */
  #define I2C_ISR_TXIS       0x00000002	/* Transmit interrupt status */
  #define I2C_ISR_RXNE       0x00000004	/* Receive data register not empty */
  #define I2C_ISR_ADDR       0x00000008	/* Address matched (slave mode)*/
  #define I2C_ISR_NACKF      0x00000010	/* NACK received flag */
  #define I2C_ISR_STOPF      0x00000020	/* STOP detection flag */
  #define I2C_ISR_TC         0x00000040	/* Transfer complete (master mode) */
  #define I2C_ISR_TCR        0x00000080	/* Transfer complete reload */
  #define I2C_ISR_BERR       0x00000100	/* Bus error */
  #define I2C_ISR_ARLO       0x00000200	/* Arbitration lost */
  #define I2C_ISR_OVR        0x00000400	/* Overrun/Underrun */
  #define I2C_ISR_PECERR     0x00000800	/* PEC error in reception */
  #define I2C_ISR_TIMEOUT    0x00001000	/* Timeout or Tlow detection flag */
  #define I2C_ISR_ALERT      0x00002000	/* SMBus alert */
  #define I2C_ISR_BUSY       0x00008000	/* Bus busy */
  #define I2C_ISR_DIR        0x00010000	/* Transfer direction (slave mode) */
  #define I2C_ISR_ADDCODE    0x00FE0000	/* Address match code (slave mode) */
#define TOFF_I2C_ICR        0x001C		/* (RW) I2C Interrupt clear register */
  #define I2C_ICR_ADDRCF     0x00000008	/* Address matched clear flag */
  #define I2C_ICR_NACKCF     0x00000010	/* NACK clear flag */
  #define I2C_ICR_STOPCF     0x00000020	/* STOP detection clear flag */
  #define I2C_ICR_BERRCF     0x00000100	/* Bus error clear flag */
  #define I2C_ICR_ARLOCF     0x00000200	/* Arbitration lost clear flag */
  #define I2C_ICR_OVRCF      0x00000400	/* Overrun/Underrun clear flag */
  #define I2C_ICR_PECCF      0x00000800	/* PAC error clear flag */
  #define I2C_ICR_TIMOUTCF   0x00001000	/* Timeout clear flag */
  #define I2C_ICR_ALERTCF    0x00002000	/* Alert clear flag */
#define TOFF_I2C_PECR       0x0020		/* (RW) I2C PEC register */
  #define I2C_PECR_PEC       0x000000FF	/* PEC register */
#define TOFF_I2C_RXDR       0x0024		/* (RW) I2C Receive data register */
  #define I2C_RXDR_RXDATA    0x000000FF	/* 8-bit receive data */
#define TOFF_I2C_TXDR       0x0028		/* (RW) I2C Transmit data register */
  #define I2C_TXDR_TXDATA    0x000000FF	/* 8-bit transmit data */

/*
 *  USB DEVICE
 */
#define TADR_USB_BASE       (APBPERIPH_BASE + 0x5C00)	/* USB_IP Peripheral Registers base address */
#define TADR_USB_PMAADDR    (APBPERIPH_BASE + 0x6000)	/* USB_IP Packet Memory Area base address */
#define TOFF_USB_EP0R       0x0000		/* (RW-16) USB Endpoint 0 register  */
  #define USB_EPADDR_FIELD   0x000F		/* EndPoint ADDRess FIELD */
  #define USB_EPTX_STAT      0x0030		/* EndPoint TX STATus bit field */
    #define USB_EP_TX_DIS    0x0000		/*  EndPoint TX DISabled */
    #define USB_EP_TX_STALL  0x0010		/*  EndPoint TX STALLed */
    #define USB_EP_TX_NAK    0x0020		/*  EndPoint TX NAKed */
    #define USB_EP_TX_VALID  0x0030		/*  EndPoint TX VALID */
    #define USB_EPTX_DTOG1   0x0010		/*  EndPoint TX Data TOGgle bit1 */
    #define USB_EPTX_DTOG2   0x0020		/*  EndPoint TX Data TOGgle bit2 */
    #define USB_EPTX_DTOGMASK  (USB_EPTX_STAT|USB_EPREG_MASK)
  #define USB_EP_DTOG_TX     0x0040		/* EndPoint Data TOGGLE TX */
  #define USB_EP_CTR_TX      0x0080		/* EndPoint Correct TRansfer TX */
  #define USB_EP_KIND        0x0100		/* EndPoint KIND */
  #define USB_EP_T_FIELD     0x0600		/* EndPoint TYPE */
    #define USB_EP_TYPE_MASK 0x0600		/*  EndPoint TYPE Mask */
    #define USB_EP_BULK      0x0000		/*  EndPoint BULK */
    #define USB_EP_CONTROL   0x0200		/*  EndPoint CONTROL */
    #define USB_EP_ISOCHRONOUS 0x0400	/*  EndPoint ISOCHRONOUS */
    #define USB_EP_INTERRUPT 0x0600		/*  EndPoint INTERRUPT */
  #define USB_EP_SETUP       0x0800		/* EndPoint SETUP */
  #define USB_EPRX_STAT      0x3000		/* EndPoint RX STATus bit field */
    #define USB_EP_RX_DIS    0x0000		/*  EndPoint RX DISabled */
    #define USB_EP_RX_STALL  0x1000		/*  EndPoint RX STALLed */
    #define USB_EP_RX_NAK    0x2000		/*  EndPoint RX NAKed */
    #define USB_EP_RX_VALID  0x3000		/*  EndPoint RX VALID */
    #define USB_EPRX_DTOG1   0x1000		/*  EndPoint RX Data TOGgle bit1 */
    #define USB_EPRX_DTOG2   0x2000		/*  EndPoint RX Data TOGgle bit1 */
    #define USB_EPRX_DTOGMASK  (USB_EPRX_STAT|USB_EPREG_MASK)
  #define USB_EP_DTOG_RX     0x4000		/* EndPoint Data TOGGLE RX */
  #define USB_EP_CTR_RX      0x8000		/* EndPoint Correct TRansfer RX */
  #define USB_EPREG_MASK     (USB_EP_CTR_RX|USB_EP_SETUP|USB_EP_T_FIELD|USB_EP_KIND|USB_EP_CTR_TX|USB_EPADDR_FIELD)
#define TOFF_USB_EP1R       0x0004		/* (RW-16) endpoint 1 register address */
#define TOFF_USB_EP2R       0x0008		/* (RW-16) endpoint 2 register address */
#define TOFF_USB_EP3R       0x000C		/* (RW-16) endpoint 3 register address */
#define TOFF_USB_EP4R       0x0010		/* (RW-16) endpoint 4 register address */
#define TOFF_USB_EP5R       0x0014		/* (RW-16) endpoint 5 register address */
#define TOFF_USB_EP6R       0x0018		/* (RW-16) endpoint 6 register address */
#define TOFF_USB_EP7R       0x001C		/* (RW-16) endpoint 7 register address */
#define TOFF_USB_CNTR       0x0040		/* (RW-16) Control register */
  #define USB_CNTR_FRES      0x0001		/* Force USB RESet */
  #define USB_CNTR_PDWN      0x0002		/* Power DoWN */
  #define USB_CNTR_LPMODE    0x0004		/* Low-power MODE */
  #define USB_CNTR_FSUSP     0x0008		/* Force SUSPend */
  #define USB_CNTR_RESUME    0x0010		/* RESUME request */
  #define USB_CNTR_L1RESUME  0x0020		/* LPM L1 Resume request */
  #define USB_CNTR_L1REQM    0x0080		/* LPM L1 state request interrupt mask */
  #define USB_CNTR_ESOFM     0x0100		/* Expected Start Of Frame Mask */
  #define USB_CNTR_SOFM      0x0200		/* Start Of Frame Mask */
  #define USB_CNTR_RESETM    0x0400		/* RESET Mask   */
  #define USB_CNTR_SUSPM     0x0800		/* SUSPend Mask */
  #define USB_CNTR_WKUPM     0x1000		/* WaKe UP Mask */
  #define USB_CNTR_ERRM      0x2000		/* ERRor Mask */
  #define USB_CNTR_PMAOVRM   0x4000		/* DMA OVeR/underrun Mask */
  #define USB_CNTR_CTRM      0x8000		/* Correct TRansfer Mask */
#define TOFF_USB_ISTR       0x0044		/* (RW-16) Interrupt status register */
  #define USB_ISTR_EP_ID     0x000F		/* EndPoint IDentifier (read-only bit)  */
  #define USB_ISTR_DIR       0x0010		/* DIRection of transaction (read-only bit)  */
  #define USB_ISTR_L1REQ     0x0080		/* LPM L1 state request  */
  #define USB_ISTR_ESOF      0x0100		/* Expected Start Of Frame (clear-only bit) */
  #define USB_ISTR_SOF       0x0200		/* Start Of Frame (clear-only bit) */
  #define USB_ISTR_RESET     0x0400		/* RESET (clear-only bit) */
  #define USB_ISTR_SUSP      0x0800		/* SUSPend (clear-only bit) */
  #define USB_ISTR_WKUP      0x1000		/* WaKe UP (clear-only bit) */
  #define USB_ISTR_ERR       0x2000		/* ERRor (clear-only bit) */
  #define USB_ISTR_PMAOVR    0x4000		/* DMA OVeR/underrun (clear-only bit) */
  #define USB_ISTR_CTR       0x8000		/* Correct TRansfer (clear-only bit) */
  #define USB_CLR_L1REQ      (~USB_ISTR_L1REQ)	/* clear LPM L1  bit */
  #define USB_CLR_ESOF       (~USB_ISTR_ESOF)	/* clear Expected Start Of Frame bit */
  #define USB_CLR_SOF        (~USB_ISTR_SOF)	/* clear Start Of Frame bit */
  #define USB_CLR_RESET      (~USB_ISTR_RESET)	/* clear RESET bit */
  #define USB_CLR_SUSP       (~USB_ISTR_SUSP)	/* clear SUSPend bit */
  #define USB_CLR_WKUP       (~USB_ISTR_WKUP)	/* clear WaKe UP bit */
  #define USB_CLR_ERR        (~USB_ISTR_ERR)	/* clear ERRor bit */
  #define USB_CLR_PMAOVR     (~USB_ISTR_PMAOVR)	/* clear DMA OVeR/underrun bit*/
  #define USB_CLR_CTR        (~USB_ISTR_CTR)	/* clear Correct TRansfer bit */
#define TOFF_USB_FNR        0x0048		/* (RW-16) Frame number register */
  #define USB_FNR_FN         0x07FF		/* Frame Number */
  #define USB_FNR_LSOF       0x1800		/* Lost SOF */
  #define USB_FNR_LCK        0x2000		/* LoCKed */
  #define USB_FNR_RXDM       0x4000		/* status of D- data line */
  #define USB_FNR_RXDP       0x8000		/* status of D+ data line */
#define TOFF_USB_DADDR      0x004C		/* (RW-16) Device address register */
  #define USB_DADDR_ADD      0x007F		/* USB device address */
  #define USB_DADDR_EF       0x0080		/* USB device address Enable Function */
#define TOFF_USB_BTABLE     0x0050		/* (RW-16) Buffer Table address register */
#define TOFF_USB_LPMCSR     0x0054		/* (RW-16) LPM Control and Status register */
  #define USB_LPMCSR_LMPEN  0x0001		/* LPM support enable  */
  #define USB_LPMCSR_LPMACK 0x0002		/* LPM Token acknowledge enable*/
  #define USB_LPMCSR_REMWAKE 0x0008		/* bRemoteWake value received with last ACKed LPM Token */
  #define USB_LPMCSR_BESL   0x00F0		/* BESL value received with last ACKed LPM Token  */ 
#define TOFF_USB_BCDR       0x0058		/* (RW-16) Battery Charging detector register */
  #define USB_BCDR_BCDEN     0x0001		/* Battery charging detector (BCD) enable */
  #define USB_BCDR_DCDEN     0x0002		/* Data contact detection (DCD) mode enable */
  #define USB_BCDR_PDEN      0x0004		/* Primary detection (PD) mode enable */
  #define USB_BCDR_SDEN      0x0008		/* Secondary detection (SD) mode enable */
  #define USB_BCDR_DCDET     0x0010		/* Data contact detection (DCD) status */
  #define USB_BCDR_PDET      0x0020		/* Primary detection (PD) status */
  #define USB_BCDR_SDET      0x0040		/* Secondary detection (SD) status */
  #define USB_BCDR_PS2DET    0x0080		/* PS2 port or proprietary charger detected */
  #define USB_BCDR_DPPU      0x8000		/* DP Pull-up Enable */

/*
 *  POWER CONTROL
 */
#define TADR_PWR_BASE       (APBPERIPH_BASE + 0x7000)
#define TOFF_PWR_CR         0x0000		/* (RW) PWR power control register */
  #define PWR_CR_LPDS        0x00000001	/* Low-Power Deepsleep */
  #define PWR_CR_PDDS        0x00000002	/* Power Down Deepsleep */
  #define PWR_CR_CWUF        0x00000004	/* Clear Wakeup Flag */
  #define PWR_CR_CSBF        0x00000008	/* Clear Standby Flag */
  #define PWR_CR_PVDE        0x00000010	/* Power Voltage Detector Enable */
  #define PWR_CR_PLS_0       0x00000020	/* Bit 0 */
  #define PWR_CR_PLS_1       0x00000040	/* Bit 1 */
  #define PWR_CR_PLS_2       0x00000080	/* Bit 2 */
  #define PWR_CR_DBP         0x00000100	/* Disable Backup Domain write protection */
  #define PWR_CR_ULP         0x00000200	/* Ultra Low Power mode */
  #define PWR_CR_FWU         0x00000400	/* Fast wakeup */
  #define PWR_CR_VOS         0x00001800	/* VOS[1:0] bits (Voltage scaling range selection) */
  #define PWR_CR_VOS_0       0x00000800
  #define PWR_CR_VOS_1       0x00001000
  #define PWR_CR_DSEEKOFF    0x00002000	/* Deep Sleep mode with EEPROM kept Off */
  #define PWR_CR_LPRUN       0x00004000	/* Low power run mode */
#define TOFF_PWR_CSR        0x0004		/* (RW) PWR power control/status register */
  #define PWR_CSR_WUF        0x00000001	/* Wakeup Flag */
  #define PWR_CSR_SBF        0x00000002	/* Standby Flag */
  #define PWR_CSR_PVDO       0x00000004	/* PVD Output */
  #define PWR_CSR_VREFINTRDYF 0x00000008	/* Internal voltage reference (VREFINT) ready flag */
  #define PWR_CSR_VOSF       0x00000010	/* Voltage Scaling select flag */
  #define PWR_CSR_REGLPF     0x00000020	/* Regulator LP flag */
  #define PWR_CSR_EWUP       0x00000F00	/* Enable WKUP pin */
  #define PWR_CSR_EWUP1      0x00000100	/* Enable WKUP pin 1 */
  #define PWR_CSR_EWUP2      0x00000200	/* Enable WKUP pin 2 */
  #define PWR_CSR_EWUP3      0x00000400	/* Enable WKUP pin 3 */

/*
 *  DIGITAL TO ANALOG CONVTER (F/L)
 */
#define TADR_DAC_BASE       (APBPERIPH_BASE + 0x7400)
#define TOFF_DAC_CR         0x0000		/* (RW) DAC control register */
#define TOFF_DAC_SWTRIGR	0x0004		/* (RW) DAC software trigger register */
#define TOFF_DAC_DHR12R1    0x0008		/* (RW) DAC channel1 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12L1    0x000C		/* (RW) DAC channel1 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R1     0x0010		/* (RW) DAC channel1 8-bit right aligned data holding register */
#define TOFF_DAC_DHR12R2    0x0014		/* (RW) DAC channel2 12-bit right aligned data holding register */
#define TOFF_DAC_DHR12L2    0x0018		/* (RW) DAC channel2 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8R2     0x001C		/* (RW) DAC channel2 8-bit right-aligned data holding register */
#define TOFF_DAC_DHR12RD    0x0020		/* (RW) Dual DAC 12-bit right-aligned data holding register */
#define TOFF_DAC_DHR12LD    0x0024		/* (RW) DUAL DAC 12-bit left aligned data holding register */
#define TOFF_DAC_DHR8RD     0x0028		/* (RW) DUAL DAC 8-bit right aligned data holding register */
#define TOFF_DAC_DOR1       0x002C		/* (RW) DAC channel1 data output register */
#define TOFF_DAC_DOR2       0x0030		/* (RW) DAC channel2 data output register */
#define TOFF_DAC_SR         0x0034		/* (RW) DAC status register */

/*
 *  LPTIMIMER
 */
#define TADR_LPTIM1_BASE    (APBPERIPH_BASE + 0x7C00)
#define TOFF_LPTIM_ISR       0x0000		/* (RW) LPTIM Interrupt and Status register */
#define TOFF_LPTIM_ICR       0x0004		/* (RW) LPTIM Interrupt Clear register */
#define TOFF_LPTIM_IER       0x0008		/* (RW) LPTIM Interrupt Enable register */
#define TOFF_LPTIM_CFGR      0x000C		/* (RW) LPTIM Configuration register */
#define TOFF_LPTIM_CR        0x0010		/* (RW) LPTIM Control register */
#define TOFF_LPTIM_CMP       0x0014		/* (RW) LPTIM Compare register */
#define TOFF_LPTIM_ARR       0x0018		/* (RW) LPTIM Autoreload register */
#define TOFF_LPTIM_CNT       0x001C		/* (RW) LPTIM Counter register */

/*
 *  ANALOG TO DIGITAL CONVERTER
 */
#define TADR_ADC1_BASE      (APBPERIPH_BASE + 0x00012400)
#define TOFF_ADC_ISR        0x0000		/* (RW) ADC interrupt and status register */
  #define ADC_ISR_ADRDY      0x00000001	/* ADC ready flag */
  #define ADC_ISR_EOSMP      0x00000002	/* ADC group regular end of sampling flag */
  #define ADC_ISR_EOC        0x00000004	/* ADC group regular end of unitary conversion flag */
  #define ADC_ISR_EOSEQ      0x00000008	/* ADC End of Sequence flag */
  #define ADC_ISR_OVR        0x00000010	/* ADC group regular overrun flag */
  #define ADC_ISR_AWD        0x00000080	/* ADC Analog watchdog flag */
  #define ADC_ISR_EOCAL      0x00000800	/* ADC End of calibration flag */
  #define ADC_ISR_EOS        ADC_ISR_EOSEQ
  #define ADC_ISR_AWD1       ADC_ISR_AWD
#define TOFF_ADC_IER        0x0004		/* (RW) ADC interrupt enable register */
  #define ADC_IER_ADRDYIE    0x00000001	/* ADC ready interrupt */
  #define ADC_IER_EOSMPIE    0x00000002	/* ADC group regular end of sampling interrupt */
  #define ADC_IER_EOCIE      0x00000004	/* ADC group regular end of unitary conversion interrupt */
  #define ADC_IER_EOSEQIE    0x00000008	/* ADC End of Sequence of conversion interrupt enable */
  #define ADC_IER_OVRIE      0x00000010	/* ADC group regular overrun interrupt */
  #define ADC_IER_AWDIE      0x00000080	/* ADC Analog Watchdog interrupt enable */
  #define ADC_IER_EOCALIE    0x00000800	/* ADC Enf Of Calibration interrupt enable */
  #define ADC_IER_EOSIE      ADC_IER_EOSEQIE
  #define ADC_IER_AWD1IE     ADC_IER_AWDIE
#define TOFF_ADC_CR         0x0008		/* (RW) ADC control register */
  #define ADC_CR_ADEN        0x00000001	/* ADC enable */
  #define ADC_CR_ADDIS       0x00000002	/* ADC disable */
  #define ADC_CR_ADSTART     0x00000004	/* ADC group regular conversion start */
  #define ADC_CR_ADSTP       0x00000010	/* ADC group regular conversion stop */
  #define ADC_CR_ADVREGEN    0x10000000	/* ADC Voltage Regulator Enable */
  #define ADC_CR_ADCAL       0x80000000	/* ADC calibration */
#define TOFF_ADC_CFGR1      0x000C		/* (RW) ADC configuration register 1 */
  #define ADC_CFGR1_DMAEN    0x00000001	/* ADC DMA transfer enable */
  #define ADC_CFGR1_DMACFG   0x00000002	/* ADC DMA transfer configuration */
  #define ADC_CFGR1_SCANDIR  0x00000004	/* ADC group regular sequencer scan direction */
  #define ADC_CFGR1_RES      0x00000018	/* ADC data resolution */
  #define ADC_CFGR1_RES_0    0x00000008
  #define ADC_CFGR1_RES_1    0x00000010
  #define ADC_CFGR1_ALIGN    0x00000020	/* ADC data alignement */
  #define ADC_CFGR1_EXTSEL   0x000001C0	/* ADC group regular external trigger source */
  #define ADC_CFGR1_EXTSEL_0 0x00000040
  #define ADC_CFGR1_EXTSEL_1 0x00000080
  #define ADC_CFGR1_EXTSEL_2 0x00000100
  #define ADC_CFGR1_EXTEN    0x00000C00	/* ADC group regular external trigger polarity */
  #define ADC_CFGR1_EXTEN_0  0x00000400
  #define ADC_CFGR1_EXTEN_1  0x00000800
  #define ADC_CFGR1_OVRMOD   0x00001000	/* ADC group regular overrun configuration */
  #define ADC_CFGR1_CONT     0x00002000	/* ADC group regular continuous conversion mode */
  #define ADC_CFGR1_WAIT     0x00004000	/* ADC low power auto wait */
  #define ADC_CFGR1_AUTOFF   0x00008000	/* ADC low power auto power off */
  #define ADC_CFGR1_DISCEN   0x00010000	/* ADC group regular sequencer discontinuous mode */
  #define ADC_CFGR1_AWDSGL   0x00400000	/* ADC analog watchdog 1 monitoring a single channel or all channels */
  #define ADC_CFGR1_AWDEN    0x00800000	/* ADC analog watchdog 1 enable on scope ADC group regular */
  #define ADC_CFGR1_AWDCH    0x7C000000	/* ADC analog watchdog 1 monitored channel selection */
  #define ADC_CFGR1_AWDCH_0  0x04000000
  #define ADC_CFGR1_AWDCH_1  0x08000000
  #define ADC_CFGR1_AWDCH_2  0x10000000
  #define ADC_CFGR1_AWDCH_3  0x20000000
  #define ADC_CFGR1_AWDCH_4  0x40000000
#define TOFF_ADC_CFGR2      0x0010	/* (RW) ADC configuration register 2 */
  #define ADC_CFGR2_OVSE     0x00000001	/* Oversampler Enable */
  #define ADC_CFGR2_OVSR     0x0000001C	/* OVSR  [2:0] bits (Oversampling ratio) */
  #define ADC_CFGR2_OVSR_0   0x00000004
  #define ADC_CFGR2_OVSR_1   0x00000008
  #define ADC_CFGR2_OVSR_2   0x00000010
  #define ADC_CFGR2_OVSS     0x000001E0	/* OVSS [3:0] bits (Oversampling shift) */
  #define ADC_CFGR2_OVSS_0   0x00000020
  #define ADC_CFGR2_OVSS_1   0x00000040
  #define ADC_CFGR2_OVSS_2   0x00000080
  #define ADC_CFGR2_OVSS_3   0x00000100
  #define ADC_CFGR2_TOVS     0x00000200	/* Triggered Oversampling */
  #define ADC_CFGR2_CKMODE   0xC0000000	/* ADC clock source and prescaler (prescaler only for clock source synchronous) */
  #define ADC_CFGR2_CKMODE_1 0x80000000
  #define ADC_CFGR2_CKMODE_0 0x40000000
#define TOFF_ADC_SMPR       0x0014	/* (RW) ADC sampling time register */
  #define ADC_SMPR_SMP       0x00000007	/* ADC group of channels sampling time 2 */
  #define ADC_SMPR_SMP_0     0x00000001
  #define ADC_SMPR_SMP_1     0x00000002
  #define ADC_SMPR_SMP_2     0x00000004
#define TOFF_ADC_TR         0x0020	/* (RW) ADC analog watchdog 1 threshold register */
  #define ADC_TR_LT          0x00000FFF	/* ADC analog watchdog 1 threshold low */
  #define ADC_TR_LT_0        0x00000001
  #define ADC_TR_LT_1        0x00000002
  #define ADC_TR_LT_2        0x00000004
  #define ADC_TR_LT_3        0x00000008
  #define ADC_TR_LT_4        0x00000010
  #define ADC_TR_LT_5        0x00000020
  #define ADC_TR_LT_6        0x00000040
  #define ADC_TR_LT_7        0x00000080
  #define ADC_TR_LT_8        0x00000100
  #define ADC_TR_LT_9        0x00000200
  #define ADC_TR_LT_10       0x00000400
  #define ADC_TR_LT_11       0x00000800
  #define ADC_TR_HT          0x0FFF0000	/* ADC Analog watchdog 1 threshold high */
  #define ADC_TR_HT_0        0x00010000
  #define ADC_TR_HT_1        0x00020000
  #define ADC_TR_HT_2        0x00040000
  #define ADC_TR_HT_3        0x00080000
  #define ADC_TR_HT_4        0x00100000
  #define ADC_TR_HT_5        0x00200000
  #define ADC_TR_HT_6        0x00400000
  #define ADC_TR_HT_7        0x00800000
  #define ADC_TR_HT_8        0x01000000
  #define ADC_TR_HT_9        0x02000000
  #define ADC_TR_HT_10       0x04000000
  #define ADC_TR_HT_11       0x08000000
#define TOFF_ADC_CHSELR     0x0028	/* (RW) ADC group regular sequencer register */
  #define ADC_CHSELR_CHSEL   0x0007FFFF	/* ADC group regular sequencer channels, available when ADC_CFGR1_CHSELRMOD is reset */
  #define ADC_CHSELR_CHSEL0  0x00000001	/* Channel 0 selection */
  #define ADC_CHSELR_CHSEL1  0x00000002	/* Channel 1 selection */
  #define ADC_CHSELR_CHSEL2  0x00000004	/* Channel 2 selection */
  #define ADC_CHSELR_CHSEL3  0x00000008	/* Channel 3 selection */
  #define ADC_CHSELR_CHSEL4  0x00000010	/* Channel 4 selection */
  #define ADC_CHSELR_CHSEL5  0x00000020	/* Channel 5 selection */
  #define ADC_CHSELR_CHSEL6  0x00000040	/* Channel 6 selection */
  #define ADC_CHSELR_CHSEL7  0x00000080	/* Channel 7 selection */
  #define ADC_CHSELR_CHSEL8  0x00000100	/* Channel 8 selection */
  #define ADC_CHSELR_CHSEL9  0x00000200	/* Channel 9 selection */
  #define ADC_CHSELR_CHSEL10 0x00000400	/* Channel 10 selection */
  #define ADC_CHSELR_CHSEL11 0x00000800	/* Channel 11 selection */
  #define ADC_CHSELR_CHSEL12 0x00001000	/* Channel 12 selection */
  #define ADC_CHSELR_CHSEL13 0x00002000	/* Channel 13 selection */
  #define ADC_CHSELR_CHSEL14 0x00004000	/* Channel 14 selection */
  #define ADC_CHSELR_CHSEL15 0x00008000	/* Channel 15 selection */
  #define ADC_CHSELR_CHSEL16 0x00010000	/* Channel 16 selection */
  #define ADC_CHSELR_CHSEL17 0x00020000	/* Channel 17 selection */
  #define ADC_CHSELR_CHSEL18 0x00040000	/* Channel 18 selection */
#define TOFF_ADC_DR         0x0040		/* (RW) ADC group regular data register */
  #define ADC_DR_DATA        0x0000FFFF	/* ADC group regular conversion data */
#define TOFF_ADC_CALFACT    0x00B4		/* ADC data register */
  #define ADC_CALFACT_CALFACT 0x0000007F	/* Calibration factor */

#define TADR_ADC_BASE      (APBPERIPH_BASE + 0x00012708)
#define TOFF_ADC_CCR        0x0000
  #define ADC_CCR_PRESC      0x003C0000	/* PRESC  [3:0] bits (ADC prescaler) */
  #define ADC_CCR_PRESC_0    0x00040000
  #define ADC_CCR_PRESC_1    0x00080000
  #define ADC_CCR_PRESC_2    0x00100000
  #define ADC_CCR_PRESC_3    0x00200000
  #define ADC_CCR_VREFEN     0x00400000	/* Vrefint enable */
  #define ADC_CCR_TSEN       0x00800000	/* Temperature sensore enable */
  #define ADC_CCR_VLCDEN     0x01000000	/* Voltage LCD enable */
  #define ADC_CCR_LFMEN      0x02000000	/* Low Frequency Mode enable */

/*
 *  SYSTEM CONFIGURATION CONTROLLER
 */
#define TADR_SYSCFG_BASE    (APBPERIPH_BASE + 0x00010000)
#define TOFF_SYSCFG_CFGR1   0x0000		/* (RW) SYSCFG configuration register 1 */
  #define SYSCFG_CFGR1_MEM_MODE     0x00000003	/* SYSCFG_Memory Remap Config */
  #define SYSCFG_CFGR1_MEM_MODE_0   0x00000001
  #define SYSCFG_CFGR1_MEM_MODE_1   0x00000002
  #define SYSCFG_CFGR1_UFB          0x00000008	/* User bank swapping */
  #define SYSCFG_CFGR1_BOOT_MODE    0x00000300	/* SYSCFG_Boot mode Config */
  #define SYSCFG_CFGR1_BOOT_MODE_0  0x00000100
  #define SYSCFG_CFGR1_BOOT_MODE_1  0x00000200
#define TOFF_SYSCFG_CFGR2   0x0004		/* (RW) SYSCFG configuration register 2 */
  #define SYSCFG_CFGR2_FWDISEN      0x00000001	/* Firewall disable bit */
  #define SYSCFG_CFGR2_CAPA         0x0000003E	/* Connection of internal Vlcd rail to external capacitors */
  #define SYSCFG_CFGR2_CAPA_0       0x00000002
  #define SYSCFG_CFGR2_CAPA_1       0x00000004
  #define SYSCFG_CFGR2_CAPA_2       0x00000008
  #define SYSCFG_CFGR2_CAPA_3       0x00000010
  #define SYSCFG_CFGR2_CAPA_4       0x00000020
  #define SYSCFG_CFGR2_I2C_PB6_FMP  0x00000100	/* I2C PB6 Fast mode plus */
  #define SYSCFG_CFGR2_I2C_PB7_FMP  0x00000200	/* I2C PB7 Fast mode plus */
  #define SYSCFG_CFGR2_I2C_PB8_FMP  0x00000400	/* I2C PB8 Fast mode plus */
  #define SYSCFG_CFGR2_I2C_PB9_FMP  0x00000800	/* I2C PB9 Fast mode plus */
  #define SYSCFG_CFGR2_I2C1_FMP     0x00001000	/* I2C1 Fast mode plus */
  #define SYSCFG_CFGR2_I2C2_FMP     0x00002000	/* I2C2 Fast mode plus */
  #define SYSCFG_CFGR2_I2C3_FMP     0x00004000	/* I2C3 Fast mode plus */
#define TOFF_SYSCFG_EXTICR0 0x0008		/* (RW) SYSCFG external interrupt configuration registers 0 */
#define TOFF_SYSCFG_EXTICR1 0x000C		/* (RW) SYSCFG external interrupt configuration registers 1 */
#define TOFF_SYSCFG_EXTICR2 0x0010		/* (RW) SYSCFG external interrupt configuration registers 2 */
#define TOFF_SYSCFG_EXTICR3 0x0014		/* (RW) SYSCFG external interrupt configuration registers 3 */
#define TOFF_SYSCFG_CFGR3   0x0020		/* (RW) SYSCFG configuration register 3 */
  #define SYSCFG_CFGR3_VREF_OUT     0x00000030	/* Verf_ADC connection bit */
  #define SYSCFG_CFGR3_VREF_OUT_0   0x00000010
  #define SYSCFG_CFGR3_VREF_OUT_1   0x00000020
  #define SYSCFG_CFGR3_ENBUF_VREFINT_ADC    0x00000100	/* VREFINT reference for ADC enable bit */
  #define SYSCFG_CFGR3_ENBUF_SENSOR_ADC     0x00000200	/* Sensor reference for ADC enable bit */
  #define SYSCFG_CFGR3_ENBUFLP_VREFINT_COMP 0x00001000	/* VREFINT reference for comparator 2 enable bit */
  #define SYSCFG_CFGR3_ENREF_HSI48  0x00002000	/* VREFINT reference or 48 MHz RC oscillator enable bit */
  #define SYSCFG_CFGR3_VREFINT_RDYF 0x40000000	/* VREFINT ready flag */
  #define SYSCFG_CFGR3_REF_LOCK     0x80000000	/* CFGR3 lock bit */
  #define SYSCFG_CFGR3_ENBUF_BGAP_ADC       SYSCFG_CFGR3_ENBUF_VREFINT_ADC
  #define SYSCFG_CFGR3_ENBUFLP_BGAP_COMP    SYSCFG_CFGR3_ENBUFLP_VREFINT_COMP
  #define SYSCFG_CFGR3_ENREF_RC48MHz        SYSCFG_CFGR3_ENREF_HSI48
  #define SYSCFG_CFGR3_REF_RC48MHz_RDYF     SYSCFG_CFGR3_VREFINT_RDYF
  #define SYSCFG_CFGR3_REF_HSI48_RDYF       SYSCFG_CFGR3_VREFINT_RDYF
  #define SYSCFG_VREFINT_ADC_RDYF           SYSCFG_CFGR3_VREFINT_RDYF
  #define SYSCFG_CFGR3_SENSOR_ADC_RDYF      SYSCFG_CFGR3_VREFINT_RDYF
  #define SYSCFG_CFGR3_VREFINT_ADC_RDYF     SYSCFG_CFGR3_VREFINT_RDYF
  #define SYSCFG_CFGR3_VREFINT_COMP_RDYF    SYSCFG_CFGR3_VREFINT_RDYF

/*
 *  FIREWALL
 */
#define TADR_FIREWALL_BASE  (APBPERIPH_BASE + 0x00011C00)
#define TOFF_FW_CSSA        0x0000		/* (RW) Code Segment Start Address register */
  #define FW_CSSA_ADD        0x00FFFF00	/* Code Segment Start Address */
#define TOFF_FW_CSL         0x0004		/* (RW) Code Segment Length register */
  #define FW_CSL_LENG        0x003FFF00	/* Code Segment Length */
#define TOFF_FW_NVDSSA      0x0008		/* (RW) NON volatile data Segment Start Address register */
  #define FW_NVDSSA_ADD      0x00FFFF00	/* Non Volatile Dat Segment Start Address */ 
#define TOFF_FW_NVDSL       0x000C		/* (RW) NON volatile data Segment Length register */
  #define FW_NVDSL_LENG      0x003FFF00	/* Non Volatile Data Segment Length */
#define TOFF_FW_VDSSA       0x0010		/* (RW) Volatile data Segment Start Address register */
  #define FW_VDSSA_ADD       0x0000FFC0	/* Volatile Data Segment Start Address */ 
#define TOFF_FW_VDSL        0x0014		/* (RW) Volatile data Segment Length register */
  #define FW_VDSL_LENG       0x0000FFC0	/* Volatile Data Segment Length */ 
#define TOFF_FW_LSSA        0x0018		/* (RW) Library Segment Start Address register */
#define TOFF_FW_LSL         0x001C		/* (RW) Library Segment Length register */
#define TOFF_FW_CR          0x0020		/* (RW) Configuration  register */

/*
 *  EXTERNAL INTERRUPT/EVENT CONTROLLER (F/L)
 */
#define TADR_EXTI_BASE      (APBPERIPH_BASE + 0x00010400)
#define TOFF_EXTI_IMR       0x0000		/* (RW) EXTI Interrupt mask register */
  #define EXTI_IMR_MR0       0x00000001	/* Interrupt Mask on line 0 */
  #define EXTI_IMR_MR1       0x00000002	/* Interrupt Mask on line 1 */
  #define EXTI_IMR_MR2       0x00000004	/* Interrupt Mask on line 2 */
  #define EXTI_IMR_MR3       0x00000008	/* Interrupt Mask on line 3 */
  #define EXTI_IMR_MR4       0x00000010	/* Interrupt Mask on line 4 */
  #define EXTI_IMR_MR5       0x00000020	/* Interrupt Mask on line 5 */
  #define EXTI_IMR_MR6       0x00000040	/* Interrupt Mask on line 6 */
  #define EXTI_IMR_MR7       0x00000080	/* Interrupt Mask on line 7 */
  #define EXTI_IMR_MR8       0x00000100	/* Interrupt Mask on line 8 */
  #define EXTI_IMR_MR9       0x00000200	/* Interrupt Mask on line 9 */
  #define EXTI_IMR_MR10      0x00000400	/* Interrupt Mask on line 10 */
  #define EXTI_IMR_MR11      0x00000800	/* Interrupt Mask on line 11 */
  #define EXTI_IMR_MR12      0x00001000	/* Interrupt Mask on line 12 */
  #define EXTI_IMR_MR13      0x00002000	/* Interrupt Mask on line 13 */
  #define EXTI_IMR_MR14      0x00004000	/* Interrupt Mask on line 14 */
  #define EXTI_IMR_MR15      0x00008000	/* Interrupt Mask on line 15 */
  #define EXTI_IMR_MR16      0x00010000	/* Interrupt Mask on line 16 */
  #define EXTI_IMR_MR17      0x00020000	/* Interrupt Mask on line 17 */
  #define EXTI_IMR_MR18      0x00040000	/* Interrupt Mask on line 18 */
  #define EXTI_IMR_MR19      0x00080000	/* Interrupt Mask on line 19 */
  #define EXTI_IMR_MR20      0x00100000	/* Interrupt Mask on line 20 */
  #define EXTI_IMR_MR21      0x00200000	/* Interrupt Mask on line 21 */
  #define EXTI_IMR_MR22      0x00400000	/* Interrupt Mask on line 22 */
  #define EXTI_IMR_MR23      0x00800000	/* Interrupt Mask on line 23 */
  #define EXTI_IMR_MR25      0x02000000	/* Interrupt Mask on line 25 */
  #define EXTI_IMR_MR26      0x04000000	/* Interrupt Mask on line 26 */
  #define EXTI_IMR_MR27      0x08000000	/* Interrupt Mask on line 27 */
  #define EXTI_IMR_MR28      0x10000000	/* Interrupt Mask on line 28 */
  #define EXTI_IMR_MR31      0x80000000	/* Interrupt Mask on line 31 */
#define TOFF_EXTI_EMR       0x0004		/* (RW) EXTI Event mask register */
  #define EXTI_EMR_MR0       0x00000001	/* Event Mask on line 0  */
  #define EXTI_EMR_MR1       0x00000002	/* Event Mask on line 1  */
  #define EXTI_EMR_MR2       0x00000004	/* Event Mask on line 2  */
  #define EXTI_EMR_MR3       0x00000008	/* Event Mask on line 3  */
  #define EXTI_EMR_MR4       0x00000010	/* Event Mask on line 4  */
  #define EXTI_EMR_MR5       0x00000020	/* Event Mask on line 5  */
  #define EXTI_EMR_MR6       0x00000040	/* Event Mask on line 6  */
  #define EXTI_EMR_MR7       0x00000080	/* Event Mask on line 7  */
  #define EXTI_EMR_MR8       0x00000100	/* Event Mask on line 8  */
  #define EXTI_EMR_MR9       0x00000200	/* Event Mask on line 9  */
  #define EXTI_EMR_MR10      0x00000400	/* Event Mask on line 10 */
  #define EXTI_EMR_MR11      0x00000800	/* Event Mask on line 11 */
  #define EXTI_EMR_MR12      0x00001000	/* Event Mask on line 12 */
  #define EXTI_EMR_MR13      0x00002000	/* Event Mask on line 13 */
  #define EXTI_EMR_MR14      0x00004000	/* Event Mask on line 14 */
  #define EXTI_EMR_MR15      0x00008000	/* Event Mask on line 15 */
  #define EXTI_EMR_MR16      0x00010000	/* Event Mask on line 16 */
  #define EXTI_EMR_MR17      0x00020000	/* Event Mask on line 17 */
  #define EXTI_EMR_MR18      0x00040000	/* Event Mask on line 18 */
  #define EXTI_EMR_MR19      0x00080000	/* Event Mask on line 19 */
  #define EXTI_EMR_MR20      0x00100000	/* Event Mask on line 20 */
  #define EXTI_EMR_MR21      0x00200000	/* Event Mask on line 21 */
  #define EXTI_EMR_MR22      0x00400000	/* Event Mask on line 22 */
  #define EXTI_EMR_MR23      0x00800000	/* Event Mask on line 23 */
  #define EXTI_EMR_MR25      0x02000000	/* Event Mask on line 25 */
  #define EXTI_EMR_MR26      0x04000000	/* Event Mask on line 26 */
  #define EXTI_EMR_MR27      0x08000000	/* Event Mask on line 27 */
  #define EXTI_EMR_MR28      0x10000000	/* Event Mask on line 28 */
  #define EXTI_EMR_MR31      0x80000000	/* Event Mask on line 31 */
#define TOFF_EXTI_RTSR      0x0008		/* (RW) EXTI Rising trigger selection register */
  #define EXTI_RTSR_TR0      0x00000001	/* Rising trigger event configuration bit of line 0 */
  #define EXTI_RTSR_TR1      0x00000002	/* Rising trigger event configuration bit of line 1 */
  #define EXTI_RTSR_TR2      0x00000004	/* Rising trigger event configuration bit of line 2 */
  #define EXTI_RTSR_TR3      0x00000008	/* Rising trigger event configuration bit of line 3 */
  #define EXTI_RTSR_TR4      0x00000010	/* Rising trigger event configuration bit of line 4 */
  #define EXTI_RTSR_TR5      0x00000020	/* Rising trigger event configuration bit of line 5 */
  #define EXTI_RTSR_TR6      0x00000040	/* Rising trigger event configuration bit of line 6 */
  #define EXTI_RTSR_TR7      0x00000080	/* Rising trigger event configuration bit of line 7 */
  #define EXTI_RTSR_TR8      0x00000100	/* Rising trigger event configuration bit of line 8 */
  #define EXTI_RTSR_TR9      0x00000200	/* Rising trigger event configuration bit of line 9 */
  #define EXTI_RTSR_TR10     0x00000400	/* Rising trigger event configuration bit of line 10 */
  #define EXTI_RTSR_TR11     0x00000800	/* Rising trigger event configuration bit of line 11 */
  #define EXTI_RTSR_TR12     0x00001000	/* Rising trigger event configuration bit of line 12 */
  #define EXTI_RTSR_TR13     0x00002000	/* Rising trigger event configuration bit of line 13 */
  #define EXTI_RTSR_TR14     0x00004000	/* Rising trigger event configuration bit of line 14 */
  #define EXTI_RTSR_TR15     0x00008000	/* Rising trigger event configuration bit of line 15 */
  #define EXTI_RTSR_TR16     0x00010000	/* Rising trigger event configuration bit of line 16 */
  #define EXTI_RTSR_TR17     0x00020000	/* Rising trigger event configuration bit of line 17 */
  #define EXTI_RTSR_TR18     0x00040000	/* Rising trigger event configuration bit of line 18 */
  #define EXTI_RTSR_TR19     0x00080000	/* Rising trigger event configuration bit of line 19 */
  #define EXTI_RTSR_TR20     0x00100000	/* Rising trigger event configuration bit of line 20 */
  #define EXTI_RTSR_TR21     0x00200000	/* Rising trigger event configuration bit of line 21 */
  #define EXTI_RTSR_TR22     0x00400000	/* Rising trigger event configuration bit of line 22 */
  #define EXTI_RTSR_TR31     0x80000000	/* Rising trigger event configuration bit of line 31 */
#define TOFF_EXTI_FTSR      0x000C		/* (RW) EXTI Falling trigger selection register */
  #define EXTI_FTSR_TR0      0x00000001	/* Falling trigger event configuration bit of line 0 */
  #define EXTI_FTSR_TR1      0x00000002	/* Falling trigger event configuration bit of line 1 */
  #define EXTI_FTSR_TR2      0x00000004	/* Falling trigger event configuration bit of line 2 */
  #define EXTI_FTSR_TR3      0x00000008	/* Falling trigger event configuration bit of line 3 */
  #define EXTI_FTSR_TR4      0x00000010	/* Falling trigger event configuration bit of line 4 */
  #define EXTI_FTSR_TR5      0x00000020	/* Falling trigger event configuration bit of line 5 */
  #define EXTI_FTSR_TR6      0x00000040	/* Falling trigger event configuration bit of line 6 */
  #define EXTI_FTSR_TR7      0x00000080	/* Falling trigger event configuration bit of line 7 */
  #define EXTI_FTSR_TR8      0x00000100	/* Falling trigger event configuration bit of line 8 */
  #define EXTI_FTSR_TR9      0x00000200	/* Falling trigger event configuration bit of line 9 */
  #define EXTI_FTSR_TR10     0x00000400	/* Falling trigger event configuration bit of line 10 */
  #define EXTI_FTSR_TR11     0x00000800	/* Falling trigger event configuration bit of line 11 */
  #define EXTI_FTSR_TR12     0x00001000	/* Falling trigger event configuration bit of line 12 */
  #define EXTI_FTSR_TR13     0x00002000	/* Falling trigger event configuration bit of line 13 */
  #define EXTI_FTSR_TR14     0x00004000	/* Falling trigger event configuration bit of line 14 */
  #define EXTI_FTSR_TR15     0x00008000	/* Falling trigger event configuration bit of line 15 */
  #define EXTI_FTSR_TR16     0x00010000	/* Falling trigger event configuration bit of line 16 */
  #define EXTI_FTSR_TR17     0x00020000	/* Falling trigger event configuration bit of line 17 */
  #define EXTI_FTSR_TR18     0x00040000	/* Falling trigger event configuration bit of line 18 */
  #define EXTI_FTSR_TR19     0x00080000	/* Falling trigger event configuration bit of line 19 */
  #define EXTI_FTSR_TR20     0x00100000	/* Falling trigger event configuration bit of line 20 */
  #define EXTI_FTSR_TR21     0x00200000	/* Falling trigger event configuration bit of line 21 */
  #define EXTI_FTSR_TR22     0x00400000	/* Falling trigger event configuration bit of line 22 */
  #define EXTI_FTSR_TR31     0x80000000	/* Falling trigger event configuration bit of line 31 */
#define TOFF_EXTI_SWIER     0x0010		/* (RW) EXTI Software interrupt event register */
  #define EXTI_SWIER_SWIER0  0x00000000	/* Software Interrupt on line 0  */
  #define EXTI_SWIER_SWIER1  0x00000002	/* Software Interrupt on line 1  */
  #define EXTI_SWIER_SWIER2  0x00000004	/* Software Interrupt on line 2  */
  #define EXTI_SWIER_SWIER3  0x00000008	/* Software Interrupt on line 3  */
  #define EXTI_SWIER_SWIER4  0x00000010	/* Software Interrupt on line 4  */
  #define EXTI_SWIER_SWIER5  0x00000020	/* Software Interrupt on line 5  */
  #define EXTI_SWIER_SWIER6  0x00000040	/* Software Interrupt on line 6  */
  #define EXTI_SWIER_SWIER7  0x00000080	/* Software Interrupt on line 7  */
  #define EXTI_SWIER_SWIER8  0x00000100	/* Software Interrupt on line 8  */
  #define EXTI_SWIER_SWIER9  0x00000200	/* Software Interrupt on line 9  */
  #define EXTI_SWIER_SWIER10 0x00000400	/* Software Interrupt on line 10 */
  #define EXTI_SWIER_SWIER11 0x00000800	/* Software Interrupt on line 11 */
  #define EXTI_SWIER_SWIER12 0x00001000	/* Software Interrupt on line 12 */
  #define EXTI_SWIER_SWIER13 0x00002000	/* Software Interrupt on line 13 */
  #define EXTI_SWIER_SWIER14 0x00004000	/* Software Interrupt on line 14 */
  #define EXTI_SWIER_SWIER15 0x00008000	/* Software Interrupt on line 15 */
  #define EXTI_SWIER_SWIER16 0x00010000	/* Software Interrupt on line 16 */
  #define EXTI_SWIER_SWIER17 0x00020000	/* Software Interrupt on line 17 */
  #define EXTI_SWIER_SWIER19 0x00080000	/* Software Interrupt on line 19 */
  #define EXTI_SWIER_SWIER20 0x00100000	/* Software Interrupt on line 20 */
  #define EXTI_SWIER_SWIER21 0x00200000	/* Software Interrupt on line 21 */
  #define EXTI_SWIER_SWIER22 0x00400000	/* Software Interrupt on line 22 */
  #define EXTI_SWIER_SWIER31 0x80000000	/* Software Interrupt on line 31 */
#define TOFF_EXTI_PR        0x0014		/* (RW) EXTI Pending register */
  #define EXTI_PR_PR0        0x00000001	/* Pending bit for line 0 */
  #define EXTI_PR_PR1        0x00000002	/* Pending bit for line 1 */
  #define EXTI_PR_PR2        0x00000004	/* Pending bit for line 2 */
  #define EXTI_PR_PR3        0x00000008	/* Pending bit for line 3 */
  #define EXTI_PR_PR4        0x00000010	/* Pending bit for line 4 */
  #define EXTI_PR_PR5        0x00000020	/* Pending bit for line 5 */
  #define EXTI_PR_PR6        0x00000040	/* Pending bit for line 6 */
  #define EXTI_PR_PR7        0x00000080	/* Pending bit for line 7 */
  #define EXTI_PR_PR8        0x00000100	/* Pending bit for line 8 */
  #define EXTI_PR_PR9        0x00000200	/* Pending bit for line 9 */
  #define EXTI_PR_PR10       0x00000400	/* Pending bit for line 10 */
  #define EXTI_PR_PR11       0x00000800	/* Pending bit for line 11 */
  #define EXTI_PR_PR12       0x00001000	/* Pending bit for line 12 */
  #define EXTI_PR_PR13       0x00002000	/* Pending bit for line 13 */
  #define EXTI_PR_PR14       0x00004000	/* Pending bit for line 14 */
  #define EXTI_PR_PR15       0x00008000	/* Pending bit for line 15 */
  #define EXTI_PR_PR16       0x00010000	/* Pending bit for line 16 */
  #define EXTI_PR_PR17       0x00020000	/* Pending bit for line 17 */
  #define EXTI_PR_PR18       0x00040000	/* Pending bit for line 18 */
  #define EXTI_PR_PR19       0x00080000	/* Pending bit for line 19 */
  #define EXTI_PR_PR20       0x00100000	/* Pending bit for line 20 */
  #define EXTI_PR_PR21       0x00200000	/* Pending bit for line 21 */
  #define EXTI_PR_PR22       0x00400000	/* Pending bit for line 22 */
  #define EXTI_PR_PR31       0x80000000	/* Pending bit for line 31 */

/*
 *  GENERAL PURPOSE I/O (F/L)
 */
#define TADR_GPIOA_BASE     (IOPPERIPH_BASE + 0x0000)
#define TADR_GPIOB_BASE     (IOPPERIPH_BASE + 0x0400)
#define TADR_GPIOC_BASE     (IOPPERIPH_BASE + 0x0800)
#define TADR_GPIOD_BASE     (IOPPERIPH_BASE + 0x0C00)
#define TADR_GPIOE_BASE     (IOPPERIPH_BASE + 0x1000)
#define TADR_GPIOH_BASE     (IOPPERIPH_BASE + 0x1C00)
#define TOFF_GPIO_MODER     0x0000		/* (RW) GPIO port mode register */
  #define GPIO_MODER_MODER0  0x1
  #define GPIO_MODER_MODER1  0x2
  #define GPIO_MODER_MODER2  0x3
#define TOFF_GPIO_OTYPER    0x0004		/* (RW) GPIO port output type register */
  #define GPIO_OTYPER_OT     0x1
#define TOFF_GPIO_OSPEEDR   0x0008		/* (RW) GPIO port output speed register */
  #define GPIO_OSPEEDER_OSPEEDR0 0x1
  #define GPIO_OSPEEDER_OSPEEDR1 0x2
  #define GPIO_OSPEEDER_OSPEEDR2 0x3
#define TOFF_GPIO_PUPDR     0x000C		/* (RW) GPIO port pull-up/pull-down register */
  #define GPIO_PUPDR_PUPDR0  0x1
  #define GPIO_PUPDR_PUPDR1  0x2
  #define GPIO_PUPDR_PUPDR2  0x3
#define TOFF_GPIO_IDR       0x0010		/* (R)  GPIO port input data register */
#define TOFF_GPIO_ODR       0x0014		/* (RW) GPIO port output data register */
#define TOFF_GPIO_BSRR      0x0018		/* (RW) GPIO port bit set/reset low register */
#define TOFF_GPIO_LCKR      0x001C		/* (RW) GPIO port configuration lock register */
#define TOFF_GPIO_AFR0      0x0020		/* (RW) GPIO alternate function registers */
#define TOFF_GPIO_AFR1      0x0024		/* (RW) GPIO alternate function registers */

/*
 *  CRC CALCULATION UNIT (F/L)
 */
#define TADR_CRC_BASE       (AHBPERIPH_BASE + 0x3000)
#define TOFF_CRC_DR         0x0000		/* (RW) CRC Data register */
#define TOFF_CRC_IDR        0x0004		/* (RW-8) CRC Independent data register */
#define TOFF_CRC_CR         0x0008		/* (RW) CRC Control register */
#define TOFF_CRC_INIT       0x0010		/* (RW) Initial CRC value register */
#define TOFF_CRC_POL        0x0014		/* (RW) CRC polynomial register */

/*
 *  TOUCH SENSING CONTROLLER
 */
#define TADR_TSC_BASE       (AHBPERIPH_BASE + 0x4000)
#define TOFF_TSC_CR         0x0000		/* (RW) TSC control register */
  #define TSC_CR_TSCE        0x00000001	/* Touch sensing controller enable */
  #define TSC_CR_START       0x00000002	/* Start acquisition */
  #define TSC_CR_AM          0x00000004	/* Acquisition mode */
  #define TSC_CR_SYNCPOL     0x00000008	/* Synchronization pin polarity */
  #define TSC_CR_IODEF       0x00000010	/* IO default mode */
  #define TSC_CR_MCV         0x000000E0	/* MCV[2:0] bits (Max Count Value) */
  #define TSC_CR_MCV_0       0x00000020
  #define TSC_CR_MCV_1       0x00000040
  #define TSC_CR_MCV_2       0x00000080
  #define TSC_CR_PGPSC       0x00007000	/* PGPSC[2:0] bits (Pulse Generator Prescaler) */
  #define TSC_CR_PGPSC_0     0x00001000
  #define TSC_CR_PGPSC_1     0x00002000
  #define TSC_CR_PGPSC_2     0x00004000
  #define TSC_CR_SSPSC       0x00008000	/* Spread Spectrum Prescaler */
  #define TSC_CR_SSE         0x00010000	/* Spread Spectrum Enable */
  #define TSC_CR_SSD         0x00FE0000	/* SSD[6:0] bits (Spread Spectrum Deviation) */
  #define TSC_CR_SSD_0       0x00020000
  #define TSC_CR_SSD_1       0x00040000
  #define TSC_CR_SSD_2       0x00080000
  #define TSC_CR_SSD_3       0x00100000
  #define TSC_CR_SSD_4       0x00200000
  #define TSC_CR_SSD_5       0x00400000
  #define TSC_CR_SSD_6       0x00800000
  #define TSC_CR_CTPL        0x0F000000	/* CTPL[3:0] bits (Charge Transfer pulse low) */
  #define TSC_CR_CTPL_0      0x01000000
  #define TSC_CR_CTPL_1      0x02000000
  #define TSC_CR_CTPL_2      0x04000000
  #define TSC_CR_CTPL_3      0x08000000
  #define TSC_CR_CTPH        0xF0000000	/* CTPH[3:0] bits (Charge Transfer pulse high) */
  #define TSC_CR_CTPH_0      0x10000000
  #define TSC_CR_CTPH_1      0x20000000
  #define TSC_CR_CTPH_2      0x40000000
  #define TSC_CR_CTPH_3      0x80000000
#define TOFF_TSC_IER        0x0004		/* (RW) TSC interrupt enable register */
  #define TSC_IER_EOAIE      0x00000001	/* End of acquisition interrupt enable */
  #define TSC_IER_MCEIE      0x00000002	/* Max count error interrupt enable */
#define TOFF_TSC_ICR        0x0008		/* (RW) TSC interrupt clear register */
  #define TSC_ICR_EOAIC      0x00000001	/* End of acquisition interrupt clear */
  #define TSC_ICR_MCEIC      0x00000002	/* Max count error interrupt clear */
#define TOFF_TSC_ISR        0x000C		/* (RW) TSC interrupt status register */
  #define TSC_ISR_EOAF       0x00000001	/* End of acquisition flag */
  #define TSC_ISR_MCEF       0x00000002	/* Max count error flag */
#define TOFF_TSC_IOHCR      0x0010		/* (RW) TSC I/O hysteresis control register */
  #define TSC_IOHCR_G1_IO1   0x00000001	/* GROUP1_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G1_IO2   0x00000002	/* GROUP1_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G1_IO3   0x00000004	/* GROUP1_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G1_IO4   0x00000008	/* GROUP1_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G2_IO1   0x00000010	/* GROUP2_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G2_IO2   0x00000020	/* GROUP2_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G2_IO3   0x00000040	/* GROUP2_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G2_IO4   0x00000080	/* GROUP2_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G3_IO1   0x00000100	/* GROUP3_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G3_IO2   0x00000200	/* GROUP3_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G3_IO3   0x00000400	/* GROUP3_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G3_IO4   0x00000800	/* GROUP3_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G4_IO1   0x00001000	/* GROUP4_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G4_IO2   0x00002000	/* GROUP4_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G4_IO3   0x00004000	/* GROUP4_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G4_IO4   0x00008000	/* GROUP4_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G5_IO1   0x00010000	/* GROUP5_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G5_IO2   0x00020000	/* GROUP5_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G5_IO3   0x00040000	/* GROUP5_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G5_IO4   0x00080000	/* GROUP5_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G6_IO1   0x00100000	/* GROUP6_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G6_IO2   0x00200000	/* GROUP6_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G6_IO3   0x00400000	/* GROUP6_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G6_IO4   0x00800000	/* GROUP6_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G7_IO1   0x01000000	/* GROUP7_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G7_IO2   0x02000000	/* GROUP7_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G7_IO3   0x04000000	/* GROUP7_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G7_IO4   0x08000000	/* GROUP7_IO4 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G8_IO1   0x10000000	/* GROUP8_IO1 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G8_IO2   0x20000000	/* GROUP8_IO2 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G8_IO3   0x40000000	/* GROUP8_IO3 schmitt trigger hysteresis mode */
  #define TSC_IOHCR_G8_IO4   0x80000000	/* GROUP8_IO4 schmitt trigger hysteresis mode */
#define TOFF_TSC_IOASCR     0x0018		/* (RW) TSC I/O analog switch control register */
  #define TSC_IOASCR_G1_IO1  0x00000001	/*GROUP1_IO1 analog switch enable */
  #define TSC_IOASCR_G1_IO2  0x00000002	/* GROUP1_IO2 analog switch enable */
  #define TSC_IOASCR_G1_IO3  0x00000004	/* GROUP1_IO3 analog switch enable */
  #define TSC_IOASCR_G1_IO4  0x00000008	/* GROUP1_IO4 analog switch enable */
  #define TSC_IOASCR_G2_IO1  0x00000010	/* GROUP2_IO1 analog switch enable */
  #define TSC_IOASCR_G2_IO2  0x00000020	/* GROUP2_IO2 analog switch enable */
  #define TSC_IOASCR_G2_IO3  0x00000040	/* GROUP2_IO3 analog switch enable */
  #define TSC_IOASCR_G2_IO4  0x00000080	/* GROUP2_IO4 analog switch enable */
  #define TSC_IOASCR_G3_IO1  0x00000100	/* GROUP3_IO1 analog switch enable */
  #define TSC_IOASCR_G3_IO2  0x00000200	/* GROUP3_IO2 analog switch enable */
  #define TSC_IOASCR_G3_IO3  0x00000400	/* GROUP3_IO3 analog switch enable */
  #define TSC_IOASCR_G3_IO4  0x00000800	/* GROUP3_IO4 analog switch enable */
  #define TSC_IOASCR_G4_IO1  0x00001000	/* GROUP4_IO1 analog switch enable */
  #define TSC_IOASCR_G4_IO2  0x00002000	/* GROUP4_IO2 analog switch enable */
  #define TSC_IOASCR_G4_IO3  0x00004000	/* GROUP4_IO3 analog switch enable */
  #define TSC_IOASCR_G4_IO4  0x00008000	/* GROUP4_IO4 analog switch enable */
  #define TSC_IOASCR_G5_IO1  0x00010000	/* GROUP5_IO1 analog switch enable */
  #define TSC_IOASCR_G5_IO2  0x00020000	/* GROUP5_IO2 analog switch enable */
  #define TSC_IOASCR_G5_IO3  0x00040000	/* GROUP5_IO3 analog switch enable */
  #define TSC_IOASCR_G5_IO4  0x00080000	/* GROUP5_IO4 analog switch enable */
  #define TSC_IOASCR_G6_IO1  0x00100000	/* GROUP6_IO1 analog switch enable */
  #define TSC_IOASCR_G6_IO2  0x00200000	/* GROUP6_IO2 analog switch enable */
  #define TSC_IOASCR_G6_IO3  0x00400000	/* GROUP6_IO3 analog switch enable */
  #define TSC_IOASCR_G6_IO4  0x00800000	/* GROUP6_IO4 analog switch enable */
  #define TSC_IOASCR_G7_IO1  0x01000000	/* GROUP7_IO1 analog switch enable */
  #define TSC_IOASCR_G7_IO2  0x02000000	/* GROUP7_IO2 analog switch enable */
  #define TSC_IOASCR_G7_IO3  0x04000000	/* GROUP7_IO3 analog switch enable */
  #define TSC_IOASCR_G7_IO4  0x08000000	/* GROUP7_IO4 analog switch enable */
  #define TSC_IOASCR_G8_IO   0x10000000	/* GROUP8_IO1 analog switch enable */
  #define TSC_IOASCR_G8_IO2  0x20000000	/* GROUP8_IO2 analog switch enable */
  #define TSC_IOASCR_G8_IO3  0x40000000	/* GROUP8_IO3 analog switch enable */
  #define TSC_IOASCR_G8_IO4  0x80000000	/* GROUP8_IO4 analog switch enable */
#define TOFF_TSC_IOSCR      0x0020		/* (RW) TSC I/O sampling control register */
  #define TSC_IOSCR_G1_IO1   0x00000001	/* GROUP1_IO1 sampling mode */
  #define TSC_IOSCR_G1_IO2   0x00000002	/* GROUP1_IO2 sampling mode */
  #define TSC_IOSCR_G1_IO3   0x00000004	/* GROUP1_IO3 sampling mode */
  #define TSC_IOSCR_G1_IO4   0x00000008	/* GROUP1_IO4 sampling mode */
  #define TSC_IOSCR_G2_IO1   0x00000010	/* GROUP2_IO1 sampling mode */
  #define TSC_IOSCR_G2_IO2   0x00000020	/* GROUP2_IO2 sampling mode */
  #define TSC_IOSCR_G2_IO3   0x00000040	/* GROUP2_IO3 sampling mode */
  #define TSC_IOSCR_G2_IO4   0x00000080	/* GROUP2_IO4 sampling mode */
  #define TSC_IOSCR_G3_IO1   0x00000100	/* GROUP3_IO1 sampling mode */
  #define TSC_IOSCR_G3_IO2   0x00000200	/* GROUP3_IO2 sampling mode */
  #define TSC_IOSCR_G3_IO3   0x00000400	/* GROUP3_IO3 sampling mode */
  #define TSC_IOSCR_G3_IO4   0x00000800	/* GROUP3_IO4 sampling mode */
  #define TSC_IOSCR_G4_IO1   0x00001000	/* GROUP4_IO1 sampling mode */
  #define TSC_IOSCR_G4_IO2   0x00002000	/* GROUP4_IO2 sampling mode */
  #define TSC_IOSCR_G4_IO3   0x00004000	/* GROUP4_IO3 sampling mode */
  #define TSC_IOSCR_G4_IO4   0x00008000	/* GROUP4_IO4 sampling mode */
  #define TSC_IOSCR_G5_IO1   0x00010000	/* GROUP5_IO1 sampling mode */
  #define TSC_IOSCR_G5_IO2   0x00020000	/* GROUP5_IO2 sampling mode */
  #define TSC_IOSCR_G5_IO3   0x00040000	/* GROUP5_IO3 sampling mode */
  #define TSC_IOSCR_G5_IO4   0x00080000	/* GROUP5_IO4 sampling mode */
  #define TSC_IOSCR_G6_IO1   0x00100000	/* GROUP6_IO1 sampling mode */
  #define TSC_IOSCR_G6_IO2   0x00200000	/* GROUP6_IO2 sampling mode */
  #define TSC_IOSCR_G6_IO3   0x00400000	/* GROUP6_IO3 sampling mode */
  #define TSC_IOSCR_G6_IO4   0x00800000	/* GROUP6_IO4 sampling mode */
  #define TSC_IOSCR_G7_IO1   0x01000000	/* GROUP7_IO1 sampling mode */
  #define TSC_IOSCR_G7_IO2   0x02000000	/* GROUP7_IO2 sampling mode */
  #define TSC_IOSCR_G7_IO3   0x04000000	/* GROUP7_IO3 sampling mode */
  #define TSC_IOSCR_G7_IO4   0x08000000	/* GROUP7_IO4 sampling mode */
  #define TSC_IOSCR_G8_IO1   0x10000000	/* GROUP8_IO1 sampling mode */
  #define TSC_IOSCR_G8_IO2   0x20000000	/* GROUP8_IO2 sampling mode */
  #define TSC_IOSCR_G8_IO3   0x40000000	/* GROUP8_IO3 sampling mode */
  #define TSC_IOSCR_G8_IO4   0x80000000	/* GROUP8_IO4 sampling mode */
#define TOFF_TSC_IOCCR      0x0028		/* (RW) TSC I/O channel control register */
  #define TSC_IOCCR_G1_IO1   0x00000001	/* GROUP1_IO1 channel mode */
  #define TSC_IOCCR_G1_IO2   0x00000002	/* GROUP1_IO2 channel mode */
  #define TSC_IOCCR_G1_IO3   0x00000004	/* GROUP1_IO3 channel mode */
  #define TSC_IOCCR_G1_IO4   0x00000008	/* GROUP1_IO4 channel mode */
  #define TSC_IOCCR_G2_IO1   0x00000010	/* GROUP2_IO1 channel mode */
  #define TSC_IOCCR_G2_IO2   0x00000020	/* GROUP2_IO2 channel mode */
  #define TSC_IOCCR_G2_IO3   0x00000040	/* GROUP2_IO3 channel mode */
  #define TSC_IOCCR_G2_IO4   0x00000080	/* GROUP2_IO4 channel mode */
  #define TSC_IOCCR_G3_IO1   0x00000100	/* GROUP3_IO1 channel mode */
  #define TSC_IOCCR_G3_IO2   0x00000200	/* GROUP3_IO2 channel mode */
  #define TSC_IOCCR_G3_IO3   0x00000400	/* GROUP3_IO3 channel mode */
  #define TSC_IOCCR_G3_IO4   0x00000800	/* GROUP3_IO4 channel mode */
  #define TSC_IOCCR_G4_IO1   0x00001000	/* GROUP4_IO1 channel mode */
  #define TSC_IOCCR_G4_IO2   0x00002000	/* GROUP4_IO2 channel mode */
  #define TSC_IOCCR_G4_IO3   0x00004000	/* GROUP4_IO3 channel mode */
  #define TSC_IOCCR_G4_IO4   0x00008000	/* GROUP4_IO4 channel mode */
  #define TSC_IOCCR_G5_IO1   0x00010000	/* GROUP5_IO1 channel mode */
  #define TSC_IOCCR_G5_IO2   0x00020000	/* GROUP5_IO2 channel mode */
  #define TSC_IOCCR_G5_IO3   0x00040000	/* GROUP5_IO3 channel mode */
  #define TSC_IOCCR_G5_IO4   0x00080000	/* GROUP5_IO4 channel mode */
  #define TSC_IOCCR_G6_IO1   0x00100000	/* GROUP6_IO1 channel mode */
  #define TSC_IOCCR_G6_IO2   0x00200000	/* GROUP6_IO2 channel mode */
  #define TSC_IOCCR_G6_IO3   0x00400000	/* GROUP6_IO3 channel mode */
  #define TSC_IOCCR_G6_IO4   0x00800000	/* GROUP6_IO4 channel mode */
  #define TSC_IOCCR_G7_IO1   0x01000000	/* GROUP7_IO1 channel mode */
  #define TSC_IOCCR_G7_IO2   0x02000000	/* GROUP7_IO2 channel mode */
  #define TSC_IOCCR_G7_IO3   0x04000000	/* GROUP7_IO3 channel mode */
  #define TSC_IOCCR_G7_IO4   0x08000000	/* GROUP7_IO4 channel mode */
  #define TSC_IOCCR_G8_IO1   0x10000000	/* GROUP8_IO1 channel mode */
  #define TSC_IOCCR_G8_IO2   0x20000000	/* GROUP8_IO2 channel mode */
  #define TSC_IOCCR_G8_IO3   0x40000000	/* GROUP8_IO3 channel mode */
  #define TSC_IOCCR_G8_IO4   0x80000000	/*GROUP8_IO4 channel mode */
#define TOFF_TSC_IOGCSR     0x0030		/* (RW) TSC I/O group control status register */
  #define TSC_IOGCSR_G1E     0x00000001	/* Analog IO GROUP1 enable */
  #define TSC_IOGCSR_G2E     0x00000002	/* Analog IO GROUP2 enable */
  #define TSC_IOGCSR_G3E     0x00000004	/* Analog IO GROUP3 enable */
  #define TSC_IOGCSR_G4E     0x00000008	/* Analog IO GROUP4 enable */
  #define TSC_IOGCSR_G5E     0x00000010	/* Analog IO GROUP5 enable */
  #define TSC_IOGCSR_G6E     0x00000020	/* Analog IO GROUP6 enable */
  #define TSC_IOGCSR_G7E     0x00000040	/* Analog IO GROUP7 enable */
  #define TSC_IOGCSR_G8E     0x00000080	/* Analog IO GROUP8 enable */
  #define TSC_IOGCSR_G1S     0x00010000	/* Analog IO GROUP1 status */
  #define TSC_IOGCSR_G2S     0x00020000	/* Analog IO GROUP2 status */
  #define TSC_IOGCSR_G3S     0x00040000	/* Analog IO GROUP3 status */
  #define TSC_IOGCSR_G4S     0x00080000	/* Analog IO GROUP4 status */
  #define TSC_IOGCSR_G5S     0x00100000	/* Analog IO GROUP5 status */
  #define TSC_IOGCSR_G6S     0x00200000	/* Analog IO GROUP6 status */
  #define TSC_IOGCSR_G7S     0x00400000	/* Analog IO GROUP7 status */
  #define TSC_IOGCSR_G8S     0x00800000	/* Analog IO GROUP8 status */
#define TOFF_TSC_IOGXCR     0x0034		/* (RW) TSC I/O group x counter register 0x34-50 */
  #define TSC_IOGXCR_CNT     0x00003FFF	/* CNT[13:0] bits (Counter value) */

/*
 *  RANDOM NUMBER GENERATOR
 */
#define TADR_RNG_BASE       (AHBPERIPH_BASE + 0x5000)
#define TOFF_RNG_CR         0x0000		/* (RW) RNG control register */
  #define RNG_CR_RNGEN       0x00000004
  #define RNG_CR_IE          0x00000008
#define TOFF_RNG_SR         0x0004		/* (RW) RNG status register */
  #define RNG_SR_DRDY        0x00000001
  #define RNG_SR_CECS        0x00000002
  #define RNG_SR_SECS        0x00000004
  #define RNG_SR_CEIS        0x00000020
  #define RNG_SR_SEIS        0x00000040
#define TOFF_RNG_DR         0x0008		/* (RW) RNG data register */

/*
 *  CLOCK RECCOVRY SYSTEM (F/L)
 */
#define TADR_CRS_BASE       (APBPERIPH_BASE + 0x6C00)
#define TOFF_CRS_CR         0x0000		/* (RW) CRS ccontrol register */
  #define CRS_CR_SYNCOKIE    0x00000001	/* SYNC event OK interrupt enable */
  #define CRS_CR_SYNCWARNIE  0x00000002 /* SYNC warning interrupt enable */
  #define CRS_CR_ERRIE       0x00000004	/* SYNC error interrupt enable */
  #define CRS_CR_ESYNCIE     0x00000008	/* Expected SYNC(ESYNCF) interrupt Enable*/
  #define CRS_CR_CEN         0x00000020	/* Frequency error counter enable */
  #define CRS_CR_AUTOTRIMEN  0x00000040	/* Automatic trimming enable */
  #define CRS_CR_SWSYNC      0x00000080	/* A Software SYNC event is generated */
  #define CRS_CR_TRIM        0x00003F00	/* HSI48 oscillator smooth trimming */
#define TOFF_CRS_CFGR       0x0004		/* (RW) CRS configuration register */
  #define CRS_CFGR_RELOAD    0x0000FFFF	/* Counter reload value */
  #define CRS_CFGR_FELIM     0x00FF0000	/* Frequency error limit */
  #define CRS_CFGR_SYNCDIV   0x07000000	/* SYNC divider */
  #define CRS_CFGR_SYNCDIV_0 0x01000000
  #define CRS_CFGR_SYNCDIV_1 0x02000000
  #define CRS_CFGR_SYNCDIV_2 0x04000000
  #define CRS_CFGR_SYNCSRC   0x30000000	/* SYNC signal source selection */
  #define CRS_CFGR_SYNCSRC_0 0x10000000
  #define CRS_CFGR_SYNCSRC_1 0x20000000
  #define CRS_CFGR_SYNCPOL   0x80000000	/* SYNC polarity selection */
#define TOFF_CRS_ISR        0x0008		/* (RW) CRS interrupt and status register */
  #define CRS_ISR_SYNCOKF    0x00000001	/* SYNC event OK flag */
  #define CRS_ISR_SYNCWARNF  0x00000002	/* SYNC warning */
  #define CRS_ISR_ERRF       0x00000004	/* SYNC error flag */
  #define CRS_ISR_ESYNCF     0x00000008	/* Expected SYNC flag */
  #define CRS_ISR_SYNCERR    0x00000100	/* SYNC error */
  #define CRS_ISR_SYNCMISS   0x00000200	/* SYNC missed */
  #define CRS_ISR_TRIMOVF    0x00000400	/* Trimming overflow or underflow */
  #define CRS_ISR_FEDIR      0x00008000	/* Frequency error direction */
  #define CRS_ISR_FECAP      0xFFFF0000	/* Frequency error capture */
#define TOFF_CRS_ICR        0x000C		/* (RW) CRS interrupt flag clear register */
  #define CRS_ICR_SYNCOKC    0x00000001	/* SYNC event OK clear flag */
  #define CRS_ICR_SYNCWARNC  0x00000002	/* SYNC warning clear flag */
  #define CRS_ICR_ERRC       0x00000004	/* Error clear flag */
  #define CRS_ICR_ESYNCC     0x00000008	/* Expected SYNC clear flag */

/*
 *  RESET AND CLOCK CONTROL
 */
#define TADR_RCC_BASE       (AHBPERIPH_BASE + 0x1000)
#define TOFF_RCC_CR         0x0000		/* (RW) RCC clock control register */
  #define RCC_CR_HSION             0x00000001	/* Internal High Speed clock enable */
  #define RCC_CR_HSIKERON          0x00000002	/* Internal High Speed clock enable for some IPs Kernel */
  #define RCC_CR_HSIRDY            0x00000004	/* Internal High Speed clock ready flag */
  #define RCC_CR_HSIDIVEN          0x00000008	/* Internal High Speed clock divider enable */
  #define RCC_CR_HSIDIVF           0x00000010	/* Internal High Speed clock divider flag */
  #define RCC_CR_HSIOUTEN          0x00000020	/* Internal High Speed clock out enable */
  #define RCC_CR_MSION             0x00000100	/* Internal Multi Speed clock enable */
  #define RCC_CR_MSIRDY            0x00000200	/* Internal Multi Speed clock ready flag */
  #define RCC_CR_HSEON             0x00010000	/* External High Speed clock enable */
  #define RCC_CR_HSERDY            0x00020000	/* External High Speed clock ready flag */
  #define RCC_CR_HSEBYP            0x00040000	/* External High Speed clock Bypass */
  #define RCC_CR_CSSHSEON          0x00080000	/* HSE Clock Security System enable */
  #define RCC_CR_RTCPRE            0x00300000	/* RTC/LCD prescaler [1:0] bits */
  #define RCC_CR_RTCPRE_0          0x00100000
  #define RCC_CR_RTCPRE_1          0x00200000
  #define RCC_CR_PLLON             0x01000000	/* PLL enable */
  #define RCC_CR_PLLRDY            0x02000000	/* PLL clock ready flag */
  #define RCC_CR_CSSON             RCC_CR_CSSHSEON
#define TOFF_RCC_ICSCR      0x0004		/* (RW) RCC Internal clock sources calibration register */
  #define RCC_ICSCR_HSICAL         0x000000FF	/* Internal High Speed clock Calibration */
  #define RCC_ICSCR_HSITRIM        0x00001F00	/* Internal High Speed clock trimming */
  #define RCC_ICSCR_MSIRANGE       0x0000E000	/* Internal Multi Speed clock Range */
  #define RCC_ICSCR_MSIRANGE_0     0x00000000
  #define RCC_ICSCR_MSIRANGE_1     0x00002000
  #define RCC_ICSCR_MSIRANGE_2     0x00004000
  #define RCC_ICSCR_MSIRANGE_3     0x00006000
  #define RCC_ICSCR_MSIRANGE_4     0x00008000
  #define RCC_ICSCR_MSIRANGE_5     0x0000A000
  #define RCC_ICSCR_MSIRANGE_6     0x0000C000
  #define RCC_ICSCR_MSICA          0x00FF0000	/* Internal Multi Speed clock Calibration */
  #define RCC_ICSCR_MSITRIM        0xFF000000	/* Internal Multi Speed clock trimming */
#define TOFF_RCC_CRRCR      0x0008		/* (RW) RCC Clock recovery RC register */
  #define RCC_CRRCR_HSI48ON        0x00000001	/* HSI 48MHz clock enable */
  #define RCC_CRRCR_HSI48RDY       0x00000002	/* HSI 48MHz clock ready flag */
  #define RCC_CRRCR_HSI48DIV6OUTEN 0x00000004	/* HSI 48MHz DIV6 out enable */
  #define RCC_CRRCR_HSI48CAL       0x0000FF00	/* HSI 48MHz clock Calibration */
#define TOFF_RCC_CFGR       0x000C		/* (RW) RCC clock configuration register */
  #define RCC_CFGR_SW              0x00000003	/* SW[1:0] bits (System clock Switch) */
  #define RCC_CFGR_SW_0            0x00000001	/* Bit 0 */
  #define RCC_CFGR_SW_1            0x00000002	/* Bit 1 */
  #define RCC_CFGR_SW_MSI          0x00000000	/* MSI selected as system clock */
  #define RCC_CFGR_SW_HSI          0x00000001	/* HSI selected as system clock */
  #define RCC_CFGR_SW_HSE          0x00000002	/* HSE selected as system clock */
  #define RCC_CFGR_SW_PLL          0x00000003	/* PLL selected as system clock */
  #define RCC_CFGR_SWS             0x0000000C	/* SWS[1:0] bits (System Clock Switch Status) */
  #define RCC_CFGR_SWS_0           0x00000004	/* Bit 0 */
  #define RCC_CFGR_SWS_1           0x00000008	/* Bit 1 */
  #define RCC_CFGR_SWS_MSI         0x00000000	/* MSI oscillator used as system clock */
  #define RCC_CFGR_SWS_HSI         0x00000004	/* HSI oscillator used as system clock */
  #define RCC_CFGR_SWS_HSE         0x00000008	/* HSE oscillator used as system clock */
  #define RCC_CFGR_SWS_PLL         0x0000000C	/* PLL used as system clock */
  #define RCC_CFGR_HPRE            0x000000F0	/* HPRE[3:0] bits (AHB prescaler) */
  #define RCC_CFGR_HPRE_0          0x00000010	/* Bit 0 */
  #define RCC_CFGR_HPRE_1          0x00000020	/* Bit 1 */
  #define RCC_CFGR_HPRE_2          0x00000040	/* Bit 2 */
  #define RCC_CFGR_HPRE_3          0x00000080	/* Bit 3 */
  #define RCC_CFGR_HPRE_DIV1       0x00000000	/* SYSCLK not divided */
  #define RCC_CFGR_HPRE_DIV2       0x00000080	/* SYSCLK divided by 2 */
  #define RCC_CFGR_HPRE_DIV4       0x00000090	/* SYSCLK divided by 4 */
  #define RCC_CFGR_HPRE_DIV8       0x000000A0	/* SYSCLK divided by 8 */
  #define RCC_CFGR_HPRE_DIV16      0x000000B0	/* SYSCLK divided by 16 */
  #define RCC_CFGR_HPRE_DIV64      0x000000C0	/* SYSCLK divided by 64 */
  #define RCC_CFGR_HPRE_DIV128     0x000000D0	/* SYSCLK divided by 128 */
  #define RCC_CFGR_HPRE_DIV256     0x000000E0	/* SYSCLK divided by 256 */
  #define RCC_CFGR_HPRE_DIV512     0x000000F0	/* SYSCLK divided by 512 */
  #define RCC_CFGR_PPRE1           0x00000700	/* PRE1[2:0] bits (APB1 prescaler) */
  #define RCC_CFGR_PPRE1_0         0x00000100
  #define RCC_CFGR_PPRE1_1         0x00000200
  #define RCC_CFGR_PPRE1_2         0x00000400
  #define RCC_CFGR_PPRE1_DIV1      0x00000000	/* HCLK not divided */
  #define RCC_CFGR_PPRE1_DIV2      0x00000400	/* HCLK divided by 2 */
  #define RCC_CFGR_PPRE1_DIV4      0x00000500	/* HCLK divided by 4 */
  #define RCC_CFGR_PPRE1_DIV8      0x00000600	/* HCLK divided by 8 */
  #define RCC_CFGR_PPRE1_DIV16     0x00000700	/* HCLK divided by 16 */
  #define RCC_CFGR_PPRE2           0x00003800	/* PRE2[2:0] bits (APB2 prescaler) */
  #define RCC_CFGR_PPRE2_0         0x00000800
  #define RCC_CFGR_PPRE2_1         0x00001000
  #define RCC_CFGR_PPRE2_2         0x00002000
  #define RCC_CFGR_PPRE2_DIV1      0x00000000	/* HCLK not divided */
  #define RCC_CFGR_PPRE2_DIV2      0x00002000	/* HCLK divided by 2 */
  #define RCC_CFGR_PPRE2_DIV4      0x00002800	/* HCLK divided by 4 */
  #define RCC_CFGR_PPRE2_DIV8      0x00003000	/* HCLK divided by 8 */
  #define RCC_CFGR_PPRE2_DIV16     0x00003800	/* HCLK divided by 16 */
  #define RCC_CFGR_STOPWUCK        0x00008000	/* Wake Up from Stop Clock selection */
  #define RCC_CFGR_PLLSRC          0x00010000	/* PLL entry clock source */
  #define RCC_CFGR_PLLSRC_HSI      0x00000000	/* HSI as PLL entry clock source */
  #define RCC_CFGR_PLLSRC_HSE      0x00010000	/* HSE as PLL entry clock source */
  #define RCC_CFGR_PLLMUL          0x003C0000	/* PLLMUL[3:0] bits (PLL multiplication factor) */
  #define RCC_CFGR_PLLMUL_0        0x00040000
  #define RCC_CFGR_PLLMUL_1        0x00080000
  #define RCC_CFGR_PLLMUL_2        0x00100000
  #define RCC_CFGR_PLLMUL_3        0x00200000
  #define RCC_CFGR_PLLMUL3         0x00000000	/* PLL input clock * 3 */
  #define RCC_CFGR_PLLMUL4         0x00040000	/* PLL input clock * 4 */
  #define RCC_CFGR_PLLMUL6         0x00080000	/* PLL input clock * 6 */
  #define RCC_CFGR_PLLMUL8         0x000C0000	/* PLL input clock * 8 */
  #define RCC_CFGR_PLLMUL12        0x00100000	/* PLL input clock * 12 */
  #define RCC_CFGR_PLLMUL16        0x00140000	/* PLL input clock * 16 */
  #define RCC_CFGR_PLLMUL24        0x00180000	/* PLL input clock * 24 */
  #define RCC_CFGR_PLLMUL32        0x001C0000	/* PLL input clock * 32 */
  #define RCC_CFGR_PLLMUL48        0x00200000	/* PLL input clock * 48 */
  #define RCC_CFGR_PLLDIV          0x00C00000	/* PLLDIV[1:0] bits (PLL Output Division) */
  #define RCC_CFGR_PLLDIV_0        0x00400000
  #define RCC_CFGR_PLLDIV_1        0x00800000
  #define RCC_CFGR_PLLDIV2         0x00400000	/* PLL clock output = CKVCO / 2 */
  #define RCC_CFGR_PLLDIV3         0x00800000	/* PLL clock output = CKVCO / 3 */
  #define RCC_CFGR_PLLDIV4         0x00C00000	/* PLL clock output = CKVCO / 4 */
  #define RCC_CFGR_MCOSEL          0x0F000000	/* MCO[3:0] bits (Microcontroller Clock Output) */
  #define RCC_CFGR_MCOSEL_0        0x01000000
  #define RCC_CFGR_MCOSEL_1        0x02000000
  #define RCC_CFGR_MCOSEL_2        0x04000000
  #define RCC_CFGR_MCOSEL_3        0x08000000
  #define RCC_CFGR_MCOSEL_NOCLOCK  0x00000000	/* No clock */
  #define RCC_CFGR_MCOSEL_SYSCLK   0x01000000	/* System clock selected as MCO source */
  #define RCC_CFGR_MCOSEL_HSI      0x02000000	/* Internal 16 MHz RC oscillator clock selected */
  #define RCC_CFGR_MCOSEL_MSI      0x03000000	/* Internal Medium Speed RC oscillator clock selected */
  #define RCC_CFGR_MCOSEL_HSE      0x04000000	/* External 1-25 MHz oscillator clock selected */
  #define RCC_CFGR_MCOSEL_PLL      0x05000000	/* PLL clock divided */
  #define RCC_CFGR_MCOSEL_LSI      0x06000000	/* LSI selected */
  #define RCC_CFGR_MCOSEL_LSE      0x07000000	/* LSE selected */
  #define RCC_CFGR_MCOSEL_HSI48    0x08000000	/* HSI48 clock selected as MCO source */
  #define RCC_CFGR_MCOPRE          0x70000000	/* MCO prescaler  */
  #define RCC_CFGR_MCOPRE_DIV1     0x00000000	/* MCO is divided by 1  */
  #define RCC_CFGR_MCOPRE_DIV2     0x10000000	/* MCO is divided by 2  */
  #define RCC_CFGR_MCOPRE_DIV4     0x20000000	/* MCO is divided by 4  */
  #define RCC_CFGR_MCOPRE_DIV8     0x30000000	/* MCO is divided by 8  */
  #define RCC_CFGR_MCOPRE_DIV16    0x40000000	/* MCO is divided by 16  */
  #define RCC_CFGR_MCO_NOCLOCK     RCC_CFGR_MCOSEL_NOCLOCK
  #define RCC_CFGR_MCO_SYSCLK      RCC_CFGR_MCOSEL_SYSCLK
  #define RCC_CFGR_MCO_HSI         RCC_CFGR_MCOSEL_HSI
  #define RCC_CFGR_MCO_MSI         RCC_CFGR_MCOSEL_MSI
  #define RCC_CFGR_MCO_HSE         RCC_CFGR_MCOSEL_HSE
  #define RCC_CFGR_MCO_PLL         RCC_CFGR_MCOSEL_PLL
  #define RCC_CFGR_MCO_LSI         RCC_CFGR_MCOSEL_LSI
  #define RCC_CFGR_MCO_LSE         RCC_CFGR_MCOSEL_LSE
  #define RCC_CFGR_MCO_HSI48       RCC_CFGR_MCOSEL_HSI48
  #define RCC_CFGR_MCO_PRE         RCC_CFGR_MCOPRE		/* MCO prescaler */
  #define RCC_CFGR_MCO_PRE_1       RCC_CFGR_MCOPRE_DIV1	/* MCO is divided by 1 */
  #define RCC_CFGR_MCO_PRE_2       RCC_CFGR_MCOPRE_DIV2	/* MCO is divided by 1 */
  #define RCC_CFGR_MCO_PRE_4       RCC_CFGR_MCOPRE_DIV4	/* MCO is divided by 1 */
  #define RCC_CFGR_MCO_PRE_8       RCC_CFGR_MCOPRE_DIV8	/* MCO is divided by 1 */
  #define RCC_CFGR_MCO_PRE_16      RCC_CFGR_MCOPRE_DIV16 /* MCO is divided by 1 */
#define TOFF_RCC_CIER       0x0010		/* (RW) RCC Clock interrupt enable register */
  #define RCC_CIER_LSIRDYIE        0x00000001	/* LSI Ready Interrupt Enable */
  #define RCC_CIER_LSERDYIE        0x00000002	/* LSE Ready Interrupt Enable */
  #define RCC_CIER_HSIRDYIE        0x00000004	/* HSI Ready Interrupt Enable */
  #define RCC_CIER_HSERDYIE        0x00000008	/* HSE Ready Interrupt Enable */
  #define RCC_CIER_PLLRDYIE        0x00000010	/* PLL Ready Interrupt Enable */
  #define RCC_CIER_MSIRDYIE        0x00000020	/* MSI Ready Interrupt Enable */
  #define RCC_CIER_HSI48RDYIE      0x00000040	/* HSI48 Ready Interrupt Enable */
  #define RCC_CIER_CSSLSE          0x00000080	/* LSE CSS Interrupt Enable */
  #define RCC_CIER_LSECSSIE        RCC_CIER_CSSLSE
#define TOFF_RCC_CIFR       0x0014		/* (RW) RCC Clock interrupt flag register */
  #define RCC_CIFR_LSIRDYF         0x00000001	/* LSI Ready Interrupt flag */
  #define RCC_CIFR_LSERDYF         0x00000002	/* LSE Ready Interrupt flag */
  #define RCC_CIFR_HSIRDYF         0x00000004	/* HSI Ready Interrupt flag */
  #define RCC_CIFR_HSERDYF         0x00000008	/* HSE Ready Interrupt flag */
  #define RCC_CIFR_PLLRDYF         0x00000010	/* PLL Ready Interrupt flag */
  #define RCC_CIFR_MSIRDYF         0x00000020	/* MSI Ready Interrupt flag */
  #define RCC_CIFR_HSI48RDYF       0x00000040	/* HSI48 Ready Interrupt flag */
  #define RCC_CIFR_CSSLSEF         0x00000080	/* LSE Clock Security System Interrupt flag */
  #define RCC_CIFR_CSSHSEF         0x00000100	/* HSE Clock Security System Interrupt flag */
  #define RCC_CIFR_LSECSSF         RCC_CIFR_CSSLSEF
  #define RCC_CIFR_CSSF            RCC_CIFR_CSSHSEF
#define TOFF_RCC_CICR       0x0018		/* (RW) RCC Clock interrupt clear register */
  #define RCC_CICR_LSIRDYC         0x00000001	/* LSI Ready Interrupt Clear */
  #define RCC_CICR_LSERDYC         0x00000002	/* LSE Ready Interrupt Clear */
  #define RCC_CICR_HSIRDYC         0x00000004	/* HSI Ready Interrupt Clear */
  #define RCC_CICR_HSERDYC         0x00000008	/* HSE Ready Interrupt Clear */
  #define RCC_CICR_PLLRDYC         0x00000010	/* PLL Ready Interrupt Clear */
  #define RCC_CICR_MSIRDYC         0x00000020	/* MSI Ready Interrupt Clear */
  #define RCC_CICR_HSI48RDYC       0x00000040	/* HSI48 Ready Interrupt Clear */
  #define RCC_CICR_CSSLSEC         0x00000080	/* LSE Clock Security System Interrupt Clear */
  #define RCC_CICR_CSSHSEC         0x00000100	/* HSE Clock Security System Interrupt Clear */
  #define RCC_CICR_LSECSSC         RCC_CICR_CSSLSEC
  #define RCC_CICR_CSSC            RCC_CICR_CSSHSEC
#define TOFF_RCC_IOPRSTR    0x001C		/* (RW) RCC IO port reset register */
  #define RCC_IOPRSTR_IOPARST      0x00000001	/* GPIO port A reset */
  #define RCC_IOPRSTR_IOPBRST      0x00000002	/* GPIO port B reset */
  #define RCC_IOPRSTR_IOPCRST      0x00000004	/* GPIO port C reset */
  #define RCC_IOPRSTR_IOPDRST      0x00000008	/* GPIO port D reset */
  #define RCC_IOPRSTR_IOPERST      0x00000010	/* GPIO port E reset */
  #define RCC_IOPRSTR_IOPHRST      0x00000080	/* GPIO port H reset */
  #define RCC_IOPRSTR_GPIOARST     RCC_IOPRSTR_IOPARST	/* GPIO port A reset */
  #define RCC_IOPRSTR_GPIOBRST     RCC_IOPRSTR_IOPBRST	/* GPIO port B reset */
  #define RCC_IOPRSTR_GPIOCRST     RCC_IOPRSTR_IOPCRST	/* GPIO port C reset */
  #define RCC_IOPRSTR_GPIODRST     RCC_IOPRSTR_IOPDRST	/* GPIO port D reset */
  #define RCC_IOPRSTR_GPIOERST     RCC_IOPRSTR_IOPERST	/* GPIO port E reset */
  #define RCC_IOPRSTR_GPIOHRST     RCC_IOPRSTR_IOPHRST	/* GPIO port H reset */
#define TOFF_RCC_AHBRSTR    0x0020		/* (RW) RCC AHB peripheral reset register */
  #define RCC_AHBRSTR_DMARST       0x00000001	/* DMA1 reset */
  #define RCC_AHBRSTR_MIFRST       0x00000100	/* Memory interface reset reset */
  #define RCC_AHBRSTR_CRCRST       0x00001000	/* CRC reset */
  #define RCC_AHBRSTR_TSCRST       0x00010000	/* TSC reset */
  #define RCC_AHBRSTR_RNGRST       0x00100000	/* RNG reset */
  #define RCC_AHBRSTR_DMA1RST      RCC_AHBRSTR_DMARST	/* DMA1 reset */
#define TOFF_RCC_APB2RSTR   0x0024		/* (RW) RCC APB2 peripheral reset register */
  #define RCC_APB2RSTR_SYSCFGRST   0x00000001	/* SYSCFG clock reset */
  #define RCC_APB2RSTR_TIM21RST    0x00000004	/* TIM21 clock reset */
  #define RCC_APB2RSTR_TIM22RST    0x00000020	/* TIM22 clock reset */
  #define RCC_APB2RSTR_ADCRST      0x00000200	/* ADC1 clock reset */
  #define RCC_APB2RSTR_SPI1RST     0x00001000	/* SPI1 clock reset */
  #define RCC_APB2RSTR_USART1RST   0x00004000	/* USART1 clock reset */
  #define RCC_APB2RSTR_DBGRST      0x00400000	/* DBGMCU clock reset */
  #define RCC_APB2RSTR_ADC1RST     RCC_APB2RSTR_ADCRST	/* ADC1 clock reset */
  #define RCC_APB2RSTR_DBGMCURST   RCC_APB2RSTR_DBGRST	/* DBGMCU clock reset */
#define TOFF_RCC_APB1RSTR   0x0028		/* (RW) RCC APB1 peripheral reset register */
  #define RCC_APB1RSTR_TIM2RST     0x00000001	/* Timer 2 clock reset */
  #define RCC_APB1RSTR_TIM3RST     0x00000002	/* Timer 3 clock reset */
  #define RCC_APB1RSTR_TIM6RST     0x00000010	/* Timer 6 clock reset */
  #define RCC_APB1RSTR_TIM7RST     0x00000020	/* Timer 7 clock reset */
  #define RCC_APB1RSTR_LCDRST      0x00000200	/* LCD clock reset */
  #define RCC_APB1RSTR_WWDGRST     0x00000800	/* Window Watchdog clock reset */
  #define RCC_APB1RSTR_SPI2RST     0x00004000	/* SPI2 clock reset */
  #define RCC_APB1RSTR_USART2RST   0x00020000	/* USART 2 clock reset */
  #define RCC_APB1RSTR_LPUART1RST  0x00040000	/* LPUART1 clock reset */
  #define RCC_APB1RSTR_USART4RST   0x00080000	/* USART4 clock reset */
  #define RCC_APB1RSTR_USART5RST   0x00100000	/* USART5 clock reset */
  #define RCC_APB1RSTR_I2C1RST     0x00200000	/* I2C 1 clock reset */
  #define RCC_APB1RSTR_I2C2RST     0x00400000	/* I2C 2 clock reset */
  #define RCC_APB1RSTR_USBRST      0x00800000	/* USB clock reset */
  #define RCC_APB1RSTR_CRSRST      0x08000000	/* CRS clock reset */
  #define RCC_APB1RSTR_PWRRST      0x10000000	/* PWR clock reset */
  #define RCC_APB1RSTR_DACRST      0x20000000	/* DAC clock reset */
  #define RCC_APB1RSTR_I2C3RST     0x40000000	/* I2C 3 clock reset */
  #define RCC_APB1RSTR_LPTIM1RST   0x80000000	/* LPTIM1 clock reset */
#define TOFF_RCC_IOPENR     0x002C		/* (RW) RCC Clock IO port enable register */
  #define RCC_IOPENR_IOPAEN        0x00000001	/* GPIO port A clock enable */
  #define RCC_IOPENR_IOPBEN        0x00000002	/* GPIO port B clock enable */
  #define RCC_IOPENR_IOPCEN        0x00000004	/* GPIO port C clock enable */
  #define RCC_IOPENR_IOPDEN        0x00000008	/* GPIO port D clock enable */
  #define RCC_IOPENR_IOPEEN        0x00000010	/* GPIO port E clock enable */
  #define RCC_IOPENR_IOPHEN        0x00000080	/* GPIO port H clock enable */
  #define RCC_IOPENR_GPIOAEN       RCC_IOPENR_IOPAEN	/* GPIO port A clock enable */
  #define RCC_IOPENR_GPIOBEN       RCC_IOPENR_IOPBEN	/* GPIO port B clock enable */
  #define RCC_IOPENR_GPIOCEN       RCC_IOPENR_IOPCEN	/* GPIO port C clock enable */
  #define RCC_IOPENR_GPIODEN       RCC_IOPENR_IOPDEN	/* GPIO port D clock enable */
  #define RCC_IOPENR_GPIOEEN       RCC_IOPENR_IOPEEN	/* GPIO port E clock enable */
  #define RCC_IOPENR_GPIOHEN       RCC_IOPENR_IOPHEN	/* GPIO port H clock enable */
#define TOFF_RCC_AHBENR     0x0030		/* (RW) RCC AHB peripheral clock enable register */
  #define RCC_AHBENR_DMAEN         0x00000001	/* DMA1 clock enable */
  #define RCC_AHBENR_MIFEN         0x00000100	/* NVM interface clock enable bit */
  #define RCC_AHBENR_CRCEN         0x00001000	/* CRC clock enable */
  #define RCC_AHBENR_TSCEN         0x00010000	/* TSC clock enable */
  #define RCC_AHBENR_RNGEN         0x00100000	/* RNG clock enable */
  #define RCC_AHBENR_DMA1EN        RCC_AHBENR_DMAEN	/* DMA1 clock enable */
#define TOFF_RCC_APB2ENR    0x0034		/* (RW) RCC APB2 peripheral enable register */
  #define RCC_APB2ENR_SYSCFGEN     0x00000001	/* SYSCFG clock enable */
  #define RCC_APB2ENR_TIM21EN      0x00000004	/* TIM21 clock enable */
  #define RCC_APB2ENR_TIM22EN      0x00000020	/* TIM22 clock enable */
  #define RCC_APB2ENR_FWEN         0x00000080	/* MiFare Firewall clock enable */
  #define RCC_APB2ENR_ADCEN        0x00000200	/* ADC1 clock enable */
  #define RCC_APB2ENR_SPI1EN       0x00001000	/* SPI1 clock enable */
  #define RCC_APB2ENR_USART1EN     0x00004000	/* USART1 clock enable */
  #define RCC_APB2ENR_DBGEN        0x00400000	/* DBGMCU clock enable */
  #define RCC_APB2ENR_MIFIEN       RCC_APB2ENR_FWEN		/* MiFare Firewall clock enable */
  #define RCC_APB2ENR_ADC1EN       RCC_APB2ENR_ADCEN	/* ADC1 clock enable */
  #define RCC_APB2ENR_DBGMCUEN     RCC_APB2ENR_DBGEN	/* DBGMCU clock enable */
#define TOFF_RCC_APB1ENR    0x0038		/* (RW) RCC APB1 peripheral enable register */
  #define RCC_APB1ENR_TIM2EN       0x00000001	/* Timer 2 clock enable */
  #define RCC_APB1ENR_TIM3EN       0x00000002	/* Timer 3 clock enable */
  #define RCC_APB1ENR_TIM6EN       0x00000010	/* Timer 6 clock enable */
  #define RCC_APB1ENR_TIM7EN       0x00000020	/* Timer 7 clock enable */
  #define RCC_APB1ENR_LCDEN        0x00000200	/* LCD clock enable */
  #define RCC_APB1ENR_WWDGEN       0x00000800	/* Window Watchdog clock enable */
  #define RCC_APB1ENR_SPI2EN       0x00004000	/* SPI2 clock enable */
  #define RCC_APB1ENR_USART2EN     0x00020000	/* USART2 clock enable */
  #define RCC_APB1ENR_LPUART1EN    0x00040000	/* LPUART1 clock enable */
  #define RCC_APB1ENR_USART4EN     0x00080000	/* USART4 clock enable */
  #define RCC_APB1ENR_USART5EN     0x00100000	/* USART5 clock enable */
  #define RCC_APB1ENR_I2C1EN       0x00200000	/* I2C1 clock enable */
  #define RCC_APB1ENR_I2C2EN       0x00400000	/* I2C2 clock enable */
  #define RCC_APB1ENR_USBEN        0x00800000	/* USB clock enable */
  #define RCC_APB1ENR_CRSEN        0x08000000	/* CRS clock enable */
  #define RCC_APB1ENR_PWREN        0x10000000	/* PWR clock enable */
  #define RCC_APB1ENR_DACEN        0x20000000	/* DAC clock enable */
  #define RCC_APB1ENR_I2C3EN       0x40000000	/* I2C3 clock enable */
  #define RCC_APB1ENR_LPTIM1EN     0x80000000	/* LPTIM1 clock enable */
#define TOFF_RCC_IOPSMENR   0x003C		/* (RW) RCC IO port clock enable in sleep mode register */
  #define RCC_IOPSMENR_IOPASMEN    0x00000001	/* GPIO port A clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPBSMEN    0x00000002	/* GPIO port B clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPCSMEN    0x00000004	/* GPIO port C clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPDSMEN    0x00000008	/* GPIO port D clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPESMEN    0x00000010	/* GPIO port E clock enabled in sleep mode */
  #define RCC_IOPSMENR_IOPHSMEN    0x00000080	/* GPIO port H clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOASMEN   RCC_IOPSMENR_IOPASMEN	/* GPIO port A clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOBSMEN   RCC_IOPSMENR_IOPBSMEN	/* GPIO port B clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOCSMEN   RCC_IOPSMENR_IOPCSMEN	/* GPIO port C clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIODSMEN   RCC_IOPSMENR_IOPDSMEN	/* GPIO port D clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOESMEN   RCC_IOPSMENR_IOPESMEN	/* GPIO port E clock enabled in sleep mode */
  #define RCC_IOPSMENR_GPIOHSMEN   RCC_IOPSMENR_IOPHSMEN	/* GPIO port H clock enabled in sleep mode */
#define TOFF_RCC_AHBSMENR   0x0040		/* (RW) RCC AHB peripheral clock enable in sleep mode register */
  #define RCC_AHBSMENR_DMASMEN     0x00000001	/* DMA1 clock enabled in sleep mode */
  #define RCC_AHBSMENR_MIFSMEN     0x00000100	/* NVM interface clock enable during sleep mode */
  #define RCC_AHBSMENR_SRAMSMEN    0x00000200	/* SRAM clock enabled in sleep mode */
  #define RCC_AHBSMENR_CRCSMEN     0x00001000	/* CRC clock enabled in sleep mode */
  #define RCC_AHBSMENR_TSCSMEN     0x00010000	/* TSC clock enabled in sleep mode */
  #define RCC_AHBSMENR_RNGSMEN     0x00100000	/* RNG clock enabled in sleep mode */
  #define RCC_AHBSMENR_DMA1SMEN    RCC_AHBSMENR_DMASMEN	/* DMA1 clock enabled in sleep mode */
#define TOFF_RCC_APB2SMENR  0x0044		/* (RW) RCC APB2 peripheral clock enable in sleep mode register */
  #define RCC_APB2SMENR_SYSCFGSMEN 0x00000001	/* SYSCFG clock enabled in sleep mode */
  #define RCC_APB2SMENR_TIM21SMEN  0x00000004	/* TIM21 clock enabled in sleep mode */
  #define RCC_APB2SMENR_TIM22SMEN  0x00000020	/* TIM22 clock enabled in sleep mode */
  #define RCC_APB2SMENR_ADCSMEN    0x00000200	/* ADC1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_SPI1SMEN   0x00001000	/* SPI1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_USART1SMEN 0x00004000	/* USART1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_DBGSMEN    0x00400000	/* DBGMCU clock enabled in sleep mode */
  #define RCC_APB2SMENR_ADC1SMEN   RCC_APB2SMENR_ADCSMEN	/* ADC1 clock enabled in sleep mode */
  #define RCC_APB2SMENR_DBGMCUSMEN RCC_APB2SMENR_DBGSMEN	/* DBGMCU clock enabled in sleep mode */
#define TOFF_RCC_APB1SMENR  0x0048		/* (RW) RCC APB1 peripheral clock enable in sleep mode register */
  #define RCC_APB1SMENR_TIM2SMEN   0x00000001	/* Timer 2 clock enabled in sleep mode */
  #define RCC_APB1SMENR_TIM3SMEN   0x00000002	/* Timer 3 clock enabled in sleep mode */
  #define RCC_APB1SMENR_TIM6SMEN   0x00000010	/* Timer 6 clock enabled in sleep mode */
  #define RCC_APB1SMENR_TIM7SMEN   0x00000020	/* Timer 7 clock enabled in sleep mode */
  #define RCC_APB1SMENR_LCDSMEN    0x00000200	/* LCD clock enabled in sleep mode */
  #define RCC_APB1SMENR_WWDGSMEN   0x00000800	/* Window Watchdog clock enabled in sleep mode */
  #define RCC_APB1SMENR_SPI2SMEN   0x00004000	/* SPI2 clock enabled in sleep mode */
  #define RCC_APB1SMENR_USART2SMEN 0x00020000	/* USART2 clock enabled in sleep mode */
  #define RCC_APB1SMENR_LPUART1SMEN 0x00040000	/* LPUART1 clock enabled in sleep mode */
  #define RCC_APB1SMENR_USART4SMEN 0x00080000	/* USART4 clock enabled in sleep mode */
  #define RCC_APB1SMENR_USART5SMEN 0x00100000	/* USART5 clock enabled in sleep mode */
  #define RCC_APB1SMENR_I2C1SMEN   0x00200000	/* I2C1 clock enabled in sleep mode */
  #define RCC_APB1SMENR_I2C2SMEN   0x00400000	/* I2C2 clock enabled in sleep mode */
  #define RCC_APB1SMENR_USBSMEN    0x00800000	/* USB clock enabled in sleep mode */
  #define RCC_APB1SMENR_CRSSMEN    0x08000000	/* CRS clock enabled in sleep mode */
  #define RCC_APB1SMENR_PWRSMEN    0x10000000	/* PWR clock enabled in sleep mode */
  #define RCC_APB1SMENR_DACSMEN    0x20000000	/* DAC clock enabled in sleep mode */
  #define RCC_APB1SMENR_I2C3SMEN   0x40000000	/* I2C3 clock enabled in sleep mode */
  #define RCC_APB1SMENR_LPTIM1SMEN 0x80000000	/* LPTIM1 clock enabled in sleep mode */
#define TOFF_RCC_CCIPR      0x004C		/* (RW) RCC clock configuration register */
  #define RCC_CCIPR_USART1SEL      0x00000003	/* USART1SEL[1:0] bits */
  #define RCC_CCIPR_USART1SEL_0    0x00000001
  #define RCC_CCIPR_USART1SEL_1    0x00000002
  #define RCC_CCIPR_USART2SEL      0x0000000C	/* USART2SEL[1:0] bits */
  #define RCC_CCIPR_USART2SEL_0    0x00000004
  #define RCC_CCIPR_USART2SEL_1    0x00000008
  #define RCC_CCIPR_LPUART1SEL     0x00000C00	/* LPUART1SEL[1:0] bits */
  #define RCC_CCIPR_LPUART1SEL_0   0x00000400
  #define RCC_CCIPR_LPUART1SEL_1   0x00000800
  #define RCC_CCIPR_I2C1SEL        0x00003000	/* I2C1SEL [1:0] bits */
  #define RCC_CCIPR_I2C1SEL_0      0x00001000
  #define RCC_CCIPR_I2C1SEL_1      0x00002000
  #define RCC_CCIPR_I2C3SEL        0x00030000	/* I2C3SEL [1:0] bits */
  #define RCC_CCIPR_I2C3SEL_0      0x00010000
  #define RCC_CCIPR_I2C3SEL_1      0x00020000
  #define RCC_CCIPR_LPTIM1SEL      0x000C0000	/* LPTIM1SEL [1:0] bits */
  #define RCC_CCIPR_LPTIM1SEL_0    0x00040000
  #define RCC_CCIPR_LPTIM1SEL_1    0x00080000
  #define RCC_CCIPR_HSI48SEL       0x04000000	/* HSI48 RC clock source selection bit for USB and RNG*/
  #define RCC_CCIPR_HSI48MSEL      RCC_CCIPR_HSI48SEL
#define TOFF_RCC_CSR        0x0050		/* (RW) RCC Control/status register */
  #define RCC_CSR_LSION            0x00000001	/* Internal Low Speed oscillator enable */
  #define RCC_CSR_LSIRDY           0x00000002	/* Internal Low Speed oscillator Ready */
  #define RCC_CSR_LSEON            0x00000100	/* External Low Speed oscillator enable */
  #define RCC_CSR_LSERDY           0x00000200	/* External Low Speed oscillator Ready */
  #define RCC_CSR_LSEBYP           0x00000400	/* External Low Speed oscillator Bypass */
  #define RCC_CSR_LSEDRV           0x00001800	/* LSEDRV[1:0] bits (LSE Osc. drive capability) */
  #define RCC_CSR_LSEDRV_0         0x00000800
  #define RCC_CSR_LSEDRV_1         0x00001000
  #define RCC_CSR_LSECSSON         0x00002000	/* External Low Speed oscillator CSS Enable */
  #define RCC_CSR_LSECSSD          0x00004000	/* External Low Speed oscillator CSS Detected */
  #define RCC_CSR_RTCSEL           0x00030000	/* RTCSEL[1:0] bits (RTC clock source selection) */
  #define RCC_CSR_RTCSEL_0         0x00010000
  #define RCC_CSR_RTCSEL_1         0x00020000
  #define RCC_CSR_RTCSEL_NOCLOCK   0x00000000	/* No clock */
  #define RCC_CSR_RTCSEL_LSE       0x00010000	/* LSE oscillator clock used as RTC clock */
  #define RCC_CSR_RTCSEL_LSI       0x00020000	/* LSI oscillator clock used as RTC clock */
  #define RCC_CSR_RTCSEL_HSE       0x00030000	/* HSE oscillator clock used as RTC clock */
  #define RCC_CSR_RTCEN            0x00040000	/* RTC clock enable */
  #define RCC_CSR_RTCRST           0x00080000	/* RTC software reset  */
  #define RCC_CSR_RMVF             0x00800000	/* Remove reset flag */
  #define RCC_CSR_FWRSTF           0x01000000	/* Mifare Firewall reset flag */
  #define RCC_CSR_OBLRSTF          0x02000000	/* OBL reset flag */
  #define RCC_CSR_PINRSTF          0x04000000	/* PIN reset flag */
  #define RCC_CSR_PORRSTF          0x08000000	/* POR/PDR reset flag */
  #define RCC_CSR_SFTRSTF          0x10000000	/* Software Reset flag */
  #define RCC_CSR_IWDGRSTF         0x20000000	/* Independent Watchdog reset flag */
  #define RCC_CSR_WWDGRSTF         0x40000000	/* Window watchdog reset flag */
  #define RCC_CSR_LPWRRSTF         0x80000000	/* Low-Power reset flag */
  #define RCC_CSR_OBL              RCC_CSR_OBLRSTF	/* OBL reset flag */

/*
 *  FLASH REGISTERS
 */
#define TADR_FLASH_R_BASE   (AHBPERIPH_BASE + 0x2000)
#define TOFF_FLASH_ACR      0x0000		/* (RW) FLASH access control register */
  #define FLASH_ACR_LATENCY  0x00000001	/* LATENCY bit (Latency) */
  #define FLASH_ACR_PRFTEN   0x00000002	/* Prefetch Buffer Enable */
  #define FLASH_ACR_SLEEP    0x00000008	/* Flash mode during sleep mode */
  #define FLASH_ACR_RUN_PD   0x00000010	/* Flash mode during RUN mode */
  #define FLASH_ACR_DISAB_BUF 0x00000020	/* Disable Buffer */
  #define FLASH_ACR_PRE_READ 0x00000040	/* Pre-read data address */
#define TOFF_FLASH_PECR     0x0004		/* (RW) Program/erase control register */
  #define FLASH_PECR_PELOCK  0x00000001	/* FLASH_PECR and Flash data Lock */
  #define FLASH_PECR_PRGLOCK 0x00000002	/* Program matrix Lock */
  #define FLASH_PECR_OPTLOCK 0x00000004	/* Option byte matrix Lock */
  #define FLASH_PECR_PROG    0x00000008	/* Program matrix selection */
  #define FLASH_PECR_DATA    0x00000010	/* Data matrix selection */
  #define FLASH_PECR_FIX     0x00000100	/* Fixed Time Data write for Word/Half Word/Byte programming */
  #define FLASH_PECR_ERASE   0x00000200	/* Page erasing mode */
  #define FLASH_PECR_FPRG    0x00000400	/* Fast Page/Half Page programming mode */
  #define FLASH_PECR_PARALLBANK  0x00008000	/* Parallel Bank mode */
  #define FLASH_PECR_EOPIE   0x00010000	/* End of programming interrupt */ 
  #define FLASH_PECR_ERRIE   0x00020000	/* Error interrupt */ 
  #define FLASH_PECR_OBL_LAUNCH  0x00040000	/* Launch the option byte loading */
  #define FLASH_PECR_HALF_ARRAY  0x00080000	/* Half array mode */
  #define FLASH_PECR_NZDISABLE   0x00400000	/* Non-Zero check disable */
#define TOFF_FLASH_PDKEYR   0x0008		/* (RW) Power down key register */
#define TOFF_FLASE_PEKEYR   0x000C		/* (RW) Program/erase key register */
#define TOFF_FLASH_PRGKEYR  0x0010		/* (RW) Program memory key register */
#define TOFF_FLASH_OPTKEYR  0x0014		/* (RW) Option byte key register */
#define TOFF_FLASH_SR       0x0018		/* (RW) Status register */
  #define FLASH_SR_BSY       0x00000001	/* Busy */
  #define FLASH_SR_EOP       0x00000002	/* End Of Programming*/
  #define FLASH_SR_HVOFF     0x00000004	/* End of high voltage */
  #define FLASH_SR_READY     0x00000008	/* Flash ready after low power mode */
  #define FLASH_SR_WRPERR    0x00000100	/* Write protection error */
  #define FLASH_SR_PGAERR    0x00000200	/* Programming Alignment Error */
  #define FLASH_SR_SIZERR    0x00000400	/* Size error */
  #define FLASH_SR_OPTVERR   0x00000800	/* Option Valid error */
  #define FLASH_SR_RDERR     0x00002000	/* Read protected error */
  #define FLASH_SR_NOTZEROERR 0x00010000	/* Not Zero error */
  #define FLASH_SR_FWWERR    0x00020000	/* Write/Errase operation aborted */
  #define FLASH_SR_FWWER     FLASH_SR_FWWERR
  #define FLASH_SR_ENHV      FLASH_SR_HVOFF
  #define FLASH_SR_ENDHV     FLASH_SR_HVOFF
#define TOFF_FLASH_OPTR     0x001C		/* (RW) Option byte register */
  #define FLASH_OPTR_RDPROT  0x000000FF	/* Read Protection */
  #define FLASH_OPTR_WPRMOD  0x00000100	/* Selection of protection mode of WPR bits */
  #define FLASH_OPTR_BOR_LEV 0x000F0000	/* BOR_LEV[3:0] Brown Out Reset Threshold Level*/
  #define FLASH_OPTR_IWDG_SW 0x00100000	/* IWDG_SW */
  #define FLASH_OPTR_nRST_STOP   0x00200000	/* nRST_STOP */
  #define FLASH_OPTR_nRST_STDBY  0x00400000	/* nRST_STDBY */
  #define FLASH_OPTR_BFB2    0x00800000	/* BFB2 */
  #define FLASH_OPTR_USER    0x00700000	/* User Option Bytes */
  #define FLASH_OPTR_BOOT1   0x80000000	/* BOOT1 */
#define TOFF_FLASH_WRPR     0x0020		/* (RW) Write protection register */
  #define FLASH_WRPR_WRP     0x0000FFFF	/* Write Protection bits */
#define TOFF_FLASH_WRPR2    0x0080		/* (RW) Write protection register 2 */

#define TOFF_FLASH_AR       0x0014		/* (RW) FLASH address register */
#define TOFF_FLASH_OBR      0x001C		/* (RW) FLASH option bytes register */
  #define FLASH_OBR_OPTERR   0x00000001	/* Option Byte Error */
  #define FLASH_OBR_RDPRT1   0x00000002	/* Read protection Level 1 */
  #define FLASH_OBR_RDPRT2   0x00000004	/* Read protection Level 2 */
  #define FLASH_OBR_USER     0x0000FF00	/* User Option Bytes */
  #define FLASH_OBR_IWDG_SW  0x00000100	/* IWDG SW */
  #define FLASH_OBR_nRST_STOP    0x00000200	/* nRST_STOP */
  #define FLASH_OBR_nRST_STDBY   0x00000400	/* nRST_STDBY */
  #define FLASH_OBR_nBOOT0   0x00000800	/* nBOOT0 */
  #define FLASH_OBR_nBOOT1   0x00001000	/* nBOOT1 */
  #define FLASH_OBR_VDDA_MONITOR 0x00002000	/* VDDA power supply supervisor */
  #define FLASH_OBR_RAM_PARITY_CHECK 0x00004000	/* RAM parity check */
  #define FLASH_OBR_BOOT_SEL 0x00008000	/* BOOT selection */
  #define FLASH_OBR_DATA0    0x00FF0000	/* Data0 */
  #define FLASH_OBR_DATA1    0xFF000000	/* Data1 */
#define TOFF_FLASH_WRPR     0x0020		/* (RW) FLASH option bytes register */
  #define FLASH_WRPR_WRP     0x0000FFFF	/* Write Protect */

/* 
 *  DMA CONTROLLER (F/L)
 */
#define TADR_DMA1_BASE      (AHBPERIPH_BASE + 0x0000)
#define TOFF_DMA_ISR        0x0000		/* (RW) DMA interrupt status register */
  #define DMA_ISR_GIF        0x1		/* Channel Global interrupt flag */
  #define DMA_ISR_TCIF       0x2		/* Channel Transfer Complete flag */
  #define DMA_ISR_HTIF       0x4		/* Channel Half Transfer flag */
  #define DMA_ISR_TEIF       0x8		/* Channel Transfer Error flag */
#define TOFF_DMA_IFCR       0x0004		/* (RW) DMA interrupt flag clear register */
  #define DMA_IFCR_CGIF      0x1		/* Channel Global interrupt clear    */
  #define DMA_IFCR_CTCIF     0x2		/* Channel Transfer Complete clear   */
  #define DMA_IFCR_CHTIF     0x4		/* Channel Half Transfer clear       */
  #define DMA_IFCR_CTEIF     0x8		/* Channel Transfer Error clear      */
#define TOFF_DMA_CSELR      0x00A8		/* (RW) Channel selection register */
  #define DMA_CSELR_C1S      0x0000000F	/* Channel 1 Selection */
  #define DMA_CSELR_C2S      0x000000F0	/* Channel 2 Selection */
  #define DMA_CSELR_C3S      0x00000F00	/* Channel 3 Selection */
  #define DMA_CSELR_C4S      0x0000F000	/* Channel 4 Selection */
  #define DMA_CSELR_C5S      0x000F0000	/* Channel 5 Selection */
  #define DMA_CSELR_C6S      0x00F00000	/* Channel 6 Selection */
  #define DMA_CSELR_C7S      0x0F000000	/* Channel 7 Selection */

#define TADR_DMA1_CH1_BASE  (TADR_DMA1_BASE + 0x008)
#define TADR_DMA1_CH2_BASE  (TADR_DMA1_BASE + 0x01C)
#define TADR_DMA1_CH3_BASE  (TADR_DMA1_BASE + 0x030)
#define TADR_DMA1_CH4_BASE  (TADR_DMA1_BASE + 0x044)
#define TADR_DMA1_CH5_BASE  (TADR_DMA1_BASE + 0x058)
#define TADR_DMA1_CH6_BASE  (TADR_DMA1_BASE + 0x06C)
#define TADR_DMA1_CH7_BASE  (TADR_DMA1_BASE + 0x080)
#define TOFF_DMACH_CCR      0x0000		/* (RW) DMA channel x configuration register */
  #define DMA_CCR_EN         0x00000001	/* Channel enable */
  #define DMA_CCR_TCIE       0x00000002	/* Transfer complete interrupt enable */
  #define DMA_CCR_HTIE       0x00000004	/* Half Transfer interrupt enable */
  #define DMA_CCR_TEIE       0x00000008	/* Transfer error interrupt enable */
  #define DMA_CCR_DIR        0x00000010	/* Data transfer direction */
  #define DMA_CCR_CIRC       0x00000020	/* Circular mode */
  #define DMA_CCR_PINC       0x00000040	/* Peripheral increment mode */
  #define DMA_CCR_MINC       0x00000080	/* Memory increment mode */
  #define DMA_CCR_PSIZE      0x00000300	/* PSIZE[1:0] bits (Peripheral size) */
  #define DMA_CCR_PSIZE_0    0x00000100
  #define DMA_CCR_PSIZE_1    0x00000200
  #define DMA_CCR_MSIZE      0x00000C00	/* MSIZE[1:0] bits (Memory size) */
  #define DMA_CCR_MSIZE_0    0x00000400
  #define DMA_CCR_MSIZE_1    0x00000800
  #define DMA_CCR_PL         0x00003000	/* PL[1:0] bits(Channel Priority level) */
  #define DMA_CCR_PL_0       0x00001000
  #define DMA_CCR_PL_1       0x00002000
  #define DMA_CCR_MEM2MEM    0x00004000	/* Memory to memory mode */
#define TOFF_DMACH_CNDTR    0x0004		/* (RW) DMA channel x number of data register */
  #define DMA_CNDTR_NDT      0x0000FFFF	/* Number of data to Transfer */
#define TOFF_DMACH_CPAR     0x0008		/* (RW) DMA channel x peripheral address register   */
#define TOFF_DMACH_CMAR     0x000C		/* (RW) DMA channel x memory address register */

/*
 *  DEBUG MCU (F/L)
 */
#define TADR_DBGMCU_BASE    (APBPERIPH_BASE + 0x00015800)
#define TOFF_DBGMCU_IDCODE  0x0000		/* (RW) MCU device ID code */
#define TOFF_DBGMCU_CR      0x0004		/* (RW) Debug MCU configuration register */
#define TOFF_DBGMCU_APB1FZ  0x0008		/* (RW) Debug MCU APB1 freeze register */
#define TOFF_DBGMCU_APB2FZ  0x000C		/* (RW) Debug MCU APB2 freeze register */

#endif  /* _STM32L0XX_H_ */

