/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2020  by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	rommon Serial Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"
#include "serial.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))


/*
 *  GPIO BASE AND PIN POSITION
 */
#define GPIO_Speed              GPIO_Speed_50MHz
#define UARTREADY_TIMEOUT_VALUE 0x1FFFFFF	/* UART polling-based communications time-out value */

/*
 *  GPIO Configuration Mode enumeration
 */
#define GPIO_Mode_IN            0x0					/* GPIO Input Mode */
#define GPIO_Mode_OUT           GPIO_MODER_MODER0	/* GPIO Output Mode */
#define GPIO_Mode_AF            GPIO_MODER_MODER1	/* GPIO Alternate function Mode */
#define GPIO_Mode_AN            GPIO_MODER_MODER2	/* GPIO Analog Mode */

/*
 *  GPIO Output type enumeration
 */
#define GPIO_OType_PP           0x0
#define GPIO_OType_OD           0x1

/*
 *  GPIO Output Maximum frequency enumeration
 */
#define GPIO_Speed_2MHz         0x0						/* Low speed */
#define GPIO_Speed_25MHz        GPIO_OSPEEDER_OSPEEDR0	/* Medium speed */
#define GPIO_Speed_50MHz        GPIO_OSPEEDER_OSPEEDR1	/* Fast speed */
#define GPIO_Speed_100MHz       GPIO_OSPEEDER_OSPEEDR2	/* High speed on 30 pF (80 MHz Output max speed on 15 pF) */

/*
 *  GPIO Configuration PullUp PullDown enumeration
 */
#define GPIO_PuPd_NOPULL        0x0
#define GPIO_PuPd_UP            GPIO_PUPDR_PUPDR0
#define GPIO_PuPd_DOWN          GPIO_PUPDR_PUPDR1

/*
 *  AF 7 selection
 */
#define GPIO_AF7                0x07	/* AF7 value */

/*
 *  UARTå
 */
#define UART_CLOCKSOURCE_PCLK1  0x00	/* PCLK1 clock source */
#define UART_CLOCKSOURCE_PCLK2  0x01	/* PCLK2 clock source */
#define UART_CLOCKSOURCE_PCLK5  0x02	/* PCLK5 clock source (only used by UART1) */
#define UART_CLOCKSOURCE_PLL3Q  0x04	/* PLL3Q clock source (only used by UART1) */
#define UART_CLOCKSOURCE_PLL4Q  0x08	/* PLL4Q clock source  */
#define UART_CLOCKSOURCE_HSI    0x10	/* HSI clock source */
#define UART_CLOCKSOURCE_CSI    0x20	/* CSI clock source */
#define UART_CLOCKSOURCE_HSE    0x40	/* HSE clock source */
#define UART_CLOCKSOURCE_UNDEF  0x80	/* Undefined clock source */

/*
 *  UART Word Length
 */
#define UART_WORDLENGTH_7B      USART_CR1_M1	/* 7-bit long UART frame */
#define UART_WORDLENGTH_8B      0x00000000		/* 8-bit long UART frame */
#define UART_WORDLENGTH_9B      USART_CR1_M0	/* 9-bit long UART frame */

/*
 *  UART Stop Bits
 */
#define UART_STOPBITS_0_5       USART_CR2_STOP_0	/* UART frame with 0.5 stop bit  */
#define UART_STOPBITS_1         0x00000000			/* UART frame with 1 stop bit    */
#define UART_STOPBITS_1_5       (USART_CR2_STOP_0 | USART_CR2_STOP_1)	/* UART frame with 1.5 stop bits */
#define UART_STOPBITS_2         USART_CR2_STOP_1	/* UART frame with 2 stop bits   */

/*
 *  UART Parity
 */
#define UART_PARITY_NONE        0x00000000		/* No parity   */
#define UART_PARITY_EVEN        USART_CR1_PCE	/* Even parity */
#define UART_PARITY_ODD         (USART_CR1_PCE | USART_CR1_PS)	/* Odd parity  */

/*
 *  UART MODE
 */
#define UART_MODE_RX            USART_CR1_RE	/* RX mode */
#define UART_MODE_TX            USART_CR1_TE	/* TX mode */
#define UART_MODE_TX_RX         (USART_CR1_TE |USART_CR1_RE)	/* RX and TX mode */

/*
 *  UART HARDWARE FLOW CONTROL
 */
#define UART_HWCONTROL_NONE     0x00000000		/* No hardware control */
#define UART_HWCONTROL_RTS      USART_CR3_RTSE	/* Request To Send */
#define UART_HWCONTROL_CTS      USART_CR3_CTSE	/* Clear To Send */
#define UART_HWCONTROL_RTS_CTS  (USART_CR3_RTSE | USART_CR3_CTSE)	/* Request and Clear To Send */

/*
 *  UART OVER SAMPLING
 */
#define UART_OVERSAMPLING_16    0x00000000		/* Oversampling by 16 */
#define UART_OVERSAMPLING_8     USART_CR1_OVER8	/* Oversampling by 8 */

/*
 *  UART ONEBIT SAMPLING
 */
#define UART_ONE_BIT_SAMPLE_DISABLE 0x00000000	/* One-bit sampling disable */
#define UART_ONE_BIT_SAMPLE_ENABLE  USART_CR3_ONEBIT	/* One-bit sampling enable  */

#define CR1_CLEAR_MASK          (USART_CR1_M | USART_CR1_PCE | USART_CR1_PS | \
                                 USART_CR1_TE | USART_CR1_RE | USART_CR1_OVER8| \
                                 USART_CR1_FIFOEN )
#define CR3_CLEAR_MASK          (USART_CR3_RTSE | USART_CR3_CTSE | USART_CR3_ONEBIT| \
                                 USART_CR3_TXFTCFG | USART_CR3_RXFTCFG )

#define CR2_CLEAR_BITS          (USART_CR2_LINEN | USART_CR2_CLKEN)
#define CR3_CLEAR_BITS          (USART_CR3_SCEN | USART_CR3_HDSEL | USART_CR3_IREN)

#define CR1_CLEAR_ERROR         (USART_CR1_RXNEIE_RXFNEIE | USART_CR1_PEIE | USART_CR1_TXEIE_TXFNFIE)
/*
 *  UART BRR RENGE
 */
#define UART_BRR_MIN            0x10U			/* UART BRR minimum authorized value */
#define UART_BRR_MAX            0x0000FFFFU		/* UART BRR maximum authorized value */

/*
 *  UART CLOCK PRESCALER
 */
#define UART_PRESCALER_DIV1     0x00000000		/* fclk_pres = fclk */
#define UART_PRESCALER_DIV2     0x00000001		/* fclk_pres = fclk/2 */
#define UART_PRESCALER_DIV4     0x00000002		/* fclk_pres = fclk/4 */
#define UART_PRESCALER_DIV6     0x00000003		/* fclk_pres = fclk/6 */
#define UART_PRESCALER_DIV8     0x00000004		/* fclk_pres = fclk/8 */
#define UART_PRESCALER_DIV10    0x00000005		/* fclk_pres = fclk/10 */
#define UART_PRESCALER_DIV12    0x00000006		/* fclk_pres = fclk/12 */
#define UART_PRESCALER_DIV16    0x00000007		/* fclk_pres = fclk/16 */
#define UART_PRESCALER_DIV32    0x00000008		/* fclk_pres = fclk/32 */
#define UART_PRESCALER_DIV64    0x00000009		/* fclk_pres = fclk/64 */
#define UART_PRESCALER_DIV128   0x0000000A		/* fclk_pres = fclk/128 */
#define UART_PRESCALER_DIV256   0x0000000B		/* fclk_pres = fclk/256 */

/*
 *  UART FIFO DEPTH
 */
#define RX_FIFO_DEPTH           8U
#define TX_FIFO_DEPTH           8U

#if USE_UART_FIFOMODE == 0
#define UART_TXFIFO_THRESHOLD   UART_TXFIFO_THRESHOLD_1_8
#else
#define UART_TXFIFO_THRESHOLD   UART_TXFIFO_THRESHOLD_8_8
#endif
#define UART_RXFIFO_THRESHOLD   UART_RXFIFO_THRESHOLD_1_8

/*
 *  UART TXFIFO THRESHOLD
 */
#define UART_TXFIFO_THRESHOLD_1_8 0x00000000			/* TXFIFO reaches 1/8 of its depth */
#define UART_TXFIFO_THRESHOLD_1_4 USART_CR3_TXFTCFG_0	/* TXFIFO reaches 1/4 of its depth */
#define UART_TXFIFO_THRESHOLD_1_2 USART_CR3_TXFTCFG_1	/* TXFIFO reaches 1/2 of its depth */
#define UART_TXFIFO_THRESHOLD_3_4 (USART_CR3_TXFTCFG_0|USART_CR3_TXFTCFG_1)	/* TXFIFO reaches 3/4 of its depth */
#define UART_TXFIFO_THRESHOLD_7_8 USART_CR3_TXFTCFG_2	/* TXFIFO reaches 7/8 of its depth */
#define UART_TXFIFO_THRESHOLD_8_8 (USART_CR3_TXFTCFG_2|USART_CR3_TXFTCFG_0)	/* TXFIFO becomes empty */

/*
 *  UART RXFIFO THRESHOLD
 */
#define UART_RXFIFO_THRESHOLD_1_8 0x00000000			/* RXFIFO FIFO reaches 1/8 of its depth */
#define UART_RXFIFO_THRESHOLD_1_4 USART_CR3_RXFTCFG_0	/* RXFIFO FIFO reaches 1/4 of its depth */
#define UART_RXFIFO_THRESHOLD_1_2 USART_CR3_RXFTCFG_1	/* RXFIFO FIFO reaches 1/2 of its depth */
#define UART_RXFIFO_THRESHOLD_3_4 (USART_CR3_RXFTCFG_0|USART_CR3_RXFTCFG_1)	/* RXFIFO FIFO reaches 3/4 of its depth */
#define UART_RXFIFO_THRESHOLD_7_8 USART_CR3_RXFTCFG_2	/* RXFIFO FIFO reaches 7/8 of its depth */
#define UART_RXFIFO_THRESHOLD_8_8 (USART_CR3_RXFTCFG_2|USART_CR3_RXFTCFG_0)	/* RXFIFO FIFO becomes full */

#define USART_CR3_TXFTCFG_SHIFT   (29U)


typedef struct usart_struct {
	uint32_t    taddr;
	uint32_t    txbase;
	uint32_t    rxbase;
	uint32_t    clkenbase;
	uint32_t    clkenbit;
	uint32_t    clksrcbase;
	uint8_t     no;
	uint8_t     txpin;
	uint8_t     rxpin;
} usart_struct_t;

static const usart_struct_t usart_table[MAX_SERIAL] = {
	{ TADR_UART7_BASE, TADR_GPIOE_BASE, TADR_GPIOE_BASE,
	  TADR_RCC_BASE+TOFF_RCC_MP_APB1ENSETR, RCC_MC_APB1ENSETR_UART7EN,
	  TADR_RCC_BASE+TOFF_RCC_UART78CKSELR, (IRQ_VECTOR_UART7-16),  8, 7 }
};

static const uint8_t usart1_clock_source[8] = {
	UART_CLOCKSOURCE_PCLK5,
	UART_CLOCKSOURCE_PLL3Q,
	UART_CLOCKSOURCE_HSI,
	UART_CLOCKSOURCE_CSI,
	UART_CLOCKSOURCE_PLL4Q,
	UART_CLOCKSOURCE_HSE,
	UART_CLOCKSOURCE_UNDEF,
	UART_CLOCKSOURCE_UNDEF
};

static const uint8_t usart6_clock_source[8] = {
	UART_CLOCKSOURCE_PCLK2,
	UART_CLOCKSOURCE_PLL4Q,
	UART_CLOCKSOURCE_HSI,
	UART_CLOCKSOURCE_CSI,
	UART_CLOCKSOURCE_HSE,
	UART_CLOCKSOURCE_UNDEF,
	UART_CLOCKSOURCE_UNDEF,
	UART_CLOCKSOURCE_UNDEF
};

static const uint8_t default_clock_source[8] = {
	UART_CLOCKSOURCE_PCLK1,
	UART_CLOCKSOURCE_PLL4Q,
	UART_CLOCKSOURCE_HSI,
	UART_CLOCKSOURCE_CSI,
	UART_CLOCKSOURCE_HSE,
	UART_CLOCKSOURCE_UNDEF,
	UART_CLOCKSOURCE_UNDEF,
	UART_CLOCKSOURCE_UNDEF
};

static const uint16_t usart_dev_factor[12] = {
	1, 2, 4, 6, 8, 10, 12, 16, 32, 64, 128, 256
};

static const uint8_t numerator[] = {1U, 1U, 1U, 3U, 7U, 1U, 0U, 0U};
static const uint8_t denominator[] = {8U, 4U, 2U, 4U, 8U, 1U, 1U, 1U};

void SendTXWait(int id);
extern int MonVector[];


static void sys_putc(int c)
{
	SendTXWait(DEF_MON_SERIAL);
	SendTX(DEF_MON_SERIAL, c);
	if(c == '\n'){
		SendTXWait(DEF_MON_SERIAL);
		SendTX(DEF_MON_SERIAL, '\r');
	}
}

static void sys_printf(const char *s)
{
	int c;

	while((c = *s++) != 0){
		sys_putc(c);
	}
}

#if 1	/* ROI DEBUG */
void put_hex(char a, int val)
{
	int i, j;
	sys_putc(a);
	sys_putc(' ');
	for(i = 28 ; i >= 0 ; i-= 4){
		j = (val >> i) & 0xf;;
		if(j > 9)
			j += ('A'-10);
		else
			j += '0';
		sys_putc(j);
	}
	sys_putc('\n');
	sys_putc('\r');
}


#endif	/* ROI DEBUG */
void Disable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ICER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

void Enable(void)
{
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((usart_table[0].no>>5)*4)), 1 << (usart_table[0].no & 0x1F));
}

/*
 *  ̤㳰äν
 */
void NMI_Handler(void)
{
    sys_printf("NMI Exception occurs. !\n");
    while(1);
}

void HardFault_Handler(void)
{
    sys_printf("Hard Fault Exception occurs. !\n");
    while(1);
}

void MemManage_Handler(void)
{
    sys_printf("Memory Manager Exception occurs. !\n");
    while(1);
}

void BusFault_Handler(void)
{
    sys_printf("Bus Fault Exception occurs. !\n");
    while(1);
}


void UsageFault_Handler(void)
{
    sys_printf("Usage Fault Exception occurs. !\n");
    while(1);
}

void DebugMon_Handler(void)
{
    sys_printf("Debug Monitor Exception occurs. !\n");
    while(1);
}

void PendSV_Handler(void)
{
    sys_printf("Pend SV Exception occurs. !\n");
    while(1);
}

static void setup_gpio_source(uint32_t base, unsigned char source, unsigned char select)
{
	uint32_t tmpreg, regoff;
	regoff = TOFF_GPIO_AFR0+((source>>1) & 0x4);
	tmpreg = (sil_rew_mem((uint32_t *)(base+regoff)) & ~(0xF << ((source & 0x07) * 4)))
			    | (select << ((source & 0x07) * 4));
	sil_wrw_mem((uint32_t *)(base+regoff), tmpreg);
}

/*
 *  UART READYԤؿ
 *  input base  uart base address
 *        flag  ISRԤե饰
 *  result: 0:OK
 */
static int UART_ReadyWaitOnFlag(uint32_t base, uint32_t flag)
{
	uint32_t tick = 0;

	/*
	 *  ե饰åȤޤԤ
	 */
	while((sil_rew_mem((uint32_t *)(base+TOFF_USART_ISR)) & flag) == 0){
		if(++tick > UARTREADY_TIMEOUT_VALUE){
			/*
			 *  顼ꥻå
			 */
			sil_andw_mem((uint32_t *)(base+TOFF_USART_CR1), CR1_CLEAR_ERROR);
			sil_andw_mem((uint32_t *)(base+TOFF_USART_CR3), USART_CR3_EIE);
			return -1;
		}
		if((sil_rew_mem((uint32_t *)(base+TOFF_USART_CR1)) & USART_CR1_RE) != 0){
			if((sil_rew_mem((uint32_t *)(base+TOFF_USART_ISR)) & USART_ISR_RTOF) != 0){
				/*
				 *  ॢȥե饰ꥻå
				 */
				sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_RTOCF);

				/*
				 *  顼ꥻå
				 */
				sil_andw_mem((uint32_t *)(base+TOFF_USART_CR1), CR1_CLEAR_ERROR);
				sil_andw_mem((uint32_t *)(base+TOFF_USART_CR3), USART_CR3_EIE);
				return -1;
			}
		}
		sil_dly_nse(1000);
	}
	return 0;
}


/*
 *	Initialize Serial Channel
 *  Input: id: Serial Channel #
 */
void InitSIO(int id)
{
	uint32_t usart_base = usart_table[id].taddr;
	uint32_t txbase = usart_table[id].txbase;
	uint32_t rxbase = usart_table[id].rxbase;
	uint8_t  txpin  = usart_table[id].txpin;
	uint8_t  rxpin  = usart_table[id].rxpin;
	uint16_t intno  = usart_table[id].no;
	RCC_ClocksTypeDef RCC_Clocks;
	uint32_t tmp;
	uint8_t  clocksource;
	uint32_t usartdiv = 0;
	uint32_t pclk;
	uint32_t prioritygroup = 0x00;
	uint32_t PreemptPriorityBits;
	uint32_t SubPriorityBits;
	uint32_t priority;

	/*
	 *  UARTǥХå
	 */
	sil_wrw_mem((uint32_t *)(usart_table[id].clkenbase), usart_table[id].clkenbit);


	PERIPH_LOCK(TADR_GPIOE_BASE);

	/*
	 *  TXԥν
	 */
	sil_modw_mem((uint32_t *)(txbase+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (txpin*2)), (GPIO_Mode_AF << (txpin*2)));
	sil_modw_mem((uint32_t *)(txbase+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (txpin*2)), (GPIO_Speed << (txpin*2)));
	sil_modw_mem((uint32_t *)(txbase+TOFF_GPIO_OTYPER), (GPIO_OType_OD << txpin), (GPIO_OType_PP << txpin));
	sil_modw_mem((uint32_t *)(txbase+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (txpin*2)), (GPIO_PuPd_UP << (txpin*2)));
	setup_gpio_source(txbase, txpin, GPIO_AF7);

	/*
	 *  RXԥν
	 */
	sil_modw_mem((uint32_t *)(rxbase+TOFF_GPIO_MODER), (GPIO_MODER_MODER2 << (rxpin*2)), (GPIO_Mode_AF << (rxpin*2)));
	sil_modw_mem((uint32_t *)(rxbase+TOFF_GPIO_OSPEEDR), (GPIO_OSPEEDER_OSPEEDR2 << (rxpin*2)), (GPIO_Speed << (rxpin*2)));
	sil_modw_mem((uint32_t *)(rxbase+TOFF_GPIO_OTYPER), (GPIO_OType_OD << rxpin), (GPIO_OType_PP << rxpin));
	sil_modw_mem((uint32_t *)(rxbase+TOFF_GPIO_PUPDR), (GPIO_PUPDR_PUPDR2 << (rxpin*2)), (GPIO_PuPd_UP << (rxpin*2)));
	setup_gpio_source(rxbase, rxpin, GPIO_AF7);

	PERIPH_UNLOCK(TADR_GPIOE_BASE);


	/*
	 *  UART̵
	 */
	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_UE);

	/*
	 *  UART CR1,2,3
	 */
	tmp = (uint32_t)(UART_WORDLENGTH_8B | UART_PARITY_NONE | UART_MODE_TX_RX | UART_OVERSAMPLING);
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), CR1_CLEAR_MASK, tmp);
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR2), USART_CR2_STOP, UART_STOPBITS_1);
	tmp = UART_HWCONTROL_NONE | UART_ONE_BIT_SAMPLE_DISABLE;
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), CR3_CLEAR_MASK, tmp);

	/*
	 *  UART PRESC
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_PRESC), USART_PRESC_PRESCALER, UART_PRESCALER_DIV);

	/*
	 *  UART BRR
	 */
	tmp = sil_rew_mem((uint32_t *)usart_table[id].clksrcbase) & 7;
	if(usart_base == TADR_USART1_BASE)
		clocksource = usart1_clock_source[tmp];
	else if(usart_base == TADR_USART6_BASE)
		clocksource = usart6_clock_source[tmp];
	else
		clocksource = default_clock_source[tmp];

	RCC_GetClocksFreq(&RCC_Clocks);
	switch (clocksource){
	case UART_CLOCKSOURCE_PCLK2:
		pclk = RCC_Clocks.PCLK2_Frequency;
		break;
	case UART_CLOCKSOURCE_PCLK5:
		pclk = RCC_Clocks.PCLK5_Frequency;
		break;
	case UART_CLOCKSOURCE_PLL3Q:
		pclk = RCC_Clocks.PLL3_Q_Frequency;
		break;
	case UART_CLOCKSOURCE_PLL4Q:
		pclk = RCC_Clocks.PLL4_Q_Frequency;
		break;
	case UART_CLOCKSOURCE_HSI:
		pclk = HSI_VALUE;
		break;
	case UART_CLOCKSOURCE_CSI:
		pclk = CSI_VALUE;
		break;
	case UART_CLOCKSOURCE_HSE:
		pclk = HSE_VALUE;
		break;
	case UART_CLOCKSOURCE_PCLK1:
	default:
		pclk = RCC_Clocks.PCLK1_Frequency;
		break;
	}

	/*
	 *  UART ܡ졼
	 */
	if((sil_rew_mem((uint32_t *)(usart_base+TOFF_USART_CR1)) & UART_OVERSAMPLING_8) == UART_OVERSAMPLING_8){
		uint16_t brrtemp;
		usartdiv = (((pclk/usart_dev_factor[UART_PRESCALER_DIV])*2U) + (DEFAULT_SPEED/2U)) / DEFAULT_SPEED;

		/*
		 *  ܡ졼Ⱦ¡ϰ
		 */
		if(usartdiv < UART_BRR_MIN)
			usartdiv = UART_BRR_MIN;
		else if(usartdiv > UART_BRR_MAX)
			usartdiv = UART_BRR_MAX;

		brrtemp = (uint16_t)(usartdiv & 0xFFF0U);
		brrtemp |= (uint16_t)((usartdiv & (uint16_t)0x000FU) >> 1U);
		sil_wrw_mem((uint32_t *)(usart_base+TOFF_USART_BRR), brrtemp);
	}
	else{
		usartdiv = ((pclk/usart_dev_factor[UART_PRESCALER_DIV]) + (DEFAULT_SPEED/2U)) / DEFAULT_SPEED;

		/*
		 *  ܡ졼Ⱦ¡ϰ
		 */
		if(usartdiv < UART_BRR_MIN)
			usartdiv = UART_BRR_MIN;
		else if(usartdiv > UART_BRR_MAX)
			usartdiv = UART_BRR_MAX;
		sil_wrw_mem((uint32_t *)(usart_base+TOFF_USART_BRR), usartdiv);
	}

	/*
	 *  UART󥯥⡼ɤפ򥯥ꥢ
	 */
	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR2), CR2_CLEAR_BITS);
	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), CR3_CLEAR_BITS);

    /*
	 *  UART
	 */
	prioritygroup = (sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR)) & SCB_AIRCR_PRIGROUP_Msk) >> SCB_AIRCR_PRIGROUP_Pos;

	PreemptPriorityBits = ((7UL - prioritygroup) > (uint32_t)(__NVIC_PRIO_BITS)) ? (uint32_t)(__NVIC_PRIO_BITS) : (uint32_t)(7UL - prioritygroup);
	SubPriorityBits     = ((prioritygroup + (uint32_t)(__NVIC_PRIO_BITS)) < (uint32_t)7UL) ? (uint32_t)0UL : (uint32_t)((prioritygroup - 7UL) + (uint32_t)(__NVIC_PRIO_BITS));

	priority = 
           ((MAIN_PRIORITY & (uint32_t)((1UL << (PreemptPriorityBits)) - 1UL)) << SubPriorityBits) |
           ((SUB_PRIORITY  & (uint32_t)((1UL << (SubPriorityBits    )) - 1UL)));

	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_IP+intno*4), ((priority << (8U - __NVIC_PRIO_BITS)) & (uint32_t)0xFFUL));
	sil_wrw_mem((uint32_t *)(TADR_NVIC_BASE+TOFF_NVIC_ISER+((intno>>5)*4)), 1 << (intno & 0x1F));

	/*
	 *  TX FIFOå
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), USART_CR3_TXFTCFG, UART_TXFIFO_THRESHOLD);

	/*
	 *  RX FIFOå
	 */
	sil_modw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), USART_CR3_RXFTCFG, UART_RXFIFO_THRESHOLD);

	/*
	 *  UART FIFO⡼
	 */
#if USE_UART_FIFOMODE == 0
	sil_andw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_FIFOEN);
#else
	sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_FIFOEN);
#endif

	/*
	 *  UARTͭ
	 */
	sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_UE);

	/*
	 *  ͭ(TEACK)Ԥ
	 */
	if((sil_rew_mem((uint32_t *)(usart_base+TOFF_USART_CR1)) & USART_CR1_TE) == USART_CR1_TE){
		if(UART_ReadyWaitOnFlag(usart_base, USART_ISR_TEACK) != 0){
			return;
		}
	}

	/*
	 *  ͭ(REACK)Ԥ
	 */
	if((sil_rew_mem((uint32_t *)(usart_base+TOFF_USART_CR1)) & USART_CR1_RE) == USART_CR1_RE){
		if(UART_ReadyWaitOnFlag(usart_base, USART_ISR_REACK) != 0){
			return;
		}
	}

	/*
	 *  UART
	 */
	sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_PEIE);
	if((sil_rew_mem((uint32_t *)(usart_base+TOFF_USART_CR1)) & USART_CR1_FIFOEN) != 0)
		sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR3), USART_CR3_RXFTIE);
	else
		sil_orw_mem((uint32_t *)(usart_base+TOFF_USART_CR1), USART_CR1_RXNEIE_RXFNEIE);
}

/*
 *  UART7ߥϥɥ
 */
void UART7_IRQHandler(void)
{
	uint32_t base = usart_table[0].taddr;
	uint32_t isr = sil_rew_mem((uint32_t *)(base+TOFF_USART_ISR));
	uint32_t cr1 = sil_rew_mem((uint32_t *)(base+TOFF_USART_CR1));
	uint32_t cr3 = sil_rew_mem((uint32_t *)(base+TOFF_USART_CR3));
	uint32_t errflag;
	uint32_t i;

	/*
	 *  UART顼å
	 */
	errflag = (isr & (USART_ISR_PE | USART_ISR_FE | USART_ISR_ORE | USART_ISR_NE | USART_ISR_RTOF));
	if(errflag == 0){
		if((isr & USART_ISR_RXNE_RXFNE) != 0 && 
				((cr1 & USART_CR1_RXNEIE_RXFNEIE) != 0 || (cr3 & USART_CR3_RXFTIE) != 0)){
			ComInterRX(0);
			return;
		}
	}
	else if((cr3 & (USART_CR3_RXFTIE | USART_CR3_EIE)) != 0
			|| (cr1 & (USART_CR1_RXNEIE_RXFNEIE | USART_CR1_PEIE | USART_CR1_RTOIE)) != 0){
		/*
		 *  UART ѥƥ顼ꥢ
		 */
		if((isr & USART_ISR_PE) != 0 && (cr1 & USART_CR1_PEIE) != 0)
			sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_PECF);

		/*
		 *  UART ե졼२顼ꥢ
		 */
		if((isr & USART_ISR_FE) != 0 && (cr3 & USART_CR3_EIE) != 0)
			sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_FECF);

		/*
		 *  UART Υ顼ꥢ
		 */
		if((isr & USART_ISR_NE) != 0 && (cr3 & USART_CR3_EIE) != 0)
			sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_NECF);

		/*
		 *  UART С󥨥顼ꥢ
		 */
		if((isr & USART_ISR_ORE) != 0 &&
			((cr1 & USART_CR1_RXNEIE_RXFNEIE) != 0 || (cr3 & (USART_CR3_RXFTIE | USART_CR3_EIE)) != 0))
			sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_ORECF);

		/*
		 *  UART ॢȥ顼ꥢ
		 */
		if((isr & USART_ISR_RTOF) != 0 && (cr1 & USART_CR1_RTOIE) != 0)
			sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_RTOCF);
		return;
	}

	/* UART wakeup from Stop mode */
	if((isr & USART_ISR_WUF) != 0 && (cr3 & USART_CR3_WUFIE) != 0){
		sil_wrw_mem((uint32_t *)(base+TOFF_USART_ICR), USART_ICR_WUCF);
		return;
	}

	if((isr & USART_ISR_TXE_TXFNF) != 0 && 
			((cr1 & USART_CR1_TXEIE_TXFNFIE) != 0 || (cr3 & USART_CR3_TXFTIE) != 0)){
		if((sil_rew_mem((uint32_t *)(base+TOFF_USART_CR1)) & USART_CR1_FIFOEN) != 0){
			uint8_t  th  = (uint8_t)((cr3 & USART_CR3_TXFTCFG) >> USART_CR3_TXFTCFG_SHIFT);
			uint16_t num = ((uint16_t)TX_FIFO_DEPTH * numerator[th]) / (uint16_t)denominator[th];
			for(i = 0 ; i < num ; num++){
				ComInterTX(0);
				if((sil_rew_mem((uint32_t *)(base+TOFF_USART_CR3)) & USART_CR3_TXFTIE) == 0)
					break;
			}
		}
		else
			ComInterTX(0);
	    return;
	}
}

/*
 *  Get RX Data
 *  Input: id: Serial Channel #
 *  output: c: Rx Data
 */
unsigned short GetRxData(int id)
{
	return sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_RDR)) | CHKRXDATA;
}

/*
 *  Enable Tx interrupt
 *  Input: id: Serial Channel #
 */
void EnableITX(int id)
{
	uint32_t base = usart_table[id].taddr;

	if((sil_rew_mem((uint32_t *)(base+TOFF_USART_CR1)) & USART_CR1_FIFOEN) != 0)
		sil_orw_mem((uint32_t *)(base+TOFF_USART_CR3), USART_CR3_TXFTIE);
	else
		sil_orw_mem((uint32_t *)(base+TOFF_USART_CR1), USART_CR1_TXEIE_TXFNFIE);
}

/*
 *  Disable Tx interrupt
 *  Input: id: Serial Channel #
 */
void DisableITX(int id)
{
	uint32_t base = usart_table[id].taddr;

	if((sil_rew_mem((uint32_t *)(base+TOFF_USART_CR1)) & USART_CR1_FIFOEN) != 0)
		sil_andw_mem((uint32_t *)(base+TOFF_USART_CR3), USART_CR3_TXFTIE);
	else
		sil_andw_mem((uint32_t *)(base+TOFF_USART_CR1), USART_CR1_TXEIE_TXFNFIE);
}

/*
 *  Send Tx in interrupt
 *  Input: id: Serial Channel #
 *         c : Send charactor
 */
void SendTX(int id, char c)
{
	sil_wrw_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_TDR), (c & 0xFF));
}

/*
 * Send Tx wait
 * Inputs: id: Serial Channel #
 */
void SendTXWait(int id)
{
	while((sil_rew_mem((uint32_t *)(usart_table[id].taddr+TOFF_USART_ISR)) & USART_ISR_TC) == 0);
}

