/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2015-2020 by Roi Takeuchi
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */
/*
 *	rommon Hardware Intialize Functions
 */
#include "sys_defs.h"
#include <string.h>
#include "sil.h"

#define sil_orw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) | (b))
#define sil_andw_mem(a, b)		sil_wrw_mem((a), sil_rew_mem(a) & ~(b))
#define sil_modw_mem(a, b, c)	sil_wrw_mem((a), (sil_rew_mem(a) & (~b)) | (c))

#define HSE_TIMEOUT_VALUE   (HSE_STARTUP_TIMEOUT*1000)
#define HSI_TIMEOUT_VALUE   (100*1000U)  /* 100 ms */
#define DBP_TIMEOUT_VALUE   (100*1000)
#define LSE_TIMEOUT_VALUE   (5000*1000)
#define PLL_TIMEOUT_VALUE   (100*1000U)  /* 100 ms */
#define CLOCKSWITCH_TIMEOUT_VALUE   (1000*1000U) /* 1 s    */

#define VECT_TAB_OFFSET     0x00		/* Vector Table base offset field. 
                                		   This value must be a multiple of 0x200. */
/*
 *  CORTEX PREEMPTION PRIORTY GROUP
 */
#define NVIC_PRIORITYGROUP_0    0x00000007	/* 0 bits for pre-emption priority 4 bits for subpriority */
#define NVIC_PRIORITYGROUP_1    0x00000006	/* 1 bits for pre-emption priority 3 bits for subpriority */
#define NVIC_PRIORITYGROUP_2    0x00000005	/* 2 bits for pre-emption priority 2 bits for subpriority */
#define NVIC_PRIORITYGROUP_3    0x00000004	/* 3 bits for pre-emption priority 1 bits for subpriority */
#define NVIC_PRIORITYGROUP_4    0x00000003	/* 4 bits for pre-emption priority 0 bits for subpriority */

/*
 *  PLL
 */
#define PLL12_CLOCKSOURCE   RCC_PLL12SOURCE_HSE
#define PLL_M               3
#define PLL_N               81
#define PLL_P               1
#define PLL_Q               1
#define PLL_R               1
#define PLL_FRACV           0x800

#define PLL2_M              3
#define PLL2_N              66
#define PLL2_P              2
#define PLL2_Q              1
#define PLL2_R              1
#define PLL2_FRACV          0x1400

#define PLL3_CLOCKSOURCE    RCC_PLL3SOURCE_HSE
#define PLL3_M              2
#define PLL3_N              34
#define PLL3_P              2
#define PLL3_Q              17
#define PLL3_R              37
#define PLL3_RGE            RCC_PLL3CFGR1_IFRGE_1
#define PLL3_FRACV          0x1A04

#define PLL4_CLOCKSOURCE    RCC_PLL4SOURCE_HSE
#define PLL4_M              4
#define PLL4_N              99
#define PLL4_P              6
#define PLL4_Q              8
#define PLL4_R              8
#define PLL4_RGE            RCC_PLL4CFGR1_IFRGE_0

/*
 *  å
 */
#define MPU_CLOCK           RCC_MPUSOURCE_PLL1
#define AXI_CLOCK           RCC_AXISSOURCE_PLL2
#define AXI_DIV             RCC_AXI_DIV1
#define MCU_CLOCK           RCC_MCUSSOURCE_PLL3
#define MCU_DIV             RCC_MCU_DIV1
#define APB1_DIV            RCC_APB1_DIV2
#define	APB2_DIV            RCC_APB2_DIV2
#define APB3_DIV            RCC_APB3_DIV2
#define APB4_DIV            RCC_APB4_DIV2
#define APB5_DIV            RCC_APB5_DIV4

#define HSICALIBRATIONVAL   16
#define HSI_DIV_VALUE       RCC_HSI_DIV1

#define PLL1_DIVIEREN       (RCC_PLL1CR_DIVPEN | RCC_PLL1CR_DIVQEN | RCC_PLL1CR_DIVREN)
#define PLL2_DIVIEREN       (RCC_PLL2CR_DIVPEN | RCC_PLL2CR_DIVQEN | RCC_PLL2CR_DIVREN)
#define PLL3_DIVIEREN       (RCC_PLL3CR_DIVPEN | RCC_PLL3CR_DIVQEN | RCC_PLL3CR_DIVREN)
#define PLL4_DIVIEREN       (RCC_PLL4CR_DIVPEN | RCC_PLL4CR_DIVQEN | RCC_PLL4CR_DIVREN)

/*
 *  RCC HSI CLOCK PRESCALER
 */
#define RCC_HSI_DIV1        RCC_HSICFGR_HSIDIV_0	/* Division by 1, ck_hsi(_ker) = 64 MHz (default after reset)*/
#define RCC_HSI_DIV2        RCC_HSICFGR_HSIDIV_1	/* Division by 2, ck_hsi(_ker) = 32 MHz*/
#define RCC_HSI_DIV4        RCC_HSICFGR_HSIDIV_2	/* Division by 4, ck_hsi(_ker) = 16 MHz*/
#define RCC_HSI_DIV8        RCC_HSICFGR_HSIDIV_3	/* Division by 8, ck_hsi(_ker) =  8 MHz*/

/*
 *  RCC MPU CLOCK SOURCE
 */
#define RCC_MPUSOURCE_HSI   RCC_MPCKSELR_MPUSRC_0
#define RCC_MPUSOURCE_HSE   RCC_MPCKSELR_MPUSRC_1
#define RCC_MPUSOURCE_PLL1  RCC_MPCKSELR_MPUSRC_2
#define RCC_MPUSOURCE_MPUDIV RCC_MPCKSELR_MPUSRC_3

/*
 *  RCC AXISS CLOCK SOURCE
 */
#define RCC_AXISSOURCE_HSI  RCC_ASSCKSELR_AXISSRC_0
#define RCC_AXISSOURCE_HSE  RCC_ASSCKSELR_AXISSRC_1
#define RCC_AXISSOURCE_PLL2 RCC_ASSCKSELR_AXISSRC_2
#define RCC_AXISSOURCE_OFF  RCC_ASSCKSELR_AXISSRC_3

/*
 *  RCC MCU CLOCK SOURCE
 */
#define RCC_MCUSSOURCE_HSI  RCC_MSSCKSELR_MCUSSRC_0
#define RCC_MCUSSOURCE_HSE  RCC_MSSCKSELR_MCUSSRC_1
#define RCC_MCUSSOURCE_CSI  RCC_MSSCKSELR_MCUSSRC_2
#define RCC_MCUSSOURCE_PLL3 RCC_MSSCKSELR_MCUSSRC_3


/*
 *  RCC AXI CLOCK SOURCE
 */
#define RCC_AXI_DIV1        RCC_AXIDIVR_AXIDIV_0
#define RCC_AXI_DIV2        RCC_AXIDIVR_AXIDIV_1
#define RCC_AXI_DIV3        RCC_AXIDIVR_AXIDIV_2
#define RCC_AXI_DIV4        RCC_AXIDIVR_AXIDIV_3

/*
 *  RCC APB4 CLOCK DIVIER
 */
#define RCC_APB4_DIV1       RCC_APB4DIVR_APB4DIV_0
#define RCC_APB4_DIV2       RCC_APB4DIVR_APB4DIV_1
#define RCC_APB4_DIV4       RCC_APB4DIVR_APB4DIV_2
#define RCC_APB4_DIV8       RCC_APB4DIVR_APB4DIV_3
#define RCC_APB4_DIV16      RCC_APB4DIVR_APB4DIV_4

/*
 *  RCC APB5 CLOCK DIVIER
 */
#define RCC_APB5_DIV1       RCC_APB5DIVR_APB5DIV_0
#define RCC_APB5_DIV2       RCC_APB5DIVR_APB5DIV_1
#define RCC_APB5_DIV4       RCC_APB5DIVR_APB5DIV_2
#define RCC_APB5_DIV8       RCC_APB5DIVR_APB5DIV_3
#define RCC_APB5_DIV16      RCC_APB5DIVR_APB5DIV_4


/*
 *  RCC MCU CLOCK DIVIER
 */
#define RCC_MCU_DIV1        RCC_MCUDIVR_MCUDIV_0
#define RCC_MCU_DIV2        RCC_MCUDIVR_MCUDIV_1
#define RCC_MCU_DIV4        RCC_MCUDIVR_MCUDIV_2
#define RCC_MCU_DIV8        RCC_MCUDIVR_MCUDIV_3
#define RCC_MCU_DIV16       RCC_MCUDIVR_MCUDIV_4
#define RCC_MCU_DIV32       RCC_MCUDIVR_MCUDIV_5
#define RCC_MCU_DIV64       RCC_MCUDIVR_MCUDIV_6
#define RCC_MCU_DIV128      RCC_MCUDIVR_MCUDIV_7
#define RCC_MCU_DIV256      RCC_MCUDIVR_MCUDIV_8
#define RCC_MCU_DIV512      RCC_MCUDIVR_MCUDIV_9

/*
 *  RCC APB1 CLOCK DIVIER
 */
#define RCC_APB1_DIV1       RCC_APB1DIVR_APB1DIV_0
#define RCC_APB1_DIV2       RCC_APB1DIVR_APB1DIV_1
#define RCC_APB1_DIV4       RCC_APB1DIVR_APB1DIV_2
#define RCC_APB1_DIV8       RCC_APB1DIVR_APB1DIV_3
#define RCC_APB1_DIV16      RCC_APB1DIVR_APB1DIV_4

/*
 *  RCC APB2 CLOCK DIVIER
 */
#define RCC_APB2_DIV1       RCC_APB2DIVR_APB2DIV_0
#define RCC_APB2_DIV2       RCC_APB2DIVR_APB2DIV_1
#define RCC_APB2_DIV4       RCC_APB2DIVR_APB2DIV_2
#define RCC_APB2_DIV8       RCC_APB2DIVR_APB2DIV_3
#define RCC_APB2_DIV16      RCC_APB2DIVR_APB2DIV_4

/*
 *  RCC APB3 CLOCK DIVIER
 */
#define RCC_APB3_DIV1       RCC_APB3DIVR_APB3DIV_0
#define RCC_APB3_DIV2       RCC_APB3DIVR_APB3DIV_1
#define RCC_APB3_DIV4       RCC_APB3DIVR_APB3DIV_2
#define RCC_APB3_DIV8       RCC_APB3DIVR_APB3DIV_3
#define RCC_APB3_DIV16      RCC_APB3DIVR_APB3DIV_4

/*
 *  RCC PLL12 CLOCK SOURCE
 */
#define RCC_PLL12SOURCE_HSI RCC_RCK12SELR_PLL12SRC_0
#define RCC_PLL12SOURCE_HSE RCC_RCK12SELR_PLL12SRC_1
#define RCC_PLL12SOURCE_OFF RCC_RCK12SELR_PLL12SRC_2

/*
 *  RCC PLL3 CLOCK SOURCE
 */
#define RCC_PLL3SOURCE_HSI  RCC_RCK3SELR_PLL3SRC_0
#define RCC_PLL3SOURCE_HSE  RCC_RCK3SELR_PLL3SRC_1
#define RCC_PLL3SOURCE_CSI  RCC_RCK3SELR_PLL3SRC_2
#define RCC_PLL3SOURCE_OFF  RCC_RCK3SELR_PLL3SRC_3

/*
 *  RCC PLL4 CLOCK SOURCE
 */
#define RCC_PLL4SOURCE_HSI  RCC_RCK4SELR_PLL4SRC_0
#define RCC_PLL4SOURCE_HSE  RCC_RCK4SELR_PLL4SRC_1
#define RCC_PLL4SOURCE_CSI  RCC_RCK4SELR_PLL4SRC_2
#define RCC_PLL4SOURCE_I2S_CKIN RCC_RCK4SELR_PLL4SRC_3

/*
 *  RCC UART78 CLOCK SOURCE
 */
#define RCC_UART78CLKSOURCE_PCLK1   RCC_UART78CKSELR_UART78SRC_0
#define RCC_UART78CLKSOURCE_PLL4    RCC_UART78CKSELR_UART78SRC_1
#define RCC_UART78CLKSOURCE_HSI     RCC_UART78CKSELR_UART78SRC_2
#define RCC_UART78CLKSOURCE_CSI     RCC_UART78CKSELR_UART78SRC_3
#define RCC_UART78CLKSOURCE_HSE     RCC_UART78CKSELR_UART78SRC_4

/*
 *  RCC LSEDRIVE CONFIG
 */
#define RCC_LSEDRIVE_LOW        RCC_BDCR_LSEDRV_0	/* LSE low drive capability */
#define RCC_LSEDRIVE_MEDIUMLOW  RCC_BDCR_LSEDRV_1	/* LSE medium low drive capability */
#define RCC_LSEDRIVE_MEDIUMHIGH RCC_BDCR_LSEDRV_2	/* LSE medium high drive capability */
#define RCC_LSEDRIVE_HIGH       RCC_BDCR_LSEDRV_3	/* LSE high drive capability */

/*
 *  쥸ե
 */
#define HSICFGR_HSITRIM_SHIFT   (8U)
#define PLLCFGR1_DIVM2_SHIFT    (16U)
#define PLLCFGR2_DIVP_SHIFT     (0U)
#define PLLCFGR2_DIVQ_SHIFT     (8U)
#define PLLCFGR2_DIVR_SHIFT     (16U)
#define PLLFRACR_FRACV_SHIFT    (3U)
#define PLLFRACR_FRACLE_SHIFT   (16U)


/*
 *  åޥ
 */
#define getPLL12source() ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK12SELR)) & RCC_RCK12SELR_PLL12SRC))
#define getPLL3source()  ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK3SELR)) & RCC_RCK3SELR_PLL3SRC))
#define getPLL4source()  ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK4SELR)) & RCC_RCK4SELR_PLL4SRC))
#define getMPUsource()   ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MPCKSELR)) & RCC_MPCKSELR_MPUSRC))
#define getAXISsource()  ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ASSCKSELR)) & RCC_ASSCKSELR_AXISSRC))
#define getMCUsource()   ((uint32_t)(sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MSSCKSELR)) & RCC_MSSCKSELR_MCUSSRC))


/*
 *  åǥޥ
 */
#define getMPUsourcerdy()  ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MPCKSELR)) & RCC_MPCKSELR_MPUSRCRDY) == RCC_MPCKSELR_MPUSRCRDY)
#define getAXISsourcerdy() ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ASSCKSELR)) & RCC_ASSCKSELR_AXISSRCRDY) == RCC_ASSCKSELR_AXISSRCRDY)
#define getMCUSsourcerdy() ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MSSCKSELR)) & RCC_MSSCKSELR_MCUSSRCRDY) == RCC_MSSCKSELR_MCUSSRCRDY)
#define getPLL1rdy()       ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR)) & RCC_PLL1CR_PLL1RDY) == RCC_PLL1CR_PLL1RDY)
#define getPLL2rdy()       ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR)) & RCC_PLL2CR_PLL2RDY) == RCC_PLL2CR_PLL2RDY)
#define getPLL3rdy()       ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR)) & RCC_PLL3CR_PLL3RDY) == RCC_PLL3CR_PLL3RDY)
#define getPLL4rdy()       ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR)) & RCC_PLL4CR_PLL4RDY) == RCC_PLL4CR_PLL4RDY)

/*
 *  ڥե륢ɥ쥹HSENֹѴޥ
 */
#define get_hsem_no(taddr)   (((taddr) == (TADR_GPIOA_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOB_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOC_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOD_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOE_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOF_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOG_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOH_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOI_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOJ_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOK_BASE))? 0U :\
                              ((taddr) == (TADR_GPIOZ_BASE))? 0U :\
                              ((taddr) == (TADR_EXTI_BASE))?  1U : HSEM_SEMID_MAX + 1U)


typedef struct {
	uint32_t PLL_P_Frequency;	/*  PLL P clock frequency expressed in Hz */
	uint32_t PLL_Q_Frequency;	/*  PLL Q clock frequency expressed in Hz */
	uint32_t PLL_R_Frequency;	/*  PLL R clock frequency expressed in Hz */
} RCC_PLLClocksTypeDef;


extern int MonVector[];

uint32_t SystemCoreClock = HSI_VALUE;

/*
 *  BOOT⡼ɼ
 */
static uint32_t get_bootmode(void)
{
	return (sil_rew_mem((uint32_t *)(TADR_SYSCFG_BASE+TOFF_SYSCFG_BOOTR)) & (SYSCFG_BOOTR_BOOT2|SYSCFG_BOOTR_BOOT1|SYSCFG_BOOTR_BOOT0));
}

/*
 *  HSEȽ
 */
static int is_hse_in_use(void)
{
	if((getMPUsource() == RCC_MPUSOURCE_HSI) && getMPUsourcerdy())
		return 1;
	else if((getAXISsource() == RCC_AXISSOURCE_HSI) && getAXISsourcerdy())
		return 1;
	else if((getMCUsource() == RCC_MCUSSOURCE_HSI) && getMCUSsourcerdy())
		return 1;
	else if((getPLL12source() == RCC_PLL12SOURCE_HSI) && (getPLL1rdy() || getPLL2rdy()))
		return 1;
	else if((getPLL3source() == RCC_PLL3SOURCE_HSI) && getPLL3rdy())
		return 1;
	else if((getPLL4source() == RCC_PLL4SOURCE_HSI) && getPLL4rdy())
		return 1;
	else
		return 0;
}

/*
 *  HSIȽ
 */
static int is_hsi_in_use(void)
{
	if((getMPUsource() == RCC_MPUSOURCE_HSI) && getMPUsourcerdy())
		return 1;
	else if((getAXISsource() == RCC_AXISSOURCE_HSI) && getAXISsourcerdy())
		return 1;
	else if((getMCUsource() == RCC_MCUSSOURCE_HSI) && getMCUSsourcerdy())
		return 1;
	else if((getPLL12source() == RCC_PLL12SOURCE_HSI) && (getPLL1rdy() || getPLL2rdy()))
		return 1;
	else if((getPLL3source() == RCC_PLL3SOURCE_HSI) && getPLL3rdy())
		return 1;
	else if((getPLL4source() == RCC_PLL4SOURCE_HSI) && getPLL4rdy())
		return 1;
	else
		return 0;
}


void SetVector(void *addr)
{
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_VTOR), (unsigned int)addr | VECT_TAB_OFFSET);	/* Vector Table Relocation */
}

/*
 *  Peripheral semaphore unlock
 */
int Periph_Lock(uint32_t Peripheral, uint32_t Timeout)
{
	uint32_t tick = 0;
	int ret = 0;
	uint32_t semno = get_hsem_no(Peripheral);
	uint32_t off;

	if(semno > HSEM_SEMID_MAX)
		return ret;

	/*
	 *  ޥեԤ
	 */
	off = TOFF_HSEM_RLR + semno * 4;
	while(sil_rew_mem((uint32_t *)(TADR_HSEM_BASE+off)) != (HSEM_CR_COREID_CURRENT | HSEM_RLR_LOCK)){
		if((Timeout == 0U) || ( ++tick > (Timeout * 1000))){
			ret = -2;
			for(;;){}
		}
		sil_dly_nse(1000);
	}
	return ret;
}

/*
 *  Peripheral semaphore unlock
 */
void Periph_Unlock(uint32_t Peripheral)
{
	uint32_t semno = get_hsem_no(Peripheral);
	uint32_t off;

	if(semno > HSEM_SEMID_MAX)
		return;

	/*
	 *  ϡɥޥե
	 */
	off = TOFF_HSEM_R + semno * 4;
	sil_wrw_mem((uint32_t *)(TADR_HSEM_BASE+off), (0 | HSEM_CR_COREID_CURRENT));
}

/*
 *  PLL2å
  */
static void GetPLL2ClockFreq(RCC_PLLClocksTypeDef *PLL2_Clocks)
{
	uint32_t pll2m = 1U, pll2fracen = 0U, hsivalue = 0U;
	uint32_t pll2cfgr1, pll2cfgr2, pll2fracr;
	float fracn1, pll2vco = 0;

	pll2cfgr1 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CFGR1));
	pll2fracr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2FRACR));
	pll2m = ((pll2cfgr1 & RCC_PLL2CFGR1_DIVM2) >> PLLCFGR1_DIVM2_SHIFT) + 1U;
	pll2fracen = (pll2fracr & RCC_PLL2FRACR_FRACLE) >> PLLFRACR_FRACLE_SHIFT;
	fracn1 = (float)(pll2fracen * ((pll2fracr & RCC_PLL2FRACR_FRACV) >> PLLFRACR_FRACV_SHIFT));
	pll2vco = (float)((float)((pll2cfgr1 & RCC_PLL2CFGR1_DIVN) + 1U) + (fracn1 / (float)0x1FFF));  //Intermediary value
	switch(getPLL12source()){
	case RCC_PLL12SOURCE_HSI:  /* HSI١ PLL å */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) != 0){
			hsivalue = (HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR)) & RCC_HSICFGR_HSIDIV));
			pll2vco *= (float)(hsivalue / pll2m);
		}
		else{
			pll2vco *= (float)(HSI_VALUE / pll2m);
		}
		break;
	case RCC_PLL12SOURCE_HSE:  /* HSE١ PLL å */
		pll2vco *= (float)(HSE_VALUE / pll2m);
		break;
	case RCC_PLL12SOURCE_OFF:  /* PLLåʤ */
	default:
		pll2vco = 0;
		break;
	}
	pll2cfgr2 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CFGR2));
	PLL2_Clocks->PLL_P_Frequency = (uint32_t)(pll2vco / ((float)(((pll2cfgr2 & RCC_PLL2CFGR2_DIVP) >> PLLCFGR2_DIVP_SHIFT) + 1U)));
	PLL2_Clocks->PLL_Q_Frequency = (uint32_t)(pll2vco / ((float)(((pll2cfgr2 & RCC_PLL2CFGR2_DIVQ) >> PLLCFGR2_DIVQ_SHIFT) + 1U)));
	PLL2_Clocks->PLL_R_Frequency = (uint32_t)(pll2vco / ((float)(((pll2cfgr2 & RCC_PLL2CFGR2_DIVR) >> PLLCFGR2_DIVR_SHIFT) + 1U)));
}

/*
 *  PLL3å
 */
static void GetPLL3ClockFreq(RCC_PLLClocksTypeDef *PLL3_Clocks)
{
	uint32_t pll3m = 1, pll3fracen = 0, hsivalue = 0;
	uint32_t pll3cfgr1, pll3cfgr2, pll3fracr;
	float fracn1, pll3vco = 0;

	pll3cfgr1 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CFGR1));
	pll3fracr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3FRACR));
	pll3m = ((pll3cfgr1 & RCC_PLL3CFGR1_DIVM3) >> PLLCFGR1_DIVM2_SHIFT) + 1U;
	pll3fracen = (pll3fracr & RCC_PLL3FRACR_FRACLE) >> PLLFRACR_FRACLE_SHIFT;
	fracn1 = (float)(pll3fracen * ((pll3fracr & RCC_PLL3FRACR_FRACV) >> PLLFRACR_FRACV_SHIFT));
	pll3vco = (float)((float)((pll3cfgr1 & RCC_PLL3CFGR1_DIVN) + 1U) + (fracn1 / (float) 0x1FFF));  //Intermediary value
	switch(getPLL3source()){
	case RCC_PLL3SOURCE_HSI:  /* HSI١ PLL å */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) != 0){
			hsivalue = (HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR)) & RCC_HSICFGR_HSIDIV));
			pll3vco *= (float)(hsivalue / pll3m);
		}
		else{
			pll3vco *= (float)(HSI_VALUE / pll3m);
		}
		break;
	case RCC_PLL3SOURCE_HSE:  /* HSE١ PLL å */
		pll3vco *= (float)(HSE_VALUE / pll3m);
		break;
	case RCC_PLL3SOURCE_CSI:  /* CSI١ PLL å */
		pll3vco *= (float)(CSI_VALUE / pll3m);
		break;
	case RCC_PLL3SOURCE_OFF:  /* PLLåʤ */
		pll3vco = 0;
		break;
	}
	pll3cfgr2 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CFGR2));
	PLL3_Clocks->PLL_P_Frequency = (uint32_t)(pll3vco / ((float)(((pll3cfgr2 & RCC_PLL3CFGR2_DIVP) >> PLLCFGR2_DIVP_SHIFT) + 1U)));
	PLL3_Clocks->PLL_Q_Frequency = (uint32_t)(pll3vco / ((float)(((pll3cfgr2 & RCC_PLL3CFGR2_DIVQ) >> PLLCFGR2_DIVQ_SHIFT) + 1U)));
	PLL3_Clocks->PLL_R_Frequency = (uint32_t)(pll3vco / ((float)(((pll3cfgr2 & RCC_PLL3CFGR2_DIVR) >> PLLCFGR2_DIVR_SHIFT) + 1U)));
}

/*
 *  PLL4å
 */
static void GetPLL4ClockFreq(RCC_PLLClocksTypeDef *PLL4_Clocks)
{
	uint32_t pll4m = 1U, pll4fracen = 0U, hsivalue = 0U;
	uint32_t pll4cfgr1, pll4cfgr2, pll4fracr;
	float fracn1, pll4vco = 0;

	pll4cfgr1 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CFGR1));
	pll4fracr = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4FRACR));
	pll4m = ((pll4cfgr1 & RCC_PLL4CFGR1_DIVM4) >> PLLCFGR1_DIVM2_SHIFT) + 1U;
	pll4fracen = (pll4fracr & RCC_PLL4FRACR_FRACLE) >> PLLFRACR_FRACLE_SHIFT;
	fracn1 = (float)(pll4fracen * ((pll4fracr & RCC_PLL4FRACR_FRACV) >> PLLFRACR_FRACV_SHIFT));
	pll4vco = (float)((float)((pll4cfgr1 & RCC_PLL4CFGR1_DIVN) + 1U) + (fracn1 / (float) 0x1FFF));  //Intermediary value
	switch(getPLL4source()){
	case RCC_PLL4SOURCE_HSI:  /* HSI١ PLL å */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) != 0){
			hsivalue = (HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR)) & RCC_HSICFGR_HSIDIV));
			pll4vco *= (float)(hsivalue / pll4m);
		}
		else{
			pll4vco *= (float)(HSI_VALUE / pll4m);
		}
		break;
	case RCC_PLL4SOURCE_HSE:  /* HSE١ PLL å */
		pll4vco *= (float)(HSE_VALUE / pll4m);
		break;
	case RCC_PLL4SOURCE_CSI:  /* CSI١ PLL å */
		pll4vco *= (float)(CSI_VALUE / pll4m);
		break;
	case RCC_PLL4SOURCE_I2S_CKIN:  /* Signal I2S_CKIN PLL å */
		pll4vco *= (float)(EXTERNAL_CLOCK_VALUE / pll4m);
		break;
	}
	pll4cfgr2 = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CFGR2));
	PLL4_Clocks->PLL_P_Frequency = (uint32_t)(pll4vco / ((float)(((pll4cfgr2 & RCC_PLL4CFGR2_DIVP) >> PLLCFGR2_DIVP_SHIFT) + 1U)));
	PLL4_Clocks->PLL_Q_Frequency = (uint32_t)(pll4vco / ((float)(((pll4cfgr2 & RCC_PLL4CFGR2_DIVQ) >> PLLCFGR2_DIVQ_SHIFT) + 1U)));
	PLL4_Clocks->PLL_R_Frequency = (uint32_t)(pll4vco / ((float)(((pll4cfgr2 & RCC_PLL4CFGR2_DIVR) >> PLLCFGR2_DIVR_SHIFT) + 1U)));
}

/*
 *  ACLK
 */
static uint32_t GetACLKFreq(void)
{
	uint32_t axidiv = 0;
	uint32_t axissfreq = 0;
	RCC_PLLClocksTypeDef pll2_clocks;

	/*
	 *  ACLKåȿ
	 */
	axidiv = (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AXIDIVR)) & RCC_AXIDIVR_AXIDIV);
	if(axidiv > RCC_AXI_DIV4)
		axidiv = RCC_AXI_DIV4;
	axidiv++;

	switch (getAXISsource()){
	case RCC_AXISSOURCE_PLL2:	/* PLL2-På */
		GetPLL2ClockFreq(&pll2_clocks);
		axissfreq = pll2_clocks.PLL_P_Frequency;
		break;

	case RCC_AXISSOURCE_HSI:	/* HSIå */
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) != 0)
			axissfreq = (HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR)) & RCC_HSICFGR_HSIDIV));
		else
			axissfreq = HSI_VALUE;
		break;

	case RCC_AXISSOURCE_HSE:	/* HSEå */
		axissfreq = HSE_VALUE;
		break;

	case RCC_AXISSOURCE_OFF:
	default:
		axissfreq = 0; /* ck_axiss is gated */
		break;
	}
	return axissfreq / axidiv;
}

/*
 *  ƥࡦå
 */
static uint32_t GetSystemFrequency(void)
{
	RCC_PLLClocksTypeDef pll3_clocks;
	uint32_t mcudiv = 0;
	uint32_t mcussfreq = 0;

	/*
	 *  MCUåȿ
	 */
	mcudiv = sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MCUDIVR)) & RCC_MCUDIVR_MCUDIV;
	if (mcudiv > RCC_MCU_DIV512)
		mcudiv = RCC_MCU_DIV512;

	switch (getMCUsource()){
	case RCC_MCUSSOURCE_PLL3:	/* PLL3-På */
		GetPLL3ClockFreq(&pll3_clocks);
		mcussfreq = pll3_clocks.PLL_P_Frequency;
		break;

	case RCC_MCUSSOURCE_HSI:	/* HSIå */
		mcussfreq = (HSI_VALUE >> (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR)) & RCC_HSICFGR_HSIDIV));
		break;

	case RCC_MCUSSOURCE_HSE:	/* HSEå */
		mcussfreq = HSE_VALUE;
		break;

	case RCC_MCUSSOURCE_CSI:	/* CSIå */
		mcussfreq = CSI_VALUE;
		break;
	}
	return mcussfreq >> mcudiv;
}


/*
 *  ƥOSCILLATOR
 */
static int SystemOscConfig(void)
{
	uint32_t tick = 0;

	/*
	 *  HSEåꡢѤʤХå
	 */
	if(is_hse_in_use()){
		if((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSERDY) != 0){
			return -1;
		}
	}
	else{

		/*
		 *  HSE
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENCLRR), RCC_OCENCLRR_HSEON);

		/*
		 *  HSEåԤ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSERDY) != 0){
			if ( ++tick > HSE_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  ⡼ӥåȥꥢ
		 */
		sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENCLRR), (RCC_OCENCLRR_DIGBYP | RCC_OCENSETR_HSEBYP));

		/*
		 *  HSERCC_HSE_BYPASS_DIG⡼ɤ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENSETR), RCC_OCENCLRR_DIGBYP);
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENSETR), RCC_OCENSETR_HSEBYP);

		/*
		 *  OSCILLATORͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENSETR), RCC_OCENSETR_HSEON);

		/*
		 *  HSEåԤ
		 */
		tick = 0;
		while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSERDY) == 0){
			if ( ++tick > HSE_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}
	}

	/*
	 *  HSIåꡢʤХå
	 */
	if(is_hsi_in_use()){
		/*
		 *  HSI֥졼
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR), RCC_HSICFGR_HSITRIM, \
                            (HSICALIBRATIONVAL << HSICFGR_HSITRIM_SHIFT));

		/* It is not allowed to change HSIDIV if HSI is currently used as
		 * reference clock for a PLL
		 */
		if(((getPLL12source() != RCC_PLL12SOURCE_HSI) || ((!getPLL1rdy()) && ((!getPLL2rdy())))) &&
			((getPLL3source() != RCC_PLL3SOURCE_HSI) || (!getPLL3rdy())) &&
			((getPLL4source() != RCC_PLL4SOURCE_HSI) || (!getPLL4rdy()))){

			/*
			 *  HSI Divied͹
			 */
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR), RCC_HSICFGR_HSIDIV, HSI_DIV_VALUE);

			/*
			 *  HSI DividerǥԤ
			 */
			tick = 0;
			while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) == 0){
				if( ++tick > HSI_TIMEOUT_VALUE){
					return -2;
				}
				sil_dly_nse(1000);
			}
		}

		/*
		 *  ƥ९å
		 */
		SystemCoreClock =  GetSystemFrequency();
	}
	else{
		/*
		 *  HSI(Internal High Speed oscillator)ͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCENSETR), RCC_OCENSETR_HSION);

		/*
		 *  HSIǥԤ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIRDY) == 0){
			if(++tick > HSI_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  HSI Divied͹
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR), RCC_HSICFGR_HSIDIV, HSI_DIV_VALUE);

		/*
		 *  HSI DividerǥԤ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_OCRDYR)) & RCC_OCRDYR_HSIDIVRDY) == 0){
			if(++tick > HSI_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  HSI֥졼
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_HSICFGR), RCC_HSICFGR_HSITRIM, \
                            (HSICALIBRATIONVAL << HSICFGR_HSITRIM_SHIFT));
    }

	/*
	 *  LSEå
	 */
	/*
	 *  Хååץɥᥤ 饤ȥ
	 */
	sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);

	/*
	 *  Хååסɥᥤ 饤ȥץƥ̵Ԥ
	 */
	tick = 0;
	while ((sil_rew_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1)) & PWR_CR1_DBP) == 0){
		if ( ++tick > DBP_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  LSEå
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEON);

	/*
	 *  LSEåԤ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_LSERDY) != 0){
		if ( ++tick > LSE_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  BDCR LSEBYP/DIGBYPӥåȥ
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), (RCC_BDCR_LSEBYP | RCC_BDCR_DIGBYP));

	/*
	 *  LSEͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEON);

	/*
	 *  LSEåǥԤ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR)) & RCC_BDCR_LSERDY) == 0){
		if( ++tick > LSE_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  PLL1,2,3,4
	 */
	/*
	 *  PLL1:PLL1ѥåʤХå
	 */
	if(!((getMPUsource() == RCC_MPUSOURCE_PLL1) && getMPUsourcerdy()) || \
		((getMPUsource() == RCC_MPUSOURCE_MPUDIV) && getMPUsourcerdy()) ){

		/*
		 *  DIVIERPLL1
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR), PLL1_DIVIEREN);
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR), RCC_PLL1CR_PLLON);

		/*
		 *  PLL1Ԥ
		 */
		tick = 0;
		while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR)) & RCC_PLL1CR_PLL1RDY) != 0){
			if( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL2椫γǧ̤Ѥʤ饯å
		 */
		if(!((getAXISsource() == RCC_AXISSOURCE_PLL2) && getAXISsourcerdy())){
			/*
			 *  PLL1,PLL2å
			 */
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK12SELR), RCC_RCK12SELR_PLL12SRC, PLL12_CLOCKSOURCE);
		}

		/*
		 *  PLL12ǥԤ
		 */
		tick = 0;
		while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK12SELR)) & RCC_RCK12SELR_PLL12SRCRDY) == 0){
			if( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL1ʬե
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CFGR1), (RCC_PLL1CFGR1_DIVN | RCC_PLL1CFGR1_DIVM1), \
			((PLL_N - 1U) | ((PLL_M - 1U) << 16U)));
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CFGR2), (RCC_PLL1CFGR2_DIVP | RCC_PLL1CFGR2_DIVQ | RCC_PLL1CFGR2_DIVR), \
			((PLL_P - 1U) | ((PLL_Q - 1U) <<8U ) | ((PLL_R - 1U) <<16U)));

		/*
		 *  PLL1 FRACTIONAL DIVIER
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1FRACR), RCC_PLL1FRACR_FRACLE);	/* ̵ */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1FRACR), RCC_PLL1FRACR_FRACV, (PLL_FRACV << PLLFRACR_FRACV_SHIFT));
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1FRACR), RCC_PLL1FRACR_FRACLE);	/* ͭ */

		/*
		 *  PLL1 Spectrum Clock Generator̵
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR), RCC_PLL1CR_SSCG_CTRL);

		/*
		 *  PLL1ͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR), RCC_PLL1CR_PLLON);

		/*
		 *  PLL1Ԥ
		 */
		tick = 0;
		while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR)) & RCC_PLL1CR_PLL1RDY) == 0){
			if(++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL1 DIVIERͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL1CR), PLL1_DIVIEREN);
	}

	/*
	 *  PLL2:PLL2ѥåʤХå
	 */
	if(!((getAXISsource() == RCC_AXISSOURCE_PLL2) && getAXISsourcerdy())){

		/*
		 *  DIVIERPLL2
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR), PLL2_DIVIEREN);
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR), RCC_PLL2CR_PLLON);

		/*
		 *  PLL2Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR)) & RCC_PLL2CR_PLL2RDY) != 0){
			if ( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL1椫γǧ̤Ѥʤ饯å
		 */
		if(!((getMPUsource() == RCC_MPUSOURCE_PLL1) && getMPUsourcerdy()) || \
			((getMPUsource() == RCC_MPUSOURCE_MPUDIV) && getMPUsourcerdy()) ){
			/*
			 *  PLL1,PLL2å
			 */
			sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK12SELR), RCC_RCK12SELR_PLL12SRC, PLL12_CLOCKSOURCE);
		}

		/*
		 *  PLL2ʬե
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CFGR1), (RCC_PLL2CFGR1_DIVN | RCC_PLL2CFGR1_DIVM2), \
			((PLL2_N - 1U) | ((PLL2_M - 1U) << 16U)));
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CFGR2), (RCC_PLL2CFGR2_DIVP | RCC_PLL2CFGR2_DIVQ | RCC_PLL2CFGR2_DIVR), \
			((PLL2_P - 1U) | ((PLL2_Q - 1U) << 8U) | ((PLL2_R - 1U) << 16U)));

		/*
		 *  PLL2 FRACTIONAL DIVIER
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2FRACR), RCC_PLL2FRACR_FRACLE);	/* ̵ */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2FRACR), RCC_PLL2FRACR_FRACV, (PLL2_FRACV << PLLFRACR_FRACV_SHIFT));
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2FRACR), RCC_PLL2FRACR_FRACLE);	/* ͭ */

		/*
		 *  PLL2 Spread Spectrum Clock Generator̵
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR), RCC_PLL2CR_SSCG_CTRL);

		/*
		 *  PLL2ͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR), RCC_PLL2CR_PLLON);

		/*
		 *  PLL2Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR)) & RCC_PLL2CR_PLL2RDY) == 0){
			if ( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL2 DIVIERͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL2CR), PLL2_DIVIEREN);
	}

	/*
	 *  PLL3:PLL3ѥåʤХå
	 */
	if(!((getMCUsource() == RCC_MCUSSOURCE_PLL3) && getMCUSsourcerdy())){

		/*
		 *  DIVIERPLL3
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR), PLL3_DIVIEREN);
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR), RCC_PLL3CR_PLLON);

		/*
		 *  PLL3Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR)) & RCC_PLL3CR_PLL3RDY) != 0){
			if ( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL3å
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK3SELR), RCC_RCK3SELR_PLL3SRC, PLL3_CLOCKSOURCE);

		/*
		 *  PLL3åԤ
		 */
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK3SELR)) & RCC_RCK3SELR_PLL3SRCRDY) == 0){
			if ( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL3ϻȼȿ
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CFGR1), RCC_PLL3CFGR1_IFRGE, PLL3_RGE);

		/*
		 *  PLL3ʬե
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CFGR1), (RCC_PLL3CFGR1_DIVN | RCC_PLL3CFGR1_DIVM3), \
			((PLL3_N - 1U) | ((PLL3_M - 1U) << 16U)));
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CFGR2), (RCC_PLL3CFGR2_DIVP | RCC_PLL3CFGR2_DIVQ | RCC_PLL3CFGR2_DIVR), \
			((PLL3_P - 1U) | ((PLL3_Q - 1U) <<8U) | ( (PLL3_R - 1U) <<16U)));

		/*
		 *  PLL3 FRACTIONAL DIVIER
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3FRACR), RCC_PLL3FRACR_FRACLE);	/* ̵ */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3FRACR), RCC_PLL3FRACR_FRACV, (PLL3_FRACV << PLLFRACR_FRACV_SHIFT));
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3FRACR), RCC_PLL3FRACR_FRACLE);	/* ͭ */

		/*
		 *  PLL3 Spread Spectrum Clock Generator̵
		 */
		sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR), RCC_PLL3CR_SSCG_CTRL);

		/*
		 *  PLL3ͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR), RCC_PLL3CR_PLLON);

		/*
		 *  PLL3Ԥ
		 */
		tick = 0;
		while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR)) & RCC_PLL3CR_PLL3RDY) == 0){
			if ( ++tick > PLL_TIMEOUT_VALUE){
				return -2;
			}
			sil_dly_nse(1000);
		}

		/*
		 *  PLL3 DIVIERͭ
		 */
		sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL3CR), PLL3_DIVIEREN);
	}

	/*
	 *  PLL4:INTEGER⡼
	 */
	/*
	 *  DIVIERPLL4
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR), PLL4_DIVIEREN);
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR), RCC_PLL4CR_PLLON);

	/*
	 *  PLL4Ԥ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR)) & RCC_PLL4CR_PLL4RDY) != 0){
		if ( ++tick > PLL_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  PLL4å
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK4SELR), RCC_RCK4SELR_PLL4SRC, PLL4_CLOCKSOURCE);

	/*
	 *  PLL4åԤ
	 */
	while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RCK4SELR)) & RCC_RCK4SELR_PLL4SRCRDY) == 0){
		if ( ++tick > PLL_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  PLL4ϻȼȿ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CFGR1), RCC_PLL4CFGR1_IFRGE, PLL4_RGE);

	/*
	 *  PLL4ʬե
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CFGR1), (RCC_PLL4CFGR1_DIVN | RCC_PLL4CFGR1_DIVM4), \
		((PLL4_N - 1U) | ( (PLL4_M - 1U) << 16U)));
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CFGR2), (RCC_PLL4CFGR2_DIVP | RCC_PLL4CFGR2_DIVQ | RCC_PLL4CFGR2_DIVR), \
		((PLL4_P - 1U) | ( (PLL4_Q - 1U) <<8U ) | ((PLL4_R - 1U) <<16U)));

	/*
	 *  PLL4 ե󥯥ʥ롦ǥХ
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4FRACR), RCC_PLL4FRACR_FRACLE);	/* ̵ */
	/*
	 *  ե󥯥ʥ롦ǥХѤʤ᥼
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4FRACR), RCC_PLL4FRACR_FRACV, 0 << PLLFRACR_FRACV_SHIFT);
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4FRACR), RCC_PLL4FRACR_FRACLE);	/* ͭ */

	/*
	 *  PLL4 Spread Spectrum Clock Generator̵
	 */
	sil_andw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR), RCC_PLL4CR_SSCG_CTRL);

	/*
	 *  PLL4ͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR), RCC_PLL4CR_PLLON);

	/*
	 *  PLL4Ԥ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR)) & RCC_PLL4CR_PLL4RDY) == 0){
		if ( ++tick > PLL_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  PLL4 DIVIERͭ
	 */
	sil_orw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_PLL4CR), PLL4_DIVIEREN);
	return 0;
}

/*
 *  ƥࡦå
 */
static int SystemClockConfig(void)
{
	uint32_t tick = 0;

	/*
	 *  MPUå
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MPCKSELR), RCC_MPCKSELR_MPUSRC , MPU_CLOCK);

	/*
	 *  MPUåǥԤ
	 */
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MPCKSELR)) & RCC_MPCKSELR_MPUSRCRDY) == 0){
		if (++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  AXISS֥åå
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ASSCKSELR), RCC_ASSCKSELR_AXISSRC, AXI_CLOCK);

	/*
	 *  AXISS֥ååǥԤ
	 */
	tick = 0;
	while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_ASSCKSELR)) & RCC_ASSCKSELR_AXISSRCRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  AXISS֥åǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AXIDIVR), RCC_AXIDIVR_AXIDIV, AXI_DIV);

	/*
	 *  AXISS֥åǥХǥԤ
	 */
	tick = 0;
	while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_AXIDIVR)) & RCC_AXIDIVR_AXIDIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  MCU֥åå
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MSSCKSELR), RCC_MSSCKSELR_MCUSSRC, MCU_CLOCK);

	/*
	 *  MCU֥ååǥԤ
	 */
	tick = 0;
	while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MSSCKSELR)) & RCC_MSSCKSELR_MCUSSRCRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  ƥ९å򹹿
	 */
	SystemCoreClock = GetSystemFrequency();

	/*
	 *  MCUǥХ򹹿
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MCUDIVR), RCC_MCUDIVR_MCUDIV , MCU_DIV);

	/*
	 *  MCUǥХǥԤ
	 */
	tick = 0;
	while ((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MCUDIVR)) & RCC_MCUDIVR_MCUDIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  ƥ९å򹹿
	 */
	SystemCoreClock = GetSystemFrequency();


	/*
	 *  APB4ǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB4DIVR), RCC_APB4DIVR_APB4DIV, APB4_DIV);

	/*
	 *  APB4ǥХǥԤ
	 */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB4DIVR)) & RCC_APB4DIVR_APB4DIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  APB5ǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB5DIVR), RCC_APB5DIVR_APB5DIV , APB5_DIV);

	/*
	 *  APB5ǥХǥԤ
	 */
    tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB5DIVR)) & RCC_APB5DIVR_APB5DIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  APB1ǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1DIVR), RCC_APB1DIVR_APB1DIV, APB1_DIV);

	/*
	 *  APB1ǥХǥԤ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1DIVR)) & RCC_APB1DIVR_APB1DIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  APB2ǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2DIVR), RCC_APB2DIVR_APB2DIV, APB2_DIV);

	/*
	 *  APB2ǥХǥԤ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2DIVR)) & RCC_APB2DIVR_APB2DIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}

	/*
	 *  APB3ǥХ
	 */
	sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB3DIVR), RCC_APB3DIVR_APB3DIV , APB3_DIV);

	/*
	 *  APB3ǥХǥԤ
	 */
	tick = 0;
	while((sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB3DIVR)) & RCC_APB3DIVR_APB3DIVRDY) == 0){
		if ( ++tick > CLOCKSWITCH_TIMEOUT_VALUE){
			return -2;
		}
		sil_dly_nse(1000);
	}
	return 0;
}


/*
 * STM32MP157A/C-DK Cortex-m4ؿ
 */
void SystemInit(void)
{
	uint32_t tmp;

	/*
	 *  FPU
	 */
	sil_orw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_CPACR), ((3UL << 10*2)|(3UL << 11*2)));

	/*
	 *  EXTIߡ٥ȤΥꥢ
	 */
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_IMR1), 0);
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_IMR2), 0);
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_IMR3), 0);
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_EMR1), 0);
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_EMR2), 0);
	sil_wrw_mem((uint32_t *)(TADR_EXTI_C2_BASE+TOFF_EXTI_C_EMR3), 0);

	/*
	 *  롼4ͥ
	 */
	tmp  = sil_rew_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR));
	tmp &= ~((uint32_t)(SCB_AIRCR_VECTKEY_Msk | SCB_AIRCR_PRIGROUP_Msk)); /* clear bits to change               */
	tmp |=  ((uint32_t)0x5FAUL << SCB_AIRCR_VECTKEY_Pos) |
            (NVIC_PRIORITYGROUP_4 << SCB_AIRCR_PRIGROUP_Pos);  /* Insert write key and priority group */
	sil_wrw_mem((uint32_t *)(TADR_SCB_BASE+TOFF_SCB_AIRCR), tmp);

	/*
	 *  ƥ९å򹹿
	 */
	SystemCoreClock = GetSystemFrequency();

	if(get_bootmode() == SYSCFG_BOOTR_BOOT2){
		/*
		 *  LSEɥ饤֥ѥƥ
		 */
		sil_orw_mem((uint32_t *)(TADR_PWR_BASE+TOFF_PWR_CR1), PWR_CR1_DBP);
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_BDCR), RCC_BDCR_LSEDRV, RCC_LSEDRIVE_MEDIUMHIGH);

		/*
		 *  ƥOSCILLATOR
		 */
		if(SystemOscConfig() != 0){
			for(;;){}
		}

		/*
		 *  ƥ९å
		 */
		if (SystemClockConfig() != 0){
			for(;;){}
		}

		/*
		 *  HSERTCåѤΥǥХɥե
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_RTCDIVR), RCC_RTCDIVR_RTCDIV, (24-1));
	}

	/*
	 *  ϡɥޥեå
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MC_AHB3ENSETR), RCC_MC_AHB3ENSETR_HSEMEN);

	/*
	 *  GPIOå
	 */
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOHEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIODEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOGEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOBEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOFEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOCEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOEEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOAEN);
	sil_wrw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_MP_AHB4ENSETR), RCC_MC_AHB4ENSETR_GPIOIEN);

	/*
	 * UART7å
	 */
	if(get_bootmode() == SYSCFG_BOOTR_BOOT2){
		/*
		 *  UART78å
		 */
		sil_modw_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_UART78CKSELR), RCC_UART78CKSELR_UART78SRC, RCC_UART78CLKSOURCE_HSI);
	}

	/*
	 *  ߥ٥
	 */
	SetVector((void*)MonVector);
}

/*
 *  ƥࡦåФؿ
 */
void RCC_GetClocksFreq(RCC_ClocksTypeDef* pRCC_Clocks)
{
	uint32_t div = 0;


	pRCC_Clocks->SYSCLK_Frequency = SystemCoreClock;
	pRCC_Clocks->HCLK_Frequency   = SystemCoreClock;

	/*
	 *  PCLK1åȿ
	 */
	div = (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB1DIVR)) & RCC_APB1DIVR_APB1DIV);
	if(div > RCC_APB1_DIV16)
		div = RCC_APB1_DIV16;
	pRCC_Clocks->PCLK1_Frequency  = SystemCoreClock >> div;

	/*
	 *  PCLK2åȿ
	 */
	div = (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB2DIVR)) & RCC_APB2DIVR_APB2DIV);
	if(div > RCC_APB2_DIV16)
		div = RCC_APB2_DIV16;
	pRCC_Clocks->PCLK2_Frequency  = SystemCoreClock >> div;

	/*
	 *  PCLK5åȿ
	 */
	div = (sil_rew_mem((uint32_t *)(TADR_RCC_BASE+TOFF_RCC_APB5DIVR)) & RCC_APB5DIVR_APB5DIV);
	if(div > RCC_APB5_DIV16)
		div = RCC_APB5_DIV16;
	pRCC_Clocks->PCLK5_Frequency  = GetACLKFreq() >> div;

	GetPLL3ClockFreq((RCC_PLLClocksTypeDef *)&pRCC_Clocks->PLL3_P_Frequency);
	GetPLL4ClockFreq((RCC_PLLClocksTypeDef *)&pRCC_Clocks->PLL4_P_Frequency);
}

